<?
/**
 * Copyright 2001 Boris Wesslowski 
 *
 * @modulegroup BASE
 * @module acl_overview
 * @package acl
 */
 include("webelements.p3");
 include("permission.p3");

 include("acl.pinc");
 include("Date.pinc");
 include("history.pinc");
 include("location.pinc");
 include("mailbox.pinc");
 include("mail.pinc");
 include("team.pinc");
 include("bug.pinc");
 include("file.pinc");
 include 'product.pinc';
 include 'installation.pinc';
 include 'task.pinc';
 include 'timetrack.pinc';
 include 'appointment.pinc';

 check_user();

 Function info($type,$start,$hidden) {
   global $lang, $tutos, $dbconn, $current_user,$link1;

   if ( $current_user->admin == 0) {
     echo "<SPAN CLASS=warn>". sprintf($lang['Err0022'],$lang['ACLOverview']) ."</SPAN>\n";
     return;
   }

   if ( $type != ""  ) {
     $query = "SELECT DISTINCT id FROM ". $type ." ORDER by id";
   } else {
     $query = "SELECT DISTINCT obj_id as id FROM acl WHERE obj_id > 0 ORDER by obj_id";
   }

   $result = $dbconn->Exec($query);
   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }


   if ( $tutos[massupdate] == 1 ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"acl_overview.php\">\n";
     echo $hidden;
     hiddenFormElements();
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }

   echo "<TABLE BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo "<TH>#</TH><TH>ID</TH><TH>type</TH><TH>object</TH><TH>owner</TH><TH>". $lang['permissions'] ."</TH>\n";
   if ( $tutos[massupdate] == 1 ) {
     echo "  <TH NOWRAP><INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\"></TH>\n";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $g = $result->get($a, "id");
     $obj = getObject($dbconn,$g);
	 if ( ($obj == -1) || ($obj->id == -1) ) {
       $a++;
       continue;
	 }
     $q = "SELECT * FROM acl WHERE obj_id=". $g;
     $r = $dbconn->Exec($q);
     $n2 = $r->numrows();
 
     echo "<TR>\n";
     echo "<TD ALIGN=\"right\" ROWSPAN=\"". max($n2,1) ."\">". ($a +1) ."</TD>\n";
     if ( $obj != -1 ) {
       echo "<TD ROWSPAN=\"". $n2 ."\">". acl_link($obj,$obj->id) ."</TD>\n";
       echo "<TD ROWSPAN=\"". $n2 ."\">". $lang[$obj->getType()] ."</TD>\n";
       echo "<TD ROWSPAN=\"". $n2 ."\">". $obj->getLink() ."</TD>\n";
     } else {
       echo "<TD ROWSPAN=\"". $n2 ."\">". $g ."</TD>\n";
       echo "<TD ROWSPAN=\"". $n2 ."\">unknown</TD>\n";
       echo "<TD ROWSPAN=\"". $n2 ."\">unknown</TD>\n";
     }
     if ( $n2 == 0 ) {
       echo "<TD COLSPAN=2>&nbsp;</TD>\n";
       if ( $tutos[massupdate] == 1 ) {
         if ( $obj->mod_ok() ) {
           echo " <TD ROWSPAN=\"". $n2 ."\"><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $obj->id ."\"></TD>\n";
	     } else {
	       echo "<TD ROWSPAN=\"". $n2 ."\">&nbsp;-&nbsp;</TD>";
         }
       }
       echo "</TR>\n";
	 } else {
       $b = 0;
       while ( $b < $n2 ) {
         if ( $b > 0 ) {
           echo "<TR>\n";
         }
         $h = $r->get($b, "adr_id");
         $o = getObject($dbconn,$h);
         if ( $o != -1 ) {
           echo "<TD>". $o->getFullName() ."</TD>\n";
         } else {
           if ( $h == 0 ) {
             echo "<TD>". $lang['everybody'] ."</TD>\n";
           } else {
             echo "<TD>Unknown object ". $h ."</TD>\n";
           }
         }
         echo "<TD>";
         $p = $r->get($b, "perm");
         if ( $p == 1 ) {
           echo $lang['ACLread'];
         } else if ( $p == 10 ) {
           echo $lang['ACLmodify'];
         } else if ( $p == 20 ) {
           echo $lang['ACLdelete'];
         } else {
           echo "?";
         }
         echo "</TD>\n";
         if ( $b == 0 ) {
           if ( $tutos[massupdate] == 1 ) {
             if ( method_exists($obj,"mod_ok") &&  $obj->mod_ok() ) {
               if ( $obj->getType() == "user" ) {
                 echo " <TD ROWSPAN=\"". $n2 ."\"><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $obj->uid ."\"> U</TD>\n";
               } else {
                 echo " <TD ROWSPAN=\"". $n2 ."\"><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $obj->id ."\"></TD>\n";
               }
	         } else {
	           echo "<TD ROWSPAN=\"". $n2 ."\">&nbsp;-&nbsp;</TD>";
             }
           }
		 }
         echo "</TR>\n";
         $b++;
       }
	 }
     $r->free();
     $a++;
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,6+ $tutos[massupdate],$start,$a,$n);

   if ( $tutos[massupdate] == 1 ) {
     echo "<TR>\n";
     echo "<TD ALIGN=right COLSPAN=5>\n";
     echo sprintf($lang['withmarked'],"");
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ." Object</OPTION>\n";
     echo "</SELECT>\n";

     echo "</TD>\n";
     echo " <TD COLSPAN=2><INPUT type=submit value=OK></TD>\n";
     echo "</TR>\n";
   }

   echo "</TFOOT>\n";
   echo "</TABLE>\n";
   if ( $tutos[massupdate] == 1 ) {
     echo "</FORM>";
   }
 }

 Function navigate() {
   global $lang,$tutos,$current_user;

   echo "<TABLE>\n";
   echo "<TR><TD>\n";
   echo "<SPAN CLASS=nodeco>".$lang['show'] ."</SPAN><BR><UL>\n";
   echo "<LI>". menulink("acl_overview.php",$lang['AppEverything'],$lang['AppEverything']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=addresses",$lang['Address'],$lang['Address']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=location",$lang['Location'],$lang['Location']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=bugs",$lang['Bugs'],$lang['Bugs']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=files",$lang['Files'],$lang['Files']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=calendar",$lang['Appointments'],$lang['Appointments']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=tasks",$lang['Tasks'],$lang['Tasks']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=people",$lang['User'],$lang['User']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=companies",$lang['Company'],$lang['Company']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=departments",$lang['Departments'],$lang['Departments']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=products",$lang['ProductPs'],$lang['ProductPs']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=installations",$lang['Installations'],$lang['Installations']) ."\n";
   echo "<LI>". menulink("acl_overview.php?type=mailboxes",$lang['ProdMailbox'],$lang['ProdMailbox']) ."\n";
   @reset($tutos[modules]);
   while ( list ($r,$x) = @each ($tutos[modules])) {
     $ref = new $x[name]($current_user->dbconn);
	 if ( isset($lang[$ref->getType()]) ) {
       echo "<LI>". menulink("acl_overview.php?type=". $ref->tablename,$lang[$ref->getType()],$lang[$ref->getType()]) ."\n";
	 }
   }
   echo "</UL></TD></TR>\n";

   HTML_Select();
 }

 # Perform possible actions
 if ( isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = getObject($dbconn,$val);
       if ( $b->id != $val ) {
         continue;
	   }
       if ( method_exists($b,"del_ok") && method_exists($b,"delete") &&  $b->del_ok() ) {
         $msg .= $lang['Delete'] .":&nbsp;". $lang[$b->getType()] ." ". $b->getFullName() ."<BR>";
         $msg .= $b->delete();
	   } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0023'],$lang[$b->getType()]);
	   }
       unset($p);
     }
     $dbconn->Commit("WORK");
   }
 }

 HTML_Header($lang['ACLOverview']);

 $hidden = "";
 $link1 = "acl_overview.php";
 if ( isset($HTTP_GET_VARS['type']) && ($HTTP_GET_VARS['type'] != "") ) {
   $type = $HTTP_GET_VARS['type'];
   $link1 = addUrlParameter($link1,"type=".UrlEncode($type));
   $hidden .= "<INPUT TYPE=hidden NAME=\"type\" VALUE=\"". $type ."\">\n";
 } else {
   $type = "";
 }
 if ( isset($HTTP_GET_VARS['start']) ) {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
 }

 # read the table definitions of modules
 @reset($tutos[modules]);
 while ( list ($r,$x) = @each ($tutos[modules])) {
   loadmodule($r);
 }

 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($type,$start,$hidden);
 HTML_Base3();

 $dbconn->close();
?>
<!--
    CVS Info:  $Id: acl_overview.php,v 1.19.2.4 2002/08/28 16:36:26 gokohnert Exp $
    $Author: gokohnert $
-->
