<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 *   CVS Info:  $Id: address_show.php,v 1.42 2002/07/17 07:27:13 gokohnert Exp $
 *   $Author: gokohnert $
 *
 * @modulegroup address
 * @module adr_ldap_overview
 * @package address
 */
 include("webelements.p3");
 include("permission.p3");
 include("installation.pinc");
 include("address_tools.p3");
 include("mailbox.pinc");
 include("file.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("address");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$a) {
   global $tutos, $lang,$current_user;

   if ( $a->id == -1 ) {
     return;
   }
   $a->readTeamList();
   $cols = 1;
   if ( count($a->loc) > 0 ) {
     $cols = 1 + count($a->loc);
   } else {
     $cols++;
   }
   if ( $cols == 2 ) {
     $cols++;
   }
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";

   echo "<TR><TH COLSPAN=". $cols .">". $lang['AddressEntries'] ."</TH></TR>\n";

   Show_LocFields($lang['AdrTitle'],$a,"title",0);

   Show_LocFields($lang['AdrFirstName'],$a,"f_name",0);

   Show_LocFields($lang['AdrMiddleName'],$a,"m_name",0);

   Show_LocFields($lang['AdrLastName'],$a,"l_name",0);

   Show_LocFields($lang['AdrBirthday'],$a,"birthday",0);

   # References to modules
   show_module_infolists($current_user,$a,$cols);

   Show_LocFields($lang['AdrDescription'],$a,"lname",1);

   Show_LocFields($lang['Company'],$a,"c_id",1);

   Show_LocFields($lang['Department'],$a,"d_id",1);

   Show_LocFields($lang['Description'],$a,"desc1",1);

   Show_LocFields($lang['Phone'] ." #1",$a,"phone_1",1);

   Show_LocFields($lang['Phone'] ." #2",$a,"phone_2",1);

   Show_LocFields($lang['AdrFax'],$a,"fax_1",1);

   Show_LocFields($lang['AdrEmail'] ." #1",$a,"email_1",1);

   Show_LocFields($lang['AdrEmail'] ." #2",$a,"email_2",1);

   Show_LocFields($lang['Street'],$a,"street1",1);

   Show_LocFields($lang['Street'],$a,"street2",1);

   Show_LocFields($lang['City'],$a,"city",1);

   Show_LocFields($lang['ZIP'],$a,"zip",1);

   Show_LocFields($lang['State'],$a,"state",1);

   Show_LocFields($lang['Country'],$a,"country",1);

#   Show_LocFields($lang['AdrLinks'],$a,"id",0);


   if ( count($a->teamids) > 0 ) {
     Show_LocFields("",$a,"teams",0);
   }

   # Files
   tutos_file::infolist($current_user,$a,$cols);

   if ( $current_user->feature_ok(usemailboxes,PERM_SEE) ) {
     $a->readMailboxes();
     if ( count($a->mboxlist) >0 ) {
       Show_LocFields("",$a,"mbox",0);
     }
   }

   if ( $current_user->feature_ok(usecalendar,PERM_SEE) ) {
     $a->readApps();
     if ( count($a->applist) >0 ) {
       Show_LocFields("",$a,"apps",0);
     }
   }

   if ( $current_user->feature_ok(useinstmanagement,PERM_SEE) ) {
     $a->readInstallations();
     if ( count($a->instlist) >0 ) {
       Show_LocFields("",$a,"inst",0);
     }
   }

   if ( $current_user->feature_ok(useprojects,PERM_SEE) ) {
     $yy = $lang['ProdRole'];
     while ( list ($role,$y) = @each ($yy) ) {
       $a->readProducts($role);
       if ( isset($a->prolist[$role]) && (count($a->prolist[$role]) >0) ) {
         Show_LocFields("",$a,"role".$role,0);
       }
     }
   }

   echo $a->getHistoryLink($cols);
   echo "</TABLE>\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";

   echo tutos_address::getSelectLink($current_user,$lang['Search']) ."<BR>\n";

   if ( $current_user->feature_ok(useaddressbook,PERM_NEW) ) {
     echo menulink("address_new.php",$lang['NewEntry'],$lang['AdrCreateInfo']) . "<BR>\n";
   }
   if ( $obj->id != -1 ) {
     if ( $obj->mod_ok() != 0 ) {
       echo menulink("address_new.php?id=". $obj->id,$lang['Modify'],$lang['Modify']) ."<BR>\n";
     }
     echo "<BR>\n";
     if ( $obj->isUser() ) {
       if ( $current_user->feature_ok(usecalendar,PERM_SEE) ) {
	     echo menulink("calendar.php?team=". $obj->id ,$lang['Calendar'],sprintf($lang['ShowCal'],$obj->getFullName())) ."<BR>\n";
       }
       if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) ) {
		 echo menulink("task_overview.php?id=". $obj->id ,$lang['TaskOverview'],sprintf($lang['TaskOverviewInfo'],$obj->getFullName())) ."<BR>\n";
       }
       if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) &&  $current_user->feature_ok(usecalendar,PERM_SEE) ) {
		   echo menulink("res_cal.php?id=".$obj->id,$lang['ResCal'],$lang['ResCal']) ."<BR>\n";
       }
       if ( $current_user->feature_ok(usetimetrack,PERM_SEE) ) {
		 echo menulink("timetrack_overview.php?worker=".$obj->id,$lang['TimetrackBooked'],sprintf($lang['TimetrackBookedI'],$obj->getFullName())) ."<BR>\n";
       }
     }
     if ( $current_user->feature_ok(usevcard,PERM_SEE) ) {
       echo  menulink($obj->getUrl() ."&format=vcard" ,$lang['AdrGetVcard'],$lang['AdrGetVcardI']) . "<BR>\n";
	 }
   }
   echo "<BR>\n";
   echo tutos_file::getaddlink($current_user,$obj);

   echo "<BR>\n";
   if ( $current_user->feature_ok(useaddressbook,PERM_NEW) ) {
     echo menulink("company_new.php",$lang['CompanyCreate'],$lang['CompanyCreateInfo']) ."<BR>";
     echo menulink("department_new.php",$lang['DepartmentCreate'],$lang['DepCreateInfo'] ) ."<BR>";
   }

   show_module_addlinks($current_user,$obj);

   echo "</TD></TR>";

   HTML_Select();
 }


 if ( ! isset($HTTP_GET_VARS['format']) ) {
   $format = "";
 } else {
   $format = $HTTP_GET_VARS['format'];
 }

 $a = new tutos_address($dbconn);

 # REGISTER VARIABLES
 if ( isset($HTTP_POST_VARS['id']) ) {
   $id = $HTTP_POST_VARS['id'];
 } elseif ( isset($HTTP_GET_VARS['id']) ) {
   $id = $HTTP_GET_VARS['id'];
 }
 if ( isset($HTTP_POST_VARS['lid']) ) {
   $lid = $HTTP_POST_VARS['lid'];
 } elseif ( isset($HTTP_GET_VARS['lid']) ) {
   $lid = $HTTP_GET_VARS['lid'];
 }

 # First find the address for the given location
 if ( isset($lid) ) {
   $q = "SELECT adr_id FROM adrloc WHERE loc_id = ". $lid;
   $result = $dbconn->Exec($q);
   if ($result->numrows() == 1) {
     $id = $result->get(0, "adr_id");
   } else {
     $id = -1;
   }
   $result->free();
 }

 if ($id > 0) {
   $a->read($id);
   $a->read_locs_data();
 } else {
   $msg .= sprintf($lang['Err0040'],$lang[$a->getType()]);
 }
 if ( ! $a->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$a->getType()]);
   $format = "";
 }

 if ( $format == "vcard" ) {
   Header("Content-type: text/x-vcard");
   echo $a->getIcard();
 } else {
   if ( $a->id > 0 ) {
     HTML_Header($lang['AddressDetail']." :".$a->getFullName());
   } else {
     HTML_Header($lang['AddressDetail']);
   }
   HTML_Base1();
   navigate($a);
   HTML_Base2($msg);
   if ( ($a->id > 0) && $a->see_ok() ) {
     info($a);
   }
   HTML_Base3();
 }
 $dbconn->Close();
?>
