<?
/**
 * Copyright 2001 by Gero Kohnert
 *
 * @modulegroup ADMIN
 * @module admin_show
 * @package BASE
 */
 include("webelements.p3");
 include("permission.p3");
 include("table.pinc");

 /* Check if user is allowed to use it */
 check_user();

 /* ---------------------------------------------------------------------------
  *
  */
 Function getTableCount($tbl,&$dbconn) {
   $q = "SELECT count(*) as c from ". $tbl;
   $r = $dbconn->exec($q);
   if ( 1 != $r->numrows()) {
     HTML_Footer();
     $dbconn->Close();
     exit;
   }
   $cnt = $r->get(0, "c");
   $r->free();
   return $cnt;
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function getinfo() {
   global $table, $dbconn;

   ksort($table);
   @reset($table);
   while ( list ($i,$f) = @each ($table) ) {
     $table[$i]['count'] = 0;
     $table[$i]['count'] = getTableCount($f[name],$dbconn);
   }
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$result) {
   global $current_user,$lang,$dbconn,$tutos,$table;

   $link2 = "admin_show.php";
   if ( $current_user->admin == 0 ) {
     echo "<SPAN CLASS=warn>Only admins are allowed to see this</SPAN><BR>\n";
     if ( $tutos[demo] == 1 ) {
       echo "<SPAN CLASS=warn>exceptionally enabled for this demo</SPAN><BR>\n";
     } else {
       return;
     }
   }

   $url['acl'] = "acl_overview.php";
   $url['teams'] = "team_overview.php";
   $url['bugs'] = "bug_overview.php";
   $url['addresses'] = "address_overview.php";
   $url['products'] = "product_overview.php";
   $url['files'] = "file_select.php";
   $url['timetrack'] = "timetrack_select.php";
   $url['calendar'] = "app_select.php";
   $url['installations'] = "installation_overview.php";
   $url['companies'] = "company_overview.php";
   $url['tutos_dbs'] = "database_overview.php";
   $url['history'] = "history_show.php";
   $url['messages'] = "message_overview.php";
   $url['people'] = "user_overview.php";


   getinfo();
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=6>". $lang['AdminDBInfo'] ." : ". $dbconn->db->alias ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   showfield($lang['AdminDBName']);
   echo " <TD COLSPAN=2>". $dbconn->db->getLink($dbconn->db->name) ."</TD>\n";
   showfield($lang['AdminDBUser']);
   echo " <TD COLSPAN=2>". $dbconn->db->user ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   if ( $dbconn->gettype() == "Oracle" ) {
     showfield($lang['AdminDBHome']);
     echo " <TD COLSPAN=5>". $dbconn->db->home ."&nbsp;</TD>\n";
   } else {
     showfield($lang['AdminDBHost']);
     echo " <TD COLSPAN=2>". $dbconn->db->host ."</TD>\n";
     if ( $dbconn->gettype() == "Postgres" ) {
       showfield($lang['AdminDBPort']);
       echo " <TD COLSPAN=2>". $dbconn->db->port ."</TD>\n";
     } else {
       echo " <TD COLSPAN=3>&nbsp;</TD>\n";
	 }
   }
   echo "</TR>\n";

   echo "<TR>\n";
   echo " <TH>". $lang['AdminDBTable'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBCount'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBTable'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBCount'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBTable'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBCount'] ."</TH>\n";
   echo "</TR>\n";
   @ksort($table);
   @reset ($table);
   $c = 0;
   while ( list ($i,$f) = @each ($table) ) {
     if ( $c == 0 ) {
       echo "<TR>\n";
     }
     if ( isset($url[$f[name]]) ) {
       echo " <TD ALIGN=right>". makelink($url[$f[name]],$f[name],$f[Desc]) ."</TD>";
     } else {
       echo " <TD ALIGN=right>". $f[name] ."</TD>";
     }
     echo " <TD ALIGN=right>". $f['count'] ."</TD>";
     if ( $c == 2 ) {
       echo "</TR>\n";
       $c = 0;
     } else {
       $c++;
     }
   }
   if ($c != 0) {
     echo " <TD COLSPAN=". (3 - $c) * 2 .">&nbsp;</TD></TR>\n";
   }

   echo "<TR>\n";
   echo " <TH COLSPAN=4>Known Modules</TH>\n";
   echo " <TH COLSPAN=1>". $lang['AdminDBTable'] ."</TH>\n";
   echo " <TH COLSPAN=1>" .$lang['AdminDBCount'] ."</TH>\n";
   echo "</TR>\n";
   @reset($tutos[modules]);
   while ( list ($i,$f) = @each ($tutos[modules]) ) {
     echo "<TR>\n";
	 unset ($table);
	 include($f[name] ."/mtable.pinc");
     echo " <TD VALIGN=top ALIGN=left>". makelink($f[name]."/".$f['overview'],$f[name]) ."</TD>\n";
     echo " <TD VALIGN=top COLSPAN=2 ALIGN=left>". $f[Desc] ."</TD>\n";
     echo " <TD VALIGN=top ALIGN=left>". $f[file] ."</TD>\n";
     echo " <TD ALIGN=right>&nbsp;";
     @reset($table);
     $pre = "";
     while ( list ($i2,$f2) = @each ($table) ) {
       echo $pre. $f2[name];
       $pre = "<BR>\n";
     }
     echo "</TD>\n";
     echo " <TD ALIGN=right>&nbsp;";
     @reset($table);
     $pre = "";
     while ( list ($i2,$f2) = @each ($table) ) {
       echo $pre . getTableCount($f2[name],$dbconn);
       $pre = "<BR>\n";
     }
     echo "</TD>\n";

     echo "</TR>\n";
   }

   echo "<TR>\n";
   echo " <TH COLSPAN=6>". menulink("user_overview.php",$lang['AdminLoginInfo'],$lang['AdminLoginInfo']) ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   echo order_header("", $lang['AdrName'],$link2,1);
   echo order_header("login", $lang['User'],$link2);
   echo order_header("last_seen", $lang['UserLastSeen'],$link2,2);
   echo order_header("last_host", $lang['UserLastHost'],$link2);
   echo order_header("disabled", $lang['UserDisabled'],$link2);
   echo "</TR>\n";

   $n = $result->numrows();
   $a = 0;
   $line = 1;
   while ( ($a < $n) && ( $a < $tutos[maxshow])) {
     if ( $line == 1 ) {
       $line = 2;
     } else {
       $line = 1;
     }
     echo "<TR CLASS=line". $line .">\n";
     $adr = new tutos_user($dbconn);
     $uid = $result->get($a, "id");
     $adr->read($uid,1);
     echo " <TD COLSPAN=1>". $adr->getLink() ."</TD>";
     echo " <TD ALIGN=right>". makelink("user_new.php?uid=".$uid ,$result->get($a, "login")) ."</TD>";
     $ls = new DateTime($result->get($a, "last_seen"));
     echo " <TD COLSPAN=2>". $ls->getLinkDateTime() ."</TD>";
     echo " <TD>&nbsp;". $result->get($a, "last_host") ."</TD>";
     echo " <TD ALIGN=center>". ($adr->disabled == 0 ? $lang['no']:$lang['yes']) ."</TD>";
     echo "</TR>\n";
     $a++;
   }
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $lang;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo menulink("acl_overview.php",$lang['ACLOverview'],$lang['ACLOverviewI']) ."<BR>\n";
   echo menulink("admin_sync.php",$lang['AdminDBSync'],$lang['AdminDBSync']) ."<BR>";
   echo "</TD></TR>";

   HTML_Select();
 }

 HTML_Header($lang['AdminShow']);

 $q = "SELECT * from people WHERE last_seen is not null";

 # sorting
 $xxx = "";
 order_parse($q,$xxx,$xxx,$xxx,"last_seen DESC");

 $result = $dbconn->Exec($q);

 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($result);
 HTML_Base3();

 $result->free();
 $dbconn->close();
?>
<!--
    CVS Info:  $Id: admin_show.php,v 1.35 2002/07/20 13:14:44 gokohnert Exp $
    $Author: gokohnert $
-->
