<?
/**
 * Copyright 2001 - 2002 by Gero Kohnert
 *
 * @modulegroup ADMIN
 * @module admin_sync
 * @package BASE
 */
 include("webelements.p3");
 include("permission.p3");
 include("table.pinc");

 /* Check if user is allowed to use it */
 check_user();


 /* ---------------------------------------------------------------------------
  * Make a insert from a result set
  */
 Function result2insert(&$dbconn1,&$dbconn2,$f,&$r,$a) {
#   echo $r->numfields()." :".$r->numrows() ."<BR>\n";
   $fc = $r->numfields();
   $b = 0;
   $upd  = "UPDATE ". $f ;
   $flds = "INSERT into ". $f ."";
   $vals = " VALUES ";
   $pre = "(";
   $upre = " SET ";
   while ( $b < $fc ) {
     $fn = strtoupper($r->fieldname($b));
     $ft = strtoupper($r->fieldtype($b));
     $fv = $r->get($a,$fn);
#	 echo $b .": |". $fn ."|". $fv ."|". $ft ."|<BR>";
     # OLD VERSIONS
     if ( ($f == "products") && ( ($fn == "MANAGER") || ($fn == "SELLER") || ($fn == "MANAGER2") ) ) {
       $b++;
       continue;
     }
     if ( ($f == "people") &&  ($fn == "OVERLIB") ) {
       $b++;
       continue;
     }
	 if ( ($f == "files") && ( ($fn == "SIZE")  ) ) {
       $b++;
       continue;
     }
	 if ( ($f == "people") && ( ($fn == "ADMIN") && ($fv == '')  ) ) {
       $fv = 0;
     }
     if ( ($f == "people") &&  ($fn == "PW") ) {
       if ( ($dbconn1->db->crypt == 1) && ($dbconn2->db->crypt != 1) ) {
         # Create a new password
         $fv = "tutos";
         echo "MODIFYING  PASSWORD to tutos<BR>\n";
         $modpass = 1;
       } else if ( ($dbconn1->db->crypt != 1) && ($dbconn2->db->crypt == 1) ) {
         # encrypt previously  unencrypted password
       } else if ( ($dbconn1->db->crypt == 1) && ($dbconn1->db->crypt == 1) && ($dbconn1->gettype() == "MySQL") && ($dbconn2->gettype() != "MySQL") ) {
         # Create a new password
         $fv = "tutos";
         echo "MODIFYING  PASSWORD to tutos<BR>\n";
       } else if ( ($dbconn1->db->crypt == 1) && ($dbconn1->db->crypt == 1) && ($dbconn1->gettype() != "MySQL") && ($dbconn2->gettype() == "MySQL") ) {
         # Create a new password
         $fv = "tutos";
         echo "MODIFYING  PASSWORD to tutos<BR>\n";
	   }
     }

     $upd .= $upre . $dbconn2->colname($fn) ." = ";
     if ( ($ft == "VARCHAR") || ($ft == "VARCHAR2") || ($ft == "STRING") || ($ft == "TEXT") || ($ft == "VARYING")) {
       if ( ($f == "people") &&  ($fn == "PW") ) {
         $vals .= $pre. $dbconn2->password($fv);
       } else {
         $vals .= $pre. $dbconn2->String($fv);
	   }
       $upd .= $dbconn2->String($fv);
     } else if ( $ft == "BLOB" ) {
       $vals .= $pre. $dbconn2->String($fv);
       $upd .= $dbconn2->String($fv);
     } else if ( ($ft == "TIMESTAMP") || ($ft == "DATETIME") || ( ($ft == "DATE") && ($r->dbconn->getType() == "Oracle")) ) {
       $dt = new DateTime($fv);
       $vals .= $pre. $dbconn2->DateTime($dt);
       $upd .= $dbconn2->DateTime($dt);
     } else if ( $ft == "DATE" ) {
       $dt = new DateTime($fv);
       $vals .= $pre. $dbconn2->Date($dt);
       $upd .= $dbconn2->Date($dt);
     } else if ( $ft == "TIMESTAMPTZ" ) {
       $dt = new DateTime($fv);
       $vals .= $pre. $dbconn2->Date($dt);
       $upd .= $dbconn2->Date($dt);
     } else if ( eregi("^INT",$ft) || ($ft == "REAL") || eregi("^FLOAT",$ft) || ($ft == "LONG") || ($ft == "NUMBER") ) {
       if ( !is_numeric($fv) ) {
         $fv = 'null';
       }
       $vals .= $pre. $fv;
       $upd .= $fv;
	 } else {
       echo "<SPAN CLASS=warn>". $dbconn2->colname($fn)." = ". $ft ." === </SPAN> ". $r->get($a,$b);
       echo "<BR>". $flds ."......". $vals .".......";
       exit;
	 } 
     $flds .= $pre. $dbconn2->colname($fn);
     $pre = ",";
     $upre = ",";
     $b++;
   }
   if ( $pre == "(" ) {
     echo "<SPAN CLASS=warn> no values  ???</SPAN><BR>\n";
     return;
   }

   $flds .= ")";
   $vals .= ")";

   $q[0] = $flds . $vals;
   $q[1] = $upd;

   return $q;
 }
 /* ---------------------------------------------------------------------------
  * Copy a selection of objects
  */
 Function copy_selected(&$dbconn1,&$dbconn2) {
   global $lang,$tutos;

   $msg = "";
   echo "changes since last sync (". $dbconn1->db->lastsync->getDateTime() .")<BR>\n";
   $q1 = "SELECT obj_id,val_old,m_field from history"; 
   if ( $dbconn1->db->lastsync->notime != 1) {
     $q1 .= " WHERE m_time > ". $dbconn2->DateTime($dbconn1->db->lastsync);
   }
   $r1 = $dbconn2->Exec($q1);
   $n1 = $r1->numrows();

   $trans = array();
   $obj = array();
   $table = array();

   $new = 0;
   $del = 0;
   $a = 0;
   while ( $a < $n1) {
	 $xid =  $r1->get($a,"obj_id");
     $mf = $r1->get($a,"m_field");

     if ( $mf == "created" ) {
       # ALL NEW Objects in "target" DB  will get a id for the "source" DB
       $x = getObject($dbconn2,$xid,1);
       # GET a new ID on source DB for this object
       $newid = $dbconn1->NextID();

       echo "NEW: ". $xid ." : ". $lang[$x->getType()] ." ". $x->getFullName() ." ---&gt;". $newid ." T:". $x->tablename ."<BR>\n";
       $trans[$xid] = $newid;
       $table[$xid] = $x->tablename;
       $obj[$xid] = $x;
       $new++;
	 } else if ( $mf == "Delete" ) {
       # DELETED Stuff
       $typ = $r1->get($a,"val_old");
       if ( $xid <  $dbconn1->db->lastid ) {
         echo "DEL: ". $xid ." : ". $typ ."<BR>\n";
         $trans[$xid] = -1;
         $table[$xid] = $typ;
         $del++;
         echo "DEL: ". $xid ." : ". $typ ."<BR>\n";
	   } else {
         echo "DEL (was new): ". $xid ." : ". $typ ."<BR>\n";
	   }
	 } else if ( $mf == "AdminDBSync" ) {
       # Do nothing
	 } else if ( ! isset($trans[$xid]) ) {
       $x = getObject($dbconn2,$xid,1);
       $trans[$xid] = $xid;
       $table[$xid] = $x->tablename;
       $obj[$xid] = $x;
       echo "MOD: ". $xid ." : ". $lang[$x->getType()] ." ". $x->getFullName() ." ---&gt;". $mf ."T:". $x->tablename ."<BR>\n";
	 }

     $a++;
   }   
   @reset($trans);
   while( list ($i,$f) = @each ($trans)) {
     echo "TR:". $i ."->".$f."<BR>\n";
   }
   @reset($obj);
   while( list ($i,$f) = @each ($obj)) {
     echo $i ." ". $obj[$i]->id . "<BR>\n";
	 if ( method_exists($obj[$i],"transfer_ids") ) {
       $obj[$i]->transfer_ids($trans);
	 }
   }   

   echo "New on target: ". $new ."<BR>\n";
   echo "Deleted on target: ". $del ."<BR>\n";


   # NOW we walk along the trans array
   # and do what have to be done !
   @reset($trans);
   while( list ($i,$f) = @each ($trans)) {
     # DELETE
     if ( $f == -1 ) {
       echo "SOURCE: Delete ". $i ." : ". $table[$i] ."<BR>\n";
	 } else if ( $f == $i ) {
       echo "SOURCE: Update ". $i ." in table ". $table[$i] ."<BR>\n";
       $obj[$i]->dbconn = $dbconn1;
       $obj[$i]->save();
       # READ history since last sync
       $obj[$i]->modified = array();
       $obj[$i]->modified[] = array ( "field" => "AdminDBSync" ,
                                      "old" => "" ,
                                      "new" => "",
                                      "obj_id" => $obj[$i]->id
                                    );
       $msg .= history_save($obj[$i]);
     } else {
       echo "SOURCE: Create ". $i ." as ". $f ." in table ". $table[$i] ."<BR>\n";
       $obj[$i]->dbconn = $dbconn1;
       $obj[$i]->newid = $f;
       $obj[$i]->id = -2;
       $obj[$i]->save();
       # READ history
       $obj[$i]->modified = array ();
       $obj[$i]->modified[] = array ( "field" => "AdminDBSync" ,
                                      "old" => "" ,
                                      "new" => "",
                                      "obj_id" => $obj[$i]->id
                                    );
       $msg .= history_save($obj[$i]);
	 }
   }
   $r1->free();
   $dbconn1->db->lastsync = new DateTime();
   $dbconn1->db->save();
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function copy_all(&$dbconn1,&$dbconn2) {
   global $lang,$tutos,$table;

   $dbconn2->Begin("WORK");
   # delete targets
   @reset($table);
   while ( list ($i,$f) = @each ($table) ) {
     $q = "SELECT * from ". $f[name];
     $r = $dbconn1->Exec($q);
     $n = $r->numrows();
     $fc = $r->numfields();
     echo "<B>SOURCE:</B> ". $q ." ===> (". $f[Desc] .") ". $n ." Entries <BR>\n";
     if ( $fc == 0 ) {
       echo "<SPAN CLASS=warn> ". $fc ." COLUMNS ???</SPAN><BR>\n";
       return;
	 }
     $q = "DELETE from ". $f[name];
     $dbconn2->Exec($q);
     echo "<B>TARGET:</B> ". $q ."<BR>\n";


     $a = 0;
     while ( $a < $n ) {
       $q2 = result2insert($dbconn1,$dbconn2,$f[name],$r,$a);
       $dbconn2->Exec($q2[0]);
#       echo "&nbsp; ". $fc ."&nbsp;". $q2[0] ."<BR>\n";
       flush();
       $a++;
     }
     echo " <===<BR>\n";
      
     $r->free();

     flush();
   }

   # Get the Sync and save it
   $seq1 =  $dbconn1->NextID();
   $dbconn2->setSeqID($seq1);

   # Create a tutos_dbs entry of the source database in the target
   # there we store the info about this action

   # Delete all other databases
   $q = "DELETE from tutos_dbs";
   $dbconn2->Exec($q);
   echo "<B>TARGET:</B> ". $q ."<BR>\n";
   
   # The database is that of dbconn1 but it should use dbconn2 for saving
   $dbconn1->db->dbconn = $dbconn2;
   # The sync happens now
   $dbconn1->db->id = -1;
   $dbconn1->db->lastid = $seq1;
   $dbconn1->db->lastsync = new DateTime();
   $dbconn1->db->save();

   $dbconn2->Commit("WORK");
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info3(&$dbconn,$from,$to,$what) {
   global $lang,$tutos;

   $db1 = new database($dbconn);
   $db2 = new database($dbconn);

   $db1->read($from);
   $db2->read($to);

   echo "<SPAN CLASS=warn>". $lang['AdminDBSyncM'][$what] ."</SPAN><P><P>\n";
   echo "connecting to databases ...<BR>\n";

   flush();

   $dbconn1 = $db1->getConnection();

   $dbconn2 = $db2->getConnection();

   if ( $what == 1 ) {
     copy_all($dbconn1,$dbconn2);
   } else if ( $what == 2 ) {
     copy_selected($dbconn1,$dbconn2);
     copy_all($dbconn1,$dbconn2);
   } else {
     echo "<SPAN CLASS=warn>Action :". $lang['AdminDBSyncM'][$what] ." not yet implemented </SPAN>\n";
   }

   echo "disconnecting from databases ...<BR>\n";
   flush();

   $dbconn1->Close();
   $dbconn2->Close();
 }
 /* ---------------------------------------------------------------------------
  * Show infos , test input and ask to continue
  */
 Function info2(&$dbconn,$from,$to,$what) {
   global $lang,$tutos;

   $db1 = new database($dbconn);
   $db2 = new database($dbconn);

   $db1->read($from);
   $db2->read($to);

   echo "connecting to databases ...<BR>\n";
   flush();

   $dbconn2 = $db2->getConnection();
   echo $db2->getFullName()." ...<BR>\n";
   flush();
   $dbconn1 = $db1->getConnection();
   echo $db1->getFullName()." ...<BR>\n";
   flush();

   $stop = 0;
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=3>". $lang['AdminDBSync'] ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   echo " <TH>&nbsp;</TH>\n";
   echo " <TH>". $lang['AdminDBSource'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBTarget'] ."</TH>\n";
   echo "</TR>\n";


   echo "<TR>\n";
   echo " <TD>&nbsp;</TD>\n";
   echo " <TD>". $db1->getLink() ."</TD>\n";
   echo " <TD>". $db2->getLink() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['DBLastDate']);
   echo " <TD>". $db1->lastsync->getDateTime() ."</TD>\n";
   echo " <TD>". $db2->lastsync->getDateTime() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['DBLastID']);
   echo " <TD>". $db1->lastid ."</TD>\n";
   echo " <TD>". $db2->lastid ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['DBCurrID']);
   $seq1 =  $dbconn1->NextID();
   $seq2 =  $dbconn2->NextID();
   echo " <TD>". $seq1 ."</TD>\n";
   echo " <TD>". $seq2 ."</TD>\n";
   echo "</TR>\n";
   
   $q1 = "SELECT * from history where m_field = ". $dbconn1->String("created");
   if ( $db1->lastsync->notime != 1) {
     $q1 .= " AND m_time > ". $dbconn1->DateTime($db1->lastsync);
   }
   $r1 = $dbconn1->Exec($q1);

   $q2 = "SELECT * from history where m_field = ". $dbconn2->String("created");
   if ( $db1->lastsync->notime != 1) {
     $q2 .= " AND m_time > ". $dbconn2->DateTime($db1->lastsync);
   }
   $r2 = $dbconn2->Exec($q2);

   echo "<TR>\n";
   showfield("History new");
   echo " <TD>". $r1->numrows() ."</TD>\n";
   echo " <TD>". $r2->numrows() ."</TD>\n";
   echo "</TR>\n";

   $q3 = "SELECT * from history where m_field = ". $dbconn1->String("Delete");
   if ( $db1->lastsync->notime != 1) {
     $q3 .= " AND m_time > ". $dbconn1->DateTime($db1->lastsync);
   }
   $r3 = $dbconn1->Exec($q3);

   $q4 = "SELECT * from history where m_field = ". $dbconn2->String("Delete");
   if ( $db1->lastsync->notime != 1) {
     $q4 .= " AND m_time > ". $dbconn2->DateTime($db1->lastsync);
   }
   $r4 = $dbconn2->Exec($q4);

   echo "<TR>\n";
   showfield("History del");
   echo " <TD>". $r3->numrows() ."</TD>\n";
   echo " <TD>". $r4->numrows() ."</TD>\n";
   echo "</TR>\n";
  
   $r1->free();
   $r2->free();
   $r3->free();
   $r4->free();
   # Does this make sense ?
   if ( ($what != 1 ) && ($db1->lastsync->notime) ) {
     echo "<TR>\n";
     showfield("&nbsp;");
     echo " <TD COLSPAN=2><SPAN CLASS=warn>You must first sync before update</SPAN></TD>\n";
     echo "</TR>\n";
     $stop = 1;
   }
   # Check IDs
   # if the current source ID is below its last sync then a update sync is not possible
   # because it the source was reinstalled or something like this
   if ( ($what != 1 ) && ($seq1 < $db1->lastid) ) {
     echo "<TR>\n";
     showfield("&nbsp;");
     echo " <TD COLSPAN=2><SPAN CLASS=warn>Source out of sync (". $seq1 ." < ". $db1->lastid .")</SPAN></TD>\n";
     echo "</TR>\n";
     $stop = 1;
   }
   # if the current target ID is below its last sync then a update sync is not possible
   # because it the target was reinstalled or something like this
   if ( ($what != 1 ) && ($seq2 < $db1->lastid) ) {
     echo "<TR>\n";
     showfield("&nbsp;");
     echo " <TD COLSPAN=2><SPAN CLASS=warn>Target out of sync (". $seq2 ." < ". $db1->lastid .")</SPAN></TD>\n";
     echo "</TR>\n";
     $stop = 1;
   }


   if ( $stop == 0 ) {
     echo "<TR>\n";
     showfield($lang['AdminDBWhat']);
     echo " <TD COLSPAN=2><SPAN CLASS=warn>". $lang['AdminDBSyncM'][$what] ."</SPAN></TD>\n";
     echo "</TR>\n";

     echo "<TR>\n";
     echo " <TH COLSPAN=3>\n";
     echo confirmlink("admin_sync.php?step=3&from=". $from ."&to=". $to ."&what=". $what ,"Are you sure ?","Are you sure");
     echo " </TH>\n";
     echo "</TR>\n";
   } else {
     echo "<TR>\n";
     echo " <TD COLSPAN=3>\n";
     echo makelink("admin_sync.php?step=1&from=". $from ."&to=". $to ."&what=". $what ,"Go back","Go back");
     echo " </TD>\n";
     echo "</TR>\n";
   }
   echo "</TABLE>\n";

   $dbconn1->Close();
   $dbconn2->Close();
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,$from,$to,$what) {
   global $lang,$tutos,$current_user;

   $dblist = readDB($dbconn);
   if ( count($tutos[dbname]) + count($dblist)  <= 1 ) {
     echo "<SPAN CLASS=warn>You have to define more than one database</SPAN>\n";
   }

   echo "<FORM NAME=\"adminsync\" METHOD=\"GET\" ACTION=\"admin_sync.php\">\n";
   hiddenFormElements();

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=3>". $lang['AdminDBSync'] ." (Step 1)</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   echo " <TH>". $lang['AdminDBSource'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBWhat'] ."</TH>\n";
   echo " <TH>". $lang['AdminDBTarget'] ."</TH>\n";
   echo "</TR>\n";


   echo "<TR>\n";
   echo " <TD>\n";
   echo "  <SELECT SIZE=". $tutos[maxshow]." name=\"from\">\n";
   @reset($dblist);
   while ( list ($i,$f) = @each ($dblist) ) {
     echo "<OPTION VALUE=\"". $i ."\"". ($from == $i ? " selected":"") .">". $i .": ". $f->getFullName(). ($i == $current_user->dbconn->db->id ? "(*)":"") ."</OPTION>\n";
   }
   echo "  </SELECT>\n";
   echo " </TD>\n";

   echo " <TD>\n";
   echo "  <SELECT SIZE=". $tutos[maxshow]." name=\"what\">\n";
   @reset($lang['AdminDBSyncM']);
   while ( list ($i,$f) = @each ($lang['AdminDBSyncM']) ) {
     echo "   <OPTION VALUE=\"". $i ."\"". ($what == $i ? " selected":"") .">". $lang['AdminDBSyncM'][$i]."</OPTION>\n";
   }
   echo "  </SELECT>\n";
   echo " </TD>\n";

   echo " <TD VALIGN=top>\n";
   if ( ($current_user->admin != 1) || (count($tutos[dbname]) == 1) ) {
     echo "<BR>\n". $current_user->dbconn->db->getLink();
     echo " <input type=\"hidden\" name=\"to\" value=\"". $dbconn->db->id ."\"></TD>\n";
   } else {
     # show local available DBs
     echo "  <SELECT SIZE=". $tutos[maxshow]." name=\"to\">\n";
     @reset($dblist);
     while ( list ($i,$f) = @each ($dblist) ) {
       if ( $i < 1000 ) {
         echo "<OPTION VALUE=\"". $i ."\" ". ($to == $i ? "selected":"") .">". $i .": ". $f->getFullName(). ($i == $current_user->dbconn->db->id ? "(*)":"") ."</OPTION>\n";
       }
     }
     echo "  </SELECT>\n";
   }
   echo " </TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   echo " <input type=\"hidden\" name=\"step\" value=\"2\"></TD>\n";
   echo " <TD COLSPAN=3><input type=\"submit\" value=\"SYNC\" TITLE=\"". $lang['AdminDBSync'] ."\"></TD>\n";
   echo "</TR>\n";


   echo "</TABLE>\n";
   echo "</FORM>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $current_user,$lang;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo menulink("database_overview.php", $lang['DBOverview'],$lang['DBOverview']) ."<BR>\n";
   if ( ($current_user->admin == 1) ) {
     echo menulink("database_new.php", $lang['NewEntry'],$lang['DBCreate']) ."<BR>\n";
   }
   echo "</TD></TR>";

   HTML_Select();
 }

 # SyncModes
# $lang['AdminDBSyncM'][3] = "copy selected new (since last sync) from target to source, then copy all";
 
 $stop = 0;

 if ( ! isset($HTTP_GET_VARS['step']) ) {
   $step = 1;
 } else {
   $step = $HTTP_GET_VARS['step'];
 }

 if ( $current_user->admin == 0 ) {
   $msg .= "<SPAN CLASS=warn>Only admins are allowed to see this</SPAN><BR>\n";
   if ( $tutos[demo] == 1 ) {
     $msg .= "<SPAN CLASS=warn>exceptionally enabled for this demo</SPAN><BR>\n";
     $step = min($step,2);
   } else {
     $stop = 1;
   }
 }

 if ( !isset($HTTP_GET_VARS['from']) ) {
   $from = -1;
   $step = 1;
 } else {
   $from = $HTTP_GET_VARS['from'];
 }
 if ( !isset($HTTP_GET_VARS['to']) ) {
   $to = $dbconn->db->id;
   $step = 1;
 } else {
   $to = $HTTP_GET_VARS['to'];
 }
 if ( !isset($HTTP_GET_VARS['what']) ) {
   $what = 1;
   $step = 1;
 } else {
   $what = $HTTP_GET_VARS['what'];
 }
 if ( $from == $to ) {
   $msg .= "Source and target must be different !";
   $step = 1;
 }

 # load modules
 # read the table definitions of modules
 @reset($tutos[modules]);
 while ( list ($r,$x) = @each ($tutos[modules])) {
   loadmodule($r);
   @include(dirname($tutos['base'] ."/". $tutos[modules][$r][file]) ."/mtable.pinc");
 }


 HTML_Header($lang['AdminDBSync']);

 HTML_Base1();
 navigate();


 HTML_Base2($msg);
 if ( $stop == 0 ) {
   if ( $step == 1 ) {
     info($dbconn,$from,$to,$what);
   } else if ($step == 2) {
     info2($dbconn,$from,$to,$what);
   } else if ($step == 3) {
     info3($dbconn,$from,$to,$what);
   }
 }
 HTML_Base3();

 $dbconn->Close();

?>
<!--
    CVS Info:  $Id: admin_sync.php,v 1.19 2002/07/20 13:14:44 gokohnert Exp $
    $Author: gokohnert $
-->
