<?
/**
 * Copyright 2001 - 2002 by Gero Kohnert
 *
 * Make a ldap request and show results
 *
 * @modulegroup address
 * @module adr_ldap_overview
 * @package address
 */
 include("webelements.p3");
 include("permission.p3");
 include("address_tools.p3");

 /* Check if user is allowed to use it */
 check_user();

 /* ---------------------------------------------------------------------------
  * name = search string
  * sv = server number (see config.pinc)
  */
 Function info($search,$filter,$sv) {
   global $lang , $tutos, $current_user, $ashow;

   if ( ! $current_user->feature_ok(useldap,PERM_SEE) ) {
     echo "LDAP disabled<BR>\n";
     return;
   }

   $link2 = "adr_ldap_overview.php";
   $justthese = array( "cn","c");

   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   if ( $ashow['f_name'] == 1 ) {
     echo "<TH>". $lang['AdrFirstName']."</TH>\n";
	 $justthese[] = "givenname";
   }
   if ( $ashow['l_name'] == 1 ) {
     echo "<TH>". $lang['AdrLastName']."</TH>\n";
	 $justthese[] = "sn";
	 $justthese[] = "surname";
   }
   if ( $ashow['c_id'] == 1 ) {
     echo "<TH>". $lang['Company']."</TH>\n";
	 $justthese[] = "o";
   }
   if ( $ashow['d_id'] == 1 ) {
     echo "<TH>". $lang['Department']."</TH>\n";
	 $justthese[] = "department";
	 $justthese[] = "ou";
   }
   if ( $ashow['email'] == 1 ) {
	   echo "<TH>". $lang['AdrEmail']."</TH>\n";
	   $justthese[] = "mail";
   }
   if ( $ashow['city'] == 1 ) {
	   echo "<TH>". $lang['City']."</TH>\n";
	   $justthese[] = "l";
   }
   echo "<TH>". $lang['Country']."</TH>\n";
   if ( $ashow['phone'] == 1 ) {
	   echo "<TH>". $lang['Phone']."</TH>\n";
	   $justthese[] = "telephonenumber";
   }
   if ( $ashow['fax'] == 1 ) {
	   echo "<TH>". $lang['AdrFax']."</TH>\n";
	   $justthese[] = "faxnumber";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   echo "<TBODY>\n";
   # $sip = gethostbyname($tutos[ldapserver][$sv]);
   # echo  $sv ."  ". $sip ."<BR>";

   $ds = ldap_connect($tutos[ldapserver][$sv],$tutos[ldapport][$sv]);
   # echo "connect result is ". $ds ."<p>";
   # var_dump($ds);

   if ( $ds == false ) {
     echo "LDAP Error : retry<BR>\n";
	 $ds = ldap_connect($tutos[ldapserver][$sv],$tutos[ldapport][$sv]);
   }
   if ( $ds == false ) {
     echo "LDAP Error : retry <BR>\n";
	 $ds = ldap_connect($tutos[ldapserver][$sv],$tutos[ldapport][$sv]);
   }
   if ( $ds == false ) {
     echo "LDAP Error<BR>\n"; 
     echo "</TBODY>\n";
     echo "</TABLE>\n";
     return;
   }

     # echo "Binding ...";
     $r=ldap_bind($ds);     // this is an "anonymous" bind, typically
	 // read-only access
     # echo "Bind result is ".$r."<p>";

	 echo "Searching for ". $search ." on ". $tutos[ldapserver][$sv] ."<BR>\n";
	 // Search surname entry
	 $sr = ldap_search($ds,$tutos[ldapbasedn][$sv],$filter,$justthese);
     if (!$sr) {
       $errno = ldap_errno($ds);
       echo ldap_error($ds) ." (error ". $errno ." ". ldap_err2str($errno) .")<BR>";
       echo "</TBODY>\n";
       echo "</TABLE>\n";
       return;
     }

	 $cnt = ldap_count_entries($ds,$sr);

	 if ( $cnt > 0 ) {
	   echo "Number of entires returned is ". $cnt ."<p>";
 	   $info = ldap_get_entries($ds, $sr);
	   ldap_close($ds);
	 } else {
	   echo "Nothing found<p>";
       echo "</TBODY>\n";
       echo "</TABLE>\n";
	   return;
	 }

#        echo "Getting entries ...<p>";
#        echo "Data for ".$info["count"]." items returned:<p>";

	 for ($i=0; $i<$info["count"]; $i++) {
		 $dn =  $info[$i]["dn"];
		 $link  = "ldap://". $tutos[ldapserver][$sv].":".$tutos[ldapport][$sv]."/". str_replace("\"","",$dn) ;

		 echo "<TR>\n";

		 if ( $info[$i]["givenname"][0] == "" ) {
		   if ( ($ashow['f_name'] == 1) || ($ashow['l_name'] == 1) ) {
		     echo "<TD COLSPAN=2><A TARGET=ldap HREF=\"". $link ."\">". utf8_decode($info[$i]["cn"][0]) ."</A>&nbsp;</TD>\n";
		   }
		 } else {
		   if ( $ashow['f_name'] == 1 ) {
 			 echo "<TD><A TARGET=ldap HREF=\"". $link ."\">". utf8_decode($info[$i]["givenname"][0]) ."</A>&nbsp;</TD>\n";
		   }
		   if ( $ashow['l_name'] == 1 ) {
             if ( isset($info[$i]["surname"][0]) ) {
			   echo "<TD>". utf8_decode($info[$i]["surname"][0]) ."&nbsp;</TD>\n";
             } else if ( isset( $info[$i]["sn"][0]) ) {
			   echo "<TD>". utf8_decode($info[$i]["sn"][0]) ."&nbsp;</TD>\n";
             }
		   }
		 }
		 // ORG and ORGUNIT
		 if ( $ashow['c_id'] == 1 ) {
		   echo "<TD>". utf8_decode($info[$i]["o"][0]) ."&nbsp;</TD>\n";
		 }
		 if ( $ashow['c_id'] == 1 ) {
		   echo "<TD>". makelink($link2. "?ou=".UrlEncode($info[$i]["ou"][0]),utf8_decode($info[$i]["ou"][0]));
		   echo "<BR>". makelink($link2. "?department=".UrlEncode($info[$i]["department"][0]),utf8_decode($info[$i]["department"][0])) ."&nbsp;</TD>\n";
		 }
		 if ( $ashow['email'] == 1 ) {
		   // email
		   echo "<TD>". AsEmail($info[$i]["mail"][0],$info[$i]["mail"][0]) ."&nbsp;</TD>\n";
		 }
		 if ( $ashow['city'] == 1 ) {
		   echo "<TD>". utf8_decode($info[$i]["l"][0]) ."&nbsp;</TD>\n";
		 }
		 echo "<TD>". utf8_decode($info[$i]["c"][0]) ."&nbsp;</TD>\n";
		 if ( $ashow['phone'] == 1 ) {
		   echo "<TD>". $info[$i]["telephonenumber"][0] ."&nbsp;</TD>\n";
		 }
		 if ( $ashow['fax'] == 1 ) {
           echo "<TD>". asFax(0,0,$info[$i]["faxnumber"][0]) ."&nbsp;</TD>\n";
		 }
#
		 /*
		   echo "<TD>\n";
		   foreach ($info[$i] as $t)  {
		   var_dump($t);
		   echo "<BR>\n";
		   }
		   echo "</TD>\n";
		 */
		 echo "</TR>\n";
	 }
   echo "</TBODY>\n";
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $current_user,$tutos,$lang;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo tutos_address::getSelectLink($current_user,$lang['Search']) ."<BR>\n";

   if ( $current_user->feature_ok(useaddressbook,PERM_NEW) ) {
     echo menulink("address_new.php",$lang['NewEntry'],$lang['AdrCreateInfo']) . "<BR>\n";
   }
   echo "</TD></TR>";

   HTML_Select();
 }


 HTML_Header($lang['AddressOverview']);

 HTML_Base1();

 $ashow['f_name'] = 1;
 $ashow['l_name'] = 1;
 $ashow['email'] = 1;
 $ashow['phone'] = 1;
 $ashow['fax'] = 1;
 $ashow['city'] = 1;
 $ashow['c_id'] = 1;
 $ashow['d_id'] = 1;


 $atool['maxshow'] = $tutos[maxshow];
 if ( (! isset($atool['start'])) || ($atool['start'] < 0) ) {
   $atool['start'] = 0;
 }

 if ( isset($HTTP_GET_VARS['sv']) ) {
   # remember this
   $HTTP_SESSION_VARS['ldapserver'] = $HTTP_GET_VARS['sv'];
   $sv = $HTTP_GET_VARS['sv'];
 } else if ( isset($HTTP_SESSION_VARS['ldapserver']) ) {
   $sv = $HTTP_SESSION_VARS['ldapserver'];
 } else {
   $msg .= "NO Server defined !";
 }

 if ( isset($HTTP_GET_VARS['name']) ) {
   # remember this
   $HTTP_SESSION_VARS['adrlook'] = $HTTP_GET_VARS['name'];
   $name = $HTTP_GET_VARS['name'];
 } else if ( isset($HTTP_SESSION_VARS['adrlook']) ) {
   $name = $HTTP_SESSION_VARS['adrlook'];
 } else {
   $msg .= "NO Searchstring defined !";
 }

 if ( isset($name) ) {
   $n =str_replace(" ","*",$name);
   $n = $n . "*";
   $filter="(|(sn=". $n .")(givenname=". $n .")(cn=". $n ."))";
   $search = $n;
 }
 if ( isset($HTTP_GET_VARS['department']) ) {
   $filter="(|(department=". $HTTP_GET_VARS['department'] .")(ou=". $HTTP_GET_VARS['department'] ."))";
   $search = $HTTP_GET_VARS['department'];
 }
 if ( isset($HTTP_GET_VARS['ou']) ) {
   $filter="(|(ou=". $HTTP_GET_VARS['ou'] ."))";
   $search = $HTTP_GET_VARS['ou'];
 }

 navigate();
 HTML_Base2($msg);
 info($search,$filter,$sv);
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: adr_ldap_overview.php,v 1.12.2.2 2002/09/09 17:46:11 gokohnert Exp $
    $Author: gokohnert $
-->
