<?
/**
 * Copyright 1999/2000 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup appointment
 * @module app_ins
 * @package appointment
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("appointment");

 if ( ! isset($HTTP_POST_VARS['gotourl']) ) {
   $gotourl="app_new.php";
 } else {
   $gotourl=$HTTP_POST_VARS['gotourl'] ;
 }
 $msg = "";

 $a = new appointment($dbconn);
 #
 # ID
 #
 if ( isset($HTTP_POST_VARS['id']) ) {
   $gotourl= addUrlParameter($gotourl,"id=".$HTTP_POST_VARS['id']);
   $a->read($HTTP_POST_VARS['id']);
 }


 if ( isset($HTTP_POST_VARS['t_ignore']) ) {
   $a->t_ignore = 1;
 } else {
   $a->t_ignore = 0;
 }
 if ( isset($HTTP_POST_VARS['r_ignore']) ) {
   $a->r_ignore = $HTTP_POST_VARS['r_ignore'];
 } else {
   $a->r_ignore = 0;
 }
 $gotourl= addUrlParameter($gotourl,"t_ignore=".$a->t_ignore);
 $gotourl= addUrlParameter($gotourl,"r_ignore=".$a->r_ignore);

 # Set the Start and End time

 $a->start->setDateTimeF("start");
 if ( (1 != $a->start->checkDMY()) || (-1 == $a->start->getTimeStamp() ) ) {
   $msg .= sprintf($lang['Err0038'],$lang['StartDate']) ."<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"start=".$a->start->getYYYYMMDDHHMM() );
 }

 $a->end->setDateTimeF("end");
 if ( (1 != $a->end->checkDMY()) || (-1 == $a->start->getTimeStamp()) ) {
   $msg .= sprintf($lang['Err0038'],$lang['EndDate']) ."<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"end=".$a->end->getYYYYMMDDHHMM() );
 }

 #
 # Checks
 #
 if ( ($a->start->ts > $a->end->ts) && ($a->r_ignore == 0) ) {
   # Start after End
   $msg .= $lang['Err0002'] ."<BR>";
 }

 if ( !isset($HTTP_POST_VARS['people']) || (count($HTTP_POST_VARS['people']) < 1)) {
   # No Participants
   $msg .= $lang['Err0001'] ."<BR>";
 } else {
   $cnt = 0;
   @reset($HTTP_POST_VARS['people']);
   while ( list ($i,$f) = @each ($HTTP_POST_VARS['people']) ) {
     if ( $f != "" ) {
       $gotourl= addUrlParameter($gotourl,"people[]=".$f );
       $cnt++;
       $obj = new tutos_user($dbconn);
       $obj->read($f);
       if (  $obj->id == -1 ) {
         $obj = new team($dbconn);
         $obj->read($f);
       }
       if (  $obj->id == $f ) {
         $a->participant[$f] = $obj;
       }
     }
   }
   if ( $cnt == 0 ) {
     $msg .= $lang['Err0001'] ."<BR>";
   }
 }

 if ( !isset($HTTP_POST_VARS['mod_allow']) ) {
   $msg .= "Missing mod_allow<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"mod_allow=".$HTTP_POST_VARS['mod_allow'] );
   $a->mod_allow = $HTTP_POST_VARS['mod_allow'];
 }

 if ( !isset($HTTP_POST_VARS['creator']) ) {
   $msg .= "Missing creator<BR>";
 } else {
   $a->creator = new tutos_user($dbconn);
   $a->creator->read($HTTP_POST_VARS['creator']);
 }
 #
 # TRACE
 #
 if ( !isset($HTTP_POST_VARS['trace']) ) {
   $a->setTrace(0);
 } else {
   $a->setTrace($HTTP_POST_VARS['trace']);
 }
 $gotourl= addUrlParameter($gotourl,"trace=".$a->trace );
 #
 # EMAIL
 #
 if ( !isset($HTTP_POST_VARS['email']) ) {
   $a->email = 0;
 } else {
   $a->email = $HTTP_POST_VARS['email'];
 }
 $gotourl= addUrlParameter($gotourl,"email=".$a->email );
 #
 # OUTSIDE
 #
 if ( !isset($HTTP_POST_VARS['outside']) ) {
   $a->SetLocation(0);
 } else {
   $a->SetLocation($HTTP_POST_VARS['outside']);
 }
 $gotourl= addUrlParameter($gotourl,"outside=".$a->outside );
 #
 # REPEAT
 #
 if ( !isset($HTTP_POST_VARS['repeat']) ) {
   $a->repeat = 0;
 } else {
   $a->repeat = $HTTP_POST_VARS['repeat'];
 }
 $gotourl= addUrlParameter($gotourl,"repeat=".$a->repeat);

 if ( $a->repeat == 0 ) {
   $a->r_arg      = "";
 } else if ( $a->repeat == 1 ) {
   $a->r_arg      = Date("w",$a->start->GetTimeStamp());
 } else if ( $a->repeat == 2 ) {
   $a->r_arg      = Date("j",$a->start->GetTimeStamp());
 } else if ( $a->repeat == 3 ) {
   $a->r_arg      = Date("j/n",$a->start->GetTimeStamp());
 } else if ( $a->repeat == 4 ) {
   $a->r_arg      = "";
 }
 #
 # REMEMBER
 #
 if ( !isset($HTTP_POST_VARS['remember']) ) {
   $a->setRemember(0);
 } else {
   $a->setRemember($HTTP_POST_VARS['remember']);
 }
 $gotourl= addUrlParameter($gotourl,"remember=".$a->remember );
 #
 # DESCRIPTION
 #
 if ( !isset($HTTP_POST_VARS['descr']) || empty($HTTP_POST_VARS['descr']) ) {
#   $msg .= $lang['Err0003'] ."<BR>";
 } else {
   $a->SetDescription(StripSlashes(trim($HTTP_POST_VARS['descr'])));
 }
 $gotourl = addUrlParameter($gotourl,"descr=". UrlEncode($a->descr) );
 #
 # VISITOR
 #
 # Clear Visitor Address
 $a->visitor = new tutos_address($dbconn);
 if ( isset($HTTP_POST_VARS['vfn']) && !empty($HTTP_POST_VARS['vfn']) ) {
   $a->visitor = check_field(StripSlashes($HTTP_POST_VARS['vfn']),"vfn","vl","acd");
 } else {
   if ( isset($HTTP_POST_VARS['vid']) && !empty($HTTP_POST_VARS['vid']) ) {
     if ( $HTTP_POST_VARS['vid'] != -1 ) {
       $a->visitor = getObject($dbconn,$HTTP_POST_VARS['vid']);
     }
   }
 }
 #
 # PRODUCT
 #
 $p = new product($dbconn);
 if ( isset($HTTP_POST_VARS['pfn']) && !empty($HTTP_POST_VARS['pfn']) ) {
   $p = check_field(StripSlashes($HTTP_POST_VARS['pfn']),"pfn","pl","p");
 } else {
   if ( isset($HTTP_POST_VARS['pid']) && !empty($HTTP_POST_VARS['pid']) ) {
     if ( $HTTP_POST_VARS['pid'] != -1 ) {
       $p->read($HTTP_POST_VARS['pid']);
     }
   }
 }
 $a->setProduct($p);
 # other modules
 $msg .= module_parseforms($current_user,$a,$gotourl);

 ##################################################
 # End of Checks
 ##################################################
 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $msg .= $a->save();
   $dbconn->Commit("WORK");

   /* Go back to calendar */
   $gotourl = "calendar.php";
   $gotourl= addUrlParameter($gotourl,"id=".$a->id);
 }

 $gotourl = addUrlParameter($gotourl,"msg=".UrlEncode($msg));
 $gotourl = addSessionKey($gotourl);

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl() . $gotourl);
 $dbconn->Close();
/*
 *
 *   CVS Info:  $Id: app_ins.php,v 1.20.2.2 2002/09/02 19:58:47 gokohnert Exp $
 *   $Author: gokohnert $
 *
 */
?>
