<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup appointment
 * @module app_overview
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("bug.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("appointment");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,&$result,$start,$hidden) {
   global $lang,$tutos,$link1,$link2;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $tutos[massupdate] == 1 ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"app_overview.php\">\n";
     echo $hidden;
     hiddenFormElements();
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }

   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo " <TH>ID</TH>\n";
   echo order_header("a_start",$lang['AppStart'],$link2);
   echo order_header("a_end",$lang['AppEnd'],$link2);
   echo order_header("","&reg;",$link2);
   echo order_header("description",$lang['Description'],$link2);
   echo order_header("outside",$lang['Location2'],$link2);
   echo order_header("product",$lang['ProductP'],$link2);
   echo order_header("",$lang['Participants'],$link2);
   if ( $tutos[massupdate] == 1 ) {
     echo "  <TH NOWRAP><INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\"></TH>\n";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $f = new appointment($dbconn);
     $f->read_result($result,$a);
	 $f->read_participants();
     $a++;
     if ( ! $f->see_ok() ) {
       continue;
     }
     echo "<TR>\n";
     echo " <TD VALIGN=top ALIGN=right>". $f->getLink($a) ."</TD>\n";

     if ( $f->t_ignore == 0) {
       if ( $f->start->getDateTime() == $f->end->getDateTime() ) {
         echo " <TD VALIGN=top COLSPAN=2 ALIGN=left>". $f->start->getDateTime() ."</TD>\n";
       } else {
         echo " <TD VALIGN=top>". $f->start->getDateTime() ."</TD>\n";
         echo " <TD VALIGN=top>". $f->end->getDateTime() ."</TD>\n";
       }
     } else {
       if ( $f->start->getDate() == $f->end->getDate() ) {
         echo " <TD VALIGN=top COLSPAN=2 ALIGN=left>". $f->start->getDate() ."</TD>\n";
       } else {
         echo " <TD VALIGN=top>". $f->start->getDate() ."</TD>\n";
         echo " <TD VALIGN=top>". $f->end->getDate() ."</TD>\n";
       }
     }
     if ( $f->repeat ) {
       echo " <TD VALIGN=top>&reg;</TD>\n";
     } else {
       echo " <TD VALIGN=top>&nbsp;</TD>\n";
     }
     if ( $f->descr != "" ) {
       echo " <TD VALIGN=top>". urlReplace($f->descr) ."</TD>\n";
     } else {
       echo " <TD VALIGN=top>&nbsp;</TD>\n";
	 }
     echo " <TD VALIGN=top>".  $f->getLocation() ."</TD>\n";
     if ( $f->product->id > 0 ) {
       echo " <TD VALIGN=top>". $f->product->getLink() ."</TD>\n";
     } else {
       echo " <TD VALIGN=top>&nbsp;</TD>\n";
     }
     echo " <TD VALIGN=top>\n";
	 @reset($f->participant);
	 while ( list ($i,$x) = @each ($f->participant) ) {
		 echo $x->getLink() ;
		 echo "<BR>" ;
	 }
     echo " </TD>\n";

     if ( $tutos[massupdate] == 1 ) {
		 if ( $f->mod_ok() ) {
         echo " <TD><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $f->id ."\"></TD>\n";
	   } else {
	     echo "<TD>&nbsp;-&nbsp;</TD>";
       }
     }

     echo "</TR>\n";
	 unset($f);
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,8 + $tutos[massupdate],$start,$a,$n);

   if ( $tutos[massupdate] == 1 ) {
     echo "<TR>\n";
     echo "<TD ALIGN=right COLSPAN=7>\n";
     echo sprintf($lang['withmarked'],$lang['Appointments']);
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ."</OPTION>\n";
     echo "</SELECT>\n";

     echo "</TD>\n";
     echo " <TD COLSPAN=2><INPUT type=submit value=\"OK\"></TD>\n";
     echo "</TR>\n";
   }

   echo "</TFOOT>\n";
   echo "</TABLE>\n";
   if ( $tutos[massupdate] == 1 ) {
     echo "</FORM>";
   }
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(usecalendar,PERM_SEL) ) {
     echo  menulink("app_select.php" ,$lang['Search'],$lang['SearchForApp']) . "<BR>\n";
   }
   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo  menulink("app_new.php" ,$lang['NewEntry'],$lang['NewAppointInfo']) . "<BR>\n";
     echo  menulink("app_new_r.php" ,$lang['NewAppointR'],$lang['NewAppointInfoR']) . "<BR>\n";
   }
   echo "</TD></TR>";
   HTML_Select();
 }

 # Perform possible actions
 if ( isset($HTTP_GET_VARS['mark']) && isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = new appointment($dbconn);
       $b->read($val);
       if ( $b->id != $val ) {
         continue;
       }
       if ( $b->del_ok() ) {
         $msg .= $lang['Delete'] ."&nbsp;". $b->getFullName() ."<BR>";
         $msg .= $b->delete();
       } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0023'],$lang[$b->getType()]) ."<BR>";
       }
       unset($b);
     }
     $dbconn->Commit("WORK");
   }
 }

 HTML_Header($lang['AppointOverview']);

 $q = "SELECT * from calendar";
 $pre = " WHERE";
 $link1 = "app_overview.php";
 $filter = array();
 $hidden = "";

 #
 # Text Search
 #
 if ( isset($HTTP_GET_VARS['name']) && !empty($HTTP_GET_VARS['name']) ) {
   $q .= " " . $pre ."(". $dbconn->Like("description",$HTTP_GET_VARS['name']) .")";
   $pre = " AND";
   $link1 = addUrlParameter($link1,"name=". urlencode($HTTP_GET_VARS['name']));
   $hidden .= "<INPUT TYPE=hidden NAME=\"name\" VALUE=\"". $HTTP_GET_VARS['name'] ."\">\n";
 }
 #
 # Show all apps with given link (addr,company or department)
 #
 if ( isset($HTTP_GET_VARS['link_id']) ) {
   $obj = getObject($dbconn,$HTTP_GET_VARS['link_id']);
   if ( $obj->id > 0 ) {
     if ( $obj->getType() == "product" ) {
       $q .= $pre . " product = ". $HTTP_GET_VARS['link_id'];
       $pre = " AND";
     } else if ( $obj->getType() == "company" ) {
       $obj->read_members();
       $q .= $pre . " visitor in (". $HTTP_GET_VARS['link_id'];
       while ( list ($i,$f) = @each ($obj->member) ) {
         $q .= ",". $i;
       }
       $q .= " )";
       $pre = " AND";
     } else if ( $obj->getType() == "department" ) {
       $obj->read_members();
       $q .= $pre . " visitor in (". $HTTP_GET_VARS['link_id'];
       while ( list ($i,$f) = @each ($obj->member) ) {
         $q .= ",". $i;
       }
       $q .= " )";
       $pre = " AND";
     } else if ( $obj->getType() == "address" ) {
       $q .= $pre . " visitor = ". $HTTP_GET_VARS['link_id'];
     }
   }
   $link1 = addUrlParameter($link1,"link_id=".$HTTP_GET_VARS['link_id']);
   $hidden .= "<INPUT TYPE=hidden NAME=\"link_id\" VALUE=\"". $HTTP_GET_VARS['link_id'] ."\">\n";
 }
 # Start Date for search
 $from = new DateTime(0);
 if ( isset($HTTP_GET_VARS['fd']) ) {
   $from->setDateTime($HTTP_GET_VARS['fd']);
 } else {
   $from->setDateTimeF("f");
   # remember this
   $HTTP_SESSION_VARS['appsearchfrom'] = $from->getYYYYMMDD();
 }
 if ( $from->notime == 0 ) {
   $q .= $pre ."(a_start >= ". $dbconn->Date($from) .")";
   $pre = "AND ";

   $link1 = addUrlParameter($link1,"fd=".$from->getYYYYMMDD());
   $hidden .= "<INPUT TYPE=hidden NAME=\"fd\" VALUE=\"". $from->getYYYYMMDD() ."\">\n";

   $filter['from'] = $from;
 }
 # End Date for search
 $to = new DateTime(0);
 if ( isset($HTTP_GET_VARS['td']) ) {
   $to->setDateTime($HTTP_GET_VARS['td']);
 } else {
   $to->setDateTimeF("t");
   # remember this
   $HTTP_SESSION_VARS['appsearchto'] = $to->getYYYYMMDD();
 }
 if ( $to->notime == 0 ) {
   $q .= $pre ."(a_end <= ". $dbconn->Date($to) .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"td=".$to->getYYYYMMDD());
   $hidden .= "<INPUT TYPE=hidden NAME=\"td\" VALUE=\"". $to->getYYYYMMDD() ."\">\n";

   $filter['to'] = $to;
 }
 if ( isset($HTTP_GET_VARS['loc']) && ($HTTP_GET_VARS['loc'] != -1) ) {
   $q .= $pre ."(outside = ". $HTTP_GET_VARS['loc'] .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"loc=".$HTTP_GET_VARS['loc']);
   $hidden .= "<INPUT TYPE=hidden NAME=\"loc\" VALUE=\"". $HTTP_GET_VARS['loc'] ."\">\n";

   $filter['loc'] = $HTTP_GET_VARS['loc'];
 }
 #
 # display order
 #
 $link2 = $link1;
 $xxx = "";
 order_parse($q,$link1,$xxx,$hidden,"a_start ASC");

 if ( isset($HTTP_GET_VARS['start']) ) {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
 }

 $result = $dbconn->Exec($q);


 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($dbconn,$result,$start,$hidden);
 HTML_Base3();

 $result->free();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: app_overview.php,v 1.22.2.4 2002/09/09 17:46:11 gokohnert Exp $
    $Author: gokohnert $
-->
