<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup bug
 * @module bug_ins
 * @package bug
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("location.pinc");
 include("bug.pinc");
 include("product.pinc");
 include("task.pinc");
 include("installation.pinc");
 include("timetrack.pinc");


 /* Check if user is allowed to use it */
 check_user();
 loadmodules("bug");

 $gotourl = "bug_new.php";
 $msg = "";

 $b = new bug($dbconn);
 if ( isset($HTTP_POST_VARS['id']) ) {
   $gotourl= addUrlParameter($gotourl,"id=". $HTTP_POST_VARS['id']);
   $b->read($HTTP_POST_VARS['id']);
 }

 if ( empty($HTTP_POST_VARS['name']) || !isset($HTTP_POST_VARS['name']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugID']) ."<BR>";
 } else {
   $name = StripSlashes($HTTP_POST_VARS['name']);
   $gotourl= addUrlParameter($gotourl,"name=". UrlEncode($name));
 }

 if ( (empty($HTTP_POST_VARS['description']) || !isset($HTTP_POST_VARS['description']) ) && ($b->id < 0 )) {
   $msg .= sprintf($lang['Err0009'],$lang['BugAdditional']) ."<BR>";
 } else {
   $description = StripSlashes($HTTP_POST_VARS['description']);
   $gotourl= addUrlParameter($gotourl,"description=". UrlEncode($description));
 }

 if ( empty($HTTP_POST_VARS['short']) || !isset($HTTP_POST_VARS['short']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugShort']) ."<BR>";
 } else {
   $short = StripSlashes($HTTP_POST_VARS['short']);
   $gotourl= addUrlParameter($gotourl,"short=". UrlEncode($short));
 }

 if ( isset($HTTP_POST_VARS['pid']) ) {
   $gotourl= addUrlParameter($gotourl,"pid=". $HTTP_POST_VARS['pid']);
   $b->setParent(getObject($dbconn,$HTTP_POST_VARS['pid']));
 } else {
   $msg .= sprintf($lang['Err0009'],$lang['Product']) ."<BR>";
 }

 if ( empty($HTTP_POST_VARS['state']) || !isset($HTTP_POST_VARS['state']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugState']) ."<BR>";
 } else {
   $state = $HTTP_POST_VARS['state'];
   $gotourl= addUrlParameter($gotourl,"state=". $state);
 }
 if ( empty($HTTP_POST_VARS['class']) || !isset($HTTP_POST_VARS['class']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['BugClass']) ."<BR>";
 } else {
   $class = $HTTP_POST_VARS['class'];
   $gotourl= addUrlParameter($gotourl,"class=". $class);
 }

 if ( isset($HTTP_POST_VARS['sfn']) ) {
   $solver = check_field($HTTP_POST_VARS['sfn'],"sfn","sl");
 } else {
   if ( isset($HTTP_POST_VARS['sid']) ) {
     $solver = getObject($dbconn,$HTTP_POST_VARS['sid']);
   }
 }

 # other modules
 $msg .= module_parseforms($current_user,$b,$gotourl);

 if ( $msg != "" ) {
   $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));

   $gotourl = addSessionKey($gotourl);
   Header("Status: 302 Moved Temporarily");
   Header("Location:". getBaseUrl() . $gotourl);
   return;
 }


 #
 # Old Bug
 #
 if ( $b->id > 0 )  {
   $newlines = "";
   if ( !empty($description) ) {
     $newlines = sprintf("<B>%s -- Added by %s</B>\n%s" ,Date("d.m.Y H:i:s"),$current_user->getFullname() , myentities($description));
   }
   #
   # Solver Change
   #
   if ( $b->solver->id != $solver->id ) {
     if ( ($solver->id > 0) && ($b->solver->id > 0 ) ) {
       $newlines = sprintf("<B>%s -- Solver changed from <I>%s</I> to <I>%s</I> by %s</B>\n%s" ,Date("d.m.Y H:i:s"),$b->solver->getFullName(),$solver->getFullName(),$current_user->getFullname() , $newlines);
     } else {
       $newlines = sprintf("<B>%s -- Solver changed by %s</B>\n%s" ,Date("d.m.Y H:i:s"),$current_user->getFullname() , $newlines);
     }
     $b->setSolver($solver);
   }
   #
   # State Change
   #
   if ( $b->state != $state ) {
     $newlines = sprintf("<B>%s -- State changed from <I>%s</I> to <I>%s</I> by %s</B>\n%s" ,Date("d.m.Y H:i:s"),$b->getState(),$b->getState($state),$current_user->getFullname() , $newlines);
   }
   #
   # Class Change
   #
   if ( $b->class != $class ) {
     $newlines = sprintf("<B>%s -- Class changed from <I>%s</I> to <I>%s</I> by %s</B>\n%s" ,Date("d.m.Y H:i:s"),$b->getClass(),$b->getClass($class),$current_user->getFullname() , $newlines);
   }
   if ( $b->short != $short ) {
     $newlines = sprintf("<B>%s -- ShortDescription changed from <I>%s</I> to <I>%s</I> by %s</B>\n%s" ,Date("d.m.Y H:i:s"),$b->short,$short,$current_user->getFullname() , $newlines);
   }
   if ( !empty($newlines) ) {
     $b->description = sprintf("%s\n%s" ,rtrim($b->description) , $newlines);
   }
 } else {
   #
   # New Bug
   #
   $b->description = myentities($description);
   if ( $b->parent->getType() == "product" ) {
     $b->parent->readroles();
     if ( isset($b->parent->role[1][0]) ) {
       $b->setSolver($b->parent->role[1][0]);
     } else if ( isset($b->parent->role[3][0]) ) {
       $b->setSolver($b->parent->role[3][0]);
     } else {
       $b->setSolver($current_user);
     }
   } else if ( $b->parent->getType() == "installation" ) {
     $b->parent->product->readroles();
     if ( isset($b->parent->product->role[1][0]) ) {
       $b->setSolver($b->parent->product->role[1][0]);
     } else if ( isset($b->parent->product->role[3][0]) ) {
       $b->setSolver($b->parent->product->role[3][0]);
     } else {
       $b->setSolver($current_user);
	 }
   } else {
     $b->setSolver($current_user);
   }
 }
 $b->setName($name);
 $b->setShort($short);
 $b->setState($state);
 $b->setClass($class);

 $dbconn->Begin("WORK");
 $msg .= $b->save();
 $dbconn->Commit("WORK");


 $gotourl = $b->getURL();
 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));
 $gotourl = addSessionKey($gotourl);

 Header("Status: 302 Moved Temporarily");
 Header("Location:". getBaseUrl() . $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: bug_ins.php,v 1.23.2.1 2002/08/15 08:04:10 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
