<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup bug
 * @module bug_new
 * @package bug
 */
 include("webelements.p3");
 include("permission.p3");
 include("bug.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("bug");

 /** ---------------------------------------------------------------------------
  *  the dialog to enter or change a bug object
  */
 Function info(&$obj) {
   global $lang , $tutos ,$current_user;

   echo "<FORM NAME=\"bugnew\" ACTION=\"bug_ins.php\" method=\"POST\">\n";
   hiddenFormElements();
   if ( $obj->id > 0 ) {
     echo " <INPUT type=\"hidden\" value=\"". $obj->id ."\" name=\"id\">\n";
   } else {
     # state initially fixed to open
     echo " <INPUT type=\"hidden\" value=". $obj->state ." name=\"state\">\n";
   }

   if ( ($tutos[bugautoname] != "") && ( $obj->id < 1) ) {
     echo " <INPUT type=\"hidden\" value=\"auto\" name=\"name\">\n";
   }

   echo "<TABLE CLASS=single BORDER=0 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=4>".  sprintf($lang['Showing'],$lang[$obj->getType()])."</TH>\n";
   echo "</TR>\n";

   if ($obj->id > 0 ) {
     echo "<TR>\n";
     echo " <TD COLSPAN=3>". sprintf ($lang['BugCreation'],$obj->creator->getLink(),$obj->creation->getDateTime()) ."</TD>\n";
     echo " <TD ALIGN=right>". acl_link($obj) ."</TD>\n";
     echo "</TR>\n";
   }

   echo "<TR>\n";
   showfieldc($lang['BugID'],1);
   echo " <TD COLSPAN=3>";
   if ( $tutos[bugautoname] == "" ) {
     # name if totally free
     echo " <INPUT value=\"". $obj->name ."\" name=\"name\">\n";
   } else {
     # Using the autoname system for bugs
     if ( $obj->id > 0 ) {
       echo $obj->name;
       echo " <INPUT  type=\"hidden\" value=\"". $obj->name ."\" name=\"name\">\n";
     } else {
       $tmp = strftime($tutos[bugautoname]);
       echo $lang['BugAutoID'] ." ". $tmp;
	 }
   }
   echo "</TD>\n";
   echo "</TR>\n";


   echo "<TR>\n";
   showfieldc($lang['BugState']);
   if ( $obj->id > 0 ) {
     echo " <TD>". $obj->askState() ."</TD>\n";
   } else {
     echo " <TD>". $lang['BugAutoState'] ." ". $obj->getState() ."</TD>\n";
   }
   showfieldc($lang['BugClass'],0,"class");
   echo " <TD>". $obj->askClass() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['BugShort'],1,"short");
   echo " <TD COLSPAN=3 VALIGN=top><INPUT SIZE=40 MAXLENGTH=40 name=\"short\" value=\"". $obj->short ."\"></TD>";
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['BugAssignedTo']);
   echo " <TD COLSPAN=3 VALIGN=top>";
   if ( $obj->id > 0 ) {
     select_from_array_or_input($obj,"s",$obj->solver,1);
   } else {
     $sid =  $current_user->id;
     # initial
     echo $lang['BugAutoSolver'] ."&nbsp;";
     if ( $obj->parent->id > 0 ) {
       if ( $obj->parent->getType() == "product" ) {
         $obj->parent->readroles();
         if ( isset($obj->parent->role[1][0]) ) {
           echo $obj->parent->role[1][0]->getLink();
           $sid =  $obj->parent->role[1][0]->id;
         } else if ( isset($obj->parent->role[3][0]) ) {
           echo $obj->parent->role[3][0]->getLink();
           $sid =  $obj->parent->role[3][0]->id;
         } else {
           echo $current_user->getLink();
         }
       } else if ( $obj->parent->getType() == "installation" ) {
         $obj->parent->product->readroles();
         if ( isset($obj->parent->product->role[1][0]) ) {
           echo $obj->parent->product->role[1][0]->getLink();
           $sid =  $obj->parent->product->role[1][0]->id;
         } else if ( isset($obj->parent->product->role[3][0]) ) {
           echo $obj->parent->product->role[3][0]->getLink();
           $sid =  $obj->parent->product->role[3][0]->id;
         } else {
           echo $current_user->getLink();
         }
       } else {
         echo $current_user->getLink();
       }
       echo " <INPUT  type=\"hidden\" value=\"". $sid ."\" name=\"sid\">\n";
     } else {
       echo $lang['Product'] ." ". $lang['ProdRole'][1];
     }
   }
   echo " </TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   if ( $obj->parent->id > 0 ) {
     showfield($lang[$obj->parent->getType()]);
     echo " <TD COLSPAN=3 VALIGN=top>". $obj->parent->getLink();
     echo " <INPUT type=hidden name=pid value=". $obj->parent->id .">";
     echo "</TD>\n";
   } else {
     showfieldc($lang['ProductP'],1,"pid");
     echo " <TD COLSPAN=3 VALIGN=top>". $current_user->askProduct($obj->parent->id) ."</TD>";
   }
   echo "</TR>\n";

   echo "<TR>\n";
   if ( $obj->id > 0 ) {
     showfield($lang['BugHistory']);
     echo "<TD COLSPAN=3 VALIGN=top CLASS=pre><PRE>". $obj->description;
     echo "</PRE></TD>\n";
     echo "<TD></TD>\n";
     echo "</TR>\n";
     echo "<TR>\n";
     showfield($lang['BugAdditional'],0,"description");
     echo "<TD COLSPAN=3 VALIGN=top><TEXTAREA wrap=hard rows=20 cols=80 name=\"description\">". $obj->newdesc ."</TEXTAREA></TD>\n";
     echo "<TD></TD>\n";
     echo "</TR>\n";
   } else {
     showfield($lang['BugLong'],1,"description");
     echo " <TD COLSPAN=3 VALIGN=top><TEXTAREA wrap=hard rows=20 cols=80 name=\"description\">". $obj->newdesc;
     echo "</TEXTAREA></TD>\n";
     echo " <TD></TD>\n";
     echo "</TR>\n";
   }

   # References to modules
   module_addforms($current_user,$obj,4);

   if ( $obj->mod_ok() != 0 ) {
     echo "<TR>\n";

     if ($obj->id > 0 ) {
       submit_reset(0,1,1,1,1,0);
     } else {
       submit_reset(0,-1,1,1,1,0);
     }

     echo "</TR>\n";
   }
   echo "</TABLE>\n";
   echo "</FORM>\n";
   echo $lang['FldsRequired'] ."\n";
 }
 /** ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";

   echo bug::getSelectLink($current_user,$lang['Search'])."<BR>\n";

   if ( $current_user->feature_ok(usebugtracking,PERM_NEW) ) {
     echo menulink("bug_new.php",$lang['NewEntry'],$lang['CreateNewBug']) ."<BR>\n";
   }
   if ( $obj->id > 0 ) {
     if ( $tutos[bugdelete] == 1 ) {
       if ( $obj->del_ok() ) {
         echo confirmlink("bug_del.php?id=".$obj->id,$lang['Delete'],sprintf($lang['BugDeleteI'],$obj->getFullName())) ."<BR>";
       }
	 }
   }
   echo "<BR>\n";
   show_module_newlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }



 $b = new bug($dbconn);
 $b->newdesc = "";

 if ( isset($HTTP_GET_VARS['id']) ) {
   $b->read($HTTP_GET_VARS['id']);
   HTML_Header(sprintf($lang['BugModifyI'],$b->getFullName()));
 } else {
   HTML_Header($lang['BugCreate']);
 }

 if ( isset($HTTP_GET_VARS['description']) ) {
   $b->newdesc = StripSlashes($HTTP_GET_VARS['description']);
 }
 if ( isset($HTTP_GET_VARS['short']) ) {
   $b->short = StripSlashes($HTTP_GET_VARS['short']);
 }
 if ( isset($HTTP_GET_VARS['state']) ) {
   $b->state = $HTTP_GET_VARS['state'];
 }
 if ( isset($HTTP_GET_VARS['class']) ) {
   $b->class = $HTTP_GET_VARS['class'];
 }
 if ( isset($HTTP_GET_VARS['pid']) ) {
   $b->parent = getObject($dbconn,$HTTP_GET_VARS['pid']);
 } else {
 }

 # Get the solver
 preset_from_array_or_input($b,'solver',"s");

 if ( ! $b->mod_ok() ) {
   $msg .= sprintf($lang['Err0024'],$lang[$b->getType()]);
 }

 HTML_Base1();
 navigate($b);
 HTML_Base2($msg);
 if ( $b->mod_ok() ) {
   info($b);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: bug_new.php,v 1.35.2.1 2002/08/16 09:26:13 gokohnert Exp $
    $Author: gokohnert $
-->
