<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup bug
 * @module bug_overview
 * @package bug
 */
 include("webelements.p3");
 include("permission.p3");
 include("bug.pinc");
 include("product.pinc");
 include("timetrack.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("bug");

 /** ---------------------------------------------------------------------------
  * a sortable overview on a selection of bugs
  */
 Function info(&$dbconn,&$result,$start,$hidden) {
   global $lang,$tutos,$link1,$link2,$format,$filter;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   # Make a big array of all visible bugs
   $x = 0;
   while ( $x < $n ) {
     $b = new bug($dbconn);
     $b->read_result($result,$x);
     $x++;
     if ( ! $b->see_ok() ) {
       continue;
     }
     $blist[] = &$b;
     unset($b);
   }
   $n = count($blist);
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $tutos[massupdate] == 1 ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"bug_overview.php\">\n";
     echo $hidden;
     hiddenFormElements();
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }

   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("","ID",$link2);
   echo order_header("creation",$lang['Date'],$link2);
   echo order_header("",$lang['BugReference'],$link2);
   echo order_header("",$lang['BugShort'],$link2);
   echo order_header("state",$lang['BugState'],$link2);
   echo order_header("class",$lang['BugClass'],$link2);
   echo order_header("",$lang['BugCreator'],$link2);
   echo order_header("",$lang['BugAssignedTo'],$link2);
   if ( $tutos[massupdate] == 1 ) {
     echo "  <TH NOWRAP><INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\"></TH>\n";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $format == "paper" ) {
     $a = 0;
     $end = $n;
   } else if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $b = &$blist[$a];

     echo "<TR>\n";
	 $x = myentities($b->getFullName());
	 if ( $filter['name'] != "" ) {
	   $x = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$x);
	 }
     echo " <TD NOWRAP ALIGN=right>". makelink($b->getUrl(),$x) ."</TD>\n";

     echo " <TD>". $b->creation->getDate() ."</TD>\n";
     if ( $b->parent->id > 0 ) {
       echo " <TD>&nbsp;". $b->parent->getLink() ."</TD>\n";
     } else {
       echo " <TD>&nbsp;". $lang['HistoryDeleted'] ."</TD>\n";
     }

	 $x = myentities($b->short);
	 if ( $filter['name'] != "" ) {
	   $x = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$x);
	 }
     echo " <TD>&nbsp;". $x ."</TD>\n";

     echo " <TD>&nbsp;". $b->getState() ."</TD>\n";
     echo " <TD>&nbsp;". $b->getClass() ."</TD>\n";
     echo " <TD>&nbsp;". $b->creator->getLink($b->creator->getShortname()) ."</TD>\n";
     echo " <TD>&nbsp;". $b->solver->getLink($b->solver->getShortname()) ."</TD>\n";
     if ( $tutos[massupdate] == 1 ) {
       if ( $b->mod_ok() ) {
         echo " <TD><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $b->id ."\"></TD>\n";
       } else {
         echo "<TD>&nbsp;-&nbsp;</TD>";
       }
     }
     echo "</TR>\n";

     $a++;
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,8 + $tutos[massupdate] ,$start,$a,$n);

   if ( $tutos[massupdate] == 1 ) {
     echo "<TR>\n";
     echo "<TD ALIGN=right COLSPAN=7>\n";
     echo sprintf($lang['withmarked'],$lang['Bugs']);
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     if ( $tutos[bugdelete] == 1 ) {
       echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ."</OPTION>\n";
	 }
     @reset($lang['BugClasses']);
     while ( list ($f,$i) = @each ($lang['BugClasses']) ) {
       echo " <OPTION VALUE=\"C". $f ."\">". sprintf($lang['SetTo'],$lang['BugClass'],$i) ."</OPTION>\n";
     }
     @reset($lang['BugStates']);
     while ( list ($f,$i) = @each ($lang['BugStates']) ) {
       echo " <OPTION VALUE=\"S". $f ."\">". sprintf($lang['SetTo'],$lang['BugState'],$i) ."</OPTION>\n";
     }
     echo "</SELECT>\n";

     echo "</TD>\n";
     echo " <TD COLSPAN=2><INPUT type=submit value=\"". $lang['Enter'] ."\"></TD>\n";
     echo "</TR>\n";
   }
   echo "</TFOOT>\n";
   echo "</TABLE>\n";
   if ( $tutos[massupdate] == 1 ) {
     echo "</FORM>";
   }
 }
 /* ---------------------------------------------------------------------------
  * Statistical Bug Info
  */
 Function statinfo(&$dbconn,&$result,$filter) {
   global $lang,$tutos,$link,$format;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   $a = 0;

#   $linkt = "graph_timeline.php";
   $cmin = time();
   $cmax = -1;
   $tmin = time();
   $tmax = -1;
   $ttl = 0.0;
   $tts = 0.0;
   $ttc = 0.0;
   $ns = 0;
   $nc = 0;

   $cnt = 0;
   while ( $a < $n ) {
     $b = new bug($dbconn);
     $b->read_result($result,$a);
     $a++;

     if ( ! $b->see_ok() ) {
       unset($b);
       continue;
     }
     if ( !isset($states[$b->state]) ) {
       $states[$b->state] = 0;
     }
     if ( !isset($classes[$b->class]) ) {
       $classes[$b->class] = 0;
     }
     $states[$b->state]++;
     $classes[$b->class]++;
     $t1 = $b->creation->getTimestamp();
     $cmin = min($t1,$cmin);
     $tmin = min($t1,$tmin);
     $cmax = max($t1,$cmax);
     $tmax = max($t1,$tmax);

     if ( ($b->state == 3) && ($b->solvedate->notime != 1) ) {
       $t2 = $b->solvedate->getTimestamp();
       $tts += ( $t2 - $t1 );
       $tmax = max($t2,$tmax);
       $ns++;
     } else if ( ($b->state == 4) && ($b->solvedate->notime != 1)) {
       $t2 = $b->solvedate->getTimestamp();
       $ttc += ( $t2 - $t1 );
       $tmax = max($t2,$tmax);
       $nc++;
     } else {
       $t2 = time();
     }
     $ttl += ( $t2 - $t1 );
     $bl[] = &$b;
     $cnt++;
	 unset($b);
#	 echo "TTC: $ttc <BR>";
#	 echo "TTS: $tts <BR>";
#	 echo "TTL: $ttl <BR>";
   }

   # we need it 
   $b = new bug($dbconn);

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=5>". $lang['BugStatsTitle'] ."</TH>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['Count']);
   echo " <TD COLSPAN=4>". $cnt ."\n";

   $pre = "filterd by ";
   while ( list ($i,$f) = @each ($filter) ) {
     if ( $i == 'state' ) {
       echo $pre . $lang['BugState'];
       if ( $f == -2 ) {
         echo " ". $lang['BugAnyButClosed'];
       } else {
         echo " ". $lang['BugStates'][$f];
       }
     } else if ( $i == 'classes' ) {
       echo $pre . $lang['BugClass'];
       echo " ". $lang['BugClasses'][$f];
     } else if ( ($i == 'name') && ($f != "") ) {
       echo $pre . $lang['ProdDesc'];
       echo " ". $f;
     } else if ( $i == 'from' ) {
       echo $pre . $lang['DateTimeFrom'];
       echo " ". $f->getDateTime();
     } else if ( $i == 'to' ) {
       echo $pre . $lang['DateTimeTill'];
       echo " ". $f->getDateTime();
     } else if ( $i == 'product' ) {
       $p = getObject($dbconn,$f);
       echo $pre . $lang[$p->getType()];
       echo " ". $p->getLink();
     } else if ( $f != "" ) {
       echo $pre . $i;
       echo " ". $f;
     }
     $pre = " and ";
   }

   echo " </TD>\n";
   echo "</TR>\n";


   # Creation Times
   $c1 = new DateTime();
   $c2 = new DateTime();
   $t1 = new DateTime();
   $t2 = new DateTime();
   $c1->setDateTimeTS($cmin);
   $c2->setDateTimeTS($cmax);
   $t1->setDateTimeTS($tmin);
   $t2->setDateTimeTS($tmax);
   echo "<TR>\n";
   showfield($lang['BugBetween']);
   echo " <TD colspan=2>". $c1->getDateTime() ."</TD>\n";
   echo " <TD colspan=2>". $c2->getDateTime() ."</TD>\n";
   echo "</TR>\n";

   # Average Times
   echo "<TR>\n";
   showfield($lang['BugAverage']);
   echo " <TD colspan=\"4\">". sprintf($lang['BugAvgEnd'],($ttl /$cnt)/3600) ."<BR>\n";
   if ( $ns > 0 ) {
     echo sprintf($lang['BugAvgSolve'],($tts /$ns)/3600,$ns) ."<BR>\n";
   }
   if ( $nc > 0 ) {
     echo " ". sprintf($lang['BugAvgClose'],($ttc /$nc)/3600,$nc) ."\n";
   }
   echo "</TD></TR>\n";

   # State distribution
   $link = "graph_bars.php";
   $link = addSessionKey($link);
   $link = addUrlParameter($link,"type=pie");
   @reset($states);
   echo "<TR>\n";
   if ( !function_exists('ImageCreate') ) {
     echo " <TD VALIGN=top ROWSPAN=". count($states) ."><B>". $lang['BugState'] ."</B></TD>";
   } else {
     showfield($lang['BugState']);
   }
   $c = 0;
   while ( list ($i,$f) = @each ($states) ) {
     $val = number_format($f * 100.0 / $cnt ,2);
     if ( !function_exists('ImageCreate') ) {
       echo " <TD>". $lang['BugStates'][$i] ."</TD>\n";
       echo " <TD ALIGN=right>". $f ."</TD>\n";
       echo " <TD ALIGN=right>". $val ."%</TD>\n";
       echo "</TR>\n";
     }
     $link = addUrlParameter($link,"f[". $c ."]=".$val);
     $link = addUrlParameter($link,"t0[". $c ."]=". UrlEncode($lang['BugStates'][$i]));
     $link = addUrlParameter($link,"t1[". $c ."]=". $f );
     $link = addUrlParameter($link,"col[". $c ."]=". UrlEncode($b->c_state[$i]));
     $c++;
   }
   if ( function_exists('ImageCreate') ) {
     echo " <TD COLSPAN=4 VALIGN=top><IMG SRC=". $link ."></TD>";
     echo "</TR>\n";
   }

   echo "<TR>\n";
   echo " <TD>&nbsp;</TD>\n";
   echo " <TD COLSPAN=4>\n";
   echo " <TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
   echo " <TR>\n";
   echo "  <TH ALIGN=left>". $t1->getDateTime() ."</TH>\n";
   echo " </TR>\n";
   @reset($bl);
   $h = 10;
   $w = 400;
   $xx = ($tmax - $tmin) / $w;
   if ( $xx > 0 ) {
     while ( list ($i,$b) = @each ($bl) ) {
       $x1 = $b->creation->getTimeStamp();
       if ( ($b->state == 3) || ($b->state == 4) ) {
         $x2 = $b->solvedate->getTimeStamp();
       } else {
         $x2 = time();
       }
       if ( $x2 > $tmax ) {
         $x2 = $tmax;
       }
       $part1 = number_format(($x1 - $tmin) / $xx);
       $part2 = number_format(($x2 - $x1) / $xx);
       $part3 = number_format(($tmax - $x2) / $xx);

       if ( $part2 < 1 ) {
         $part2 = 1;
       }
       if ( ($part1 + $part2 + $part3) < ($w + 1) ) {
         $part3 = $w + 1 - $part2 - $part1;
       }

       echo " <TR>\n";
       echo "<TD WIDTH=". ($w +1) .">";
       if ( $part1 > 0 ) {
         $text = "<IMG BORDER=0 SRC=\"". $tutos['base'] ."/html/white.png\" WIDTH=". $part1 ." HEIGHT=". $h .">";
         echo makelink($b->getURL(),$text,sprintf($lang['BugShow'],$b->getFullName()) );
       }
       $text = "<IMG BORDER=0 SRC=\"". $tutos['base'] ."/html/". $b->c_state[$b->state] .".png\" WIDTH=". $part2 ." HEIGHT=". $h .">";
       echo makelink($b->getURL(),$text,sprintf($lang['BugShow'],$b->getFullName()) );

       if ( $part3 > 0 ) {
         $text = "<IMG BORDER=0 SRC=\"". $tutos['base'] ."/html/white.png\" WIDTH=". $part3 ." HEIGHT=". $h .">";
         echo makelink($b->getURL(),$text,sprintf($lang['BugShow'],$b->getFullName()) );
       }
       echo "</TD>\n";
       echo " </TR>\n";
     }
   }
   echo " <TR>\n";
   echo "  <TH ALIGN=right>". $t2->getDateTime() ."</TH>\n";
   echo " </TR>\n";
   echo " </TABLE>\n";
   echo " </TD>\n";
   echo "</TR>\n";

   # Class distribution
   $b = new bug($dbconn);
   $link = "graph_bars.php";
   $link = addSessionKey($link);
   $link = addUrlParameter($link,"type=pie");
   @reset($classes);
   echo "<TR>\n";
   if ( !function_exists('ImageCreate') ) {
     echo " <TD VALIGN=top ROWSPAN=". count($classes) ."><B>". $lang['BugClass'] ."</B></TD>";
   } else {
     showfield($lang['BugClass']);
   }
   $c = 0;
   while ( list ($i,$f) = @each ($classes) ) {
     $val = number_format($f * 100.0 / $cnt ,2);
     if ( !function_exists('ImageCreate') ) {
       echo " <TD>". $lang['BugClasses'][$i] ."</TD>\n";
       echo " <TD ALIGN=right>". $f ."</TD>\n";
       echo " <TD ALIGN=right>". $val ."%</TD>\n";
       echo "</TR>\n";
     }
     $link = addUrlParameter($link,"f[". $c ."]=".$val);
     $link = addUrlParameter($link,"t0[". $c ."]=". UrlEncode($lang['BugClasses'][$i]));
     $link = addUrlParameter($link,"t1[". $c ."]=". $f );
     $link = addUrlParameter($link,"col[". $c ."]=". UrlEncode($b->c_class[$i]));
     $c++;
   }
   if ( function_exists('ImageCreate') ) {
     echo " <TD COLSPAN=4 VALIGN=top><IMG SRC=". $link ."></TD>";
     echo "</TR>\n";
   }

   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate($link1) {
   global $current_user,$lang, $format;

   echo "<TABLE>";
   echo "<TR><TD>";

   echo bug::getSelectLink($current_user,$lang['Search'])."<BR>\n";

   if ( $current_user->feature_ok(usebugtracking,PERM_NEW) ) {
     echo menulink("bug_new.php",$lang['NewEntry'],$lang['CreateNewBug']) ."<BR>\n";
   }

   echo "<BR>\n";
   if ( $format != "stat" ) {
     $l = addUrlParameter($link1,"format=paper");
     echo menulink($l,$lang['Printable'],$lang['PrintableInfo']);
     echo "<BR>\n";
     $l = addUrlParameter($link1,"format=stat");
     echo menulink($l,$lang['BugStats'],$lang['BugStatsInfo']);
   } else {
     echo $lang['BugStats'];
   }
   echo "</TD></TR>";

   HTML_Select();
 }


 # Perform possible actions
 if ( isset($HTTP_GET_VARS['mark']) && isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = new bug($dbconn);
       $b->read($val);
       if ( $b->id != $val ) {
         continue;
	   }
       if ( $b->del_ok() ) {
         $msg .= sprintf($lang['BugDeleteI'], $b->getFullName()) ."<BR>";
         $msg .= $b->delete();
	   } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0023'],$lang[$b->getType()]) ."<BR>\n";
	   }
       unset($p);
     }
     $dbconn->Commit("WORK");
   } else if ( ereg("^([SC])(.*)",$HTTP_GET_VARS['action'],$a) ) {
     # Setting State or Class

     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = new bug($dbconn);
       $b->read($val);
       if ( $b->id != $val ) {
         continue;
	   }
       if ( $b->mod_ok() ) {
         if ( $a[1] == "S" ) {
           $msg .= $b->getLink() ." ". $lang['BugState'] ." = ". $lang['BugStates'][$a[2]] ."<BR>";
           $msg .= $b->setState($a[2]);
         } else if ( $a[1] == "C" ) {
           $msg .= $b->getLink() ." ". $lang['BugClass'] ." = ". $lang['BugClasses'][$a[2]] ."<BR>";
           $msg .= $b->setClass($a[2]);
         } else {
           $msg .= "A:".$HTTP_GET_VARS['action'] ." M: '". $val[1] ."'  V:". $val[2] ."<BR>";
		 }
         $msg .= $b->save();
	   } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0024'],$lang[$b->getType()])."<BR>\n";
	   }
       unset ($p);
     }
     $dbconn->Commit("WORK");
   }
 }

 $link1 = "bug_overview.php";
 $hidden = "";
 $filter = array();
 $format = "";

 if ( isset($HTTP_GET_VARS['format']) ) {
   $format = $HTTP_GET_VARS['format'];
   $link1 = addUrlParameter($link1,"format=".UrlEncode($format));
 }
 if ( isset($HTTP_GET_VARS['id']) ) {
   $id = $HTTP_GET_VARS['id'];
 }
 if ( isset($HTTP_GET_VARS['pid']) ) {
   $pid = $HTTP_GET_VARS['pid'];
 }
 if ( isset($HTTP_GET_VARS['solverid']) ) {
   $solverid = $HTTP_GET_VARS['solverid'];
 }
 if ( isset($HTTP_GET_VARS['state']) ) {
   $state = $HTTP_GET_VARS['state'];
 } else {
   $state = "";
 }
 if ( isset($HTTP_GET_VARS['class']) ) {
   $class = $HTTP_GET_VARS['class'];
 } else {
   $class = "";
 }
 if ( isset($HTTP_GET_VARS['name']) ) {
   $name = $HTTP_GET_VARS['name'];
 } else {
   $name = "";
 }
 $filter['name'] = "";

 $q = "SELECT * FROM bugs ";
 $pre = " WHERE ";

 if ( ($name != "*") && ($name != "") ) {
   $q .= " " . $pre ."(". $dbconn->Like("description",$name) ." OR ". $dbconn->Like("short",$name) ." OR ". $dbconn->Like("id",$name)." OR ". $dbconn->Like("name",$name) .")";
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"name=".UrlEncode($name));
   $hidden .= "<INPUT TYPE=hidden NAME=\"name\" VALUE=\"". $name ."\">\n";
   $filter['name'] = $name;
 }

 if ( isset($id) ) {
   $q .= " ". $pre ." id = ".$id;
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"id=". $id);
   $hidden .= "<INPUT TYPE=hidden NAME=\"id\" VALUE=\"". $id ."\">\n";
 }
 # States to display
 if ( $state == -2 )  {
   $q .= " ". $pre ." state != 3";
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"state=". $state);
   # remember this
   $HTTP_SESSION_VARS['bugsearchstate'] = $state;

   $filter['state'] = $state;
   $hidden .= "<INPUT TYPE=hidden NAME=\"state\" VALUE=\"". $state ."\">\n";
 } else if ( $state > 0 )  {
   $q .= " ". $pre ." state=".$state;
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"state=". $state);
   # remember this
   $HTTP_SESSION_VARS['bugsearchstate'] = $state;
   $filter['state'] = $state;
   $hidden .= "<INPUT TYPE=hidden NAME=\"state\" VALUE=\"". $state ."\">\n";
 }
 # Classes to display
 if ( $class > 0 ) {
   $q .= " ". $pre ." class=". $class;
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"class=". $class);
   # remember this
   $HTTP_SESSION_VARS['bugsearchclass'] = $class;
   $filter['classes'] = $class;
   $hidden .= "<INPUT TYPE=hidden NAME=\"class\" VALUE=\"". $class ."\">\n";
 }
 # Product to display
 if ( isset($pid) ) {
   $q .= $pre ." product_id = ". $pid;
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"pid=". $pid);
   $filter['product'] = $pid;
   $hidden .= "<INPUT TYPE=hidden NAME=\"pid\" VALUE=\"". $pid ."\">\n";
 }

 # Start Date for search
 $from = new DateTime(0);
 if ( isset($HTTP_GET_VARS['fd']) ) {
   $from->setDateTime($HTTP_GET_VARS['fd']);
 } else {
   $from->setDateTimeF("f");
   # remember this
   $HTTP_SESSION_VARS['bugsearchfrom'] = $from->getYYYYMMDD();
 }
 if ( $from->notime != 1 ) {
   $q .= $pre ."(creation >= ". $dbconn->Date($from) .")";
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"fd=".$from->getYYYYMMDD());
   $filter['from'] = $from;
   $hidden .= "<INPUT TYPE=hidden NAME=\"fd\" VALUE=\"". $from->getYYYYMMDD() ."\">\n";
 }
 # End Date for search
 $to = new DateTime(0);
 if ( isset($HTTP_GET_VARS['td']) ) {
   $to->setDateTime($HTTP_GET_VARS['td']);
 } else {
   $to->setDateTimeF("t");
   # remember this
   $HTTP_SESSION_VARS['bugsearchto'] = $to->getYYYYMMDD();
 }
 if ( $to->notime != 1 ) {
   $q .= $pre ."(creation <= ". $dbconn->Date($to) .")";
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"td=".$to->getYYYYMMDD());
   $filter['to'] = $to;
   $hidden .= "<INPUT TYPE=hidden NAME=\"td\" VALUE=\"". $to->getYYYYMMDD() ."\">\n";
 }

 # user to display
 if ( isset($solverid) ) {
   $q .= $pre ." solver = ". $solverid;
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"solverid=". $solverid);
   $filter['solver'] = $solverid;
   $hidden .= "<INPUT TYPE=hidden NAME=\"solverid\" VALUE=\"". $solverid ."\">\n";
 }


 # sorting
 $xxx = "";
 $link2 = $link1;
 order_parse($q,$link1,$xxx,$hidden,"state,creation");

 $result = $dbconn->Exec($q);

 if ( ! isset($HTTP_GET_VARS['start']) ) {
   $start = 0;
 } else {
   $start = $HTTP_GET_VARS['start'];
 }
 if ( ($format == "") && ($result->numrows() == 1) ) {
   $b = new bug($dbconn);
   $b->read_result($result,0);
   Header("Location: ". getBaseUrl() . addSessionKey("bug_show.php?id=".$b->id));
   $dbconn->Close();
   exit;
 }

 if ( ($format == "") || ($format == "stat")) {
   if ( $format == "stat") {
     HTML_Header($lang['BugStatsTitle']);
   } else {
     HTML_Header($lang['BugsOverview']);
   }
   HTML_Base1();
   navigate($link1);
   HTML_Base2($msg);
 } else if ( $format == "paper" ) {
   Printable_Header($lang['BugsOverview']);
 }
 if ( $format == "stat") {
   statinfo($dbconn,$result,$filter);
 } else {
   info($dbconn,$result,$start,$hidden);
 }
 if ( ($format == "") || ($format == "stat")) {
   HTML_Base3();
 }

 $dbconn->Close();
 $result->free();
?>
<!--
    CVS Info:  $Id: bug_overview.php,v 1.44.2.5 2002/09/09 17:46:11 gokohnert Exp $
    $Author: gokohnert $
-->
