<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup bug
 * @module bug_show
 * @package bug
 */
 include("webelements.p3");
 include("permission.p3");
 include("bug.pinc");
 include("product.pinc");
 include("installation.pinc");
 include("task.pinc");
 include("timetrack.pinc");
 include 'file.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("bug");

 /** ---------------------------------------------------------------------------
  * shows all data of an bug
  */
 Function info(&$b) {
   global $tutos,$lang,$current_user;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=4>". sprintf($lang['Showing'],$lang['Bug'] ." ". $b->getFullName()) ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   showfield($lang['createdby']);
   echo " <TD>". $b->creator->getLink() ."</TD>\n";
   showfield($lang['atDateTime']);
   echo " <TD>". $b->creation->getDateTime() ."</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['BugID']);
   echo " <TD COLSPAN=3>". myentities($b->name) ."</TD>\n";

   echo "</TR><TR>\n";
   if ( $b->state == 3 ) {
     showfield($lang['BugSolvedBy']);
   } else if ( $b->state == 4 )  {
     showfield($lang['BugClosedBy']);
   } else {
     showfield($lang['BugAssignedTo']);
   }
   if ( $b->solver->id > 0 ) {
     echo " <TD>". $b->solver->getMailLink("",$b->solver->getFullName()) ."</TD>\n";
   } else {
     echo " <TD>not solved</TD>\n";
   }
   showfield($lang['atDateTime']);
   if ( isset($b->solvedate) ) {
     echo "<TD>". $b->solvedate->getDateTime() ."</TD>\n";
   } else {
     echo " <TD>&nbsp;</TD>\n";
   }

   echo "</TR><TR>\n";


   if ( $b->parent->id > 0 ) {
     showfield($lang[$b->parent->getType()]);
     echo  "<TD COLSPAN=3>". $b->parent->getLink() ."</TD>\n";
   } else {
     showfield($lang['ProductP']);
     echo " <TD COLSPAN=3>". $lang['HistoryDeleted'] ."</TD>\n";
   }


   echo "</TR><TR>\n";
   showfield($lang['BugState']);
   echo " <TD>". $b->getState() ."</TD>\n";
   showfield($lang['BugClass']);
   echo " <TD>". $b->getClass() ."</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['BugShort']);
   echo " <TD COLSPAN=3>". myentities($b->short) ."</TD>\n";

   if ( $current_user->feature_ok(usetimetrack,PERM_SEE) ) {
     $b->readTimetrackSum();
     if ( $b->timetracksum > 0) {
       echo "<TR>\n";
       showfield($lang['Timetrack']);
       echo " <TD VALIGN=top COLSPAN=3>\n";
       echo makelink("timetrack_overview.php?link_id=". $b->id ,number_format($b->timetracksum,2),$lang['TimetrackOverview']);
       echo "&nbsp;". $lang['hours'] ."</TD>\n";
       echo "</TR>\n";
     }
   }

   echo "</TR><TR>\n";
   showfield($lang['BugHistory']);
   echo " <TD CLASS=pre COLSPAN=3>";
   echo "<PRE>\n". urlReplace($b->description,0) ."\n</PRE></TD>\n";
   echo "</TR>\n";

   tutos_file::infolist($current_user,$b,4);

   # References to modules
   show_module_infolists($current_user,$b,4);

   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD NOWRAP>";
   echo bug::getSelectLink($current_user,$lang['Search'])."<BR>\n";

   if ( $current_user->feature_ok(usebugtracking,PERM_NEW) ) {
     echo menulink("bug_new.php",$lang['NewEntry'],$lang['CreateNewBug']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usebugtracking,PERM_MOD) ) {
     if ( $obj->mod_ok() ) {
       echo menulink("bug_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['BugModifyI'],$obj->getFullName())) ."<BR>\n";
     } else {
       echo "<BR>\n";
     }
   }
   echo "<BR>\n";
   echo tutos_file::getaddlink($current_user,$obj);
   echo timetrack::getaddlink($current_user,$obj);
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }


 $b = new bug($dbconn);
 if ( isset($HTTP_GET_VARS['id']) ) {
   $b->read($HTTP_GET_VARS['id']);
 }
 HTML_Header($lang['BugsDetail']." :". $b->getFullName());

 if ( ! $b->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$b->getType()]);
 } else {
   if ( $b->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$b->getType()]);
   }
 }
 HTML_Base1();
 navigate($b);
 HTML_Base2($msg);
 if ( ($b->id > 0) && $b->see_ok() ) {
   info($b);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: bug_show.php,v 1.34 2002/07/24 17:03:05 gokohnert Exp $
    $Author: gokohnert $
-->
