<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup appointment
 * @module calendar
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("appointment");


 /* ---------------------------------------------------------------------------
  * Display some navigational links
  * t format YYYYMMDD of the current start date
  *
  */
 Function navigate2($t,$team,$teamname,$id = -1) {
   global $tutos, $lang, $current_user;

   $ts = mktime(0,0,0,substr($t,4,2),substr($t,6,2),substr($t,0,4));
   $last_week = Date("Ymd",$ts -  7 * 86400);
   $next_week = Date("Ymd",$ts +  7 * 86400);
   $last_month = Date("Ymd",$ts -  28 * 86400);
   $next_month = Date("Ymd",$ts +  28 * 86400);

   echo "<FORM ACTION=\"calendar.php\" method=\"GET\">\n";
   echo "<TABLE CELLPADDING=0 CELLSPACING=0 WIDTH=\"100%\" BORDER=0>\n";
   echo "<TR>\n";
   echo " <TD CLASS=navigate ROWSPAN=2 NOWRAP>\n";

   hiddenFormElements();
   # Display for current time
   echo "  <INPUT type=hidden name=t value=". $t .">\n";
   if ( $id > 0 ) {
     echo "  <INPUT type=hidden name=id value=". $id .">\n";
   }

   echo "&nbsp;". $lang['forphrase'] ."\n";
   cal_options($team,$teamname);
   echo " </TD>\n";


   echo "  <TD NOWRAP CLASS=navigate align=right>". menulink("calendar.php?t=". $last_week,$tutos[image][left],$lang['lastweek']) ."</TD>\n";
   echo "  <TD NOWRAP CLASS=navigate align=left>". menulink("calendar.php?t=". $last_week,$lang['lastweek'],$lang['lastweek']) ."</TD>\n";
   echo "  <TD NOWRAP CLASS=navigate align=CENTER>". menulink("calendar.php?t=$t",$lang['reload']) ."</TD>\n";
   echo "  <TD NOWRAP CLASS=navigate align=right>". menulink("calendar.php?t=". $next_week,$lang['nextweek'],$lang['nextweek']) ."</TD>\n";
   echo "  <TD NOWRAP CLASS=navigate align=left>". menulink("calendar.php?t=". $next_week,$tutos[image][right],$lang['nextweek']) ."</TD>\n";

   echo " </TR>\n";
   echo " <TR>\n";

   echo "  <TD NOWRAP CLASS=navigate align=right>". menulink("calendar.php?t=". $last_month,$tutos[image][left].$tutos[image][left],$lang['minus4weeks']) ."</TD>\n";
   echo "  <TD NOWRAP CLASS=navigate align=left>". menulink("calendar.php?t=". $last_month,$lang['minus4weeks'],$lang['minus4weeks']) ."</TD>\n";
   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo "  <TD NOWRAP CLASS=navigate align=CENTER>". menulink("app_new.php?t=".$t,$lang['NewAppoint'],$lang['NewAppointInfo']) ."</TD>\n";
   } else {
     echo "  <TD NOWRAP CLASS=navigate align=CENTER>&nbsp;</TD>\n";
   }
   echo "  <TD NOWRAP CLASS=navigate align=right>". menulink("calendar.php?t=". $next_month,$lang['plus4weeks'],$lang['plus4weeks']) ."</TD>\n";
   echo "  <TD NOWRAP CLASS=navigate align=left>". menulink("calendar.php?t=". $next_month,$tutos[image][right].$tutos[image][right],$lang['plus4weeks']) ."</TD>\n";
   echo " </TR>\n";
   echo "</TABLE>\n";
   echo "</FORM>";
 };

 /* ---------------------------------------------------------------------------
  * Display One Weeks appointments (including s) starting with Monday or Sunday
  * t format YYYYMMDD
  *
  */
 Function Cal_Week (&$dbconn,$t) {
   global $team,$uids,$lang, $tutos,$current_user;

   $ts = mktime(12,0,0,substr($t,4,2),substr($t,6,2),substr($t,0,4));

   /* Back to last weekstart day before ts */
   while ( Date("w",$ts) != $current_user->weekstart ) {
     $ts -= 86400;
   }

   $w0 =  (( 1 + Date("w",mktime(12,0,0,1,1, Date("Y",$ts) ) )) % 7) > 3;
   $wn = sprintf("%02d", Round( (Date("z",$ts)+7 ) / 7) );
   $yy = Date("y",$ts);
   echo " <TD CLASS=week WIDTH=\"5%\">". menulink("calendar_week.php?t=".Date("Ymd",$ts)."&team=". $team, $wn ."/". $yy, $wn ."/". $yy ) ."</TD>\n";

   /* Select appointments for this day */
   $from =  new DateTime();
   $from->setDateTimeTS($ts - 12 * 3600);
   $to = $from;
   $to->addDays(7);

   $current_user->callist = array();
   appointment::readCal($current_user,$from,$to);
   @reset($tutos[activemodules]);
   while( list ($i,$f) = @each ($tutos[activemodules])) {
     $x = new $f($current_user->dbconn);
     $x->readCal($current_user,$from,$to);
   }

   $dd = new DateTime();
   $day = 0;
   while ( $day < 7 ) {
     # $d = strftime($lang['DateFormatStr'],$ts);
	 $dd->setDateTimeTS($ts);
     $d = $dd->getDate();
     $tref = Date("Ymd",$ts);
     $next = NextDay($ts);
     # Check for workday
     if ( ! $dd->isWorkDay($current_user) ) {
       $ts = $next;
       $day++;
       continue;
     }
     $dinfo = GetDaysInfo($ts);

     echo "<TD CLASS=\"". $dinfo[color] ."\" WIDTH=\"10%\">\n";

     if ( isset($dinfo[Desc]) ) {
       if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
         echo " " . makelink("app_new.php?t=". $tref,$d,$lang['NewAppointInfo'],$dinfo[popinfo]) ."\n";
       } else {
         echo " " . $d ."\n";
       }
       echo "<BR><FONT SIZE=-1>". $dinfo[Desc] ."</FONT>\n";
     } else {
       if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
         echo " " . makelink("app_new.php?t=". $tref,$d,$lang['NewAppointInfo']) ."\n";
	   } else {
         echo " " . $d ."\n";
       }
     }
     $hastable = 0;
     $a = 0;

     $x = count( $current_user->callist );
     for ( $idx = 0 ; $idx < $x ; $idx++) {
       /* the correct day */
       if ( ! $current_user->callist[$idx]->inside($dd) ) {
         continue;
       }
       if (!cal_check_against_list($current_user->callist[$idx],$uids)) {
         continue;
       }

       if ( $hastable == 0 ) {
         if ( $tutos[caltable] == 2 ) {
           echo "<TABLE CELLSPACING=0 CELLPADDING=1 BORDER=0 WIDTH=\"100%\"><TR><TD>";
         }
         echo "\n <TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0 WIDTH=\"100%\">\n";
         $hastable = 1;
       } else {
         echo "  <TR><TD CLASS=". $dinfo[color] ." COLSPAN=3><IMG SRC=\"". $tutos['base'] ."/html/black.png\" WIDTH=\"100%\" HEIGHT=1></TD></TR>\n";
       }
       $current_user->callist[$idx]->formatted();
       $a++;
     }

     if ( $hastable == 1 ) {
       if ( $tutos[caltable] == 2 ) {
         echo "   </TABLE>\n";
         echo "  </TD>\n";
         echo " </TR>\n";
       }
       echo "</TABLE>\n";
     }
     while ( $a < 2 ) {
       echo " <BR>\n";
       $a++;
     }

     echo "</TD>\n";

     /* Next Day */
     $day++;
     $ts = $next;
   }

   return(Date("Ymd",$ts));
 };

/* --------------------------------------------------------------------------- */

 Function info($t,$team,$teamname,$id) {
   global $current_user , $tutos , $lang;

   $weeks = $current_user->get_prefweeks();

   navigate2($t,$team,$teamname,$id);
   if ( $tutos[caltable] == 2 ) {
     echo "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 WIDTH=\"100%\"><TR><TD>\n";
   }
   echo "<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=1 WIDTH=\"100%\">\n";

   echo " <TR>\n";
   echo "  <TH>". $lang['week'] ."</TH>\n";
   if ( $current_user->weekstart == 0 ) {
     if ($current_user->isWorkDay(0)) {
       echo "  <TH>". $lang['Day0'] ."</TH>\n";
     }
   }
   if ($current_user->isWorkDay(1)) {
     echo "  <TH>". $lang['Day1'] ."</TH>\n";
   }
   if ($current_user->isWorkDay(2)) {
     echo "  <TH>". $lang['Day2'] ."</TH>\n";
   }
   if ($current_user->isWorkDay(3)) {
     echo "  <TH>". $lang['Day3'] ."</TH>\n";
   }
   if ($current_user->isWorkDay(4)) {
     echo "  <TH>". $lang['Day4'] ."</TH>\n";
   }
   if ($current_user->isWorkDay(5)) {
     echo "  <TH>". $lang['Day5'] ."</TH>\n";
   }
   if ($current_user->isWorkDay(6)) {
     echo "  <TH>". $lang['Day6'] ."</TH>\n";
   }
   if ( $current_user->weekstart != 0 ) {
     if ($current_user->isWorkDay(0)) {
       echo "  <TH>". $lang['Day0'] ."</TH>\n";
     }
   }

   $t2 = $t;
   for ($i = 0; $i < $weeks; $i++) {
     echo " </TR><TR>\n";
     $t2 = Cal_Week($current_user->dbconn,$t2);
   }

   echo " </TR>\n";

   echo "</TABLE>\n";

   if ( $tutos[caltable] == 2 ) {
     echo "</TD></TR></TABLE>\n";
   }
 }
/* --------------------------------------------------------------------------- */
 Function navigate() {
   global $current_user , $tutos , $lang;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(usecalendar,PERM_SEL) ) {
     echo menulink("app_select.php",$lang['Search'],$lang['SearchForApp']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo menulink("app_new.php" ,$lang['NewEntry'],$lang['NewAppointInfo']) . "<BR>";
     echo menulink("app_new_r.php" ,$lang['NewAppointR'],$lang['NewAppointInfoR']) . "<BR>";
   }
   echo "</TD></TR>";

   HTML_Select();
 }
/* --------------------------------------------------------------------------- */
 $teamname = "";
 $start_ts = time();
 HTML_Header($lang['Appointments']);

 /* If no starting time is given */
 /* default is this week         */
 if ( isset($HTTP_GET_VARS['t']) ) {
   $t = $HTTP_GET_VARS['t'];
 } else {
   $t = Date("Ymd");
 }
 
 $uids = cal_parse_options($current_user,$teamname);
 $team = $current_user->get_prefteam();


 /* Show a calendar containing Appointment id */
 if ( isset($HTTP_GET_VARS['id']) ) {
   $id = $HTTP_GET_VARS['id'];
   $query = "SELECT a_start FROM calendar where id =". $id;
   $result = $dbconn->Exec($query);
   if ( 1 != $result->numrows()) {
     echo "<SPAN class=warn>". sprintf($lang['Err0040'],$lang['Appointment']) ."</SPAN>";
     HTML_Footer();
     $dbconn->Close();
     exit;
   }
   $d = new DateTime($result->get(0, "a_start"));
   $t = $d->getYYYYMMDD();
   $result->free();
 } else {
   $id = -1;
 }


 if ( $tutos[oldcallayout] == 1 ) {
   if ( $msg != "" ) {
     echo "<SPAN CLASS=warn>". StripSlashes($msg) ."</SPAN>\n";
   }
   info($t,$team,$teamname,$id);
   HTML_Footer();
 } else {
   HTML_Base1();
   navigate();
   HTML_Base2($msg);
   info($t,$team,$teamname,$id);
   HTML_Base3();
 }
 $dbconn->Close();
# echo time() - $start_ts;
?>
<!--
    CVS Info:  $Id: calendar.php,v 1.48.2.1 2002/08/05 19:11:14 gokohnert Exp $
    $Author: gokohnert $
-->
