<?
/*
 * Copyright 2002 by Gero Kohnert
 *
 * a calendar for a single day
 *
 * @modulegroup appointment
 * @module calendar_day
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("appointment");

 /* ---------------------------------------------------------------------------
  * A one day calendar sheet
  */
 Function info($t,$team,$teamname,&$uids) {
   global $lang,$current_user,$tutos;

   $ts = mktime(12,0,0,substr($t,4,2),substr($t,6,2),substr($t,0,4));
   $from = new DateTime();
   $from->setDateTimeTS($ts);


   $last_day = $from;
   $next_day = $from;
   $next_day->addDays(1);
   $last_day->addDays(-1);

   $wn = sprintf("%02d", Round( (Date("z",$ts)+7 ) / 7) );
   $yy = Date("y",$ts);

#   echo $last_day->getDateTime() ."<BR>";
#   echo $next_day->getDateTime() ."<BR>";
#   echo $from->getDateTime() ."<BR>";

   $current_user->callist = array();
   appointment::readCal($current_user,$from,$next_day);
   @reset($tutos[activemodules]);
   while( list ($i,$f) = @each ($tutos[activemodules])) {
     $x = new $f($current_user->dbconn);
     $x->readCal($current_user,$from,$next_day);
   }

   for ($i = -1 ; $i < 24 ; $i++ ) {
     $table[$i] = array();
   }

   $x = count( $current_user->callist );
   for ( $a = 0 ; $a < $x ; $a++) {
     if ( ! $current_user->callist[$a]->inside($from)) {
       continue;
     }
     if (!cal_check_against_list($current_user->callist[$a],$uids)) {
       continue;
     }
     if ( $current_user->callist[$a]->gettype() == "note" ) {
       $table[-1][] = &$current_user->callist[$a];
       $rowspan[-1][] = 1;
       continue;
     }
     if ( $current_user->callist[$a]->t_ignore == 1) {
       $table[-1][] = &$current_user->callist[$a];
       $rowspan[-1][] = 1;
	   continue;
     }
#     echo  $current_user->callist[$a]->s_out ."<BR>";
     if ( ($current_user->callist[$a]->s_out == 1) && ($current_user->callist[$a]->e_out == 1) ) {
       $table[-1][] = &$current_user->callist[$a];
       $rowspan[-1][] = 1;
	   continue;
     }
     $x1 = Date("G",$current_user->callist[$a]->start->getTimeStamp());
     $x2 = Date("G",$current_user->callist[$a]->end->getTimeStamp());

     if ( $current_user->callist[$a]->s_out == 1 ) {
       $x1 = 0;
     }
     if ( $current_user->callist[$a]->e_out == 1 ) {
       $x2 = 23;
     }
     # find a free position
     $pos = -1;
     $found = false;
     while ( $found == false ) {
       $found = true;
       $pos ++;
       for ( $i = $x1; $i <= $x2 ; $i++ ) {
         if (isset($table[$i][$pos]) ) {
           $found = false;
		   continue;
		 }
	   }
	 }
	 for ( $i = $x1; $i <= $x2 ; $i++ ) {
       if ( $i == $x1 ) {
         $table[$i][$pos] = &$current_user->callist[$a];
#         echo ($x2 - $x1) ." ". $x1 ." ". $x2 ." ". $pos ."<BR>";
		 $rowspan[$i][$pos] = ($x2 - $x1 +1);
	   } else {
         $table[$i][$pos] = -1;
	   }
	 }
   }

   $maxcol = 1;
   for ($i = -1 ; $i < 24 ; $i++ ) {
     $maxcol = max($maxcol,count($table[$i]));
   }
   echo "<FORM ACTION=\"calendar_day.php\" method=\"GET\">\n";
   hiddenFormElements();
   echo "  <INPUT type=hidden name=t value=". $t .">\n";

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=\"90%\">\n";
   echo " <TR>\n";
   echo "  <TH ALIGN=left nowrap COLSPAN=". ($maxcol +1) .">&nbsp;". $lang['forphrase'] ."\n";
   cal_options($team,$teamname);
   echo "  </TH>\n";
   echo " </TR>\n";
   echo " <TR>\n";
   echo " <TH nowrap COLSPAN=". ($maxcol +1) ." WIDTH=\"100%\">";
   echo menulink("calendar_day.php?t=".$last_day->getYYYYMMDD(),$tutos[image][left],$last_day->getDate());
   echo "&nbsp;". strftime($lang['DateFormatTitle'],$from->ts) ."&nbsp;(". $lang['week']." ". menulink("calendar_week.php?t=".Date("Ymd",$from->ts), $wn ."/". $yy, $wn ."/". $yy ) .")&nbsp;";
   echo menulink("calendar_day.php?t=".$next_day->getYYYYMMDD(),$tutos[image][right],$next_day->getDate());
   echo "</TH></TR>\n";
#   echo " <TR>\n";
#   echo " <TH WIDTH=\"10%\">&nbsp;</TH>\n";
#   echo " <TH WIDTH=\"100%\" COLSPAN=". $maxcol .">". $lang['Appointment']. "</TH></TR>\n";
   for ($i = -1 ; $i <24 ; $i++ ) {
     echo " <TR>\n";

     echo " <TH WIDTH=\"10%\" ALIGN=right VALIGN=top>\n";
	 if ( $i == -1 ) {
       echo  menulink("app_new.php?t=".$t, "NOTIME",$lang['NewAppointInfo']);
	 } else {
       echo  menulink("app_new.php?start=". $t.sprintf("%02d",$i)."00&end=".$t.sprintf("%02d",$i)."59" ,sprintf("%02d", $i).":00",$lang['NewAppointInfo']);
	 }
     echo "&nbsp;</TH>\n";

     for ($c = 0 ; $c < $maxcol ; $c++ ) {
	   if ( isset ( $table[$i][$c] ) ) {
         if ( is_object ( $table[$i][$c] ) ) {
           echo " <TD CLASS=\"line". (1+($i % 2)) ."\" VALIGN=top ROWSPAN=\"". $rowspan[$i][$c]."\">";
           echo "<IMG HEIGHT=1 WIDTH=100% SRC=\"". $tutos['base'] ."/html/black.png\"><BR>";
           echo "&nbsp;<CENTER><TABLE WIDTH=\"80%\" BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
           echo $table[$i][$c]->formatted();
           echo " </TABLE></CENTER></TD>\n";
		 } else if ( $table[$i][$c] = -1 ) {
           # SKIP occupied by rowspan
		 }
	   } else {
         echo "<TD CLASS=\"line". (1+($i % 2)) ."\" VALIGN=top><IMG HEIGHT=1 WIDTH=100% SRC=\"". $tutos['base'] ."/html/black.png\"></TD>";
	   }
	 }
     echo " </TR>\n";
   }
   echo "</TABLE>\n";
   echo "</FORM>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $tutos, $lang , $current_user;
   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(usecalendar,PERM_SEL) ) {
     echo menulink("app_select.php",$lang['Search'],$lang['SearchForApp']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo menulink("app_new.php" ,$lang['NewEntry'],$lang['NewAppointInfo']) . "<BR>";
     echo menulink("app_new_r.php" ,$lang['NewAppointR'],$lang['NewAppointInfoR']) . "<BR>";
   }
   echo "</TD></TR>";

   HTML_Select();
 }

 HTML_Header($lang['Appointments']);

 if ( ! isset ($HTTP_GET_VARS['t']) ) {
   $t = Date("Ymd");
 } else {
   $t = $HTTP_GET_VARS['t'];
 }

 $uids = cal_parse_options($current_user,$teamname);

 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($t,$current_user->get_prefteam(),$teamname,$uids);
 HTML_Base3();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: calendar_day.php,v 1.13.2.1 2002/08/05 19:11:14 gokohnert Exp $
    $Author: gokohnert $
-->
