<?
/**
 * Copyright 2001 - 2002 by Gero Kohnert
 *
 * A calendar for one week
 *
 * @modulegroup appointment
 * @module calendar_week
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("product.pinc");
 include("task.pinc");
 include("bug.pinc");
 include("timetrack.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("appointment");

 /* ---------------------------------------------------------------------------
  * A one week calendar sheet
  */
 Function info($t,$team,$teamname,&$uids) {
   global $lang,$current_user,$tutos;


   $adr = $current_user;
   $ts = mktime(12,0,0,substr($t,4,2),substr($t,6,2),substr($t,0,4));

   /* Back to last Monday or Sunday before ts */
   while ( Date("w",$ts) != $current_user->weekstart ) {
     $ts -= 86400;
   }

   $w0 =  (( 1 + Date("w",mktime(12,0,0,1,1, Date("Y",$ts) ) )) % 7) > 3;
   $wn = sprintf("%02d", Round( (Date("z",$ts)+7 ) / 7) );
   $yy = Date("y",$ts);

   $last_week = Date("Ymd",$ts -  7 * 86400);
   $next_week = Date("Ymd",$ts +  7 * 86400);

   echo "<FORM ACTION=\"calendar_week.php\" method=\"GET\">\n";
   hiddenFormElements();
   echo "  <INPUT type=hidden name=t value=". $t .">\n";

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=\"100%\">\n";
   echo " <TR>\n";
   echo "  <TH ALIGN=left nowrap COLSPAN=2>&nbsp;". $lang['forphrase'] ."\n";
   cal_options($team,$teamname);
   echo "  </TH>\n";
   echo " </TR>\n";
   echo " <TR>\n";
   echo "  <TH COLSPAN=2 WIDTH=\"100%\">".menulink("calendar_week.php?t=".$last_week,$tutos[image][left],$lang['lastweek']) ."&nbsp;". $lang['week'] ."&nbsp;" . $wn . "/". $yy ."&nbsp;". menulink("calendar_week.php?t=".$next_week,$tutos[image][right] ,$lang['nextweek']) ."</TH>\n";
   echo " </TR>\n";

   $from =  new DateTime();
   $from->setDateTimeTS($ts - 12 * 3600);
   $to = $from;
   $to->addDays(7);

   $current_user->callist = array();
   appointment::readCal($current_user,$from,$to);
   task::readCal($current_user,$from,$to);
   @reset($tutos[activemodules]);
   while( list ($i,$f) = @each ($tutos[activemodules])) {
     $x = new $f($current_user->dbconn);
     $x->readCal($current_user,$from,$to);
   }

   $day = 0;
   $col = 1;
   $dd = new DateTime();
   while ( $day < 7 ) {
     $dd->setDateTimeTS($ts);
     $d = $dd->getDate();
     $tref = Date("Ymd",$ts);
     $dinfo = GetDaysInfo($ts);
     /* Select appointments for this day */
     $next = NextDay($ts);

     if ( $col == 1 ) {
       echo " <TR>\n";
     }
     echo "  <TD CLASS=\"". $dinfo[color] ."\" WIDTH=\"50%\">\n";

     # TABLE STARTS
     echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0 WIDTH=\"100%\">\n";
     echo " <TR>\n";
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day'. Date("w",$ts)],strftime($lang['DateFormatTitle'],$ts)) ."</TH>\n";
     echo " </TR>\n";
     echo " <TR>\n";
     echo "  <TD CLASS=\"". $dinfo[color] ."\" WIDTH=\"50%\">\n";
     if ( isset($dinfo[Desc]) ) {
       echo " " . makelink("app_new.php?t=". $tref,$d,$lang['NewAppointInfo'],$dinfo[popinfo]) ."\n";
       echo "<BR><FONT SIZE=-1>". $dinfo[Desc] ."</FONT>\n";
     } else {
       echo " " . makelink("app_new.php?t=". $tref,$d,$lang['NewAppointInfo']) ."\n";
     }

     $hastable = 0;
     $x = count( $current_user->callist );
     for ( $idx = 0 ; $idx < $x ; $idx++) {
       /* the correct day */
       if ( ! $current_user->callist[$idx]->inside($dd) ) {
         continue;
       }
       if (!cal_check_against_list($current_user->callist[$idx],$uids)) {
         continue;
       }
       // Do not show finished tasks
       if ( ($current_user->callist[$idx]->gettype() == "task") && ($current_user->callist[$idx]->state == 2) ) {
         continue;
       }
       if ( $hastable == 0 ) {
         echo " <TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0 WIDTH=\"100%\">\n";
         $hastable = 1;
       } else {
         echo "  <TR><TD CLASS=". $dinfo[color] ." COLSPAN=3><IMG SRC=\"". $tutos['base'] ."/html/black.png\" WIDTH=\"100%\" HEIGHT=1></TD></TR>\n";
       }
       // Show appointments or task
       $current_user->callist[$idx]->formatted();
     }

     if ( $hastable == 1 ) {
       echo " </TABLE>\n";
     }

     # TABLE ENDS
     echo "</TABLE>\n";

     echo "  </TD>\n";
     if ( $col == 2 ) {
       echo " </TR>\n";
       $col = 0;
     }

     $day++;
     $col++;
     $ts = $next;
   }

   echo "</TABLE>\n";
   echo "</FORM>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $tutos, $lang , $current_user;
   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(usecalendar,PERM_SEL) ) {
     echo menulink("app_select.php",$lang['Search'],$lang['SearchForApp']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo menulink("app_new.php" ,$lang['NewEntry'],$lang['NewAppointInfo']) . "<BR>";
     echo menulink("app_new_r.php" ,$lang['NewAppointR'],$lang['NewAppointInfoR']) . "<BR>";
   }
   echo "</TD></TR>";

   HTML_Select();
 }

 $teamname = "";
 HTML_Header($lang['Appointments']);

 $uids = cal_parse_options($current_user,$teamname);
 $team = $current_user->get_prefteam();

 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($HTTP_GET_VARS['t'],$current_user->get_prefteam(),$teamname,$uids);
 HTML_Base3();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: calendar_week.php,v 1.16.2.2 2002/08/05 19:11:14 gokohnert Exp $
    $Author: gokohnert $
-->
