<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup company
 * @module company_overview
 * @package company
 */
 include("webelements.p3");
 include("permission.p3");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("company");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,&$result,$start=0) {
   global $lang,$tutos,$link1,$link2;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo $lang['Err0048'];
     return;
   }
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("name",$lang['Company'],$link2);
   echo order_header("",$lang['Department'],$link2);
   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";
   $line = 1;
   while ( ($a < $n) && ($a < $end) ) {
     $c = new company($dbconn);
     $c->read_result($result,$a);
     $c->read_departments();
     $a++;

     if ( $line == 1 ) {
       $line = 2;
     } else {
       $line = 1;
     }

     $r = max(count($c->departments),1);
     echo "<TR CLASS=line". $line .">\n";
     echo "<TD VALIGN=\"top\" ROWSPAN=$r>". $c->getLink() ."</TD>";

     if ( isset($c->departments) ) {
       @reset($c->departments);
       $r = 1;
       while( list ($i,$f) = @each ($c->departments)) {
	 if ( $r > 1 ) {
	   echo "<TR CLASS=line". $line .">\n";
	 }
	 echo "<TD>". $f->getLink($f->name) ."</TD></TR>\n";
	 $r++;
       }
     }
     if ( $r == 1 ) {
       echo "<TD>&nbsp;</TD>\n";
     }
     echo "</TR>\n";
   }
   echo "</TBODY>\n";

   ShowBackForwardNav($link1,2,$start,$a,$n);

   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $current_user,$tutos,$lang;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo tutos_address::getSelectLink($current_user,$lang['Search']) ."<BR>\n";

   echo menulink("company_new.php",$lang['NewEntry'],$lang['CompanyCreateInfo']) . "<BR>\n";

   echo "</TD></TR>";

   HTML_Select();
 }


 $link1 = "company_overview.php";
 $link2 = "company_overview.php";

 $q = "SELECT * FROM companies";
 $pre = "WHERE";

 if ( isset($HTTP_GET_VARS['name']) && ($HTTP_GET_VARS['name'] != "*") && ($HTTP_GET_VARS['name'] != "") ) {
   $q .= " ".  $pre ." ". $dbconn->Like("name",$HTTP_GET_VARS['name']);
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"name=". UrlEncode($HTTP_GET_VARS['name']));
   $link2 = addUrlParameter($link2,"name=". UrlEncode($HTTP_GET_VARS['name']));
 }

 # sorting
 $xxx = "";
 order_parse($q,$link1,$xxx,$xxx,"name");

 $result = $dbconn->Exec($q);

 if ($result->numrows() == 1) {
   $c = new company($dbconn);
   $c->read_result($result,0);

   Header("Location: ". getBaseUrl() . addSessionKey("company_show.php?id=".$c->id));
   exit;
 } else {
   if ( isset($HTTP_GET_VARS['start']) ) {
     $start = $HTTP_GET_VARS['start'];
   } else {
     $start = 0;
   }
   HTML_Header($lang['CompanyOverview']);

   HTML_Base1();
   navigate();
   HTML_Base2($msg);
   info($dbconn,$result,$start);
   HTML_Base3();
 }
 $result->free();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: company_overview.php,v 1.23.2.1 2002/08/15 08:04:11 gokohnert Exp $
    $Author: gokohnert $
-->
