<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup company
 * @module company_show
 * @package company
 */
 include("webelements.p3");
 include("permission.p3");
 include("address_tools.p3");
 include("appointment.pinc");
 include("bug.pinc");
 include("timetrack.pinc");
 include 'file.pinc';
 include 'installation.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("company");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$c,&$ra) {
   global $tutos,$lang,$current_user;

   if ( isset($c->location) ) {
     $cols = count($c->location);
   } else {
     $cols = 0;
   }
   if ( $cols < 3 ) {
     $cols = 3;
   }

   echo "<TABLE CLASS=single  BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";

   echo "<TR>\n";
   echo " <TH COLSPAN=". $cols .">". sprintf($lang['Showing'],$lang[$c->getType()]) ."</TH>\n";

   echo "</TR><TR>\n";
   showfield($lang['Company']);
   echo " <TD ALIGN=left COLSPAN=". ($cols - 1) .">". $c->name ."</TD>\n";

   echo "</TR>\n";

   $c->read_departments();
   $cnt = 0;
   @reset($c->departments);
   if ( count($c->departments) > 0 ) {
     echo "<TR>\n";
     showfield($lang['Departments']);
     echo " <TD ALIGN=top COLSPAN=". ($cols - 1) .">\n";
     while( list ($i,$f) = @each ($c->departments)) {
       echo "  ". $f->getLink() ."<BR>\n";
       $cnt++;
     }
     echo " </TD>\n";
     echo "</TR>\n";
   }

   # Locations
   if ( isset($c->location) && count($c->location) > 0 ) {
     Show_LocFields($lang['AdrDescription'],$c,"lname",1);
     Show_LocFields($lang['Phone'],$c,"phone_1",1);
     Show_LocFields($lang['AdrFax'],$c,"fax_1",1);
     Show_LocFields($lang['AdrEmail'],$c,"email_1",1);
     Show_LocFields($lang['Street'],$c,"street1",1);
     Show_LocFields($lang['Street'],$c,"street2",1);
     Show_LocFields($lang['City'],$c,"city",1);
     Show_LocFields($lang['ZIP'],$c,"zip",1);
     Show_LocFields($lang['State'],$c,"state",1);
     Show_LocFields($lang['Country'],$c,"country",1);
     Show_LocFields($lang['acc_info1'],$c,"acc_info1",1);
     Show_LocFields($lang['acc_info2'],$c,"acc_info2",1);
     Show_LocFields($lang['acc_nr'],$c,"acc_nr",1);
   }

   # No departments
   if ( $ra->numrows() > 0 ) {
     echo "<TR>\n";
     echo " <TH COLSPAN=". $cols .">". $lang['CompanyMembers'] ."</TH>\n";
     echo "</TR>\n";
     echo "<TR>\n";
     echo " <TD COLSPAN=". $cols .">\n";

     address_overview($c->dbconn,$ra);

     echo " </TD>\n";
     echo "</TR>\n";
   }


   # Links
   url::infolist($current_user,$c,$cols);
   # Older Appointments
   appointment::infolist($current_user,$c,$cols);
   # Files
   tutos_file::infolist($current_user,$c,$cols);
   # Installations
   installation::infolist($current_user,$c,$cols);
   # References to modules
   show_module_infolists($current_user,$c,$cols);

   # Project Roles
   if ( $current_user->feature_ok(useprojects,PERM_SEE) ) {
     $c->readRoles();
     if ( count($c->prolist) > 0 ) {
       @reset($c->prolist);
       echo "<TR>\n";
       showfield($lang['ProdRoles']);
       echo " <TD COLSPAN=". ($cols - 1) .">\n";
       showProdRoles($c,0);
       echo " </TD>\n";
       echo "</TR>\n";
     }
   }
   echo $c->getHistoryLink($cols);
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo tutos_address::getSelectLink($current_user,$lang['Search']) ."<BR>\n";

   echo menulink("company_new.php",$lang['NewEntry'],$lang['CompanyCreateInfo']) . "<BR>\n";
   if ( $obj->id > 0 ) {
     if ( $obj->mod_ok() ) {
       echo menulink("company_new.php?id=".$obj->id, $lang['Modify'],sprintf($lang['CompanyChgInfo'],$obj->getFullName())) . "<BR>\n";
     }
   }

   echo "<BR>\n";

   if ( ($obj->id > 0) && $obj->see_ok() ) {
     echo menulink("department_new.php?cid=". $obj->id ,$lang['DepartmentCreate'],$lang['DepCreateInfo']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo menulink("app_new.php?vid=". $obj->id,$lang['NewAppoint'],$lang['NewAppointInfo']) ."&nbsp;<BR>\n";
   }
   echo tutos_file::getaddlink($current_user,$obj);
   show_module_addlinks($current_user,$obj);

   echo "<BR>\n";

   echo "</TD></TR>";

   HTML_Select();
 }


 $c = new company($dbconn);
 if (!isset($HTTP_GET_VARS['id'])) {
   $msg .= "Missing ID";
 } else {
   $c->read($HTTP_GET_VARS['id']);
   $c->read_locs_data();
 }

 # Handling of department member list

 adr_tool_init($atool,$ashow);

 $ashow['f_name'] = 1;
 $ashow['l_name'] = 1;
 $ashow['email'] = 1;
 $ashow['phone'] = 1;
 $ashow['desc1'] = 1;

 $atool['link1'] = "company_show.php";
 $atool['link2'] = "company_show.php";

 $atool['link1'] = addUrlParameter($atool['link1'],"id=". $c->id);
 $atool['link2'] = addUrlParameter($atool['link2'],"id=". $c->id);

 $qa = "SELECT distinct(a.id) , a.* FROM addresses a, location l, adrloc r WHERE l.c_id = ". $c->id ." AND a.id = r.adr_id AND r.loc_id = l.id AND ( l.d_id is null OR l.d_id = -1 ) ";

 if ( isset($HTTP_GET_VARS['xf']) && isset($HTTP_GET_VARS['xo']) ) {
   $qa .= " ORDER by " . $HTTP_GET_VARS['xf'];
   if ( $HTTP_GET_VARS['xo'] == 1 ) {
     $qa .= " ASC ";
   } else {
     $qa .= " DESC ";
   }
   $atool['link1'] = addUrlParameter($atool['link1'],"xf=".UrlEncode($HTTP_GET_VARS['xf']));
   $atool['link1'] = addUrlParameter($atool['link1'],"xo=".$HTTP_GET_VARS['xo']);
 } else {
   $qa .= " ORDER by l_name";
 }

 $ra = $dbconn->Exec($qa);

 if ( ! $c->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$c->getType()]);
 } else {
   if ( $c->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$c->getType()]);
   }
 }

 if ( $c->id > 0 ) {
   HTML_Header($lang['CompanyDetail']." :".$c->getFullName());
 } else {
   HTML_Header($lang['CompanyDetail']);
 }

 HTML_Base1();
 navigate($c);
 HTML_Base2($msg);
 if ( ($c->id > 0) && $c->see_ok() ) {
   info($c,$ra);
 }
 HTML_Base3();

 $ra->free();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: company_show.php,v 1.37 2002/07/17 07:27:13 gokohnert Exp $
    $Author: gokohnert $
-->