<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup department
 * @module department_show
 * @package department
 */
 include("webelements.p3");
 include("permission.p3");
 include("installation.pinc");
 include("address_tools.p3");
 include("appointment.pinc");
 include("product.pinc");
 include("bug.pinc");
 include("timetrack.pinc");
 include 'file.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("department");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$d,&$ra) {
   global $tutos,$lang, $current_user;

   if ( isset($c->location) ) {
     $cols = count($c->location);
   } else {
     $cols = 0;
   }
   if ( $cols < 3 ) {
     $cols = 3;
   }

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";

   echo "<TR>\n";
   echo " <TH COLSPAN=". $cols .">". sprintf($lang['Showing'],$lang[$d->getType()]) ."</TH>\n";

   echo "</TR><TR>\n";
   showfield($lang['AdrName']);
   echo " <TD COLSPAN=". ($cols - 1) .">". $d->name ."</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['Company']);
   echo " <TD COLSPAN=". ($cols - 1) .">". $d->company->getLink() ."</TD>\n";

   echo "</TR>\n";

   # Locations
   if ( isset($d->location) && count($d->location) > 0 ) {
     Show_LocFields($lang['AdrDescription'],$d,"lname",1);
     Show_LocFields($lang['Phone'],$d,"phone_1",1);
     Show_LocFields($lang['AdrFax'],$d,"fax_1",1);
     Show_LocFields($lang['AdrEmail'],$d,"email_1",1);
     Show_LocFields($lang['Street'],$d,"street1",1);
     Show_LocFields($lang['Street'],$d,"street2",1);
     Show_LocFields($lang['City'],$d,"city",1);
     Show_LocFields($lang['ZIP'],$d,"zip",1);
     Show_LocFields($lang['State'],$d,"state",1);
     Show_LocFields($lang['Country'],$d,"country",1);
   }

   # Project Roles
   if ( $current_user->feature_ok(useprojects,PERM_SEE) ) {
     $d->readRoles();
     if ( count($d->prolist) > 0 ) {
       @reset($d->prolist);
       echo "<TR>\n";
       showfield($lang['ProdRoles']);
       echo " <TD COLSPAN=". ($cols - 1) .">\n";
       showProdRoles($d,0);
       echo " </TD>\n";
       echo "</TR>\n";
     }
   }
   # Installations
   installation::infolist($current_user,$d,$cols);

   if ( $ra->numrows() > 0 ) {
     echo "<TR>\n";
     echo " <TH COLSPAN=". $cols  .">". $lang['DepartmentMembers'] ."</TH>\n";

     echo "<TR>\n";
     echo " <TD COLSPAN=". $cols .">\n";
     address_overview($d->dbconn,$ra);
     echo " </TD>\n";
     echo "</TR>\n";
   }


   # Links
   url::infolist($current_user,$d,$cols);
   # Older Appointments
   appointment::infolist($current_user,$d,$cols);
   # Files
   tutos_file::infolist($current_user,$d,$cols);
   # References to modules
   show_module_infolists($current_user,$d,$cols);

   echo $d->getHistoryLink($cols);
   echo "</TABLE>\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang, $current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo tutos_address::getSelectLink($current_user,$lang['Search']) ."<BR>\n";

   if ( $obj->id != -1 ) {
     echo menulink("department_new.php?cid=".$obj->company->id,$lang['NewEntry'],$lang['DepCreateInfo'] ) ."<BR>\n";
     if ( $obj->mod_ok() ) {
       echo menulink("department_new.php?id=".$obj->id,$lang['Modify'],sprintf($lang['DepChgInfo'],$obj->getFullName()))    ."<BR>\n";
     }
   } else {
     echo menulink("department_new.php",$lang['NewEntry'],$lang['DepCreateInfo'] ) ."<BR>\n";
   }

   echo "<BR>\n";

   if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
     echo menulink("app_new.php?vid=". $obj->id,$lang['NewAppoint'],$lang['NewAppointInfo']) ."&nbsp;<BR>\n";
   }

   echo tutos_file::getaddlink($current_user,$obj);
   show_module_addlinks($current_user,$obj);

   echo "<BR>\n";

   echo "</TD></TR>";

   HTML_Select();
 }


 $d = new department($dbconn);
 if (!isset($HTTP_GET_VARS['id'])) {
   $msg .= "Missing ID";
 } else {
   $d->read($HTTP_GET_VARS['id']);
   $d->read_locs_data();
 }

 # Handling of department member list

 adr_tool_init($atool,$ashow);

 $ashow['f_name'] = 1;
 $ashow['l_name'] = 1;
 $ashow['email'] = 1;
 $ashow['phone'] = 1;
 $ashow['desc1'] = 1;

 $atool['link1'] = "department_show.php";
 $atool['link2'] = "department_show.php";

 $atool['link1'] = addUrlParameter($atool['link1'],"id=". $d->id);
 $atool['link2'] = addUrlParameter($atool['link2'],"id=". $d->id);

 $qa = "SELECT distinct(a.id),a.* FROM addresses a, location l, adrloc r WHERE l.d_id = ". $d->id ." AND a.id = r.adr_id AND r.loc_id = l.id ";

 if ( isset($HTTP_GET_VARS['xf']) && isset($HTTP_GET_VARS['xo']) ) {
   $qa .= " ORDER by " . $HTTP_GET_VARS['xf'];
   if ( $HTTP_GET_VARS['xo'] == 1 ) {
     $qa .= " ASC ";
   } else {
     $qa .= " DESC ";
   }
   $atool['link1'] = addUrlParameter($atool['link1'],"xf=".UrlEncode($HTTP_GET_VARS['xf']));
   $atool['link1'] = addUrlParameter($atool['link1'],"xo=".$HTTP_GET_VARS['xo']);
 } else {
   $qa .= " ORDER by l_name";
 }

 $ra = $dbconn->Exec($qa);


 if ( ! $d->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$d->getType()]);
 } else {
   if ( $d->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$d->getType()]);
   }
 }
 if ($d->id > 0 ) {
   HTML_Header($lang['DepartmentDetail']." :".$d->getFullName());
 } else {
   HTML_Header($lang['DepartmentDetail']);
 }
 HTML_Base1();
 navigate($d);
 HTML_Base2($msg);
 if ( ($d->id > 0) && $d->see_ok() ) {
   info($d,$ra);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: department_show.php,v 1.33.2.1 2002/08/07 19:03:26 gokohnert Exp $
    $Author: gokohnert $
-->
