<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup file
 * @module file_ins
 * @package file
 */
 include("webelements.p3");
 include("permission.p3");
 include("file.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("file");

 $f = new tutos_file($dbconn);

 /* Check Input */
 $msg = "";
 $log = "";

 if ( empty($HTTP_POST_VARS['gotourl']) ) {
   $gotourl = "file_new.php";
 } else {
   $gotourl = $HTTP_POST_VARS['gotourl'];
 }

 if ( isset($HTTP_POST_VARS['id']) ) {
   $f->read($HTTP_POST_VARS['id']);
   $gotourl = addUrlParameter($gotourl,"id=". $f->id );
 }
 if ( $f->id == -1 ) {
   # Versioning System could only be set at first save

   if ( isset($HTTP_POST_VARS['vsys']) ) {
     $f->vsys = $HTTP_POST_VARS['vsys'];
   }
 }
 if ( isset($HTTP_POST_VARS['save']) ) {
   $f->savemode = $HTTP_POST_VARS['save'];
 }

 if ( !isset($HTTP_POST_VARS['link_id']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['FileReference']) ."<BR>";
 } else {
   $f->link_id = $HTTP_POST_VARS['link_id'];
   $gotourl = addUrlParameter($gotourl,"link_id=". UrlEncode($f->link_id));
 }

 $file = "none";
 # Hack for Konquerer
 if ( isset($HTTP_POST_VARS['file']) ) {
   $file = $HTTP_POST_VARS['file'];
   if ( $file != "none" ) {
     $farr = $HTTP_POST_FILES["file"];
     if ( $farr['name'] == "" ) {
	   $file = "none";
     }
   }
 } else if ( isset($HTTP_POST_FILES['file']) ) {
   $file = $HTTP_POST_FILES['file']['name'];
 }
 if ( $file == "" ) {
   $file = 'none';
 }
 # New files need a path !
 if ( ($file == "none") && ($f->id == -1)  ) {
   $msg .= sprintf($lang['Err0009'],$lang['FileName']) ."<BR>";
 }

 if ( ( !isset($HTTP_POST_VARS['name']) || $HTTP_POST_VARS['name'] == "") && ($file == "none") ) {
   $msg .= sprintf($lang['Err0009'],$lang['FileName']) ."<BR>";
   $name = "";
 } else {
   $name = trim($HTTP_POST_VARS['name']);
 }

 if ( $name != "" ) {
   $gotourl = addUrlParameter($gotourl,"name=". UrlEncode(StripSlashes($name)));
 }

 if ( isset($HTTP_POST_VARS['version']) && ($HTTP_POST_VARS['version'] != "") ) {
   $version = $HTTP_POST_VARS['version'];
 } else {
   $version = "";
 }
 $gotourl = addUrlParameter($gotourl,"version=". UrlEncode(StripSlashes($version)));


 if ( isset($HTTP_POST_VARS['locked']) && ($f->locked != $HTTP_POST_VARS['locked']) ) {
   if ( $HTTP_POST_VARS['locked'] > 0 ) {
     $f->locker = new tutos_address($dbconn);
     $f->locker->read($HTTP_POST_VARS['locked']);
     $log = $log . "Document locked by ". $f->locker->getFullName() ."\n";
   } else {
     $log = $log . "Document unlocked by ". $current_user->getFullName() ."\n";
   }
   $f->locked = $HTTP_POST_VARS['locked'];
 }

 if ( isset($HTTP_POST_VARS['afn']) ) {
   # Check the author full name
   $author = check_field($HTTP_POST_VARS['afn'],"afn","al","at");
 }

 if ( $file != "none" ) {
   $farr = $HTTP_POST_FILES['file'];
   if ( $f->id > 0 ) {
     $log .=  "Changed Document \n";
     if ( $f->filename != $farr['name'] ) {
       $log .= "  Name: from ". $f->filename ." to ". $farr['name'] ."\n";
     }
     if ( $f->filesize != $farr['size'] ) {
       $log .= "  Size: from ". $f->filesize ." to ". $farr['size'] ."\n";
     }
     if ( $f->filetype != $farr['type'] ) {
       $log .= "  Type: from ". $f->filetype ." to ". $farr['type'] ."\n";
     }
   }
   if ( $name == "") {
     $name = $farr['name'];
   }
   if ( isset($farr['tmp_name']) && file_exists($farr['tmp_name']) ) {
     $f->tmploc = $farr['tmp_name'];
     $f->filesize = $farr['size'];
     $f->setFilename($farr['name']);
     $f->filetype = $farr['type'];
   } else {
     if ( isset($farr['tmp_name']) ) {
       $msg .= "Temporary file '". $farr['tmp_name'] ."' missing. Maybe too big";
     } else {
       $msg .= "Temporary file missing. Maybe too big";
     }
   }
 }

 # other modules
 $msg .= module_parseforms($current_user,$f,$gotourl);

 if ( $msg == "" ) {
   $f->oldversion = $f->version;
   $f->setVersion($version);

   if ( isset($HTTP_POST_VARS['aid']) ) {
     $author = getObject($f->dbconn,$HTTP_POST_VARS['aid']);
   }
   if ( isset($author) ) {
     if ( $f->author->id != $author->id ) {
       $log = $log . "Changed Author from ". $f->author->getFullName() ." to ". $author->getFullName() ."\n";
     }
     $f->setAuthor($author);
   }

   if ( ($f->name != $name) && ($f->name != "") ) {
     $log = $log . "Changed Documentname from ". $f->name ." to " . $name ."\n";
   }
   $f->setName($name);

   if ( $log != "" ) {
     $log = "----------- <B>". Date("j M Y  H:i:s") ." -- ". $current_user->getFullName() ." </B>---\n" . $log;
     $f->logtxt = $log. $f->logtxt;
   }
   # Save the new part of logmessage for RCS
   $f->newlog = $log;

   $dbconn->Begin("WORK");
   $msg .= $f->save();
   $dbconn->Commit("WORK");

   if ( $f->id != -1 ) {
     $gotourl = $f->getURL();
   }
 }

 if ( $msg != "" ) {
   $gotourl = addUrlParameter($gotourl,"msg=". UrlEncode($msg));
 }
 $gotourl = addSessionKey($gotourl);


 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl() . $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: file_ins.php,v 1.25.2.2 2002/08/15 08:04:11 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
