<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup file
 * @module file_overview
 * @package file
 */
 include("webelements.p3");
 include("permission.p3");
 include("product.pinc");
 include("bug.pinc");
 include("installation.pinc");
 include("file.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("file");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,&$r,$start = 0) {
   global $lang,$tutos,$current_user,$link1,$link2,$filter;

   $n = $r->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TABLE BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("name",$lang['FileNameDoc'],$link2);
   echo order_header("version",$lang['FileVersion'],$link2);
   echo order_header("filename",$lang['FileName'],$link2);
   echo order_header("",$lang['FileReference'],$link2);
   echo order_header("f_size",$lang['FileSize'],$link2);
   echo order_header("creation",$lang['created'],$link2);
   echo "</TR>\n";
   echo "</THEAD>\n";

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $f = new tutos_file($dbconn);
     $f->read_result($r,$a);
     $f->read_reference();

     echo "<TR>\n";

     $x = myentities($f->name);
	 if ( $filter['name'] != "" ) {
	   $x = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$x);
	 }
     if ( $f->see_ok() ) {
       echo " <TD>". makelink($f->getUrl(),$x) ."</TD>\n";
     } else {
       echo " <TD>". $x ."</TD>\n";
     }
     $x = $f->version;
	 if ( $filter['name'] != "" ) {
	   $x = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$x);
	 }
     echo " <TD ALIGN=right>". $x ."&nbsp;</TD>\n";

     $x = $f->filename;
	 if ( $filter['name'] != "" ) {
	   $x = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$x);
	 }
     echo " <TD>". $x ."</TD>\n";
     if ( $f->ref != -1 ) {
       echo " <TD ALIGN=right>". $f->getRefLink() ."</TD>\n";
     } else {
       echo " <TD ALIGN=right>". $lang['HistoryDeleted'] ." (". $f->link_id .")</TD>\n";
     }
     echo " <TD ALIGN=right>". $f->filesize ."</TD>\n";
     echo " <TD ALIGN=right>". $f->creation->getDateTime() ."&nbsp;</TD>\n";
     echo "</TR>\n";

     $a++;
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,6,$start,$a,$n);
   echo "</TFOOT>\n";
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $lang,$current_user;
   echo "<TABLE>";
   echo "<TR><TD>";
   echo tutos_file::getSelectLink($current_user,$lang['Search'])."<BR>\n";

   HTML_Select();
 }


 HTML_Header($lang['FileOverview']);

 $link1 = "file_overview.php";

 $q = "SELECT * FROM files";
 $pre = " WHERE " ;

 if ( isset($HTTP_GET_VARS['link_id']) ) {
   $q .= $pre . " link_id = ". $HTTP_GET_VARS['link_id'];
   $pre = " AND " ;
   $link1 = addUrlParameter($link1,"link_id=". $HTTP_GET_VARS['link_id']);
 }
 if ( isset($HTTP_GET_VARS['author']) ) {
   $q .= $pre . " author = ". $HTTP_GET_VARS['author'];
   $pre = " AND " ;
   $link1 = addUrlParameter($link1,"author=". $HTTP_GET_VARS['author']);
 }
 if ( isset($HTTP_GET_VARS['creator']) ) {
   $q .= $pre . " creator = ". $HTTP_GET_VARS['creator'];
   $pre = " AND " ;
   $link1 = addUrlParameter($link1,"creator=". $HTTP_GET_VARS['creator']);
 }
 if ( isset($HTTP_GET_VARS['type']) ) {
   $q .= $pre . $dbconn->Like("type",$HTTP_GET_VARS['type']);
   $pre = " AND " ;
   $link1 = addUrlParameter($link1,"type=". UrlEncode($HTTP_GET_VARS['type']));
 }
 if ( isset($HTTP_GET_VARS['name']) && ($HTTP_GET_VARS['name'] != "") ) {
   $q .= $pre . "(";
   $q .= $dbconn->Like("name",$HTTP_GET_VARS['name']);
   $q .= " OR ". $dbconn->Like("filename",$HTTP_GET_VARS['name']);
   $q .= " OR ". $dbconn->Like("version",$HTTP_GET_VARS['name']);
#   $q .= " OR ". $dbconn->Like("logtxt",$name);
   $q .= ")";
   $pre = " AND " ;
   $link1 = addUrlParameter($link1,"name=". UrlEncode($HTTP_GET_VARS['name']));
   $filter['name'] = $HTTP_GET_VARS['name'];
 } else {
   $filter['name'] = "";
 }

 # Start Date for search
 $from = new DateTime(0);
 if ( isset($HTTP_GET_VARS['fd']) ) {
   $from->setDateTime($HTTP_GET_VARS['fd']);
 } else {
   $from->setDateTimeF("f");
   # remember this
   $HTTP_SESSION_VARS['filesearchfrom'] = $from->getYYYYMMDD();
 }
 if ( $from->notime != 1 ) {
   $q .= $pre ."(creation >= ". $dbconn->Date($from) .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"fd=".$from->getYYYYMMDD());
   $filter['from'] = $from;
 }
 # End Date for search
 $to = new DateTime(0);
 if ( isset($HTTP_GET_VARS['td']) ) {
   $to->setDateTime($HTTP_GET_VARS['td']);
 } else {
   $to->setDateTimeF("t");
   # remember this
   $HTTP_SESSION_VARS['filesearchto'] = $to->getYYYYMMDD();
 }
 if ( $to->notime != 1 ) {
   $q .= $pre ."(creation <= ". $dbconn->Date($to) .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"td=".$to->getYYYYMMDD());
   $filter['to'] = $to;
 }

 # sorting
 $xxx = "";
 $link2 = $link1;
 order_parse($q,$link1,$xxx,$xxx,"name");

 $r = $dbconn->Exec($q);

 if ( ! isset($HTTP_GET_VARS['start']) ) {
   $start = 0;
 } else {
   $start = $HTTP_GET_VARS['start'];
 }

 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($dbconn,$r,$start);
 HTML_Base3();

 $r->free();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: file_overview.php,v 1.22.2.1 2002/09/09 17:46:11 gokohnert Exp $
    $Author: gokohnert $
-->
