<?
/**
 * Copyright 2000 - 2002 by Gero Kohnert
 *
 *   CVS Info:  $Id: file_show.php,v 1.33 2002/07/25 12:43:12 gokohnert Exp $
 *   $Author: gokohnert $
 *
 * @modulegroup file
 * @module file_show
 * @package file
 */
 include("webelements.p3");
 include("permission.p3");
 include("file.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("file");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR><TH COLSPAN=4>". $lang['FileDetail'] ."</TH></TR>\n";

   echo "<TR>\n";
   showfield($lang['FileNameDoc']);
   echo " <TD>". $obj->name ."</TD>\n";
   showfield($lang['FileVersion']);
   echo " <TD VALIGN=top>". $obj->version ."&nbsp;</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['FileName']);
   echo " <TD COLSPAN=3>". $obj->filename ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['created']);
   echo " <TD COLSPAN=3>". $obj->creation->getDateTime() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['FileAuthor']);
   echo " <TD COLSPAN=3>". $obj->author->getLink() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['FileReference']);
   if ($obj->ref != -1 ) {
     echo " <TD COLSPAN=3>". $lang[$obj->ref->gettype()] ." ". $obj->getRefLink() ."</TD>\n";
   } else {
     echo " <TD COLSPAN=3>". $lang['HistoryDeleted'] ." (". $obj->link_id .")</TD>\n";
   }
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['FileSize']);
   echo " <TD COLSPAN=3>". $obj->filesize ." Bytes</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['FileType']);
   echo " <TD COLSPAN=3>". $obj->filetype ."</TD>\n";
   echo "</TR>\n";

   if ( $obj->locked > 0 ) {
     echo "<TR>\n";
     showfield($lang['FileLockedBy']);
     echo " <TD COLSPAN=3>". $obj->locker->getMailLink() ."</TD>\n";
     echo "</TR>\n";
   }

   echo "<TR>\n";
   showfield($lang['FileMore']);
   echo " <TD COLSPAN=3 CLASS=pre><FONT SIZE=-1><PRE>\n";
   $obj->moreinfo();
   echo " </PRE></FONT></TD>\n";
   echo "</TR>\n";

   $obj->make_vlist();
   @reset($obj->vlist);
   if (count($obj->vlist) > 0 ) {
     echo "<TR>\n";
     showfield($lang['FileOldVersion']);
     echo " <TD COLSPAN=3><FONT SIZE=-1>\n";
     while ( list ($i,$v) = @each ($obj->vlist) ) {
       if ( ($obj->id > 0) && $obj->mod_ok() ) {
         echo makelink("file_show.php?id=". $obj->id ."&format=download&version=".$v, $lang['FileDownload'] ." ". $lang['FileVersion'] ." ". $i , $v);
       } else {
         echo $lang['FileVersion'] ." ". $i ."\n";
       }
       echo "<BR>\n";
     }
     echo "</FONT></TD>\n";
     echo "</TR>\n";
   }
   echo "<TR>\n";
   showfield($lang['FileLog']);
   echo " <TD COLSPAN=3 CLASS=pre><FONT SIZE=-1><PRE>\n";
   echo $obj->logtxt;
   echo " </PRE></FONT></TD>\n";
   echo "</TR>\n";

   # References to modules
   show_module_infolists($current_user,$obj,4);
   echo $obj->getHistoryLink(4);
   echo "</TABLE>\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $lang ,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";

   echo tutos_file::getSelectLink($current_user,$lang['Search'])."<BR>\n";

   if ( ($obj->id > 0) && $obj->see_ok() ) {
     echo menulink("file_show.php?format=show&id=". $obj->id ,$lang['FileShow'],sprintf($lang['FileShowI'],$obj->getFullName())) ."&nbsp;<BR>";
   }
   if ( ($obj->id > 0) && $obj->mod_ok() ) {
     echo menulink("file_show.php?format=download&id=". $obj->id ,$lang['FileDownload'],sprintf($lang['FileDownloadI'],$obj->getFullName())) ."&nbsp;<BR>";
     if ( $obj->locked > 0 ) {
       if ( $obj->locker->id == $current_user->id ) {
         echo menulink("file_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['FileModifyI'],$obj->getFullName())) ."&nbsp;<BR>";
       }
     } else {
       echo menulink("file_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['FileModifyI'],$obj->getFullName())) ."&nbsp;<BR>";
     }
   }
   if ( ($obj->id > 0) && $obj->del_ok() ) {
     if ( $obj->locked > 0 ) {
       if ( $obj->locker->id == $current_user->id ) {
         echo confirmlink("file_del.php?id=". $obj->id ,$lang['Delete'],sprintf($lang['FileDeleteI'],$obj->getFullName())) ."&nbsp;<BR>";
       }
     } else {
       echo confirmlink("file_del.php?id=". $obj->id ,$lang['Delete'],sprintf($lang['FileDeleteI'],$obj->getFullName())) ."&nbsp;<BR>";
     }
   }
   echo "<BR>\n";
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>\n";
   HTML_Select();
 }


 $f = new tutos_file($dbconn);
 $f->read($HTTP_GET_VARS['id']);

 if ( $f->id < 0 ) {
   $msg .= sprintf($lang['Err0040'],$lang[$f->getType()]);
 } else {
   $f->read_reference();

   if ( ! $f->see_ok() ) {
     $msg .= sprintf($lang['Err0022'],$lang[$f->getType()]);
   }
 }


 if ( ! isset($HTTP_GET_VARS['format']) || ($msg != "") ) {
   $format = "";
 } else {
   $format = $HTTP_GET_VARS['format'];
 }
 if ( ! isset($HTTP_GET_VARS['version']) ) {
   $version = $f->version;
 } else {
   $version = $HTTP_GET_VARS['version'] ;
 }

 if ( $format == "show" ) {
   $f->show($version);
 } else if ( $format == "thumbnail" ) {
   if (strstr($HTTP_SERVER_VARS["HTTP_USER_AGENT"],"MSIE 5") || strstr($HTTP_SERVER_VARS["HTTP_USER_AGENT"],"MSIE 6") ) {
     Header("Expires:");
     Header("Cache-Control:");
     Header("Pragma:");
     Header("Content-Type: application/octet-stream");
     Header("Connection: close");
     Header("Content-Transfer-Encoding: binary");
   } else {
     if ( ($f->filetype != "") && ($f->version == $version) ) {
       Header("Content-type: ". $f->filetype);
     } else {
       Header("Content-type: text/plain");
     }
     Header("Content-Disposition: attachment; filename=\"". $f->filename ."\"");
   }
   Header("Content-Description: Upload from TUTOS" );
   $f->thumbnail($version);
 } else if ( $format == "download" ) {
   // see also
   // http://www.phpbuilder.com/forum/archives/1/2001/3/4/113046
   // http://ppewww.ph.gla.ac.uk/~flavell/www/content-type.html
   // http://msdn.microsoft.com/library/default.asp?url=/workshop/networking/moniker/overview/appendix_a.asp
   if (strstr($HTTP_SERVER_VARS["HTTP_USER_AGENT"],"MSIE 5") || strstr($HTTP_SERVER_VARS["HTTP_USER_AGENT"],"MSIE 6") ) {
     Header("Expires:");
     Header("Cache-Control:");
     Header("Pragma:");
     Header("Content-Type: application/octet-stream");
     Header("Connection: close");
     Header("Content-Transfer-Encoding: binary");
   } else {
     if ( ($f->filetype != "") && ($f->version == $version) ) {
       Header("Content-type: ". $f->filetype);
     } else {
       Header("Content-type: text/plain");
     }
   }
   Header("Content-Disposition: attachment; filename=\"". $f->filename ."\"");
   Header("Content-Description: Upload from TUTOS" );
   $f->download($version);
 } else {
   HTML_Header($lang['FileDetail']);
   HTML_Base1();
   navigate($f);
   HTML_Base2($msg);
   if ( ($f->id > 0) && $f->see_ok() ) {
     info($f);
   }
   HTML_Base3();
 }

 $dbconn->Close();
?>
