<?
/* Display a PNG Gantt.
 * This file needs to just do that, cause the content-type will be set to
 * image/png.
 *
 * This fonctionnality needs the JpGraph tool, a PHP4 Chart librairie,
 * released under the GPL.
 *
 * $Author: gokohnert $
 *
 * $Id: gantt_png.php,v 1.8.2.1 2002/07/31 13:51:13 gokohnert Exp $
 */

include("webelements.p3");
include("permission.p3");
include("url.pinc");
include("task.pinc");
include("product.pinc");
include("timetrack.pinc");
include("bug.pinc");

/* Check if user is allowed to use it */
check_user();
session_write_close();

function get_bar(&$task, $n, $depth) {
  $name  = $task->name;
  $start = $task->s_start->getYYYYMMDD();
  $end   = $task->s_end->getYYYYMMDD();
  $vol   = $task->volume_done;
  $comp  = $task->getcompletion();

  for ($i = 1; $i < $depth; $i++) {
    $name = "  ".$name;
  }
  $bar = new GanttBar($n, $name, $start, $end,
		      sprintf("[%.0f %%]", $comp), 0.5);

  /* Outline first level tasks */
  if( $depth == 1 ) {
    $bar->title->SetFont(FF_FONT1, FS_BOLD, 8);
  }
  $bar->progress->Set($comp/100.0);
  return $bar;
}

/* Recursive adding of project tasks */
function addTasks(&$parent, &$graph, &$count, $depth) {
  if ( $parent->getType() == "task" ) {
    $graph->Add(get_bar($parent, $count++, $depth));
  }

  $parent->readTasks();
  @reset($parent->tasklist);
  while( list($i, $f) = @each($parent->tasklist) ) {
    $graph = addTasks($f, $graph, $count, $depth+1);
  }
  return $graph;
}

Function draw_gantt(&$parent) {
  global $lang , $tutos;

  task_calc($parent);

  // Standard calls to create a new graph
  $graph = new GanttGraph();
  //$graph->SetShadow();
  $graph->SetBox();
  // Titles for chart
  $graph->title->Set($lang['TaskGantt']." ". $lang['forphrase'] ." " .
		     $parent->getFullName());

  //$graph->title->SetFont(FF_ARIAL,FS_BOLD,12);

  // For illustration we enable all headers. 
  $graph->ShowHeaders(GANTT_HMONTH | GANTT_HDAY | GANTT_HWEEK);

  $graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
  $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAMEYEAR4);

  // Change the scale font 
  $graph->scale->week->SetFont(FF_FONT0);
  $graph->scale->year->SetFont(FF_ARIAL,FS_BOLD,12);

  $count = 0;
  $graph = addTasks(&$parent, &$graph, $count, 0);

  // Add a vertical line for the current day
  $vline = new GanttVLine(strftime("%Y-%m-%d", time()));
  $vline->SetDayOffset(0.5);
  $graph->Add($vline);

  $graph->Stroke();
}

if (file_exists ($tutos[jpgraph]."/jpgraph.php") ) {
  include($tutos[jpgraph]."/jpgraph.php");
  include($tutos[jpgraph]."/jpgraph_gantt.php");
} else {
  include($tutos[jpgraph]."/src/jpgraph.php");
  include($tutos[jpgraph]."/src/jpgraph_gantt.php");
}

if ( isset($HTTP_GET_VARS['id']) ) {
  $obj = GetObject($dbconn,$HTTP_GET_VARS['id']);
  $stop = 0;
} else {
  $msg .= $lang['Err0048'];
  $stop = 1;
  $obj = $id;
}
draw_gantt($obj);

$dbconn->Close();

?>
