<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup BASE
 * @module history_show
 * @package BASE
 */
 include("webelements.p3");
 include("permission.p3");
 # Needs nearly everything
 include("product.pinc");
 include("installation.pinc");
 include("bug.pinc");
 include("task.pinc");
 include("url.pinc");
 include("file.pinc");
 include("timetrack.pinc");
 include("appointment.pinc");
 include("mailbox.pinc");

 /* Check if user is allowed to use it */
 check_user();

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$obj,$id,$start,$xf,$xo) {
   global $current_user,$lang,$tutos,$link1,$link2;

   if ( $id == -1 ) {
     $cols = 7;
   } else {
     $cols = 5;
   }
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   if ( $obj != -1 ) {
     echo "  <TH COLSPAN=". $cols .">". sprintf($lang['HistoryShow'],$lang[$obj->getType()],menulink($obj->getURL(),$obj->getFullName())) ."</TH>\n";
   } else {
     if ( $id != -1 ) {
       echo "  <TH COLSPAN=". $cols .">". sprintf($lang['HistoryShow'],"","(". $lang['HistoryDeleted']) .")</TH>\n";
     } else {
       echo "  <TH COLSPAN=". $cols .">". sprintf($lang['HistoryShow'],"","\"". $lang['AppEverything']) ."\"</TH>\n";
     }
     # Pseudo empty object
     $obj = new tutos_base($current_user->dbconn);
     $obj->init($current_user->dbconn);
     $obj->id = $id;
   }
   echo "</TR>\n";

   echo "<TR>\n";
   if ( $id == -1 ) {
     echo order_header("","Type",$link2);
     echo order_header("","ID",$link2);
   }
   echo order_header("",$lang['HistoryFld'],$link2);
   echo order_header("",$lang['HistoryOldV'],$link2);
   echo order_header("",$lang['HistoryNewV'],$link2);
   echo order_header("",$lang['User'],$link2);
   echo order_header("m_time",$lang['atDateTime'],$link2);
   echo "</TR>\n";
   echo "</THEAD>\n";

   $line = "";
   $obj->readHistory($xf,$xo);
   $n = count($obj->history);
   if ( $n == 0 ) {
     echo "<SPAN class=warn>". $lang['Err0048'] ."</SPAN>";
     echo "</TABLE>\n";
     return;
   }

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $f = $obj->history[$a];
     if ( $line == 1 ) {
       $line = 2;
     } else {
       $line = 1;
     }
     echo "<TR CLASS=line". $line .">\n";

     if ( $id == -1 ) {
       $x = getObject($obj->dbconn,$f["obj_id"],1);
       if ( $x == -1 ) {
         echo " <TD COLSPAN=2><B>&nbsp;". $f["obj_id"] ."</B></TD>\n";
       } else {
         echo " <TD>&nbsp;". $lang[$x->getType()] ."</TD><TD>&nbsp;<B>". $x->getLink() ."</B></TD>\n";
       }
       unset($x);
	 }


     if ( $f['field'] == "TaskState" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['TaskStates'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['TaskStates'][$f["new"]] ."</TD>\n";
     } else if ( $f['field'] == "BugState" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['BugStates'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['BugStates'][$f["new"]] ."</TD>\n";
     } else if ( $f['field'] == "BugClass" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['BugClasses'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['BugClasses'][$f["new"]] ."</TD>\n";
     } else if ( $f['field'] == "BugCreate" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;</TD>\n";
       $b = new bug($obj->dbconn);
       $b->read($f["new"]);
       if ( $b->id > 0 ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD><I>". makelink("history_show.php?id=". $f["new"],$lang['HistoryDeleted']) ."</I></TD>\n";
       }
     } else if ( $f['field'] == "InvoiceState" ) {
       loadmodule("invoice");
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['InvoiceStates'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['InvoiceStates'][$f["new"]] ."</TD>\n";
     } else if ( $f['field'] == "InstCreate" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;</TD>\n";
       $b = new installation($obj->dbconn);
       $b->read($f["new"]);
       if ( $b->id > 0 ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD><I>". makelink("history_show.php?id=". $f["new"],$lang['HistoryDeleted']) ."</I></TD>\n";
       }
     } else if ( $f['field'] == "NoteCreate" ) {
       loadmodule("note");
       $b = new note($obj->dbconn);
       $b->read($f["new"]);
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;</TD>\n";
       if ( $b->id > 0 ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD><I>". makelink("history_show.php?id=". $f["new"],$lang['HistoryDeleted']) ."</I></TD>\n";
       }
     } else if ( $f['field'] == "FileCreate" ) {
       $b = new tutos_file($obj->dbconn);
       $b->read($f["new"]);
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;</TD>\n";
       if ( $b->id > 0 ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD><I>". $lang['HistoryDeleted'] ."</I></TD>\n";
       }
     } else if ( $f['field'] == "Location2" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['AppLoc'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['AppLoc'][$f["new"]] ."</TD>\n";
     } else if ( $f['field'] == "Company" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       $b = new company($obj->dbconn);
       $b->read($f["old"]);
       if ( $b->id == $f["old"] ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD>&nbsp;". $f["old"] ."</TD>\n";
       }
       $b = new company($obj->dbconn);
       $b->read($f["new"]);
       if ( $b->id == $f["new"] ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD>&nbsp;". $f["new"] ."</TD>\n";
       }
     } else if ( $f['field'] == "URLAdd" ) {
       $b = new url($obj->dbconn);
       $b->read($f["new"]);
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;</TD>\n";
       if ( $b->id > 0 ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD><I>". makelink("history_show.php?id=". $f["new"],$lang['HistoryDeleted']) ."</I></TD>\n";
       }
     } else if ( $f['field'] == "TaskCreate" ) {
       $b = new task($obj->dbconn);
       $b->read($f["new"]);
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;</TD>\n";
       if ( $b->id > 0 ) {
         echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       } else {
         echo " <TD><I>". makelink("history_show.php?id=". $f["new"],$lang['HistoryDeleted']) ."</I></TD>\n";
       }
     } else if ( $f['field'] == "AppointCommit" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['AppState'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['AppState'][$f["new"]] ."</TD>\n";
     } else if ( $f['field'] == "ProductP" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       $b = new product($obj->dbconn);
       $b->read($f["old"]);
       echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
       $b = new product($obj->dbconn);
       $b->read($f["new"]);
       echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
     } else if ( $f['field'] == "ProdState" ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". $lang['ProdStates'][$f["old"]] ."</TD>\n";
       echo " <TD>&nbsp;". $lang['ProdStates'][$f["new"]] ."</TD>\n";
     } else if ( ereg("ProdRole?",$f['field'])
                 ||  ($f['field'] == "Customer")
                 ||  ($f['field'] == "SoldBy")
                 ||  ($f['field'] == "FileAuthor")
                 ||  ($f['field'] == "TeamDel")
                 ||  ($f['field'] == "TeamAdd")
                 ||  ($f['field'] == "BugAssignedTo")
                 ||  ($f['field'] == "InstalledBy") ) {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       if ( $f["old"] <= 0 ) {
         echo " <TD>&nbsp;</TD>\n";
       } else {
         $b = getObject($obj->dbconn,$f["old"]);
         if ( $b->id > 0 ) {
           echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
         } else {
           echo " <TD><I>". makelink("history_show.php?id=". $f["old"],$lang['HistoryDeleted']) ."</I></TD>\n";
         }
       }
       if ( $f["new"] <= 0 ) {
         echo " <TD>&nbsp;</TD>\n";
       } else {
         $b = getObject($obj->dbconn,$f["new"]);
         if ( $b->id > 0 ) {
           echo " <TD>&nbsp;". $b->getLink() ."</TD>\n";
         } else {
           echo " <TD><I>". makelink("history_show.php?id=". $f["new"],$lang['HistoryDeleted']) ."</I></TD>\n";
         }
       }
     } else {
       echo " <TD><B>&nbsp;". (isset( $lang[$f["field"]]) ? $lang[$f["field"]] : $f["field"]) ."</B></TD>\n";
       echo " <TD>&nbsp;". myentities($f["old"]) ."</TD>\n";
       echo " <TD>&nbsp;". myentities($f["new"])."</TD>\n";
     }
     $adr = new tutos_address($obj->dbconn);
     $adr->read($f["adr_id"]);
     echo " <TD>&nbsp;". $adr->getLink() ."</TD>\n";
     $mt = new DateTime();
     $mt->setDateTime($f["m_time"]);
     echo " <TD>&nbsp;". $mt->getDateTime() ."</TD>\n";
     echo "</TR>\n";
	 flush();
     unset($adr);
     unset($mt);
     unset($b);
     $a++;
   }
   echo "</TBODY>\n";
   ShowBackForwardNav($link1,$cols,$start,$a,$n);
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $lang;

   echo "<TABLE>";
   echo "<TR><TD NOWRAP>";
   if ( $obj != -1 ) {
#     echo "<SPAN CLASS=navigate>". $lang[$obj->gettype()]."</SPAN><BR>&nbsp;".menulink($obj->getURL(),$obj->getFullName());
#     echo "<BR>\n";
# link is already in Headline
   }
   echo "</TD><TR>";
   HTML_Select();
 }

 $link1 = "history_show.php";

 if ( isset($HTTP_GET_VARS['id']) ) {
   $id = $HTTP_GET_VARS['id'];
   $obj = getObject($dbconn,$id);
   $link1 = addUrlParameter($link1,"id=".$id);
   if ( $obj != -1 ) {
     $id = $obj->id;
     HTML_Header(sprintf($lang['HistoryDetail'],$lang[$obj->getType()]));
   } else {
     HTML_Header(sprintf($lang['HistoryDetail']," (". $lang['HistoryDeleted'] ." ". $id .")"));
   }
 } else {
   if ($current_user->admin  != 0 ) {
     $id = -1;
     $obj = -1;
     HTML_Header(sprintf($lang['HistoryDetail'],"\"". $lang['AppEverything'] ."\""));
   } else {
     $id = -1;
     $obj = -1;
     $msg .= "Missing ID";
     HTML_Header("ERROR");
   }
 }
 $link2 = $link1;
 if ( ! isset($HTTP_GET_VARS['start']) ) {
   $start = 0;
 } else {
   $start = $HTTP_GET_VARS['start'];
 }
 if ( ! isset($HTTP_GET_VARS['xf']) ) {
   $xf = "m_time";
 } else {
   $xf = $HTTP_GET_VARS['xf'];
 }
 if ( ! isset($HTTP_GET_VARS['xo']) ) {
   $xo = 1;
 } else {
   $xo = $HTTP_GET_VARS['xo'];
 }

 HTML_Base1();
 navigate($obj);
 HTML_Base2($msg);
 if ( $msg == "") {
   info($obj,$id,$start,$xf,$xo);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: history_show.php,v 1.41 2002/07/20 13:14:44 gokohnert Exp $
    $Author: gokohnert $
-->
