<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup installation
 * @module installation_ins
 * @package installation
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 */
 include("webelements.p3");
 include("permission.p3");
 include("installation.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("installation");

 $obj = new installation($dbconn);
 $gotourl = "installation_new.php";
 $msg = "";
 if ( isset($HTTP_POST_VARS['id']) ) {
   $obj->read($HTTP_POST_VARS['id']);
   $gotourl= addUrlParameter($gotourl,"id=". $HTTP_POST_VARS['id']);
 } else if ( $obj->id == -1 ) {
   $msg .= "Please enter a id<BR>";
 }

 if ( empty($HTTP_POST_VARS['pid']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['Product']) ."<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"pid=". $HTTP_POST_VARS['pid']);
 }

 if ( isset($HTTP_POST_VARS['cfn']) ) {
   if ( empty($HTTP_POST_VARS['cfn']) ) {
     $msg .= sprintf($lang['Err0009'],$lang['Customer']) ."<BR>";
   } else {
     $x = check_field($HTTP_POST_VARS['cfn'],"cfn","cl","acd");
	 $obj->setCustomer($x->id);
   }
 }

 if ( isset($HTTP_POST_VARS['ifn']) ) {
   $x = check_field($HTTP_POST_VARS['ifn'],"ifn","il");
   $obj->setInstaller($x->id);
 }

 if ( isset($HTTP_POST_VARS['sfn']) ) {
   $x = check_field($HTTP_POST_VARS['sfn'],"sfn","sl","at");
   $obj->setSeller($x->id);
 }

 $money = 0.0;
 sscanf($HTTP_POST_VARS['money'],"%f",&$money);
 if ( !empty($money) && !is_double($money) ) {
   $msg .= sprintf($lang['Err0017'],$lang['Money']) ."<BR>";
 }
 $gotourl= addUrlParameter($gotourl,"money=". UrlEncode($money));
 $gotourl= addUrlParameter($gotourl,"currency=". UrlEncode($HTTP_POST_VARS['currency']));

 $sd = new DateTime();
 $id = new DateTime();
 $sd->setDateTimeF("sale");
 $id->setDateTimeF("inst");

 $obj->setInstdate($id);
 $obj->setSalesdate($sd);

 # other modules
 $msg .= module_parseforms($current_user,$obj,$gotourl);


 if ( $msg == "" ) {
   $obj->setMoney($money);
   $obj->setCurrency($HTTP_POST_VARS['currency']);
   $obj->product->read($HTTP_POST_VARS['pid']);

   if ( isset($HTTP_POST_VARS['iid']) ) {
	 $obj->setInstaller($HTTP_POST_VARS['iid']);
   }

   if ( isset($HTTP_POST_VARS['cid']) ) {
     $obj->setCustomer($HTTP_POST_VARS['cid']);
   }

   if ( isset($HTTP_POST_VARS['sid']) ) {
     $obj->setSeller($HTTP_POST_VARS['sid']);
   }

   $dbconn->Begin("WORK");
   $msg .= $obj->save();
   $dbconn->Commit("WORK");

   $gotourl = $obj->getUrl();
 }

 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));
 $gotourl = addSessionKey($gotourl);

 /* Go back to user mask */
 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl() . $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: installation_ins.php,v 1.18.2.1 2002/08/15 08:04:11 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
