<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup installation
 * @module installation_overview
 */
 include("webelements.p3");
 include("permission.p3");
 include("installation.pinc");
 include("product.pinc");


 /* Check if user is allowed to use it */
 check_user();
 loadmodules("installation");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,&$result,$start=0) {
   global $lang,$link1,$tutos;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo $lang['Err0048'];
     return;
   }

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("","#",$link1);
   echo order_header("",$lang['Product'],$link1);
   echo order_header("",$lang['Customer'],$link1);
   echo order_header("instdate",$lang['Date'],$link1);

   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";
   $line = 0;
   while ( ($a < $n) && ($a < $end) ) {
     if ( $line == 1 ) {
       $line = 2;
     } else {
       $line = 1;
     }

     $i = new installation($dbconn);
     $i->read_result($result,$a);
     $a++;
     echo "<TR CLASS=line". $line .">\n";
     echo " <TD ALIGN=right>". $i->getLink("#".$a) ."&nbsp;</TD>\n";
     echo " <TD>". $i->product->getLink() ."</TD>\n";
     if ( $i->customer->id != -1 ) {
       echo " <TD>". $i->customer->getLink() ."</TD>\n";
     } else {
       echo " <TD>&nbsp;</TD>\n";
     }
     echo " <TD>". $i->instdate->getLinkDate() ."</TD>\n";
     echo "</TR>\n";
   }
   echo "</TBODY>\n";

   ShowBackForwardNav($link1,4,$start,$a,$n);

   echo "</TABLE>\n";

 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(useinstmanagement,PERM_NEW) ) {
      echo menulink("installation_new.php",$lang['NewEntry'],sprintf($lang['InstCreateI'],"")) . "<BR>\n";
   }
   echo "</TD></TR>";

   HTML_Select();
 }


 HTML_Header($lang['InstOverview']);

 $link1 = "installation_overview.php";
 $q = "SELECT * FROM installations";
 $pre = " WHERE ";

 if ( isset($HTTP_GET_VARS['link_id']) ) {
   $link1 = addUrlParameter($link1,"link_id=". $HTTP_GET_VARS['link_id']);
   $o = getObject($dbconn,$HTTP_GET_VARS['link_id']);
   if ( $o->id > 0 ) {
     if ( $o->getType() == "product" ) {
       $q .= $pre ."product_id = ". $o->id;
       $pre = " AND ";
     } else if ( $o->getType() == "company" ) {
       $q .= $pre ."customer_id = ". $o->id;
       $pre = " AND ";
     } else if ( $o->getType() == "address" ) {
       $q .= $pre ."customer_id = ". $o->id;
       $pre = " AND ";
     }
   }
 }

 # sorting
 $xxx = "";
 order_parse($q,$link1,$xxx,$xxx,"instdate");

 $r = $dbconn->Exec($q);

 if ( isset($HTTP_GET_VARS['start']) )  {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
 }
 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($dbconn,$r,$start);
 HTML_Base3();

 $r->free();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: installation_overview.php,v 1.18 2002/06/20 10:48:20 gokohnert Exp $
    $Author: gokohnert $
-->
