<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup installation
 * @module installation_show
 * @package installation
 */
 include("webelements.p3");
 include("permission.p3");
 include("installation.pinc");
 include 'file.pinc';
 include 'bug.pinc';
 include 'timetrack.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("installation");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";

   echo "<TR>\n";
   echo " <TH COLSPAN=4>".  sprintf($lang['Showing'],$lang[$obj->getType()])."</TH>\n";

   echo "</TR><TR>\n";
   showfield($lang['ProductP']);
   echo " <TD COLSPAN=3>". $obj->product->getLink() ."&nbsp;</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['Customer']);
   if ( $obj->customer->id != -1 ) {
     echo " <TD COLSPAN=3>". $obj->customer->getLink() ."&nbsp;</TD>\n";
   } else {
     echo " <TD COLSPAN=3>&nbsp;</TD>\n";
   }

   echo "</TR><TR>\n";
   showfield($lang['InstalledBy']);
   if ( $obj->installer->id != -1 ) {
     echo " <TD>". $obj->installer->getLink() ."&nbsp;</TD>\n";
   } else {
     echo " <TD>&nbsp;</TD>\n";
   }
   showfield($lang['atDateTime']);
   echo " <TD>". $obj->instdate->getLinkDate() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['SoldBy']);
   if ( $obj->seller->id != -1 ) {
     echo " <TD>". $obj->seller->getLink() ."</TD>\n";
   } else {
     echo " <TD>&nbsp;</TD>\n";
   }
   showfield($lang['atDateTime']);
   echo " <TD>". $obj->salesdate->getLinkDate() ."</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['Money']);
   echo " <TD COLSPAN=3>".number_format( $obj->money,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". myentities($obj->currency) ."</TD>\n";

   echo "</TR>\n";

   bug::infolist($current_user,$obj,4);
   url::infolist($current_user,$obj,4);
   tutos_file::infolist($current_user,$obj,4);

   if ( $current_user->feature_ok(usetimetrack,PERM_SEE) ) {
     $obj->readTimetrackSum();
     $rows = 0;
     if ( $obj->timetracksum > 0) {
       $rows++;
	 }
     @reset ($obj->tsum);
     while( list ($i,$f) = @each ($obj->tsum)) {
       if ( $obj->tsum[$i] > 0 ) {
         $rows++;
       }
     }
     $r = 0;
     if ( $rows > 0 ) {
       echo "<TR>\n";
       echo "<TD CLASS=\"desc\" VALIGN=\"top\" ROWSPAN=". $rows .">". $lang['Timetrack'] ;
       echo "</TD>\n";

       if ( $obj->timetracksum > 0) {
         echo " <TD VALIGN=top ALIGN=right>\n";
         echo makelink("timetrack_overview.php?link_id=". $obj->id ,number_format($obj->timetracksum,2),$lang['TimetrackOverview']);
         echo " </TD>\n";
         echo " <TD ALIGN=left>". $lang['hours'] ."</TD>\n";
         echo " <TD>&nbsp;</TD>\n";
         echo "</TR>\n";
         $r = 1;
	   }
       @reset ($obj->tsum);
       while( list ($i,$f) = @each ($obj->tsum)) {
         if ( $obj->tsum[$i] > 0 ) {
           if ( $r == 1 ) {
             echo "<TR>\n";
           }
           echo " <TD ALIGN=right>". number_format($obj->tsum[$i],2) ."</TD>\n";
           echo " <TD ALIGN=left>". $lang['hours'] ."</TD>\n";
           echo " <TD>(". $lang[$i] .")</TD>\n";
           echo "</TR>\n";
           $r = 1;
         }
       }
     }
   }
   # References to modules
   show_module_infolists($current_user,$obj,4);
   echo $obj->getHistoryLink(4);
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(useinstmanagement,PERM_NEW) ) {
      echo menulink("installation_new.php",$lang['NewEntry'],sprintf($lang['InstCreateI'],"")) . "<BR>\n";
   }
   if ( $obj->id > 0 ) {

     if ( $obj->mod_ok() ) {
       echo menulink("installation_new.php?id=". $obj->id,$lang['Modify'],$lang['InstModifyI']) . "<BR>\n";
     }
     if ( $obj->del_ok() ) {
       echo confirmlink("installation_del.php?id=". $obj->id ,$lang['Delete'],sprintf($lang['InstDelI'],$obj->getFullName() )) ."&nbsp;<BR>";
     }
   }
   echo "<BR>\n";
   echo bug::getaddlink($current_user,$obj);
   echo tutos_file::getaddlink($current_user,$obj);
   echo timetrack::getaddlink($current_user,$obj);
   echo "<BR>\n";
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }


 HTML_Header($lang['InstDetail']);

 $i = new installation($dbconn);
 if (isset($HTTP_GET_VARS['id'])) {
   $i->read($HTTP_GET_VARS['id']);
 }
 if ($i->id < 1) {
   $msg .= sprintf($lang['Err0040'],$lang[$i->getType()]);
 }

 if ( ! $i->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$i->getType()]);
 }

 HTML_Base1();
 navigate($i);
 HTML_Base2($msg);
 if ( ($i->id > 0) && $i->see_ok() ) {
   info($i);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: installation_show.php,v 1.30 2002/07/15 08:01:24 gokohnert Exp $
    $Author: gokohnert $
-->
