<?
/**
 * Copyright 1999/2000 by Gero Kohnert
 *
 * insert an invoice to the database
 *
 * @modulegroup invoice
 * @module invoice_ins
 * @package invoice
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include("webelements.p3");
 include("permission.p3");
 include("product.pinc");
 include("installation.pinc");
 include("timetrack.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("invoice");
 loadmodule("invoice");

 $gotourl = "invoice_new.php";
 $msg = "";

 $i = new invoice($dbconn);
 if ( isset($HTTP_POST_VARS['id']) ) {
   $i->read($HTTP_POST_VARS['id']);
   if ( $i->id != $HTTP_POST_VARS['id'] ) {
     $msg .= sprintf($lang['Err0040'],$lang[$i->getType()]);
   } else {
     $gotourl= addUrlParameter($gotourl,"id=". $i->id);
   }
   $i->read_pos();
 } else {
   $i->creator = $current_user;
 }

 if ( isset($HTTP_POST_VARS['link_id']) ) {
   $i->link_id = $HTTP_POST_VARS['link_id'];
   $gotourl= addUrlParameter($gotourl,"link_id=". $i->link_id);
 }

 if ( isset($HTTP_POST_VARS['accountant']) ) {
   $i->setAccountant($HTTP_POST_VARS['accountant']);
   $gotourl= addUrlParameter($gotourl,"accountant=". $i->accountant);
 }

 if ( isset($HTTP_POST_VARS['name']) && ($HTTP_POST_VARS['name'] != "") ) {
   $i->setName(Stripslashes($HTTP_POST_VARS['name']));
   $gotourl= addUrlParameter($gotourl,"name=". UrlEncode($i->name));
 } else {
   $msg .= sprintf($lang['Err0009'],$lang['InvoiceName']) ."<BR>";
 }

 if ( isset($HTTP_POST_VARS['state']) ) {
   $i->setState($HTTP_POST_VARS['state']);
   $gotourl= addUrlParameter($gotourl,"state=". $i->state);
 }

 for ( $x = 0 ; $x < 3 ; $x++ ) {
   $d = new DateTime(0);
   $d->setDateTimeF("d". $x);
   $gotourl= addUrlParameter($gotourl,"d".$x."=". $d->getYYYYMMDD() );
   if ( 1 != $d->checkDMY() ) {
     $msg .= sprintf($lang['Err0038'],$lang['InvDateDue'][$i]) ."<BR>";
   } else {
     $i->setDateDue($x,$d);
   }

   $d = new DateTime(0);
   $d->setDateTimeF("s". $x);
   $gotourl= addUrlParameter($gotourl,"s".$x."=". $d->getYYYYMMDD() );
   if ( 1 != $d->checkDMY() ) {
     $msg .= sprintf($lang['Err0038'],$lang['InvDateSent'][$i]) ."<BR>";
   } else {
     $i->setDateSent($x,$d);
   }
 }

 if ( isset($HTTP_POST_VARS['cfn']) ) {
   if ( empty($HTTP_POST_VARS['cfn']) ) {
     $msg .= sprintf($lang['Err0009'],$lang['InvoiceCustomer']) ."<BR>";
   } else {
     $customer = check_field($HTTP_POST_VARS['cfn'],"cfn","cl","acd");
     $i->setCustomer($customer);
   }
 }
 if ( isset($HTTP_POST_VARS['cid']) ) {
   $m = getObject($dbconn,$HTTP_POST_VARS['cid']);
   $i->setCustomer($m);
 }
 # Add Positions
 if ( isset($HTTP_POST_VARS['add']) ) {
   @reset($HTTP_POST_VARS['add']);
   while (list ($key,$val) = @each ($HTTP_POST_VARS['add'])) {
     $i->add_Pos($val);
   }
 }

 # Actions in fields

 @reset($HTTP_POST_VARS);
 while (list ($key,$val) = @each ($HTTP_POST_VARS)) {
   if ( ereg("^([CIDST])-(.*)",$key,$a) ) {
     if ( !isset($i->pos[$a[2]]) ) {
	   $msg .= "missing ". $a[2] ."<BR>";
     }
     if ( $a[1] == "T" ) {
       $i->pos[$a[2]]->tax = $val;
     } else 
     if ( $a[1] == "D" ) {
       $i->pos[$a[2]]->description = StripSlashes($val);
     } else 
     if ( $a[1] == "I" ) {
       $i->pos[$a[2]]->items = $val;
     } else
     if ( $a[1] == "S" ) {
       $i->pos[$a[2]]->sum_single = $val;
     }
     if ( $a[1] == "C" ) {
       $i->pos[$a[2]]->currency = $val;
     }
   }
 }
 # Delete Positions
 if ( isset($HTTP_POST_VARS['del']) ) {
   @reset($HTTP_POST_VARS['del']);
   while (list ($key,$val) = @each ($HTTP_POST_VARS['del'])) {
     $i->pos[$val]->DELETE = 1;
   }
 }

 # other modules
 $msg .= module_parseforms($current_user,$i,$gotourl);

 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $msg .= $i->save();
   $dbconn->Commit("WORK");

   $gotourl = "invoice_new.php?id=". $i->id;
 }
 $gotourl = addSessionKey($gotourl);
 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl() . $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: invoice_ins.php,v 1.3.2.1 2002/08/15 08:04:11 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
