<?
/**
 * Copyright 2002 by Gero Kohnert
 *
 * show an invoice
 *
 * @modulegroup invoice
 * @module invoice_show
 * @package invoice
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include("webelements.p3");
 include("permission.p3");
 include("installation.pinc");


 /* Check if user is allowed to use it */
 check_user();
 loadmodules("invoice");
 loadmodule("invoice");

 /* ---------------------------------------------------------------------------
  *
  */
 Function show_invpos(&$f) {
   global $lang;

   $f->read_ref();
   echo "<TR>\n";
   if ( $f->ref != -1 ) {
     echo " <TD ALIGN=right VALIGN=top>". $f->ref->getLink(sprintf("%04d",$f->pos)) ."</TD>";
   } else {
     echo " <TD ALIGN=right VALIGN=top>". sprintf("%04d",$f->pos) ."</TD>";
   }
   echo " <TD ALIGN=right VALIGN=top>".  number_format($f->items,2,$lang['DecPoint'],$lang['ThousandPoint']) ."&nbsp;</TD>";
   echo " <TD ALIGN=right VALIGN=top>". $f->itype ."&nbsp;</TD>";
   echo " <TD VALIGN=top><PRE>". $f->description ."</PRE></TD>";
   echo " <TD ALIGN=right VALIGN=top>".  number_format($f->sum_single ,2,$lang['DecPoint'],$lang['ThousandPoint']) ."</TD>";
   echo " <TD ALIGN=right VALIGN=top>".  number_format($f->tax ,2,$lang['DecPoint'],$lang['ThousandPoint']) ."</TD>";
   echo " <TD ALIGN=right VALIGN=top>". number_format($f->getTotal(),2,$lang['DecPoint'],$lang['ThousandPoint']) ."</TD>";
   echo " <TD ALIGN=left VALIGN=top>&nbsp;". $f->currency ."</TD>";
   echo "</TR>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$obj) {
   global $current_user, $tutos,$lang;


   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=8>". sprintf($lang['Showing'],$lang[$obj->getType()]) ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   echo " <TD COLSPAN=8>". $lang['createdby'] ." ". $obj->creator->getLink();
   echo " ". $lang['atDateTime'] ." ". $obj->creation->getLinkDateTime() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['Accountant']);
   if ( $obj->acc->getType() == "location" ) {
     echo "<TD COLSPAN=7>". $obj->acc->company->getLink() ."</TD>\n";
   } else {
     echo "<TD COLSPAN=7>". $obj->acc->getLink() ."</TD>\n";
   }
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['InvoiceName']);
   echo "<TD COLSPAN=3>". $obj->name ."</TD>\n";
   showfieldc($lang['InvoiceState']);
   echo "<TD COLSPAN=3>". $lang['InvoiceStates'][$obj->state] ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['InvoiceCustomer']);
   if (is_object($obj->customer) ) {
     echo "<TD COLSPAN=7>". $obj->customer->getLink() ."</TD>\n";
   } else {
     echo "<TD COLSPAN=7>". $lang['HistoryDeleted'] ."</TD>\n";
   }
   echo "</TR>\n";

   if ( $obj->ref != -1 ) {
     echo "<TR>\n";
     showfieldc($lang[$obj->ref->getType()],0);
     echo " <TD COLSPAN=7 VALIGN=top>". $obj->ref->getLink() ."</TD>";
     echo "</TR>\n";
   }

   if ( ($obj->datesent[0]->notime != 1) or ($obj->datedue[0]->notime != 1) ) {
     echo "<TR>\n";
     showfieldc($lang['InvDateSent'][0]);
     echo "<TD COLSPAN=3>". $obj->datesent[0]->getDate() ."&nbsp;</TD>\n";
     showfieldc($lang['InvDateDue'][0]);
     echo "<TD COLSPAN=3>". $obj->datedue[0]->getDate() ."&nbsp;</TD>\n";
     echo "</TR>\n";
   }

   if ( $obj->datesent[1]->notime != 1 ) {
     echo "<TR>\n";
     showfieldc($lang['InvDateSent'][1]);
     echo "<TD COLSPAN=3>". $obj->datesent[1]->getDate() ."&nbsp;</TD>\n";
     showfieldc($lang['InvDateDue'][1]);
     echo "<TD COLSPAN=3>". $obj->datedue[1]->getDate() ."&nbsp;</TD>\n";
     echo "</TR>\n";
   }

   if ( $obj->datesent[2]->notime != 1 ) {
     echo "<TR>\n";
     showfieldc($lang['InvDateSent'][2]);
     echo "<TD COLSPAN=3>". $obj->datesent[2]->getDate() ."&nbsp;</TD>\n";
     showfieldc($lang['InvDateDue'][2]);
     echo "<TD COLSPAN=3>". $obj->datedue[2]->getDate() ."&nbsp;</TD>\n";
     echo "</TR>\n";
   }
   if ( $obj->state == 7 ) {
     echo "<TR>\n";
     showfieldc($lang['InvDatePayed']);
     echo "<TD COLSPAN=7>". $obj->datefinish->getDate() ."&nbsp;</TD>\n";
     echo "</TR>\n";
   }
   if ( $obj->state == 8 ) {
     echo "<TR>\n";
     showfieldc($lang['InvDateCancel']);
     echo "<TD COLSPAN=7>". $obj->datefinish->getDate() ."&nbsp;</TD>\n";
     echo "</TR>\n";
   }

   echo "<TR>\n";
   echo "<TH>". $lang['InvPosPos'] ."</TH>\n";
   echo "<TH>". $lang['InvPosItems'] ."</TH>\n";
   echo "<TH>". $lang['InvPosIType'] ."</TH>\n";
   echo "<TH>". $lang['InvPosDesc'] ."</TH>\n";
   echo "<TH>". $lang['InvPosSingle'] ."</TH>\n";
   echo "<TH>". $lang['InvPosTax'] ."</TH>\n";
   echo "<TH>". $lang['InvPosSum'] ."</TH>\n";
   echo "<TH>". $lang['Currency'] ."</TH>\n";
   echo "</TR>\n";
   
   @reset($obj->pos);
   if ( count($obj->pos) == 0 ) {
     echo "<TR>\n";
     echo "<TD COLSPAN=8 CLASS=warn>".$lang['Err0048']."</TD>\n";
     echo "</TR>\n";
   }
   @reset($tutos[currencies]);
   while( list ($i,$c) = @each ($tutos[currencies])) {
     $sum[$c] = 0.0;
   }
   $sum["?"] = 0.0;
   @reset($obj->pos) ;
   while ( list ($i,$f) = @each ($obj->pos) ) {
     show_invpos($f);
     $sum[$f->currency] += $f->getTotal();
     unset($f);
   }
   echo "<TR>";
   echo "<TD COLSPAN=6>&nbsp;</TD>\n";
   echo "<TD COLSPAN=2>&nbsp;";
   @reset($tutos[currencies]);
   $pre = "";
   while( list ($i,$c) = @each ($tutos[currencies])) {
     if ( $sum[$c] != 0 ) {
       echo $pre . number_format($sum[$c],2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". $c;
       $pre = "<BR>\n";
     }
   }
   echo  "</TD>\n";
   echo "</TR>";

   # References to modules
   show_module_infolists($current_user,$obj,8);
   echo $obj->getHistoryLink(8);
   echo "</TABLE>\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $lang, $tutos, $current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo invoice::getSelectLink($current_user,$lang['Search'])."<BR>";
   if ( ($obj->id > 0) && $obj->mod_ok() ) {
     echo menulink("invoice/invoice_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['InvModInfo'],$obj->getFullname())) ."&nbsp;<BR>";

   }
   echo "<BR>\n";

   if ( ($obj->id > 0) && $obj->see_ok() ) {
     if ( function_exists( 'pdf_open_file' ) ) {
       echo menulink($obj->getUrl()  ."&format=pdf",$lang['InvDocument'],$lang['InvDocumentI']) ."&nbsp;<BR>";
     }
   }
   echo "<BR>\n";
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }

 $i = new invoice($dbconn);
 $i->read($HTTP_GET_VARS['id']);
 if ( ! $i->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$i->getType()]);
 } else {
   if ( $i->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$i->getType()]);
     $format = "";
   } else {
     $i->read_pos();
     $i->read_ref();
   }
 }


 if ( isset($HTTP_GET_VARS['format']) ) {
   $format = $HTTP_GET_VARS['format'];
 } else {
   $format = "html";
 }

 if ( $format == "html" ) {
   if ( $i->id > 0 ) {
     HTML_Header($lang['Invoice']." :".$i->getFullName());
   } else {
     HTML_Header($lang['Invoice']);
   }
   HTML_Base1();
   navigate($i);
   HTML_Base2($msg);
   if ( ($i->id > 0) && $i->see_ok() ) {
     info($i);
   }
   HTML_Base3();
 } else if ( $format == "pdf" ) {
   $data = $i->getPDF();
   Header("Content-Type: application/pdf");
   Header("Content-Disposition: inline; filename=\"". $i->id ."pdf\"");
   Header('Content-length: ' . strlen($data));
   Header("Content-Description: Upload from TUTOS" );
   echo $i->getPDF();
 }
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: invoice_show.php,v 1.8.2.2 2002/08/28 16:36:53 gokohnert Exp $
    $Author: gokohnert $
-->
