<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup installation
 * @module installation_ins
 * @package address
 */
 include("webelements.p3");
 include("permission.p3");


 /* Check if user is allowed to use it */
 check_user();
 loadmodules("address"."ins");


 $msg = "";

 $l = new location($dbconn);
 # READ the data
 if ( isset($HTTP_POST_VARS['loc_id']) && ($HTTP_POST_VARS['loc_id']) != -1 ) {
   $l->read($HTTP_POST_VARS['loc_id']);
   if ( $l->id == -1 ) {
     $msg .= "Unknown ID";
   }
 }
 # Parent Object
 $p = getObject($dbconn,$HTTP_POST_VARS['id']);
 if ( $p == -1 ) {
   $msg .= "Missing Parent ID";
   $gotourl = $HTTP_SERVER_VARS['HTTP_REFERR'];
 } else if ( $p->getType() == "address" ) {
   $gotourl = "address_new.php";
 } else if ( $p->getType() == "company" ) {
   $gotourl = "company_new.php";
 } else if ( $p->getType() == "department" ) {
   $gotourl = "department_new.php";
 }
 $l->adr_id = $p->id;


 if ( !isset($HTTP_POST_VARS['category']) || empty($HTTP_POST_VARS['category']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['AdrCategory']) ."<BR>";
 } else {
   $category = $HTTP_POST_VARS['category'];
   $gotourl= addUrlParameter($gotourl,"category=". $category);
   $l->setCategory($category);
 }

 if ( !isset($HTTP_POST_VARS['lname']) ||  empty($HTTP_POST_VARS['lname']) ) {
   $msg .= sprintf($lang['Err0009'],$lang['AdrDescription']) ."<BR>";
 } else {
   $lname = $HTTP_POST_VARS['lname'];
   $gotourl= addUrlParameter($gotourl,"lname=". UrlEncode(StripSlashes($lname)));
   $l->setLname($lname);
 }

 # Check Company
 if ( !isset($HTTP_POST_VARS['c_id']) ) {
   $l->company = check_field($HTTP_POST_VARS['company'],"company","cl","c");
 } else {
   if ( $c_id != -1 ) {
     $l->company->read($HTTP_POST_VARS['c_id']);
   }
 }
 # Check Department
 if ( !isset($HTTP_POST_VARS['d_id']) ) {
   $l->department = check_field($HTTP_POST_VARS['department'],"department","dl","d");
 } else {
   if ( $d_id != -1 ) {
     $l->department->read($HTTP_POST_VARS['d_id']);
   }
 }
 if ( is_object ($l->department) ) {
   $l->company = $l->department->company;
 }

 $i = 0;
 while($i < count($l->larray)) {
   $f = $l->larray[$i];
   if ( isset($HTTP_POST_VARS[$f]) ) {
     $l->setField($f,$HTTP_POST_VARS[$f]);
     $gotourl= addUrlParameter($gotourl,$f ."=". UrlEncode(StripSlashes($l->$f)));
   }
   $i++;
 }
 #
 # Email Verification was fetched from http://www.phpbuilder.com/snippet/detail.php?type=snippet&id=107
 #
 $regex = '^([._a-z0-9-]+[._a-z0-9-]*)@(([a-z0-9-]+\.)*([a-z0-9-]+)(\.[a-z]{2,3}))$';
 if ( isset($HTTP_POST_VARS['email_1']) ) {
   $email_1 = trim($HTTP_POST_VARS['email_1']);
   if ( ($email_1 != "") && !eregi($regex,$email_1)) {
     $msg .= sprintf($lang['Err0043'],$email_1);
   }
 }
 if ( isset($HTTP_POST_VARS['email_2']) ) {
   $email_2 = trim($HTTP_POST_VARS['email_2']);
   if ( ($email_2 != "") && ! eregi($regex,$email_2)) {
     $msg .= sprintf($lang['Err0043'],$email_2);
   }
 }
 if ( isset($HTTP_POST_VARS['cploc']) && ($HTTP_POST_VARS['cploc'] == 1) ) {
   # Copy the location data from the companies location if possible
   $gotourl= addUrlParameter($gotourl,"cploc=1");
   if ( isset ($l->company->id) ) {
     $l->company->read_locs_data();
     if ( count($l->company->location) > 0 ) {
       reset ($l->company->location);
       $x = current($l->company->location);
       $l->city = $x->city;
       $l->state = $x->state;
       $l->country = $x->country;
       $l->zip = $x->zip;
       $l->street1 = $x->street1;
       $l->street2 = $x->street2;
     }
   }
 }
 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $l->save();
   $dbconn->Commit("WORK");
   if ( $p->getType() == "address" ) {
     $gotourl = "address_new.php";
   } else if ( $p->getType() == "company" ) {
     $gotourl = "company_new.php";
   } else if ( $p->getType() == "department" ) {
     $gotourl = "department_new.php";
   }
 }
 # The reference
 $gotourl= addUrlParameter($gotourl,"id=". $l->adr_id);
 $gotourl= addUrlParameter($gotourl,"loc_id=". $l->id);
 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));
 $gotourl = addSessionKey($gotourl);

 Header("Status: 302 Moved Temporarily");
 Header("Location:". getBaseUrl(). $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: location_ins.php,v 1.20.2.3 2002/09/13 10:42:22 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
