<?
/*
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * based on some work/ideas of Michael Somers( Twent First Century Communication <msomers at tfcci.com>)
 */
 include("webelements.p3");
 include("permission.p3");
 include("file.pinc");
 include("product.pinc");
 include("installation.pinc");
 include("appointment.pinc");
 include("bug.pinc");
 include("task.pinc");
 include("mailbox.pinc");
 include("timetrack.pinc");


 /* Check if user is allowed to use it */
 check_user();
 loadmodules('mytutos');

 Function info_table_start() {
   return " <TABLE BORDER=0 CELLPADDING=3 CELLSPACING=1 WIDTH=\"100%\">\n";
 }
 Function info_table_end() {
   return " </TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  * Display calendar for one week
  */
 Function calendar_info(&$adr,$t) {
   global $lang, $tutos, $current_user;

   $ts = mktime(12,0,0,substr($t,4,2),substr($t,6,2),substr($t,0,4));

   /* Back to last Monday or Sunday before ts */
   while ( Date("w",$ts) != $adr->weekstart ) {
     $ts -= 86400;
   }

   $w0 =  (( 1 + Date("w",mktime(12,0,0,1,1, Date("Y",$ts) ) )) % 7) > 3;
   $wn = sprintf("%02d", Round( (Date("z",$ts)+7 ) / 7) );
   $yy = Date("y",$ts);

   $day = 0;
   $dd = new DateTime();

   $from =  new DateTime();
   $from->setDateTimeTS($ts - 12 * 3600);
   $to = $from;
   $to->addDays(7);

   $adr->callist = array();
   appointment::readCal($adr,$from,$to);
   task::readCal($adr,$from,$to);
   @reset($tutos[activemodules]);
   while( list ($i,$f) = @each ($tutos[activemodules])) {
     $x = new $f($adr->dbconn);
     $x->readCal($adr,$from,$to);
   }

   echo info_table_start();
   echo " <TR>\n";
   echo "  <TH>". $lang['week'] ."</TH>\n";
   $wd = $ts;
   if ( $adr->weekstart == 0 ) {
     if ($adr->isWorkDay(0)) {
       $tref = Date("Ymd",$wd);
       echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day0']) ."</TH>\n";
     }
     $wd = NextDay($wd);
   }
   if ($adr->isWorkDay(1)) {
     $tref = Date("Ymd",$wd);
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day1']) ."</TH>\n";
   }
   $wd = NextDay($wd);

   if ($adr->isWorkDay(2)) {
     $tref = Date("Ymd",$wd);
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day2']) ."</TH>\n";
   }
   $wd = NextDay($wd);

   if ($adr->isWorkDay(3)) {
     $tref = Date("Ymd",$wd);
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day3']) ."</TH>\n";
   }
   $wd = NextDay($wd);

   if ($adr->isWorkDay(4)) {
     $tref = Date("Ymd",$wd);
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day4']) ."</TH>\n";
   }
   $wd = NextDay($wd);

   if ($adr->isWorkDay(5)) {
     $tref = Date("Ymd",$wd);
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day5']) ."</TH>\n";
   }
   $wd = NextDay($wd);

   if ($adr->isWorkDay(6)) {
     $tref = Date("Ymd",$wd);
     echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day6']) ."</TH>\n";
   }
   $wd = NextDay($wd);

   if ( $adr->weekstart != 0 ) {
     if ($adr->isWorkDay(0)) {
       $tref = Date("Ymd",$wd);
       echo "  <TH>". menulink("calendar_day.php?t=". $tref,$lang['Day0']) ."</TH>\n";
     }
     $wd = NextDay($wd);
   }
   echo " </TR>\n";

   echo " <TR>\n";
   echo " <TD CLASS=week WIDTH=\"5%\">". menulink("calendar_week.php?t=".Date("Ymd",$ts), $wn ."/". $yy, $wn ."/". $yy ) ."</TD>\n";

   while ( $day < 7 ) {
     # $d = strftime($lang['DateFormatStr'],$ts);
	 $dd->setDateTimeTS($ts);
     $d = $dd->getDate();
     $tref = Date("Ymd",$ts);
     $dinfo = GetDaysInfo($ts);
     /* Select appointments for this day */
     $next = NextDay($ts);
     if ( ! $dd->isWorkDay($adr) ) {
       $ts = $next;
       $day++;
       continue;
     }
     echo "<TD CLASS=\"". $dinfo[color] ."\" WIDTH=\"10%\">\n";

     if ( isset($dinfo[Desc]) ) {
       if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
         echo " " . makelink("app_new.php?t=". $tref,$d,$lang['NewAppointInfo'],$dinfo[popinfo]) ."\n";
       } else {
         echo " " . $d ."\n";
       }
       echo "<BR><FONT SIZE=-1>". $dinfo[Desc] ."</FONT>\n";
     } else {
       if ( $current_user->feature_ok(usecalendar,PERM_NEW) ) {
         echo " " . makelink("app_new.php?t=". $tref,$d,$lang['NewAppointInfo']) ."\n";
       } else {
         echo " " . $d ."\n";
       }
     }

     $hastable = 0;
     if ( count($adr->callist) > 0 ) {
       $xxx = $adr->callist;
       @reset($xxx);
       while( list ($a,$apo) = @each ($xxx)) {
         /* the correct day */
         if ( ! $adr->callist[$a]->inside($dd) ) {
           continue;
         }
	     # Check if appointment is displayed
	     if ( $adr->callist[$a]->gettype() == "appointment" ) {
		   $found = 0;
		   @reset($adr->callist[$a]->participant);
		   while ( ($found == 0) && (list ($i,$f) = @each ($adr->callist[$a]->participant)) ) {
			 if ( $f->id == $adr->id ) {
			   $found = 1;
			 } else if ( array_key_exists($f->id,$adr->teamids) ) {
               $found = 1;
			 }
		   }
		   if ( $found == 0 ) {
			 continue;
		   }
		 }
		 // Do not show finished tasks
		 if ( ($adr->callist[$a]->gettype() == "task") && ($adr->callist[$a]->state == 2) ) {
		   continue;
		 }
		 if ( $hastable == 0 ) {
		   echo " <TABLE CELLSPACING=0 CELLPADDING=0 BORDER=0 WIDTH=\"100%\">\n";
		   $hastable = 1;
		 } else {
           echo "  <TR><TD CLASS=". $dinfo[color] ." COLSPAN=3><IMG SRC=\"". $tutos['base'] ."/html/black.png\" WIDTH=\"100%\" HEIGHT=1></TD></TR>\n";
		 }
		 // Show appointments or task
		 $adr->callist[$a]->formatted();
       }
     }

     if ( $hastable == 1 ) {
       echo " </TABLE>\n";
     }

     echo "</TD>\n";
     $day++;
     $ts = $next;
   }
   echo " </TR>\n";
   echo info_table_end();
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$adr,$t) {
   global $lang , $tutos, $current_user;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   # Header
   echo "<TH COLSPAN=4>". sprintf($lang['PersonalPageFor'],$adr->getFullname()) ."</TH>\n";
   echo "</TR>\n";

   # Display all the info blocks
   # Weeks calendar
   $ts = mktime(0,0,0,substr($t,4,2),substr($t,6,2),substr($t,0,4));
   $last_week = Date("Ymd",$ts -  7 * 86400);
   $next_week = Date("Ymd",$ts +  7 * 86400);
   if ( $current_user->feature_ok(usecalendar,PERM_SEE) ) {
     echo "<TR>\n";
     echo " <TH COLSPAN=4>". menulink("mytutos.php?t=".$last_week,$tutos[image][left],$lang['lastweek']) . "&nbsp;". $lang['Calendar'] ."&nbsp;" . menulink("mytutos.php?t=".$next_week,$tutos[image][right] ,$lang['nextweek'])  ."</TH>\n";
     echo "</TR>\n";
     echo "<TR>\n";
     echo " <TD COLSPAN=4 VALIGN=top>\n";
     calendar_info($adr,$t);
     echo " </TD>\n";
     echo "</TR>\n";
   }
   echo "<TR>\n";
   # Projects
   echo " <TD WIDTH=\"50%\" COLSPAN=2 VALIGN=top>\n";
   echo product::mytutos($adr);
   echo " </TD>\n";
   # Bugs
   echo " <TD WIDTH=\"50%\" COLSPAN=2 VALIGN=top>\n";
   echo bug::mytutos($adr);
   echo " </TD>\n";
   echo "</TR>\n";

   $cnt = 0;
   @reset($tutos[activemodules]);
   while( list ($i,$f) = @each ($tutos[activemodules])) {
     $x = new $f($adr->dbconn);
     $r = $x->mytutos($adr);
     if ($r == "") {
       continue;
     }
     if ( ($cnt % 2) == 0 ) {
       echo "<TR>\n";
     }
     echo " <TD WIDTH=\"50%\" COLSPAN=2 VALIGN=top>\n". $r ."</TD>\n";
     if ( ($cnt % 2) != 0 ) {
       echo "</TR>\n";
     }
     $cnt++;
   }
   if ( ($cnt % 2) != 0 ) {
     echo "</TR>\n";
   }

   echo "<TR>\n";
   # Files
   echo " <TD COLSPAN=2 VALIGN=top>\n";
   echo tutos_file::mytutos($adr);
   echo " </TD>\n";
   echo " <TD COLSPAN=2 VALIGN=top>\n";
   echo mailbox::mytutos($adr);
   echo " </TD>\n";
   echo "</TR>\n";

   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $current_user,$tutos, $lang ;

   echo "<TABLE>\n";
   echo "<TR><TD>\n";
   if ( $obj->mod_ok() ) {
     echo  menulink("user_new.php?id=".$obj->id ,$lang['PersonalSettings'],sprintf($lang['PersonalSettingsI'],$obj->getFullName())) . "<BR>\n";
   }

   if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) ) {
     echo menulink("task_overview.php?id=". $obj->id ,$lang['TaskOverview'],sprintf($lang['TaskOverviewInfo'],$obj->getFullName())) ."<BR>\n";
   }

   if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) &&  $current_user->feature_ok(usecalendar,PERM_SEE) ) {
     echo menulink("res_cal.php?id=".$obj->id,$lang['ResCal'],$lang['ResCal']) ."<BR>\n";
   }

   if ( $current_user->feature_ok(usetimetrack,PERM_SEE) ) {
     echo menulink("timetrack_overview.php?worker=".$obj->id,$lang['TimetrackBooked'],sprintf($lang['TimetrackBookedI'],$obj->getFullName())) ."<BR>\n";
   }

   echo "<HR NOSHADE SIZE=1>\n";
   if ( $current_user->feature_ok(usetimetrack,PERM_SEL) ) {
     echo menulink("timetrack_select.php",$lang['TimetrackSearch'],$lang['SearchForTT']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usetaskmanagement,PERM_NEW) ) {
     echo menulink("task_new.php?p_id=".$obj->id,$lang['TaskCreate'],$lang['TaskCreate']) ."<BR>\n";
   }
   if ( $current_user->feature_ok(usetimetrack,PERM_NEW) ) {
     echo menulink("timetrack_new.php?mode=1&lid=".$obj->id,$lang['TTRecord'],$lang['TTRecord']) ."<BR>\n";
   }
   echo "</TD></TR>\n";

   HTML_Select();
 }

 if ( isset($HTTP_GET_VARS['t']) ) {
   $t = $HTTP_GET_VARS['t'];
 } else {
   $t = Date("Ymd");
 }

 if ( isset($HTTP_GET_VARS['adr']) ) {
   $a = new tutos_user($dbconn);
   $a->read($HTTP_GET_VARS['adr']);
 } else {
   $a = &$current_user;
 }

 HTML_Header($lang['PersonalPage']);

 HTML_Base1();
 navigate($a);
 HTML_Base2($msg);
 info($a,$t);
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: mytutos.php,v 1.60 2002/07/25 12:43:12 gokohnert Exp $
    $Author: gokohnert $
-->
