<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup product
 * @module product_ins
 * @package product
 */
 include("webelements.p3");
 include("permission.p3");

 include("bug.pinc");
 include("product.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('product','ins');

 $gotourl = "product_new.php";
 $msg = "";

 $p = new product($dbconn);
 if ( isset($HTTP_POST_VARS['id']) ) {
   $p->read($HTTP_POST_VARS['id']);
   $p->readroles();
   $gotourl= addUrlParameter($gotourl,"id=". $HTTP_POST_VARS['id']);
 } else {
   $p->id = -1;
   $p->creator = $current_user;
 }


 # Delete given Roles
 if ( isset($HTTP_POST_VARS['del']) ) {
   @reset ($HTTP_POST_VARS['del']);
   while( list ($i,$f) = @each ($HTTP_POST_VARS['del'])) {
     ereg ("([0-9]*),([0-9]*)",$f,$regs);
     $m = getObject($dbconn,$regs[1]);
     $p->delRole($m,$regs[2]);
     $gotourl= addUrlParameter($gotourl,"del[]=". $f);
   }
 }

 # Add given People Role
 if ( isset($HTTP_POST_VARS['r1fn']) ) {
   $m = check_field(StripSlashes($HTTP_POST_VARS['r1fn']),"r1fn","r1l",$tutos[rolecheck][$HTTP_POST_VARS['role1']]);
   if ( $m->id > 0 ) {
     $p->setRole($m,$HTTP_POST_VARS['role1']);
   }
 }
 if ( isset($HTTP_POST_VARS['r1id']) ) {
   $m = getObject($dbconn,$HTTP_POST_VARS['r1id']);
   $p->setRole($m,$HTTP_POST_VARS['role1']);
 }
 $gotourl= addUrlParameter($gotourl,"role1=". $HTTP_POST_VARS['role1']);
 # Add given Product Role
 if ( isset($HTTP_POST_VARS['r2fn']) ) {
   $m = check_field(StripSlashes($HTTP_POST_VARS['r2fn']),"r2fn","r2l",$tutos[rolecheck][$HTTP_POST_VARS['role2']]);
   if ( $m->id > 0 ) {
     $p->setRole($m,$HTTP_POST_VARS['role2']);
   }
 }
 if ( isset($HTTP_POST_VARS['r2id']) ) {
   $m = getObject($dbconn,$HTTP_POST_VARS['r2id']);
   $p->setRole($m,$HTTP_POST_VARS['role2']);
 }
 $gotourl= addUrlParameter($gotourl,"role2=". $HTTP_POST_VARS['role2']);


 # Check if at least one manager exists
 if ( count($p->role[1]) < 1 ) {
   $msg .= sprintf($lang['Err0009'],$lang['ProdRole'][1]) ."<BR>";
 }

 if ( !isset($HTTP_POST_VARS['name']) || (trim($HTTP_POST_VARS['name']) == "") ) {
   $msg .= sprintf($lang['Err0009'],$lang['ProdName']) ."<BR>";
 } else {
   $p->setName(StripSlashes(trim($HTTP_POST_VARS['name'])));
   $gotourl= addUrlParameter($gotourl,"name=". UrlEncode($p->name));
 }


 if ( !isset($HTTP_POST_VARS['state']) ) {
   $msg .= sprintf($lang['Err0014'],$lang['ProdState']) ."<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"state=". $HTTP_POST_VARS['state']);
 }

 $price = 0.0;
 list ($price) = sscanf($HTTP_POST_VARS['price'],"%f");
 if ( !empty($price) && !is_double($price) ) {
   $msg .= sprintf($lang['Err0017'],$lang['ProdPrice']) ."<BR>";
 }

 $cost = 0.0;
 list($cost) = sscanf($HTTP_POST_VARS['cost'],"%f");
 if ( !empty($cost) && !is_double($cost) ) {
   $msg .= sprintf($lang['Err0017'],$lang['ProdCost']) ."<BR>";
 }

 $prob = 0.0;
 list($prob) = sscanf($HTTP_POST_VARS['prob'],"%f");
 if ( !empty($prob) && !is_double($prob) ) {
   $msg .= sprintf($lang['Err0017'],$lang['ProdProb']) ."<BR>";
 }

 $gotourl= addUrlParameter($gotourl,"price=". $price);
 $gotourl= addUrlParameter($gotourl,"cost=". $cost);
 $gotourl= addUrlParameter($gotourl,"prob=". $prob);
 $gotourl= addUrlParameter($gotourl,"version=". UrlEncode(StripSlashes($HTTP_POST_VARS['version'])));
 $gotourl= addUrlParameter($gotourl,"desc1=". UrlEncode(StripSlashes($HTTP_POST_VARS['desc1'])));
 $gotourl= addUrlParameter($gotourl,"desc2=". UrlEncode(StripSlashes($HTTP_POST_VARS['desc2'])));
 $gotourl= addUrlParameter($gotourl,"description=". UrlEncode(StripSlashes($HTTP_POST_VARS['description'])));
 $gotourl= addUrlParameter($gotourl,"path=". UrlEncode(StripSlashes($HTTP_POST_VARS['path'])));
 $gotourl= addUrlParameter($gotourl,"currency=". UrlEncode($HTTP_POST_VARS['currency']));


 $pstart = new DateTime(0);
 $pstart->setDateTimeF("p_start");
 $gotourl= addUrlParameter($gotourl,"p_start=". $pstart->getYYYYMMDD() );
 if ( 1 != $pstart->checkDMY() ) {
   $msg .= sprintf($lang['Err0038'],$lang['ProdStart']) ."<BR>";
 }

 $pend = new DateTime(0);
 $pend->setDateTimeF("p_end");
 $gotourl= addUrlParameter($gotourl,"p_end=". $pend->getYYYYMMDD() );
 if ( 1 != $pend->checkDMY() ) {
   $msg .= sprintf($lang['Err0038'],$lang['ProdEnd']) ."<BR>";
 }


 # Classification
 for ( $cl = 1;$cl <= $p->classes; $cl++) {
   $p->cl[$cl] = array();
   $x = sprintf("cl%d",$cl);
   if ( isset($HTTP_POST_VARS[$x]) ) {
     @reset($HTTP_POST_VARS[$x]);
     while ( list ($i,$f) = @each ($HTTP_POST_VARS[$x]) ) {
       $gotourl= addUrlParameter($gotourl,"cl".$cl."[]=".$f );
       $p->cl[$cl][] = $f;
     }
   }
   else {
     if( $tutos[classify_products] ) {
       $msg .= $lang['Err0052']."<BR>";
       # just output this message once
       break;
     }
   }
 }

 # If no other problems than check if name is already used
 if ( $msg == "" ) {
   if ( ($p->id == -1) || ($HTTP_POST_VARS['name'] != $p->name) || ($HTTP_POST_VARS['version'] != $p->version) ) {
     $q = "SELECT * FROM ". $p->tablename ." WHERE ". $dbconn->Like2("name",$HTTP_POST_VARS['name']) ." AND ". $dbconn->Like2("version",StripSlashes($HTTP_POST_VARS['version']));
#	 echo $q;
     $r = $dbconn->Exec($q);
     $n = $r->numrows();
     if ( 0 != $n) {
       $x = new product($dbconn);
       $x->read_result($r,0);
       $msg .= sprintf($lang['Err0036'],$x->getLink()) ."<BR>";
     }
     $r->free();
   }
 }

 # other modules
 $msg .= module_parseforms($current_user,$p,$gotourl);

 if ( $msg == "" ) {
   $p->setVersion(StripSlashes($HTTP_POST_VARS['version']));
   $p->setDescription(trim(StripSlashes($HTTP_POST_VARS['description'])));
   $p->setDesc1(trim(StripSlashes($HTTP_POST_VARS['desc1'])));
   $p->setDesc2(trim(StripSlashes($HTTP_POST_VARS['desc2'])));
   $p->setPrice($price);
   $p->setCost($cost);
   $p->setProbability($prob);
   $p->setCurrency($HTTP_POST_VARS['currency']);
   $p->setState($HTTP_POST_VARS['state']);
   $p->setPath(StripSlashes($HTTP_POST_VARS['path']));

   $p->setPStart($pstart);
   $p->setPEnd($pend);

   $dbconn->Begin("WORK");
   $msg .= $p->save();
   $dbconn->Commit("WORK");

   $gotourl = $p->getURL();
 }

 $gotourl = addSessionKey($gotourl);
 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl(). $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: product_ins.php,v 1.33.2.3 2002/09/13 12:14:42 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
