<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup product
 * @module product_overview
 * @package product
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("timetrack.pinc");
 include("bug.pinc");
 include("product.pinc");
 include("installation.pinc");
 include("task.pinc");
 include("mailbox.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('product'.'overview');

 /* ---------------------------------------------------------------------------
  * Display table with product/project info
  */
 Function info(&$dbconn,&$result,$start = 0,$hidden) {
   global $lang,$pshow,$tutos,$current_user,$link1,$link2,$format,$filter;

   $plist = array();
   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   $flds = 0;
   $pf = 0;


   @reset($tutos[currencies]);
   while( list ($i,$c) = @each ($tutos[currencies])) {
     $sum[1][$c] = 0;
     $sum[2][$c] = 0;
   }
   $sum[1][""] = 0;
   $sum[2][""] = 0;

   # Make a big array of all visible products
   $x = 0;
   while ( $x < $n ) {
     $p = new product($dbconn);
     $p->read_result($result,$x);
     $x++;
     if ( ! $p->see_ok() ) {
       unset($p);
       continue;
     }
     if ( ($pshow['price'] == 1) || ($pshow['cost'] == 1) ) {
       $sum[1][$p->currency] += $p->price;
       $sum[2][$p->currency] += $p->cost;
     }
     $plist[] = &$p;
     unset($p);
   }
   $n = count($plist);
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $pshow['checkbox'] ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"product_overview.php\">\n";
     hiddenFormElements();
     echo $hidden;
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }
   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";

   @reset($tutos[prodfields]);
   while( list ($i,$c) = @each ($tutos[prodfields])) {
     if ( ($c == "name") && $pshow[$c] ) {
       echo order_header("name",$lang['ProdName'],$link2);
       $flds++;
     }
     if ( ($c == "version") && $pshow[$c] ) {
       echo order_header("version",$lang['ProdVersion'],$link2);
       $flds++;
     }
     if ( ($c == "seller") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][4],$link2);
       $flds++;
     }
     if ( ($c == "manager") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][1],$link2);
       $flds++;
     }
     if ( ($c == "customer") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][6],$link2);
       $flds++;
     }
     if ( ($c == "supplier") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][7],$link2);
       $flds++;
     }
     if ( ($c == "reseller") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][8],$link2);
       $flds++;
     }
     if ( ($c == "partner") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][9],$link2);
       $flds++;
     }
     if ( ($c == "desc") && $pshow[$c] ) {
       echo order_header("description",$lang['ProdDesc'],$link2);
       $flds++;
     }
     if ( ($c == "desc1") && $pshow[$c] ) {
       echo order_header("desc1",$lang['ProdDesc1'],$link2);
       $flds++;
     }
     if ( ($c == "desc2") && $pshow[$c] ) {
       echo order_header("desc2",$lang['ProdDesc2'],$link2);
       $flds++;
     }
     if ( ($c == "cl1") && $pshow[$c] ) {
       echo order_header("",$lang['ProdClass1'],$link2);
       $flds++;
     }
     if ( ($c == "cl2") && $pshow[$c] ) {
       echo order_header("",$lang['ProdClass2'],$link2);
       $flds++;
     }
     if ( ($c == "state") && $pshow[$c] ) {
       echo order_header("state",$lang['ProdState'],$link2);
       $flds++;
     }
     if ( ($c == "probability") && $pshow[$c] ) {
       echo order_header("probability",$lang['ProdProb'],$link2);
       $flds++;
     }
     if ( ($c == "price") && $pshow[$c] ) {
       echo order_header("currency,price",$lang['ProdPrice'],$link2);
       $flds++;
       $pf = $flds;
     }
     if ( ($c == "cost") && $pshow[$c] ) {
       echo order_header("currency,cost",$lang['ProdCost'],$link2);
       $flds++;
       $cf = $flds;
     }
     if ( ($c == "creator") && $pshow[$c] ) {
       echo order_header("",$lang['ProdCreator'],$link2);
       $flds++;
     }
     if ( ($c == "creation") && $pshow[$c] ) {
       echo order_header("creation",$lang['ProdCreationS'],$link2);
       $flds++;
     }
     if ( ($c == "p_start") && $pshow[$c] ) {
       echo order_header("p_start",$lang['ProdStart'],$link2);
       $flds++;
     }
     if ( ($c == "p_end") && $pshow[$c] ) {
       echo order_header("p_end",$lang['ProdEnd'],$link2);
       $flds++;
     }
     if ( $current_user->feature_ok(usebugtracking,PERM_SEE) ) {
       if ( ($c == "pbugs") && $pshow[$c] ) {
		 echo order_header("",$lang['Bugs'],$link2);
		 $flds++;
       }
     }
     if ( ($c == "checkbox") && $pshow[$c] ) {
       # Column for checkboxes
       echo "<TH>&nbsp;";
       echo " <INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\">\n";
       echo "&nbsp;</TH>";
       $flds++;
	 }
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $format == "paper" ) {
     $a = 0;
     $end = $n;
   } else if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }
   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $p = &$plist[$a];
     $p->readroles();

     echo "<TR>\n";
     @reset($tutos[prodfields]);
     while( list ($i,$c) = @each ($tutos[prodfields])) {
       if ( ($c == "name") && $pshow[$c] ) {
         $b = myentities($p->name);
         if ( $filter['name'] != "" ) {
           $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
         }
         echo "  <TD VALIGN=top>&nbsp;". makelink($p->getUrl(),$b) ."</TD>\n";
       }
       if ( ($c == "version") && $pshow[$c] ) {
	 $b = myentities($p->version);
	 if ( $filter['name'] != "" ) {
	   $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
	 }
         echo "  <TD VALIGN=top>&nbsp;". $b ."</TD>\n";
       }

       if ( ($c == "seller") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         # Show all seller roles
         if (isset($p->role[4]) && (count($p->role[4]) > 0) ) {
           @reset ($p->role[4]);
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[4]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink($r->getShortname());
             $x++;
           }
         }
         echo "  </TD>\n";
       }
       if ( ($c == "manager") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         # Show all manager roles
         if (isset($p->role[1]) && (count($p->role[1]) > 0) ) {
           @reset ($p->role[1]) ;
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[1]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink($r->getShortname());
             $x++;
           }
         }
         # Show all manager 3 roles
         if (isset($p->role[3]) && (count($p->role[3]) > 0) ) {
           @reset ($p->role[3]) ;
           while ( list ($i,$r) = @each ($p->role[3]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink($r->getShortname());
             $x++;
           }
         }
         echo "  </TD>\n";
       }
       # Customer
       if ( ($c == "customer") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         if (isset($p->role[6]) && (count($p->role[6]) > 0) ) {
           @reset ($p->role[6]) ;
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[6]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink();
             $x++;
           }
         }
         echo "  </TD>\n";
       }
       # Supplier
       if ( ($c == "supplier") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         if (isset($p->role[7]) && (count($p->role[7]) > 0) ) {
           @reset ($p->role[7]) ;
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[7]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink();
             $x++;
           }
         }
         echo "  </TD>\n";
       }
       # Reseller
       if ( ($c == "reseller") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         if (isset($p->role[8]) && (count($p->role[8]) > 0) ) {
           @reset ($p->role[8]) ;
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[8]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink();
             $x++;
           }
         }
         echo "  </TD>\n";
       }
       # Partner
       if ( ($c == "partner") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         if (isset($p->role[9]) && (count($p->role[9]) > 0) ) {
           @reset ($p->role[9]) ;
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[9]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink();
             $x++;
           }
         }
         echo "  </TD>\n";
       }
       if ( ($c == "desc") && $pshow[$c] ) {
         $b = myentities($p->description);
         if ( $filter['name'] != "" ) {
           $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
         }
         echo "  <TD VALIGN=top>&nbsp;". $b ."</TD>\n";
       }
       if ( ($c == "desc1") && $pshow[$c] ) {
         $b = myentities($p->desc1);
         if ( $filter['name'] != "" ) {
           $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
         }
         echo "  <TD VALIGN=top>&nbsp;". $b ."</TD>\n";
       }
       if ( ($c == "desc2") && $pshow[$c] ) {
         $b = myentities($p->desc2);
         if ( $filter['name'] != "" ) {
           $b = eregi_replace("(". $filter['name'] .")","<SPANN CLASS=found>\\1</SPAN>",$b);
         }
         echo "  <TD VALIGN=top>&nbsp;". $b ."</TD>\n";
       }
       for ( $cl = 1;$cl <= $p->classes; $cl++) {
         if ( ($c == "cl".$cl) && $pshow[$c] ) {
           echo "  <TD VALIGN=top>";
           $sep = "";
           @reset($p->cl[$cl]);
           while ( list ($i,$f) = @each ($p->cl[$cl]) ) {
             if ( isset ($lang['ProdClasses'.$cl][$f]) ) {
               echo $sep . $lang['ProdClasses'.$cl][$f] ;
             } else {
               echo $sep . $f ;
             }
             $sep = "<BR>\n";
           }
           echo "&nbsp;</TD>\n";
         }
       }
       if ( ($c == "state") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $lang['ProdStates'][$p->state] ."</TD>\n";
       }
       if ( ($c == "probability") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->probability ."</TD>\n";
       }
       if ( ($c == "price") && $pshow[$c] ) {
         echo "  <TD VALIGN=top ALIGN=right>&nbsp;". number_format($p->price,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". myentities($p->currency) ."</TD>\n";
       }
       if ( ($c == "cost") && $pshow[$c] ) {
         echo "  <TD VALIGN=top ALIGN=right>&nbsp;". number_format($p->cost,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". myentities($p->currency) ."</TD>\n";
       }
       if ( ($c == "creator") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->creator->getLink($p->creator->getShortname()) ."</TD>\n";
       }
       if ( ($c == "creation") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->creation->getLinkDate() ."</TD>\n";
       }
       if ( ($c == "p_start") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->p_start->getLinkDate() ."</TD>\n";
       }
       if ( ($c == "p_end") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->p_end->getLinkDate() ."</TD>\n";
       }
       if ( $current_user->feature_ok(usebugtracking,PERM_SEE) ) {
         if ( ($c == "pbugs") && $pshow[$c] ) {
		   $p->readBugs();
		   echo "  <TD NOWRAP VALIGN=top ALIGN=right>&nbsp;". $p->bugSum() ."</TD>\n";
		 }
       }
       # Column for checkboxes
       if ( ($c == "checkbox") && $pshow[$c] ) {
         if ( $p->mod_ok() ) {
           echo "<TD>&nbsp;<INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $p->id ."\">&nbsp;</TD>";
         } else {
           echo "<TD>&nbsp;-&nbsp;</TD>";
         }
	   }
     }
     echo "</TR>\n";
	 unset($plist[$a]);
	 unset($p);
     $a++;
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,$flds,$start,$a,$n);

   # Sum of Prices
   if ( ($pshow['price'] == 1) || ($pshow['cost'] == 1) ) {
     echo "<TR>\n";
     $fill = 0;
     @reset($tutos[prodfields]);
     while( list ($i,$c) = @each ($tutos[prodfields])) {
       if (  $pshow[$c] == 0 ) {
         continue;
       }
       if ( $c == "price" ) {
         if ( $fill > 0 ) {
           echo " <TD COLSPAN=". $fill .">&nbsp;</TD>\n";
           $fill = 0;
         }
         echo " <TD ALIGN=right>\n";
         @reset($sum[1]);
         $pre = "";
         while( list ($i1,$f1) = @each ($sum[1])) {
           if ( $f1 ) {
             echo $pre . number_format($f1,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". $i1;
             $pre = "<BR>\n";
           }
         }
         echo " </TD>\n";
       } else if ( $c == "cost" ) {
         if ( $fill > 0 ) {
           echo " <TD COLSPAN=". $fill .">&nbsp;</TD>\n";
           $fill = 0;
         }
         echo " <TD ALIGN=right>\n";
         @reset($sum[2]);
         $pre = "";
         while( list ($i1,$f1) = @each ($sum[2])) {
           if ( $f1 ) {
             echo $pre . number_format($f1,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". $i1;
             $pre = "<BR>\n";
           }
         }
         echo " </TD>\n";
       } else {
         $fill++;
	   }
	 }
     if ( $fill > 0 ) {
       echo " <TD COLSPAN=". $fill .">&nbsp;</TD>\n";
     }
     echo "</TR>\n";
   }

   if ( $pshow['checkbox'] ) {
     # Mass Update
     echo "<TR>\n";
     echo " <TD ALIGN=right COLSPAN=". ( $flds -1 ) .">\n";
     echo sprintf($lang['withmarked'],$lang['ProductPs']);
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ."</OPTION>\n";
     $ar = array (0,4,5,1,2,3);
     while ( list ($f,$i) = @each ($ar) ) {
       echo " <OPTION VALUE=\"". $i ."\">". sprintf($lang['SetTo'],$lang['ProdState'],$lang['ProdStates'][$i]) ."</OPTION>\n";
     }
     echo "</SELECT>\n";
     echo " </TD>\n";
     echo " <TD COLSPAN=1><INPUT type=submit value=OK></TD>\n";
     echo "</TR>\n";
   }

   echo "</TFOOT>\n";
   echo "</TABLE>\n";
   if ( $pshow['checkbox'] ) {
     echo "</FORM>\n";
   }
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function statinfo(&$dbconn,&$result,$filter) {
   global $lang,$pshow,$flds,$tutos;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   $a = 0;

   $cnt = 0;
   while ( $a < $n ) {
     $p = new product($dbconn);
     $p->read_result($result,$a);
     $p->readroles();
     $a++;
     if ( ! $p->see_ok() ) {
       continue;
     }
     $cnt++;

     # Manager
     if (isset($p->role[1]) && (count($p->role[1]) > 0) ) {
       @reset ($p->role[1]) ;
       $x = 0;
       while ( list ($i,$r) = @each ($p->role[1]) ) {
         if ( !isset($manager[$r->id]) ) {
           $manager[$r->id] = 0;
         }
         $manager[$r->id]++;
       }
     }
     if (isset($p->role[3]) && (count($p->role[3]) > 0) ) {
       @reset ($p->role[3]) ;
       $x = 0;
       while ( list ($i,$r) = @each ($p->role[3]) ) {
         if ( !isset($manager[$r->id]) ) {
           $manager[$r->id] = 0;
         }
         $manager[$r->id]++;
       }
     }

     # States
     if ( !isset($states[$p->state]) ) {
       $states[$p->state] = 0;
     }
     $states[$p->state]++;

     # Classifications
     for ( $c = 1;$c <= 2; $c++) {
       @reset($p->cl[$c]);
       while ( list ($i,$f) = @each ($p->cl[$c]) ) {
         if ( !isset($cl[$c][$i]) ) {
           $cl[$c][$i] = 0;
         }
         $cl[$c][$i]++;
       }
     }
     unset($p);
   }

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=6>". $lang['ProdStatsTitle'] ."</TH>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['Count']);
   echo "<TD COLSPAN=5>". $cnt ."\n";
   $pre = "filtered by ";
   while ( list ($i,$f) = @each ($filter) ) {
     if ( $f == "" ) {
       continue;
     }
     if ( $i == 'state' ) {
       $f = $f + 0;
       echo $pre . $lang['ProdState'];
       echo " ". $lang['ProdStates'][$f];
     } else if ( $i == 'cl1' ) {
       echo $pre . $lang['ProdClass1'];
       echo " ". $lang['ProdClasses1'][$f];
     } else if ( $i == 'cl2' ) {
       echo $pre . $lang['ProdClass2'];
       echo " ". $lang['ProdClasses2'][$f];
     } else if ( $i == 'name' ) {
       echo $pre . $lang['ProdDesc'];
       echo " ". $f;
     } else if ( $i == 'from' ) {
       echo $pre . $lang['DateTimeFrom'];
       echo " ". $f->getDateTime();
     } else if ( $i == 'to' ) {
       echo $pre . $lang['DateTimeTill'];
       echo " ". $f->getDateTime();
     } else {
       echo $pre . $i;
       echo " ". $f;
     }
     $pre = " and ";
   }
   echo " </TD>\n";
   echo "</TR>\n";

   # State distribution
   echo "<TR>\n";
   $link = "graph_bars.php";
   $link = addSessionKey($link);
   $link = addUrlParameter($link,"type=pie");
   @reset($states);
   if ( !function_exists('ImageCreate') ) {
     echo " <TD VALIGN=top ROWSPAN=". count($states) ."><B>". $lang['ProdState'] ."</B></TD>";
   } else {
     showfield($lang['ProdState']);
   }
   $c = 0;
   while ( list ($i,$f) = @each ($states) ) {
     $val = number_format($f * 100.0 / $cnt ,2);
     if ( !function_exists('ImageCreate') ) {
       echo " <TD>". $lang['ProdStates'][$i] ."</TD>\n";
       echo " <TD ALIGN=right>". $f ."</TD>\n";
       echo " <TD ALIGN=right>". $val ."%</TD>\n";
     }
     $link = addUrlParameter($link,"f[". $c ."]=".$val);
     $link = addUrlParameter($link,"t0[". $c ."]=". UrlEncode($lang['ProdStates'][$i]));
     $link = addUrlParameter($link,"t1[". $c ."]=".$f);
     $c++;
   }
   if ( function_exists('ImageCreate') ) {
     echo " <TD COLSPAN=5 VALIGN=top><IMG SRC=". $link ."></TD>\n";
   }
   echo "</TR>\n";

   # Classifications
   for ( $c = 1;$c <= 2; $c++) {
     echo "<TR>\n";
     $link = "graph_bars.php";
     $link = addSessionKey($link);
     $link = addUrlParameter($link,"type=pie");
     @reset($cl[$c]);
     if ( !function_exists('ImageCreate') ) {
       echo " <TD VALIGN=top ROWSPAN=". count($cl[$c]) ."><B>". $lang['ProdClass'.$c] ."</B></TD>";
     } else {
       showfield($lang['ProdClass'.$c]);
     }
     $x = 0;
     while ( list ($i,$f) = @each ($cl[$c]) ) {
       $val = number_format($f * 100.0 / $cnt ,2);
       if ( !function_exists('ImageCreate') ) {
         if ( isset($lang['ProdClasses'.$c][$i]) ) {
           echo " <TD>". $lang['ProdClasses'.$c][$i] ."</TD>\n";
         } else {
           echo " <TD>". $i ."</TD>\n";
         }
         echo " <TD ALIGN=right>". $f ."</TD>\n";
         echo " <TD ALIGN=right>". $val ."%</TD>\n";
       }
       $link = addUrlParameter($link,"f[". $x ."]=".$val);
       if ( isset($lang['ProdClasses'.$c][$i]) ) {
         $link = addUrlParameter($link,"t0[". $x ."]=". UrlEncode($lang['ProdClasses'.$c][$i]));
       } else {
         $link = addUrlParameter($link,"t0[". $x ."]=". $i);
       }
       $link = addUrlParameter($link,"t1[". $x ."]=". $f );
#       $link = addUrlParameter($link,"col[". $x ."]=". UrlEncode($b->c_state[$i]));
       $x++;
     }
     if ( function_exists('ImageCreate') ) {
       echo " <TD COLSPAN=5 VALIGN=top><IMG SRC=". $link ."></TD>\n";
     }
     echo "</TR>\n";
   }

   # Manager distribution
   @reset($manager);
   echo "<TR>\n";
   if ( ! function_exists('ImageCreate') ) {
     echo " <TD VALIGN=top ROWSPAN=". count($manager) ."><B>". $lang['ProdRole'][1] ."</B></TD>";
   } else {
     showfield($lang['ProdRole'][1]);
   }
   $c = 0;
   $r = 0;
   while ( list ($i,$f) = @each($manager) ) {
     if ( $c == 0 ) {
       $r++;
       $links[$r] = "graph_bars.php";
       $links[$r] = addSessionKey($links[$r]);
     }
     $m = new tutos_address($dbconn);
     $m->read($i);
     if ( $m->id == -1 ) {
       $m = new team($dbconn);
       $m->read($i);
     }
     $val = number_format($f * 100.0 / $cnt ,2);
     if ( ! function_exists('ImageCreate') ) {
       echo " <TD>". $m->getLink() ."</TD>\n";
       echo " <TD ALIGN=right>". $f ."</TD>\n";
       echo " <TD ALIGN=right>". $val ."%</TD>\n";
       echo "</TR>\n";
     }
     $links[$r] = addUrlParameter($links[$r],"f[". $c ."]=". $val);
     $links[$r] = addUrlParameter($links[$r],"t0[". $c ."]=". UrlEncode($m->getShortName()) );
     $links[$r] = addUrlParameter($links[$r],"t1[". $c ."]=". $f );
     $c++;
     if ( $c == 5 ) {
       $c = 0;
     }
   }
   if ( function_exists('ImageCreate') ) {
     echo " <TD COLSPAN=5 VALIGN=top>\n";
     @reset($links);
     while ( list ($i,$f) = @each ($links) ) {
       echo "  <IMG SRC=\"". $links[$i] ."\"><BR>\n";
     }
     echo "</TD></TR>\n";
   }
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate($link2,$hidden) {
   global $current_user,$lang,$pshow,$flds,$tutos,$format;


   echo "<SCRIPT language=\"JavaScript\">\n";

   echo "<!--\n";
   echo "function CheckAll() {\n";
   echo "  for (var i=0; i < document.forms['ProdFields'].elements.length; i++) {\n";
   echo "   var e = document.forms['ProdFields'].elements[i];\n";
   echo "   if (e.name != 'checkit')\n";
   echo "     e.checked = document.forms['ProdFields'].checkit.checked;\n";
   echo "  }\n";
   echo "}\n";
   echo "//-->\n";

   echo "</SCRIPT>\n";

   echo "<TABLE>";
   echo "<TR><TD>";

   echo product::getSelectLink($current_user,$lang['Search'])."<BR>";

   if ( $current_user->feature_ok(useprojects,PERM_NEW) ) {
     echo menulink("product_new.php",$lang['NewEntry'],$lang['ProdCreateInfo']) ."<BR>\n";
   }
   echo "</TD></TR>";
   echo "<TR><TD>";


   if ( $format != "stat" ) {
     @reset($pshow);
     while ( list ($i,$f) = @each ($pshow) ) {
       if ( $f == 0 ) {
         $schecked[$i] = "";
       } else {
         $schecked[$i] = "CHECKED";
       }
     }
     echo "<FORM name=\"ProdFields\" action=\"product_overview.php\" method=\"GET\">";
     hiddenFormElements();
     echo $hidden;
     DoubleTableStart(0,0);
     echo "<TR><TH>". $lang['ProdFields'] ."</TH></TR>\n";
     @reset($tutos[prodfields]);
     while( list ($i,$c) = @each ($tutos[prodfields])) {
       if ( ! isset($flds[$c]) ) {
         continue;
       }
       if ( $flds[$c] == '' ) {
         continue;
       }
       echo "<TR><TD NOWRAP>\n";
       echo " <INPUT TYPE=checkbox name=ps[] ". $schecked[$c] ." value=\"". $c ."\">&nbsp;". $lang[$flds[$c]] ."\n";
       echo "</TD></TR>\n";
     }

     echo "<TR><TD NOWRAP><HR NOSHADE></TD></TR>\n";
     echo "<TR><TD NOWRAP>\n";
     echo " <INPUT TYPE=checkbox name=checkit onClick=\"CheckAll();\">&nbsp;". $lang['all'] ."\n";
     echo "</TD></TR>\n";

     echo "<TR><TD><INPUT TYPE=submit value=\"". $lang['show'] ."\"></TD></TR>";
     echo "</TABLE>";
     echo "</TD></TR></TABLE>";
     echo "</FORM>";
   }
   $ll = addUrlParameter($link2,"format=paper");
   echo menulink($ll,$lang['Printable'],$lang['PrintableInfo']);

   if ( $format != "stat" ) {
     echo "<BR>";
     $ll = addUrlParameter($link2,"format=stat");
     echo menulink($ll,$lang['ProdStats'],$lang['ProdStatsInfo']);
   }
   echo "</TD></TR>";

   HTML_Select();
 }

 # Perform possible actions
 if ( isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) &&  isset($HTTP_GET_VARS['mark']) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $p = new product($dbconn);
       $p->read($val);
       $p->readroles();
       if ( $p->id != $val ) {
         continue;
	   }
       if ( $p->del_ok() ) {
         $msg .= sprintf($lang['ProdDelInfo'], $p->getFullName()) ."<BR>";
         $msg .= $p->delete();
	   } else {
         $msg .= $p->getLink() .": ". sprintf($lang['Err0023'],$lang[$p->getType()]);
	   }
       unset($p);
     }
     $dbconn->Commit("WORK");
   } else {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $p = new product($dbconn);
       $p->read($val);
       $p->readroles();
       if ( $p->id != $val ) {
         continue;
	   }
       if ( $p->mod_ok() ) {
         $msg .= $p->getLink() ." ". $lang['ProdState'] ." = ". $lang['ProdStates'][$HTTP_GET_VARS['action']] ."<BR>";
         $msg .= $p->setState($HTTP_GET_VARS['action']);
         $msg .= $p->save();
	   } else {
         $msg .= $p->getLink() .": ". sprintf($lang['Err0024'],$lang[$p->getType()]);
	   }
       unset ($p);
     }
     $dbconn->Commit("WORK");
   }
 }

 $p = new product($dbconn);
 $link1 = "product_overview.php";
 $hidden = "";
 $filter = array();

 # Prepare some structures

 $flds['name']         = 'ProdName';
 $flds['version']      = 'ProdVersion';
 $flds['seller']       = 'ProdRole4';
 $flds['manager']      = 'ProdRole1';
 $flds['customer']     = 'ProdRole6';
 $flds['supplier']     = 'ProdRole7';
 $flds['reseller']     = 'ProdRole8';
 $flds['partner']      = 'ProdRole9';
 $flds['desc']         = 'ProdDesc';
 $flds['desc1']        = 'ProdDesc1';
 $flds['desc2']        = 'ProdDesc2';
 $flds['cost']         = 'ProdCost';
 $flds['price']        = 'ProdPrice';
 $flds['probability']  = 'ProdProb';
 $flds['state']        = 'ProdState';
 $flds['creator']      = 'ProdCreator';
 $flds['creation']     = 'ProdCreationS';
 $flds['p_start']      = 'ProdStart';
 $flds['p_end']        = 'ProdEnd';
 if ( $current_user->feature_ok(usebugtracking,PERM_SEE) ) {
   $flds['pbugs']        = 'Bugs';
 }
 for ( $cl = 1;$cl <= $p->classes; $cl++) {
   $x = sprintf("cl%d",$cl);
   $flds['cl'.$cl]     = 'ProdClass'.$cl;
 }
 $flds['checkbox']     = '';
 $tutos[prodfields][]  = 'checkbox';

 @reset($tutos[prodfields]);
 while( list ($i,$c) = @each ($tutos[prodfields])) {
   $pshow[$c] = 0;
 }

 $q = "SELECT * FROM products";
 $pre = " WHERE ";

 if ( isset($HTTP_GET_VARS['format']) ) {
   $format = $HTTP_GET_VARS['format'];
 } else {
   $format = "";
 }
 if ( isset($HTTP_GET_VARS['name']) ) {
   $name = $HTTP_GET_VARS['name'];
 } else {
   $name = "";
 }
 if ( isset($HTTP_GET_VARS['state']) ) {
   $state = $HTTP_GET_VARS['state'];
   # remember this
   $HTTP_SESSION_VARS['prodsearchstate'] = $state;
 } else {
   $state = "";
 }

 if ( ($name != "*") && ($name != "") ) {
   $name = StripSlashes($name);
   $q .= $pre ."(".  $dbconn->Like("name",$name);
   $q .= " OR ". $dbconn->Like("description",$name);
   $q .= " OR ". $dbconn->Like("desc1",$name);
   $q .= " OR ". $dbconn->Like("desc2",$name);
   $q .= " OR ". $dbconn->Like("version",$name);
   $q .= ")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"name=".UrlEncode($name));

   $hidden .= "<INPUT TYPE=hidden NAME=\"name\" VALUE=\"". urlEncode($name) ."\">\n";
   $filter['name'] = $name;
 } else {
   $filter['name'] = "";
 }

 # Start Date for search
 $from = new DateTime(0);
 if ( isset($HTTP_GET_VARS['fd']) ) {
   $from->setDateTime($HTTP_GET_VARS['fd']);
 } else {
   $from->setDateTimeF("f");
   # remember this
   $HTTP_SESSION_VARS['prodsearchfrom'] = $from->getYYYYMMDD();
 }
 if ( $from->notime != 1 ) {
   $q .= $pre ."(creation >= ". $dbconn->Date($from) .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"fd=".$from->getYYYYMMDD());
   $hidden .= "<INPUT TYPE=hidden NAME=\"fd\" VALUE=\"". $from->getYYYYMMDD() ."\">\n";
   $filter['from'] = $from;
 }
 # End Date for search
 $to = new DateTime(0);
 if ( isset($HTTP_GET_VARS['td']) ) {
   $to->setDateTime($HTTP_GET_VARS['td']);
 } else {
   $to->setDateTimeF("t");
   # remember this
   $HTTP_SESSION_VARS['prodsearchto'] = $to->getYYYYMMDD();
 }
 if ( $to->notime != 1 ) {
   $q .= $pre ."(creation <= ". $dbconn->Date($to) .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"td=".$to->getYYYYMMDD());
   $hidden .= "<INPUT TYPE=hidden NAME=\"td\" VALUE=\"". $to->getYYYYMMDD() ."\">\n";
   $filter['to'] = $to;
 }
 #
 # Classifications to display
 #
 for ( $cl = 1;$cl <= $p->classes; $cl++) {
   $x = sprintf("cl%d",$cl);
   if ( isset($HTTP_GET_VARS[$x]) && ($HTTP_GET_VARS[$x] != -1) ) {
     # Get all project with classification
     $q1 =  "SELECT * from projectclass". $cl ." WHERE class_id = ". $HTTP_GET_VARS[$x];
     $r = $dbconn->Exec($q1);
     $n = $r->numrows();
     $a = 0;
     $pre1 = "";
     $z = "";
     while ($a < $n) {
       $z .= $pre1 . $r->get($a, "pro_id");
       $pre1 = ",";
       $a++;
     }
     $r->free();
     if ( $z != "" ) {
       $q .= $pre ." id in (". $z .")";
       $pre = " AND ";
     }

     $link1 = addUrlParameter($link1,"cl". $cl ."=".$HTTP_GET_VARS[$x]);
     $hidden .= "<INPUT TYPE=hidden NAME=\"cl". $cl ."\" VALUE=\"". $HTTP_GET_VARS[$x] ."\">\n";

     $filter['cl'.$cl] = $HTTP_GET_VARS[$x];
   }
   if ( isset($HTTP_GET_VARS[$x]) ) {
     $y = sprintf("prodsearchcl%d",$cl);
     # remember this
     $HTTP_SESSION_VARS[$y] = $HTTP_GET_VARS[$x];
   }
 }

 #
 # State to display
 #
 if ( ($state != -1) && ($state != "") ) {
   if ( $state < 0 ) {
     $q .= $pre . " ( state != 2 AND state != 3 and state != 5 ) " ;
   } else {
     $q .= $pre . " state = " . $state ;
   }
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"state=".$state);
   $hidden .= "<INPUT TYPE=hidden NAME=\"state\" VALUE=\"". $state ."\">\n";
   $filter['state'] = $state;
 }

 # Role Specific Selection
 if ( isset($HTTP_GET_VARS['rid']) && ($HTTP_GET_VARS['rid'] != "*") && ($HTTP_GET_VARS['rid'] != "") ) {
   # Get all managed product ids
   @reset ($HTTP_GET_VARS['rid']);
   $ml = "";
   $mpre = "";
   while( list ($i1,$f1) = @each ($HTTP_GET_VARS['rid'])) {
     $ml .= $mpre . $f1;
     $mpre = ",";

     $link1 = addUrlParameter($link1,"rid[]=".$f1);
     $hidden .= "<INPUT TYPE=hidden NAME=\"rid[]\" VALUE=\"". $f1 ."\">\n";
   }
   if ( isset($HTTP_GET_VARS['role']) ) {
     $q1 = "SELECT pro_id FROM projectroles WHERE role_id in (". $HTTP_GET_VARS['role'] .") AND adr_id in (". $ml .")";
     $link1 = addUrlParameter($link1,"role=".$HTTP_GET_VARS['role']);
     $hidden .= "<INPUT TYPE=hidden NAME=\"role\" VALUE=\"". $HTTP_GET_VARS['role'] ."\">\n";
   } else {
     $q1 = "SELECT pro_id FROM projectroles WHERE adr_id in (". $ml .")";
   }
   $r = $dbconn->Exec($q1);
   $n = $r->numrows();
   $a = 0;
   $pre1 = "";
   $x = "";
   while ($a < $n) {
     $x .= $pre1 . $r->get($a, "pro_id");
     $pre1 = ",";
     $a++;
   }
   $r->free();
   if ( $x != "" ) {
     $q .= $pre ." id in (". $x .")";
   }
   $pre = " AND ";
 }


 # Order of output
 $link2 = $link1;
 $link2 = addUrlParameter($link2,"format=".UrlEncode($format));
 $xxx = "";
 order_parse($q,$link1,$xxx,$hidden,"creation DESC");

 $result = $dbconn->Exec($q);

 /* Fields to show */
 $pscnt = 0;
 if ( isset($HTTP_GET_VARS['ps']) ) {
   # New Set Default
   @reset($HTTP_GET_VARS['ps']);
   while ( list ($i1,$f1) = @each ($HTTP_GET_VARS['ps']) ) {
     $pshow[$f1] = 1;
     $pscnt++;
     $link1 = addUrlParameter($link1,"ps[]=".$f1);
     $link2 = addUrlParameter($link2,"ps[]=".$f1);
   }
   # remember this
   $HTTP_SESSION_VARS['prodshow'] = $pshow;
 } else if ( isset($prodshow) ) {
   # Session Default
   @reset($prodshow);
   while ( list ($i1,$f1) = @each ($prodshow) ) {
     if ( $f1 != 0 ) {
       $pshow[$i1] = $f1;
       $pscnt++;
       $link1 = addUrlParameter($link1,"ps[]=".$i1);
       $link2 = addUrlParameter($link2,"ps[]=".$i1);
     }
   }
 }
 if ( $pscnt == 0 ) {
   # Default
   $pshow['name'] = 1;
   $pshow['version'] = 1;
   $pshow['manager'] = 1;
   $pshow['state'] = 1;
 }

 if ( $tutos[massupdate] == 1 ) {
   $pshow['checkbox'] = 1;
 }

 if ( isset($HTTP_GET_VARS['start']) ) {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
   $link2 = addUrlParameter($link2,"start=".$start);
 }


 if ( $format == "" ) {
   if ($result->numrows() == 1) {
     $p = new product($dbconn);
     $p->read_result($result,0);

     Header("Location: ". getBaseUrl() . addSessionKey("product_show.php?id=".$p->id));
     $result->free();
     $dbconn->Close();
     exit;
   }
   HTML_Header($lang['ProductsOverview']);
 } else if ( $format == "paper" ) {
   $pshow['checkbox'] = 0;
   Printable_Header($lang['ProductsOverview']);
   $link1 = addUrlParameter($link1,"format=".UrlEncode($format));
 } else if ( $format == "stat" ) {
   HTML_Header($lang['ProductsOverview']);
   $link1 = addUrlParameter($link1,"format=".UrlEncode($format));
 }

 if ( $format == "" ) {
   HTML_Base1();
   navigate($link2,$hidden);
   HTML_Base2($msg);
 } 
 if ($format == "stat") {
   HTML_Base1();
   navigate($link2,$hidden);
   HTML_Base2($msg);
   statinfo($dbconn,$result,$filter);
   $format = "";
 } else {
   info($dbconn,$result,$start,$hidden);
 }
 if ( $format == "" ) {
   HTML_Base3();
 }
 if ( $format == "paper" ) {
   HTML_Close();
 }
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: product_overview.php,v 1.52.2.5 2002/09/09 17:46:11 gokohnert Exp $
    $Author: gokohnert $
-->
