<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * display all product info
 *
 * @modulegroup product
 * @module product_show
 * @package product
 */
 include("webelements.p3");
 include("permission.p3");
 include("product.pinc");
 include("mailbox.pinc");
 include("installation.pinc");
 include 'appointment.pinc';
 include 'timetrack.pinc';
 include 'bug.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('product','show');

 /* ---------------------------------------------------------------------------
  * List Roles
  */
 Function showrole(&$p,$role) {
   global $lang;

   if ( isset($p->role[$role]) && (count($p->role[$role]) > 0) ) {
     echo "<TR>\n";
     showfield($lang['ProdRole'][$role]);
     echo " <TD COLSPAN=3>";
     @reset ($p->role[$role]) ;
     $n = 0;
     while ( list ($i,$r) = @each ($p->role[$role]) ) {
       if ( $n > 0 ) {
         echo  "<BR>\n";
       }
	   if ( $r->getType() == "department" ) {
         echo  $r->getLink( $r->getFullName() ." / ". $r->company->getFullName() );
	   } else {
         echo  $r->getLink();
	   }
       $n++;
     }
     echo "</TD></TR>\n";
   }
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$p,$format) {
   global $current_user, $tutos,$lang;

   if ( $p->id < 0 ) {
     return;
   }

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=4>". sprintf($lang['Showing'],$lang[$p->getType()]) ."</TH>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   echo " <TD>". $lang['createdby'] ."</TD><TD>". $p->creator->getLink() ."</TD>\n";
   echo " <TD>". $lang['atDateTime'] ."</TD><TD>". $p->creation->getLinkDateTime() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['ProdName']);
   echo " <TD COLSPAN=3>". myentities($p->name) ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['ProdVersion']);
   echo " <TD COLSPAN=3>". myentities($p->version) ."&nbsp;</TD>\n";
   echo "</TR>\n";


   echo "<TR>\n";
   showfield($lang['ProdState']);
   echo " <TD COLSPAN=1>". $lang['ProdStates'][$p->state] ."</TD>\n";
   if ( (($p->state == 0) || ($p->state == 5) || ($p->state == 4)) && ( $p->probability != "" ) ) {
     showfield($lang['ProdProb']);
     echo "<TD COLSPAN=1>". $p->probability ."%</TD>\n";
   } else {
     echo "<TD COLSPAN=2>&nbsp;</TD>\n";
   }
   echo "</TR>\n";

   $p->readroles();
   @reset($lang['ProdRole']);
   while ( list ($role,$x) = @each ($lang['ProdRole']) ) {
     showrole($p,$role);
   }

   echo "<TR>\n";
   showfield($lang['ProdDesc']);
   echo "  <TD COLSPAN=3>". myentities($p->description) ."&nbsp;</TD>\n";
   echo "</TR>\n";

   if ( $p->desc1 != "") {
     echo "<TR>\n";
     showfield($lang['ProdDesc1']);
     echo "  <TD COLSPAN=3>". myentities($p->desc1) ."</TD>\n";
     echo "</TR>\n";
   }
   if ( $p->desc2 != "" ) {
     echo "<TR>\n";
     showfield($lang['ProdDesc2']);
     echo "  <TD COLSPAN=3>". myentities($p->desc2) ."</TD>\n";
     echo "</TR>\n";
   }
   # Classification
   for ( $cl = 1;$cl <= $p->classes; $cl++) {
     if ( count($p->cl[$cl]) > 0 ) {
       echo "<TR>\n";
       showfield($lang['ProdClass'.$cl]);
       echo "  <TD COLSPAN=3>\n";
       @reset($p->cl[$cl]);
       while ( list ($i,$f) = @each ($p->cl[$cl]) ) {
	 if ( isset ($lang['ProdClasses'.$cl][$f]) ) {
	   echo $lang['ProdClasses'.$cl][$f] . "<BR>\n";
	 } else {
	   echo $f . "<BR>\n";
	 }
       }
       echo "  </TD>\n";
       echo "</TR>\n";
     }
   }

   echo "<TR>\n";
   showfield($lang['ProdPrice']);
   echo "  <TD>". number_format($p->price,2,$lang['DecPoint'],$lang['ThousandPoint']) ."&nbsp<B>". $p->currency ."</B></TD>\n";

   showfield($lang['ProdCost']);
   echo "  <TD>". number_format($p->cost,2,$lang['DecPoint'],$lang['ThousandPoint']) ."&nbsp<B>". $p->currency ."</B></TD>\n";
   echo "</TR>\n";


   echo "<TR>\n";
   showfield($lang['ProdStart']);
   echo "  <TD>". $p->p_start->GetLinkDate() ."</TD>\n";
   showfield($lang['ProdEnd']);
   echo "  <TD>". $p->p_end->GetLinkDate() ."</TD>\n";
   echo "</TR>\n";



   if ( $p->path != "" ) {
     echo "<TR>\n";
     showfield($lang['ProdPath']);
     echo "  <TD COLSPAN=3><A HREF=\"". $p->path ."\">". myentities($p->path) ."</A></TD>\n";
     echo "</TR>\n";
   }

   if ( $current_user->feature_ok(usemailboxes,PERM_SEE) ) {
     $p->readMailboxes();
	 if ( count($p->mboxlist) >0 ) {
       echo "<TR>\n";
	   showfield($lang['ProdMailbox']);
	   echo " <TD COLSPAN=3>\n";
	   @reset($p->mboxlist);
	   while ( list ($i,$f) = @each ($p->mboxlist) ) {
         echo $f->getLink() . "<BR>\n";
	   }
	   echo " </TD>\n";
	   echo "</TR>\n";
	 }
   }


   installation::infolist($current_user,$p,4,$format);
   bug::infolist($current_user,$p,4,$format);
   url::infolist($current_user,$p,4,$format);
   appointment::infolist($current_user,$p,4,$format);
   tutos_file::infolist($current_user,$p,4,$format);

   if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) ) {
     $p->readTasks();
     if ( count($p->tasklist) >0 ) {
       @reset($p->tasklist);
       echo "<TR>\n";
       showfield($lang['ProdTasks']);
       echo " <TD VALIGN=top COLSPAN=3>\n";
       echo  $tutos[image][folder] ." ". makelink("task_overview.php?id=". $p->id,$lang['TaskOverview'],sprintf($lang['TaskOverviewInfo'],$p->getFullName()));
       echo "<BR>\n";
       $n = 1;
       $x = count($p->tasklist);

       if ( $format == "paper" ) {
	     $rows = count($p->tasklist);
       } else {
	     $rows = $tutos[maxshort];
       }

       while ( list ($i,$f) = @each ($p->tasklist) ) {
	     if ( ($n >= $rows) && ( $x != $rows ) ) {
	       echo  $tutos[image][folder] ." ". makelink("task_overview.php?id=". $p->id,sprintf($lang['AllEntries'], count($p->tasklist)));
		   break;
		 }
		 echo $tutos[image][paper] ." ". $f->getLink() ."<BR>\n";
		 $n++;
       }
       echo " </TD>\n";
       echo "</TR>\n";
     }
   }

   if ( $current_user->feature_ok(usetimetrack,PERM_SEE) ) {
     $p->readTimetrackSum();
     $rows = 0;
     if ( $p->timetracksum > 0) {
       $rows++;
	 }
     @reset ($p->tsum);
     while( list ($i,$f) = @each ($p->tsum)) {
       if ( $p->tsum[$i] > 0 ) {
         $rows++;
       }
     }
     $r = 0;
     if ( $rows > 0 ) {
       echo "<TR>\n";
       echo "<TD CLASS=\"desc\" VALIGN=\"top\" ROWSPAN=". $rows .">". $lang['Timetrack'] ;
       echo "</TD>\n";

       if ( $p->timetracksum > 0) {
         echo " <TD VALIGN=top ALIGN=right>\n";
         echo makelink("timetrack_overview.php?link_id=". $p->id ,number_format($p->timetracksum,2),$lang['TimetrackOverview']);
         echo " </TD>\n";
         echo " <TD ALIGN=left>". $lang['hours'] ."</TD>\n";
         echo " <TD>&nbsp;</TD>\n";
         echo "</TR>\n";
         $r = 1;
	   }
       @reset ($p->tsum);
       while( list ($i,$f) = @each ($p->tsum)) {
         if ( $p->tsum[$i] > 0 ) {
           if ( $r == 1 ) {
             echo "<TR>\n";
           }
           echo " <TD ALIGN=right>". number_format($p->tsum[$i],2) ."</TD>\n";
           echo " <TD ALIGN=left>". $lang['hours'] ."</TD>\n";
           echo " <TD>(". $lang[$i] .")</TD>\n";
           echo "</TR>\n";
           $r = 1;
         }
       }
     }
   }

   # References to modules
   show_module_infolists($current_user,$p,4);

   if ( $format != "paper" ) {
     echo $p->getHistoryLink(4);
   }
   echo "</TABLE>\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang, $current_user;

   echo "<TABLE>";
   echo "<TR><TH>".$lang['Product']."</TH></TR>\n";
   echo "<TR><TD>\n";

   echo product::getSelectLink($current_user,$lang['Search'])."<BR>";

   if ( $current_user->feature_ok(useprojects,PERM_NEW) ) {
     echo menulink("product_new.php", $lang['NewEntry'],
		   $lang['ProdCreateInfo']);
     echo "<BR>\n";
   }
   if ( $current_user->feature_ok(useprojects,PERM_MOD) ) {
     if ( ($obj->id > 0) && $obj->mod_ok() ) {
       echo menulink("product_new.php?id=".$obj->id, $lang['Modify'],
		     sprintf($lang['ProdModInfo'],
			     $obj->getFullname()));
       echo "<BR>\n";
     }
   }
   if ( $current_user->feature_ok(useprojects,PERM_DEL) ) {
     if ( ($obj->id > 0) && $obj->del_ok() ) {
       echo confirmlink("product_del.php?id=".$obj->id,
			$lang['Delete'],
			sprintf($lang['ProdDelInfo'],
				$obj->getFullname()));
       echo "<BR>\n";
     }
     echo menulink("product_show.php?format=paper&id=".$obj->id,
		   $lang['Printable'], $lang['PrintableInfo']);
   }
   echo "</TD></TR>\n";

   echo "<TR><TH>".$lang['Tasks']."</TH></TR>\n";
   echo "<TR><TD>\n";

   if ( ($obj->id > 0) && $obj->see_ok() ) {
     if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) ) {
       echo menulink("task_overview.php?id=".$obj->id,
		     $lang['TaskOverview'],
		     sprintf($lang['TaskOverviewInfo'], $obj->getFullName()));
       echo "<BR>\n";
       if( $tutos[usejpgraph] ) {
         echo menulink("task_gantt.php?id=".$obj->id, $lang['TaskGantt']);
         echo "<BR>\n";
       }
     }
     if ( $current_user->feature_ok(usetaskmanagement,PERM_NEW) ) {
       if ( $obj->mod_ok() > 0 ) {
         echo menulink("task_new.php?p_id=".$obj->id, $lang['TaskCreate'], sprintf($lang['TaskCreateInfo'], $obj->getFullName()))."&nbsp;\n";
         echo "<BR>\n";

         echo menulink("task_import_csv.php?p_id=".$obj->id, "Import CSV");
         echo "<BR>\n";
       }
     }

     echo "</TD></TR>\n<TR><TD>\n";
     echo bug::getaddlink($current_user,$obj);
     echo installation::getaddlink($current_user,$obj);
     echo tutos_file::getaddlink($current_user,$obj);
     echo timetrack::getaddlink($current_user,$obj);
   }
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>\n";

   HTML_Select();
 }

 if (isset($HTTP_GET_VARS['format'])) {
   $format = $HTTP_GET_VARS['format'];
 } else {
   $format = "";
 }
 $p = new product($dbconn);

 if ( isset($HTTP_GET_VARS['id']) ) {
   $p->read($HTTP_GET_VARS['id']);
 }
 if ( ! $p->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$p->getType()]);
   $format = "";
 } else {
   if ( $p->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$p->getType()]);
     $format = "";
   }
 }

 if ( ($format == "paper") && ($msg == "") ) {
   Printable_Header($lang['ProductsDetail']);
   info($p,$format);
   HTML_Close();
 } else {
   if ( $p->id > 0 ) {
     HTML_Header($lang['ProductsDetail']." :". $p->getFullName());
   } else {
     HTML_Header($lang['ProductsDetail']);
   }
   HTML_Base1();
   navigate($p);
   HTML_Base2($msg);
   if ( ($p->id > 0) && $p->see_ok() ) {
     info($p,$format);
   }
   HTML_Base3();
 }
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: product_show.php,v 1.45 2002/07/24 17:03:05 gokohnert Exp $
    $Author: gokohnert $
-->
