<?
/**
 * Copyright 2001 - 2002 by Gero Kohnert
 *
 * @modulegroup resource
 * @module resource_show
 * @package resource
 */
 $tutos['base'] = "../..";
 ini_set("include_path","..");
 include 'webelements.p3';
 include 'permission.p3';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("resource");
 loadmodule("resource");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=4>". sprintf($lang['Showing'],$obj->getFullName()) ."</TH>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['createdby']);
   echo " <TD COLSPAN=3>". $obj->creator->getLink() ."</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['ResName']);
   echo " <TD COLSPAN=3>". myentities($obj->name) ."</TD>\n";

   echo "</TR><TR>\n";
   showfield($lang['ResDesc']);
   echo " <TD COLSPAN=3>". myentities($obj->desc) ."</TD>\n";

   # Usage
   $obj->readUsage();
   if ( count($obj->ulist) > 0 ) {
     echo "</TR><TR>\n";
     echo "<TH COLSPAN=4>". $lang['ResUsage'] ."</TH>\n";
     # First all future appointments and running projekts/tasks
     @reset ($obj->ulist);
     while ( list ($i,$f) = @each ($obj->ulist) ) {
       if ( ($f->getType() == "appointment") && ($f->end->getTimestamp() - time() > 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line2>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line2>". $f->getLink($f->descr) ."</TD>\n";
         echo "<TD CLASS=line2>". $f->getTimespan() ."</TD>\n";
       } else if ( ($f->getType() == "task") && ($f->s_end->getTimestamp() - time() > 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line2>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line2>". $f->getLink() ."</TD>\n";
         echo "<TD CLASS=line2>". $f->getTimespan() ."</TD>\n";
       } else if ( ($f->getType() == "product") &&  ($f->isalive() == 1) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line2>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line2>". $f->getLink() ."</TD>\n";
         echo "<TD CLASS=line2>". $f->getTimespan() ."</TD>\n";
       } else if ( ($f->getType() == "installation") &&  ($f->instdate->getTimestamp() - time() > 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line2>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line2>". $f->getLink() ."</TD>\n";
         echo "<TD CLASS=line2>". $f->instdate->getDate() ."</TD>\n";
       }
     }
     # Then some recent appointments
     $x = 0;
     @reset ($obj->ulist);
     while ( (list ($i,$f) = @each ($obj->ulist)) && ($x < $tutos[maxshort]) ) {
       if ( ($f->getType() == "appointment") && ($f->end->getTimestamp() - time() < 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line1>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line1><I>". $f->getLink($f->descr) ."</I></TD>\n";
         echo "<TD CLASS=line1>". $f->getTimespan() ."</TD>\n";
         $x++;
       }
     }
     # Then the old tasks and projects
     $x = 0;
     @reset ($obj->ulist);
     while ( (list ($i,$f) = @each ($obj->ulist)) && ($x < $tutos[maxshort]) ) {
       if ( ($f->getType() == "task") && ($f->s_end->getTimestamp() - time() < 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line1>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line1><I>". $f->getLink() ."</I></TD>\n";
         echo "<TD CLASS=line1>". $f->getTimespan() ."</TD>\n";
         $x++;
       } else if ( ($f->getType() == "product") &&  ($f->isalive() == 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line1>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line1><I>". $f->getLink() ."</I></TD>\n";
         echo "<TD CLASS=line1>".  $f->getTimespan() ."</TD>\n";
         $x++;
       } else if ( ($f->getType() == "installation") &&  ($f->instdate->getTimestamp() - time() < 0) ) {
         echo "</TR><TR>\n";
         echo "<TD CLASS=line1>". $lang[$f->getType()] ."</TD>\n";
         echo "<TD COLSPAN=2 CLASS=line1><I>". $f->getLink() ."</I></TD>\n";
         echo "<TD CLASS=line1>". $f->instdate->getDate() ."</TD>\n";
       }
     }
   }
   echo "</TR>\n";

   # References to modules
   show_module_infolists($current_user,$obj,4);
   echo $obj->getHistoryLink(4);
   echo "</TABLE>\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(useresource,PERM_NEW) ) {
     echo menulink("resource/resource_new.php",$lang['NewEntry'],$lang['ResCreate']) ."<BR>";
   }
   if ( $obj->mod_ok() ) {
     echo menulink("resource/resource_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['ResModifyI'],$obj->getFullName())) ."<BR>\n";
   }
   echo resource::getOverviewLink($current_user,$lang['Resources'])."<BR>";

   echo "<BR>\n";
   if ( $current_user->feature_ok(usecalendar,PERM_SEE) ) {
     echo menulink("calendar.php?team=". $obj->id ,$lang['Calendar'],sprintf($lang['ShowCal'],$obj->getFullName())) ."<BR>\n";
   }

   show_module_addlinks($current_user,$obj);

   echo "</TD></TR>";

   HTML_Select();
 }


 $b = new resource($dbconn);
 if ( isset($HTTP_GET_VARS['id']) ) {
   $b->read($HTTP_GET_VARS['id']);
 }
 if ( ! $b->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$b->getType()]);
 } else {
   if ( $b->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$b->getType()]);
   }
 }
 if ( !isset($HTTP_GET_VARS['format'])){
   $format = "html";
 } else {
   $format = $HTTP_GET_VARS['format'];
 }

 if ( $format == "xml" ) {
   echo $b->exportXML();
 } else {
   HTML_Header($lang['ResDetail']);
   HTML_Base1();
   navigate($b);
   HTML_Base2($msg);
   if ( ($b->id > 0) && $b->see_ok() ) {
     info($b);
   }
   HTML_Base3();
 }
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: resource_show.php,v 1.4 2002/07/25 12:06:07 gokohnert Exp $
    $Author: gokohnert $
-->
