<?
/*
 * Copyright 1999 - 2001 by Gero Kohnert
 * well, copyright? Inspired by Gero,
 * shamelessly copied and mutulated by J. Baten
 * This should turn out to be a salesforecast report
 * Multiply price * probability = balanced sales amount
 * if chances are estimated correctly this should give you
 * a good impression of future sales.
 * version 1.1 d.d. 01032002 J. Baten initial version. far from finished.
 * version 1.2 d.d. 02032002 J. Baten, fixed the totals at the bottom
 * still todo
 * -subdivide output in separate months
 * -make graph of report (using jpgraph)
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("timetrack.pinc");
 include("bug.pinc");
 include("product.pinc");
 include("installation.pinc");
 include("task.pinc");
 include("mailbox.pinc");

 /* Check if user is allowed to use it */
 check_user();

 /**
  * Display table with product/project info. This is the normal report.
  * version: 1.0 date 03022002 J. Baten Seems to be find now.
  */
 Function info(&$dbconn,&$result,$start = 0,$hidden) {
   global $lang,$pshow,$tutos,$current_user,$link1,$format,$filter;

   # extend the product class definition
   class product2 extends product {
    function balanced() {
        return $this->price * ($this->probability/100);
    }
   }
   #add a temporary field
   $tutos[prodfields][] = "balanced";
   # now where can I put the above extension?
 
   $plist = array();
   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   $flds = 0;

   @reset($tutos[currencies]);
   while( list ($i,$c) = @each ($tutos[currencies])) {
     $sum[1][$c] = 0;
     $sum[2][$c] = 0;
   }
   $sum[1][""] = 0;
   $sum[2][""] = 0;
   # Make a big array of all visible products
   $x = 0;
   while ( $x < $n ) {
     $p = new product2($dbconn);
     $p->read_result($result,$x);
     $x++;
     if ( ! $p->see_ok() ) {
       unset($p);
       continue;
     }
     if ( ($pshow['price'] == 1) || ($pshow['balanced'] == 1) ) {
       $sum[1][$p->currency] += $p->price;
       $sum[2][$p->currency] += $p->balanced();
     }
     $plist[] = $p;
     unset($p);
   }
   $n = count($plist);
   if ( 0 == $n) {
     echo $lang['Err0048'];
     return;
   }

   # start the header for the results
   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";

   @reset($tutos[prodfields]);
   while( list ($i,$c) = @each ($tutos[prodfields])) {
     if ( ($c == "name") && $pshow[$c] ) {
       echo order_header("",$lang['ProdName'],"");
       $flds++;
     }
     if ( ($c == "version") && $pshow[$c] ) {
       echo order_header("",$lang['ProdVersion'],"");
       $flds++;
     }
     if ( ($c == "customer") && $pshow[$c] ) {
       echo order_header("",$lang['ProdRole'][6],"");
       $flds++;
     }
     if ( ($c == "desc") && $pshow[$c] ) {
       echo order_header("",$lang['ProdDesc'],"");
       $flds++;
     }
     if ( ($c == "state") && $pshow[$c] ) {
       echo order_header("",$lang['ProdState'],"");
       $flds++;
     }
     if ( ($c == "probability") && $pshow[$c] ) {
       echo order_header("",$lang['ProdProb'],"");
       $flds++;
     }
     if ( ($c == "price") && $pshow[$c] ) {
       echo order_header("",$lang['ProdPrice'],"");
       $flds++;
     }
    if ( ($c == "p_start") && $pshow[$c] ) {
       echo order_header("",$lang['ProdStart'],"");
       $flds++;
     }
     if ( ($c == "p_end") && $pshow[$c] ) {
       echo order_header("",$lang['ProdEnd'],"");
       $flds++;
     }
     if ( ($c == "balanced") && $pshow[$c] ) {
       echo order_header("",$lang['SalesBalanced'],"");
       $flds++;
     }
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   # looks funny now but should someday make a difference.
   if ( $format == "paper" ) {
     $a = 0;
     $end = $n;
   } else {
     $a = 0;
     $end = $n;
   }

   # start the main body with the results
   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $p = &$plist[$a];
     $p->readroles();

     # here we select the period to display
     $period=$p->p_end->month." ".$p->p_end->year;
     if ( $period == "-1 -1" ) {
       $period=$lang["UndefinedEndDate"];
     } 
     # a new timeperiod has started. Let's make a row.
     # and if it is not the first header then print a subtotal
     if ( $oldperiod != $period ) {
       if ( $notthefirst == true ) {
         $periodtotal=$sumPeriod[$oldperiod];
         $sumPeriod[$period]=0;
         echo "<tr><td colspan='8'>&nbsp;</td><td nowrap align='right'>";
         echo number_format($periodtotal,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". htmlspecialchars($p->currency)."</td></tr>";
       }
       echo "<tr><td colspan='9' align='left'><h2>".$period."</h2></td></tr>";
       $notthefirst=true;
     }
     $oldperiod=$period; 
     $sumPeriod[$period]+=$p->balanced();
  
     #
     echo "<TR>\n";
     @reset($tutos[prodfields]);
     while( list ($i,$c) = @each ($tutos[prodfields])) {

       # projectname
       if ( ($c == "name") && $pshow[$c] ) {
         $b = myentities($p->name);
         if ( $filter['name'] != "" ) {
           $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
         }
         echo "  <TD VALIGN=top>&nbsp;". $p->getLink($b) ."</TD>\n";
       }
       if ( ($c == "version") && $pshow[$c] ) {
		 $b = myentities($p->version);
	 	if ( $filter['name'] != "" ) {
	   $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
	 }
         echo "  <TD VALIGN=top>&nbsp;". $b ."</TD>\n";
       }

       # Customer
       if ( ($c == "customer") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>\n &nbsp;";
         if (isset($p->role[6]) && (count($p->role[6]) > 0) ) {
           @reset ($p->role[6]) ;
           $x = 0;
           while ( list ($i,$r) = @each ($p->role[6]) ) {
             if ( $x > 0 ) {
               echo "<BR>\n &nbsp;";
             }
             echo  $r->getLink();
             $x++;
           }
         }
         echo "  </TD>\n";
       }

       # someone forget to say 'description' here :-)
       if ( ($c == "desc") && $pshow[$c] ) {
         $b = myentities($p->description);
         if ( $filter['name'] != "" ) {
           $b = eregi_replace("(". $filter['name'] .")","<SPAN CLASS=found>\\1</SPAN>",$b);
         }
         echo "  <TD VALIGN=top>&nbsp;". $b ."</TD>\n";
       }

       # state
       if ( ($c == "state") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $lang['ProdStates'][$p->state] ."</TD>\n";
       }
       # probability (mucho importante)
       if ( ($c == "probability") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->probability ."</TD>\n";
       }
       # price (also mucho importante)
       if ( ($c == "price") && $pshow[$c] ) {
         echo "  <TD VALIGN=top ALIGN=right>&nbsp;". number_format($p->price,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". htmlspecialchars($p->currency) ."</TD>\n";
       }
       # balanced result
       if ( ($c == "balanced") && $pshow[$c] ) {
         echo "  <TD VALIGN=top ALIGN=right>&nbsp;". number_format($p->balanced(),2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". htmlspecialchars($p->currency) ."</TD>\n";
       }

       # start date
       if ( ($c == "p_start") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->p_start->getLinkDate() ."</TD>\n";
       }
       # end date
       if ( ($c == "p_end") && $pshow[$c] ) {
         echo "  <TD VALIGN=top>&nbsp;". $p->p_end->getLinkDate() ."</TD>\n";
       }
     }
     echo "</TR>\n";
	 unset($plist[$a]);
	 unset($p);
     $a++;
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,$flds,$start,$a,$n);

   # Sums of amounts
   if ( ($pshow['price'] == 1) || ($pshow['balanced'] == 1) ) {
     echo "<TR>\n";
     $fill = 0;
     @reset($tutos[prodfields]);
     while( list ($i,$c) = @each ($tutos[prodfields])) {
       if (  $pshow[$c] == 0 ) {
         continue;
       }
       # display total sum of price
       if ( $c == "price" ) {
         if ( $fill > 0 ) {
           echo " <TD COLSPAN=". $fill .">&nbsp;</TD>\n";
           $fill = -1;
         }
         echo " <TD nowrap ALIGN=right>\n";
         @reset($sum[1]);
         $pre = "";
         while( list ($i1,$f1) = @each ($sum[1])) {
           if ( $f1 ) {
             echo $pre . number_format($f1,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". $i1;
             $pre = "<BR>\n";
           }
         }
         echo " </TD>\n";
       }
       # display total sum of balanced
       else if ( $c == "balanced" ) {
         if ( $fill > 0 ) {
           echo " <TD COLSPAN=". $fill .">&nbsp;</TD>\n";
           $fill = -1;
         }
         echo " <TD nowrap ALIGN=right>\n";
         @reset($sum[2]);
         $pre = "";
         while( list ($i1,$f1) = @each ($sum[2])) {
           if ( $f1 ) {
             echo $pre . number_format($f1,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". $i1;
             $pre = "<BR>\n";
           }
         }
         echo " </TD>\n";
       }
       else {
         $fill++;
       }
     }
     if ( $fill > 0 ) {
       echo " <TD COLSPAN=". $fill .">&nbsp;</TD>\n";
     }
     echo "</TR>\n";
   }

   echo "</TFOOT>\n";
   echo "</TABLE>\n";
#   if ( $pshow['checkbox'] ) {
#     echo "</FORM>\n";
#   }
 }

 /*
  * version 1.0 date 03032002 initial version
  * This procedure makes a graphic display of the information.
  * since I can't use jpgrapg to make an inline graphic, I just
  * call myself as an image... :-) cute no?
  */
 Function statinfo() {
   # this is were my fun starts.
   # shouldn't we sent some no-cache headers?
   Header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
   # Header("Expires: 0");
   Header("Expires: -1");
   # Header("Expires: " . gmdate("D, d M Y H:i:s",time() + 2 ) . " GMT");
   Header("Cache-Control: no-cache, must-revalidate,  max_age=0 ,post-check=0, pre-check=0");
   Header("Pragma: no-cache");
   if (file_exists("jpgraph/jpgraph.php")  ) {
     # no why doesn't $PHP_SELF work?
     #echo "<img src='".$PHP_SELF."?function=image'>";
     echo "<img src='sales_forecast.php?function=image'>";
   }
 }
 # this function is used by the above mentioned function
 Function image(&$dbconn,&$result,$filter) {
   #if (file_exists ("jpgraph/jpgraph.php")  ) {
     global $lang,$pshow,$flds,$tutos;
     include ("jpgraph/jpgraph.php");
     DEFINE("READ_CACHE",FALSE);
     DEFINE("USE_CACHE",FALSE);
     include ("jpgraph/jpgraph_bar.php");
     # extend the product class definition
     class product2 extends product {
      function balanced() {
          return $this->price * ($this->probability/100);
      }
     }
     #add a temporary field
       $tutos[prodfields][] = "balanced";
     # now where can I put the above extension?
 
     $n = $result->numrows();
     if ( 0 == $n) {
       return;
     }
     $a = 0;
     $cnt = 0;
     $notthefirst=false;
     $sumperiodtotal=0;
     $datax=array();
     $datay1=array();
     $datay2=array();
     while ( $a < $n ) {
       $p = new product2($dbconn);
       $p->read_result($result,$a);
       #$p->readroles();
       $cnt++;
       # here we select the period to display
       $m=$p->p_end->month;
       $y=$p->p_end->year;
       $period=$m." ".$y;
       if ( $period == "-1 -1" ) {
         $period=$lang["UndefinedEndDate"];
       } 
       # a new timeperiod has started. Let's make a row.
       # and if it is not the first header then print a subtotal
       if ( $oldperiod != $period ) {
         if ( $notthefirst == true ) {
           array_push($datax,$oldperiod);

           $periodtotal=$sumPeriod[$oldperiod];
           array_push($datay1,$periodtotal);

           $sumperiodtotal+=$periodtotal;
           array_push($datay2,$sumperiodtotal);

           $sumPeriod[$period]=0;
         }
         $notthefirst=true;
       }
       $oldperiod=$period; 
       $sumPeriod[$period]+=$p->balanced();
       #unset($p);
       $a++;
     }
     # let's get the last values...
     array_push($datax,$oldperiod);

     $periodtotal=$sumPeriod[$oldperiod];
     array_push($datay1,$periodtotal);

     $sumperiodtotal+=$periodtotal;
     array_push($datay2,$sumperiodtotal);

     $graph = new Graph(600,400,"auto");
     $graph->img->SetMargin(90,40,40,40);
     $graph->SetScale("textlin");
     $graph->SetShadow();
     $graph->title->Set($lang['SalesForecastRep']);
     $graph->title->SetFont(FF_FONT1,FS_BOLD);

     $graph->xaxis->title->Set($lang["Period"]);
     $graph->xaxis->SetTickLabels($datax);  
     $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

     $graph->yaxis->title->Set($lang["Est_revenue"]);
     $graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
     $graph->yaxis->SetTitleMargin(65);

     $p1 = new BarPlot($datay2);
     $p1->SetFillColor("orange");
     $p1->SetLegend($lang["AccumulatedRevenue"]);

     $p2 = new BarPlot($datay1);
     $p2->SetFillColor("blue");
     $p2->SetWidth(1.0);
     $p2->SetValueFormat("%0d");
     $p2->ShowValue();
     $p2->SetLegend($lang["PeriodRevenue"]);

     // Create the grouped bar plot
     $plot = new AccBarPlot(array($p1,$p2));
     $plot->SetShadow();

     $graph->Add($plot);
     $graph->Stroke();
   }
 #} 

 /*
 --------------------------------------------------------------------------
  *
  */
Function navigate($link1,$hidden) {
   global $lang,$current_user,$pshow,$flds,$tutos,$format;


   echo "<TABLE>";
   echo "<TR><TD>";
   echo product::getSelectLink($current_user,$lang['Search'])."<BR>";
   echo  menulink("product_new.php",$lang['NewEntry'],$lang['ProdCreateInfo']) ."<BR>";
   echo "</TD></TR>";
   echo "<TR><TD>";


   $ll = addUrlParameter($link1,"format=paper");
   echo menulink($ll,$lang['Printable'],$lang['PrintableInfo']);

//     if ( $format != "stat" ) {
//       echo "<BR>";
//       $ll = addUrlParameter($link1,"format=stat");
//       echo menulink($ll,$lang['Graph'],$lang['GraphInfo']);
//     }
   echo "</TD></TR>";

   HTML_Select();
 }

/* 
 ------ main program -----------------------------------------------------------------------
*/
 
 $tutos[maxshow]=999999;

 $p = new product($dbconn);
 $link1 = "sales_forecast.php";
 $hidden = "";
 $filter = array();

 # Prepare some structures

 $flds['name']         = 'ProdName';
 $flds['version']      = 'ProdVersion';
 $flds['customer']     = 'ProdRole6';
 $flds['desc']         = 'ProdDesc';
 $flds['cost']         = 'ProdCost';
 $flds['price']        = 'ProdPrice';
 $flds['probability']  = 'ProdProb';
 $flds['balanced']     = 'balanced';
 $flds['state']        = 'ProdState';
 $flds['p_start']      = 'ProdStart';
 $flds['p_end']        = 'ProdEnd';
 for ( $cl = 1;$cl <= $p->classes; $cl++) {
   $x = sprintf("cl%d",$cl);
   $flds['cl'.$cl]     = 'ProdClass'.$cl;
 }

 @reset($tutos[prodfields]);
 while( list ($i,$c) = @each ($tutos[prodfields])) {
   $pshow[$c] = 0;
 }

 if ( isset($HTTP_GET_VARS['format']) ) {
   $format = $HTTP_GET_VARS['format'];
 } else {
   $format = "html";
 }
 if ( ! isset($HTTP_GET_VARS['start']) ) {
   $start = 0;
 } else {
   $start = $HTTP_GET_VARS['start'];
 }

 $q = "SELECT * FROM products";
 $pre = " WHERE ";

 $filter['name'] = "";
 
 #
 # State to display
 #
 # all projects that are not cancelled or quote cancelled.
 $filter['state'] = ' state = 0 or state = 1 or state = 4 ';


 # Order of output
 # JB Let's order by project end cause thats when the billing starts.
 $q .= $pre." ".$filter['state'];
 $q .= " ORDER by p_end ASC";

 # JB: debug stuff
 # echo "<!-- query = $q -->";

 $result = $dbconn->Exec($q);

 /* Fields to show */
 $pshow['name']         = 1;
 $pshow['version']      = 0;
 $pshow['customer']     = 1;
 $pshow['desc']         = 1;
 $pshow['cost']         = 1;
 $pshow['price']        = 1;
 $pshow['probability']  = 1;
 $pshow['balanced']     = 1;
 $pshow['state']        = 1;
 $pshow['p_start']      = 1;
 $pshow['p_end']        = 1;

 # functions to do when we have a lot of info BUT BEFORE any output!
 # is the file calles with an argument 'function'?
 if ( isset($function) ) {
   # is the function = 'image'
   if ($function=='image') {
     image($dbconn,$result,$filter);
   }
   exit;
 }



 if ( $format == "html" ) {
   if ($result->numrows() == 1) {
     $p = new product($dbconn);
     $p->read_result($result,0);

     $result->free();
     $dbconn->Close();
     exit;
   }
   HTML_Header($lang['SalesForecastRep']);
   HTML_Base1();
   navigate($link1,$hidden);
   HTML_Base2($msg);
   info($dbconn,$result,$start,$hidden); 
   HTML_Base3();
 } else if ( $format == "paper" ) {
   Printable_Header($lang['SalesForecastRep']);
   $link1 = addUrlParameter($link1,"format=".UrlEncode($format));
   info($dbconn,$result,$start,$hidden); 
   HTML_Close();
 } else if ( $format == "stat" ) {
   HTML_Header($lang['SalesForecastRep']);
   $link1 = addUrlParameter($link1,"format=".UrlEncode($format));
   HTML_Base1();
   navigate($link1,$hidden);
   HTML_Base2($msg);
   statinfo($dbconn,$result,$filter);
 }
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: sales_forecast.php,v 1.7 2002/07/10 19:36:23 gokohnert Exp $
    $Author: gokohnert $
-->
