<?
/**
 * Copyright 2001 by Gero Kohnert
 *
 *  CVS Info:  $Id: scheme.php,v 1.23.2.3 2002/08/28 16:36:53 gokohnert Exp $
 *  $Author: gokohnert $
 *
 * Create all tables indices etc for TUTOS
 *
 * !! Remove/Disable this script after running !!
 *
 * @modulegroup ADMIN
 * @module scheme
 * @package BASE
 */
 include("webelements.p3");
 include("permission.p3");
 include("file.pinc");
 include("appointment.pinc");
 include("timetrack.pinc");
 include("product.pinc");
 include("task.pinc");
 include("bug.pinc");
 include("mail.pinc");
 include("history.pinc");
 include("url.pinc");
 include("table.pinc");

 /* ---------------------------------------------------------------------------
  * Perform Step 1  (creating tables,indizes,sequences)
  */
 Function step1(&$dbconn) {
   global $table,$tableidx,$sequence,$current_user;

   echo "<P>";
   echo "<P>";
   echo "Trying to open this Database !<BR>\n";
   echo "(you have to create the database or change config.pinc if this test failed !<BR>\n";
   flush();
   $out = 0;
   if ( $dbconn->conn != -1 ) {
     echo "&nbsp; Looks OK <I>(". $dbconn->gettype() ." -> ". $dbconn->conn .")</I> !<BR>\n";
   } else {
     echo "failed to open Database <BR>";
     flush();
     return;
   }
   echo "<P>";
   flush();

   @reset($table);
   while ( list ($i,$f) = @each ($table) ) {
     echo $f[Desc] ."<BR>\n";
     if ($dbconn->droptable($f) == -1) {
       echo "Table <B>". $f[name] ."</B> not dropped:<SPAN class=warn>". $dbconn->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN class=found>Table <B>". $f[name] ."</B> dropped</SPAN><BR>\n";
     } 
     if ($dbconn->createtable($f) == -1) {
       echo "Table not created:<SPAN class=warn>". $dbconn->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN CLASS=found>Table <B>". $f[name] ."</B> created</SPAN><BR>\n";
     }
	 flush();
   }


   # Build the inidces
   echo "<P>\n";
   @reset($tableidx);
   while ( list ($i,$f) = @each ($tableidx) ) {
     echo $f[Desc] ."<BR>\n";
     if ($dbconn->dropindex($f) == -1) {
#       echo "Index not dropped:<SPAN class=warn>". $dbconn->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN class=found>Index dropped</SPAN><BR>\n";
     }
     if ($dbconn->createindex($f) == -1) {
       echo "Index <B>". $f[name] ."</B> not created:<SPAN class=warn>". $dbconn->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN class=found>Index <B>". $f[name] ."</B> created</SPAN><BR>\n";
     }
	 flush();
   }

   # Build the sequencers
   echo "<P>\n";
   @reset($sequence);
   while ( list ($i,$f) = @each ($sequence) ) {
     echo $f[Desc] ."<BR>\n";
     if ( $dbconn->dropsequence($f) == -1 ) {
       echo "Sequence not dropped:<SPAN class=warn>". $dbconn->lasterror ."</SPAN><BR>\n";
     } else {
       echo "<SPAN class=found>Sequence dropped</SPAN><BR>\n";
     };
     if ( $dbconn->createsequence($f) == -1 ) {
       echo "Sequence not created:<SPAN class=warn>". $dbconn->lasterror ."</SPAN><BR>\n";
     } else {
       echo "<SPAN class=found>Sequence created</SPAN><BR>\n";
     };
     flush();
   }


   # Save the Database
   # The current DB entry is always that with the ID 1
   $dbconn->db->creator = $current_user;
   $dbconn->db->newid = 1;
   $dbconn->db->id = -1;
   $dbconn->db->dbconn = &$dbconn;
   $msg = $dbconn->db->save();
   echo $msg;
   return;
 }
 /* ---------------------------------------------------------------------------
  * Perform Step 2  (insert a single super user)
  */
 Function step2(&$dbconn) {
   global $current_user,$tutos;

   echo "Creating a <B>superuser</B> account<BR>\n";
   $tutos[demo] = 0;

   $adr = new tutos_address($dbconn);
   $adr->f_name = "Super";
   $adr->l_name = "User";
   $adr->birthday = new DateTime();
   $adr->creator = $adr;
   $msg .= $adr->save();

   $current_user = new tutos_user($dbconn);
   $current_user->updatepw = 1;
   $current_user->login = "superuser";
   $current_user->pw = "tutos";
   $current_user->id = $adr->id;
   $current_user->admin = 1;

   $msg .= $current_user->save();


   echo $msg ."<BR>\n";

 }
 /* ---------------------------------------------------------------------------
  * Perform Step 3  (example data)
  */
 Function step3(&$dbconn) {
   global $current_user, $lang,$tutos;

   # No mails here !!
   $tutos[demo] = 0;

   $u1 = new tutos_user($dbconn);
   $u2 = new tutos_user($dbconn);
   $u3 = new tutos_user($dbconn);
   $a1 = new tutos_address($dbconn);
   $a2 = new tutos_address($dbconn);
   $a3 = new tutos_address($dbconn);

   echo "Creating some demo data<BR>\n";
   flush();

   # Companies
   $f1 = new company($dbconn);
   $f1->name = "Linux Consulting";
   $msg .= $f1->save();
   echo $lang[$f1->getType()].":". $f1->getFullName() ."<BR>\n";

   $f2 = new company($dbconn);
   $f2->name = "S.u.S.E";
   $msg .= $f2->save();
   echo $lang[$f2->getType()].":". $f2->getFullName() ."<BR>\n";

   # Departments
   $d1 = new department($dbconn);
   $d1->name = "Sales";
   $d1->company = &$f1;
   $msg .= $d1->save();
   echo $lang[$d1->getType()].":". $d1->getFullName() ."<BR>\n";

   $d2 = new department($dbconn);
   $d2->name = "Sales";
   $d2->company = &$f2;
   $msg .= $d2->save();
   echo $lang[$d2->getType()].":". $d2->getFullName() ."<BR>\n";

   # User & Addresses
   $a1->f_name = "Linus";
   $a1->m_name = "B";
   $a1->l_name = "Torvalds";
   $a1->creator = &$current_user;
   $msg .= $a1->save();
   echo $lang[$a1->getType()].":". $a1->getFullName() ."<BR>\n";
   flush();

   $u1->updatepw = 1;
   $u1->login = "linus";
   $u1->pw = "guest";
   $u1->id = $a1->id;
   $msg .= $u1->save();
   echo $lang[$u1->getType()].":". $u1->login ."<BR>\n";
   flush();

   $a2->f_name = "Bill";
   $a2->l_name = "Gates";
   $a2->creator = &$current_user;
   $msg .= $a2->save();
   echo $lang[$a2->getType()].":". $a2->getFullName() ."<BR>\n";
   flush();

   $u2->updatepw = 1;
   $u2->login = "billgates";
   $u2->pw = "guest";
   $u2->id = $a2->id;
   $msg .= $u2->save();
   echo $lang[$u2->getType()].":". $u2->login ."<BR>\n";
   flush();

   $a3->f_name = "Gero";
   $a3->l_name = "Kohnert";
   $a3->creator = $current_user;
   $msg .= $a3->save();
   echo "Address:". $a3->getFullName() ."<BR>\n";
   flush();

   $u3->updatepw = 1;
   $u3->login = "gero";
   $u3->pw = "guest";
   $u3->id = $a3->id;
   $msg .= $u3->save();
   echo $lang[$u3->getType()].":". $u3->login ."<BR>\n";
   flush();

   # Locations
   $l1 = new location($dbconn);
   $l1->comapny = &$f1;
   $l1->lname = "Home";
   $l1->city = "Erlangen";
   $l1->zip  = "91058";
   $l1->country  = "DE";
   $l1->adr_id  = $a3->id;
   $msg .= $l1->save();
   echo $lang[$l1->getType()].":". $l1->lname ."<BR>\n";
   flush();
   
   $l2 = new location($dbconn);
   $l2->comapny = &$f1;
   $l2->lname = "Headquarter";
   $l2->city = "Erlangen";
   $l2->zip  = "91058";
   $l2->country  = "DE";
   $l2->adr_id  = $f1->id;
   $msg .= $l2->save();
   echo $lang[$l2->getType()].":". $l2->lname ."<BR>\n";
   flush();
   
   # Team
   $x1 = new team($dbconn);
   $add = array();
   $del = array();
   $add[0] = $a1->id;
   $add[0] = $a3->id;
   $x1->name = "TUTOS Development";
   $x1->owner = $a3;
   $msg .= $x1->save($add,$del);
   echo $lang[$x1->getType()].":". $x1->getFullName() ."<BR>\n";
   flush();

   $x2 = new team($dbconn);
   $add = array();
   $del = array();
   $add[0] = $a2->id;
   $x2->name = "The Others";
   $x2->owner = $a3;
   $msg .= $x2->save($add,$del);
   echo $lang[$x2->getType()].":". $x2->getFullName() ."<BR>\n";
   flush();

#   $dbconn->Close();
#   $dbconn->Open();

   # No mails here !!
   $tutos[demo] = 1;

   # Products
   $p1 = new product($dbconn);
   $p1->name = "TUTOS";
   $p1->version = $tutos[version];
   $p1->creator = &$u3;
   $p1->role[1][] = &$a3;
   $p1->role[9][] = &$f1;
   $p1->cl[1][] = 1;
   $p1->cl[2][] = 1;
   $msg .= $p1->save();
   echo $lang[$p1->getType()].":". $p1->getFullName() ."<BR>\n";

   $p2 = new product($dbconn);
   $p2->name = "Linux";
   $p2->version = "2.2";
   $p2->creator = &$u1;
   $p2->role[1][] = &$a1;
   $p2->cl[1][] = 1;
   $p2->cl[2][] = 1;
   $msg .= $p2->save();
   echo $lang[$p2->getType()].":". $p2->getFullName() ."<BR>\n";

   $p3 = new product($dbconn);
   $p3->name = "Linux";
   $p3->version = "2.4";
   $p3->creator = &$u1;
   $p3->role[1][] = &$a1;
   $p3->role[11][] = &$p2;
   $msg .= $p3->save();
   echo $lang[$p3->getType()].":". $p3->getFullName() ."<BR>\n";

   # Resources
   $r1 = new resource($dbconn);
   $r1->name = "Meeting Room";
   $r1->desc = "The big Meeting Room first floor";
   $r1->creator = &$u1;
   $msg .= $r1->save();
   echo $lang[$r1->getType()].":". $r1->getFullName() ."<BR>\n";

   # Appointment
   $c1 = new appointment($dbconn);
   $c1->descr = "Meeting";
   $c1->outside = 1;
   $c1->a_start = new DateTime();
   $c1->a_end   = new DateTime();
   $c1->visitor = &$a1;
   $c1->product = &$p1;
   $c1->participant[$a1->id] = &$a1;
   $c1->participant[$a3->id] = &$a3;
   $msg .= $c1->save();
   echo $lang[$c1->getType()].":". $c1->getFullName() ."<BR>\n";

   $c2 = new appointment($dbconn);
   $c2->descr = "Count my money";
   $c2->outside = 0;
   $c2->a_start = new DateTime();
   $c2->a_end   = new DateTime();
   $c2->participant[$a2->id] = &$a2;
   $msg .= $c2->save();
   echo $lang[$c2->getType()].":". $c2->getFullName() ."<BR>\n";

   # Bug
   $b1 = new bug($dbconn);
   $b1->state = 1;
   $b1->class = 1;
   $b1->short = "too slow";
   $b1->description = "too slow";
   $b1->parent = $p2;
   $b1->creator = $u1;
   $b1->solver = $a1;
   $msg .= $b1->save();
   echo $lang[$b1->getType()].":". $b1->getFullName() ."<BR>\n";

   $b2 = new bug($dbconn);
   $b2->state = 1;
   $b2->class = 1;
   $b2->short = "too fast";
   $b2->description = "too fast";
   $b2->parent = $p1;
   $b2->creator = $u2;
   $b2->solver = $a2;
   $msg .= $b2->save();
   echo $lang[$b2->getType()].":". $b2->getFullName() ."<BR>\n";

   # Task
   $t1 = new task($dbconn);
   $t1->name = "Demo Task 1";
   $t1->description = "This is a task";
   $t1->volume = 12.5;
   $t1->state = 1;
   $t1->p_id = $p1->id;
   $t1->worker = $a1;
   $msg .= $t1->save();
   echo $lang[$t1->getType()].":". $t1->getFullName() ."<BR>\n";

   $t2 = new task($dbconn);
   $t2->name = "Demo Task 2";
   $t2->description = "This is another task";
   $t2->volume = 2.5;
   $t2->state = 0;
   $t2->p_id = $p1->id;
   $t2->worker = $a1;
   $msg .= $t2->save();
   echo $lang[$t2->getType()].":". $t2->getFullName() ."<BR>\n";

   $t3 = new task($dbconn);
   $t3->name = "Demo Task 3";
   $t3->description = "a lot to do eh ?";
   $t3->volume = 14.5;
   $t3->state = 2;
   $t3->p_id = $t2->id;
   $t3->worker = $a1;
   $msg .= $t3->save();
   echo $lang[$t3->getType()].":". $t3->getFullName() ."<BR>\n";

   # Timetrack
   $tt1 = new timetrack($dbconn);
   $tt1->link_id = $t1->id;
   $tt1->worker = $a1;
   $tt1->volume = 2.1;
   $tt1->desc = "Working on demo task";
   $tt1->wday = new DateTime();
   $tt1->state = 1;
   $tt1->invoice = -1;
   $tt1->cph = 110.5;
   $tt1->currency = "EUR";
   $msg .= $tt1->save();
   echo $lang[$tt1->getType()].":". $tt1->getFullName() ."<BR>\n";

   # Notes
   $n1 = new note($dbconn);
   $n1->creator = &$u1;
   $n1->name = "Remember this !";
   $n1->note = "Remember to look at TUTOS";
   $n1->link_id = $p1->id;
   $msg .= $n1->save();
   echo $lang[$n1->getType()].":". $n1->getFullName() ."<BR>\n";

   $n2 = new note($dbconn);
   $n2->creator = &$u2;
   $n2->name = "repair";
   $n2->note = "Repair the desk in the meeting room";
   $n2->link_id = $r1->id;
   $msg .= $n2->save();
   echo $lang[$n2->getType()].":". $n2->getFullName() ."<BR>\n";

   $url1 = new url($dbconn);
   $url1->name = "homepage";
   $url1->url = "http://www.tutos.org";
   $url1->link_id = $p1->id;
   $msg .= $url1->save();
   echo $lang[$url1->getType()].":". $url1->getFullName() ."<BR>\n";

   $url2 = new url($dbconn);
   $url2->name = "homepage";
   $url2->url = "http://www.tutos.org";
   $url2->link_id = $f1->id;
   $msg .= $url2->save();
   echo $lang[$url2->getType()].":". $url2->getFullName() ."<BR>\n";



   echo $msg ."<BR>\n";
   return;
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,$step,$id) {
   global $tutos,$lang,$current_user;

#   $dbconn->Open($id);
   echo "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=4>". $lang['AdminDBInfo'] ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   showfield("Database Type");
   echo " <TD>". $dbconn->GetType() ." ". $dbconn->openfunc ."</TD>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   showfield($lang['AdminDBName']);
   echo " <TD>". $dbconn->db->name ."</TD>\n";
   showfield($lang['AdminDBUser']);
   echo " <TD>". $dbconn->db->user ."</TD>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   showfield($lang['AdminDBHost']);
   echo " <TD>". $dbconn->db->host ."</TD>\n";
   showfield($lang['AdminDBPort']);
   echo " <TD>". $dbconn->db->port ."</TD>\n";
   echo "</TR>\n";
   echo "</TABLE>\n";
   flush();

   echo "<P><B>This is initialization STEP ". $step ."</B><BR>\n";

   echo "<FORM NAME=\"init\" ACTION=\"scheme.php\" METHOD=\"GET\">\n";
   echo " <INPUT type=\"hidden\" value=\"". $id ."\" name=\"id\">\n";
   if ( $step == 0 ) {
     echo "Is the above info correct ?<BR>\n";
     echo "(otherwise correct <I>config.pinc</I> an come back)<BR>\n";
     echo "Go on to create the database layout<BR>\n";
     echo "All existing data will be removed<BR>\n";
   }
   if ( $step == 1 ) {
     step1($dbconn);
     echo "Go on to create a superuser account<BR>\n";
   }
   if ( $step == 2 ) {
     step2($dbconn);
     echo "Go on to create some example data<BR>\n";
   }
   if ( $step == 3 ) {
     step3($dbconn);
   }
   if ( $step == 4 ) {
     echo "<SPAN CLASS=warn>If everything works disable this script</SPAN><BR>\n";
     echo "Come on and login<BR>\n";
   } else {
     $step++;
     echo "<input type=\"hidden\" name=\"step\" value=\"". $step ."\">";
     echo "<input type=\"submit\" value=\"". $lang['Enter'] . " Step ". $step ."\">";
     echo "</FORM>\n";
   }
   $dbconn->Close();
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate($id) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD NOWRAP>";
   echo menulink("update.php?id=".$id ,"UPDATE ". $tutos[dbalias][$id]);
   echo "<BR>\n";
   echo "<BR>\n";

   @reset ($tutos[dbname]);
   while ( list ($i,$f) = @each ($tutos[dbname]) ) {
     echo menulink("scheme.php?id=".$i ,$tutos[dbalias][$i],$tutos[dbalias][$i]);
	 echo "<BR>\n";
   }

   echo "<BR>\n";
   echo "</TD></TR>";

   HTML_Select();
 }

 $msg = "";
 ReadLang($lang);
 # read the table definitions of modules
 @reset($tutos[modules]);
 while ( list ($r,$x) = @each ($tutos[modules])) {
   loadmodule($r);
   include(dirname($tutos['base'] ."/". $tutos[modules][$r][file]) ."/mtable.pinc");
 }

 if ( isset($HTTP_GET_VARS['step']) ) {
   $step = $HTTP_GET_VARS['step'];
 } else {
   $step = 0;
 }
 if ( isset($HTTP_GET_VARS['id']) ) {
   $id = $HTTP_GET_VARS['id'];
 } else {
   $id = "0";
 }

 $dbconn = DB_Open($id,false);

 if ( $dbconn->gettype() == "Postgres" ) {
   # No persistent connections here
   $dbconn->setPersistent(0);
 }
 if ( $dbconn->gettype() == "Interbase" ) {
   # No persistent connections here
   $dbconn->setPersistent(0);
 }


 $current_user = new tutos_user($dbconn);
 $current_user->f_name = "TUTOS";
 $current_user->l_name = "(installation service)";
 $current_user->admin = 1;

 HTML_Header($lang['DBInit']." STEP ". $step);
 HTML_Base1();
 navigate($id);
 HTML_Base2($msg);
 info($dbconn,$step,$id);
 HTML_Base3();
?>
