<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * this script parses all the inputs and stores the object into the database.
 * on completition it jumps to the detail screen of the stored object
 *
 * @modulegroup task
 * @module task_ins
 * @package task
 */
 include("webelements.p3");
 include("permission.p3");
 include("url.pinc");
 include("task.pinc");
 include("product.pinc");
 include("timetrack.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("task");

 $msg = "";

 $gotourl="task_new.php";

 $t = new task($dbconn);

 if ( !isset($HTTP_POST_VARS['p_id']) || ($HTTP_POST_VARS['p_id'] == "") ) {
   $p_id =  $current_user;
 } else {
   $p_id = $HTTP_POST_VARS['p_id'];
   $gotourl= addUrlParameter($gotourl,"p_id=". $p_id);
 }

 if ( isset($HTTP_POST_VARS['id']) ) {
   $t->read($HTTP_POST_VARS['id']);
   $gotourl= addUrlParameter($gotourl,"id=". $t->id);
 } else {
   $t->creator = $current_user;
   $t->p_id = $p_id;
 }

 if ( !isset($HTTP_POST_VARS['name']) || (trim($HTTP_POST_VARS['name']) == "") ) {
   $msg .= sprintf($lang['Err0009'],$lang['TaskName']) ."<BR>";
 } else {
   $t->setName(trim(StripSlashes($HTTP_POST_VARS['name'])));
   $gotourl= addUrlParameter($gotourl,"name=". UrlEncode($t->name));
 }
 if ( !isset($HTTP_POST_VARS['desc']) || (trim($HTTP_POST_VARS['desc']) == "") ) {
   $msg .= sprintf($lang['Err0009'],$lang['TaskDesc']) ."<BR>";
 } else {
   $t->setDescription(trim(StripSlashes($HTTP_POST_VARS['desc'])));
   $gotourl= addUrlParameter($gotourl,"desc=". UrlEncode($t->desc));
 }
 if ( !isset($HTTP_POST_VARS['state']) || ($HTTP_POST_VARS['state'] == "") ) {
   $msg .= sprintf($lang['Err0014'],$lang['TaskState']) ."<BR>";
 } else {
   $state = $HTTP_POST_VARS['state'];
   $gotourl= addUrlParameter($gotourl,"state=". UrlEncode($state));
 }

 $volume = 0.0;
 list($volume) = sscanf($HTTP_POST_VARS['volume'],"%f");
 if ( !is_double($volume) || ($volume < 0) ) {
   $msg .= sprintf($lang['Err0009'],$lang['TaskVolumeFull']) ."<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"volume=". UrlEncode($volume));
 }

 $volume_done = 0.0;
 list($volume_done) = sscanf($HTTP_POST_VARS['volume_done'],"%f");
 if ( !is_double($volume_done) || ($volume_done < 0) ) {
   $msg .= sprintf($lang['Err0009'],$lang['TaskVolumeDone']) ."<BR>";
 } else {
   $gotourl= addUrlParameter($gotourl,"volume_done=". UrlEncode($volume_done));
 }
 if ( !isset($HTTP_POST_VARS['worker']) ) {
   $msg .= sprintf($lang['Err0014'],$lang['TaskWorker']) ."<BR>";
 } else {
   $t->worker = getObject($dbconn,$HTTP_POST_VARS['worker']);
   $gotourl= addUrlParameter($gotourl,"worker=". $t->worker->id);
 }


 $s_start = new DateTime(0);
 $s_start->setDateTimeF("s_start");
 $gotourl= addUrlParameter($gotourl,"s_start=". $s_start->getYYYYMMDDHHMM() );
 if ( 1 != $s_start->checkDMY() ) {
   $msg .= sprintf($lang['Err0038'],$lang['TaskS_Start']) ."<BR>";
 }

 $s_end = new DateTime(0);
 $s_end->setDateTimeF("s_end");
 $gotourl= addUrlParameter($gotourl,"s_end=". $s_end->getYYYYMMDDHHMM() );
 if ( 1 != $s_end->checkDMY() ) {
   $msg .= sprintf($lang['Err0038'],$lang['TaskS_End']) ."<BR>";
 }

 if ( ($s_start->ts > $s_end->ts ) ) {
   $msg .= $lang['Err0002'] ."<BR>";
 }

 # other modules
 $msg .= module_parseforms($current_user,$t,$gotourl);

 if ( $msg == "" ) {
   $t->parent = getObject($dbconn,$t->p_id);

   # First time work done
   if ( ($t->volume_done == 0) && ($volume_done > 0) ) {
     $t->r_start = new DateTime();
   }
   # First time state set to finished
   if ( ($t->state != 2) && ($state == 2) ) {
     $t->r_end = new DateTime();
   }
   if ( ($volume_done > $t->volume_done) && ($state == 2) ) {
     $t->r_end = new DateTime();
   }


   $t->setState($state);
   $t->setVolume($volume);
   $t->setVolumeDone($volume_done);
   $t->setSStart($s_start);
   $t->setSEnd($s_end);

   $dbconn->Begin("WORK");
   $msg .= $t->save();
   $dbconn->Commit("WORK");

   $gotourl= $t->getURL();
 }

 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));
 $gotourl = addSessionKey($gotourl);

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl() . $gotourl);
 $dbconn->Close();
 /*
  *  CVS Info:  $Id: task_ins.php,v 1.21.2.2 2002/09/13 12:14:42 gokohnert Exp $
  *  $Author: gokohnert $
  */
?>
