<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup task
 * @module task_show
 * @package task
 */
 include("webelements.p3");
 include("permission.p3");
 include("task.pinc");
 include("product.pinc");
 include 'bug.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("task");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$t) {
   global $lang,$current_user,$tutos;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo " <TR>\n";
   echo "  <TH COLSPAN=4>". $lang['TaskDetail'] ."</TH>\n";
   echo " </TR>\n";

   echo " <TR>\n";
   echo "  <TD COLSPAN=4>". sprintf ($lang['TaskCreation'],$t->creator->getLink(),$t->creation->getDateTime()) ."</TD>\n";
   echo " </TR>\n";

   echo " <TR>\n";
   showfield($lang['TaskName']);
   echo "  <TD>". myentities($t->name) ."</TD>\n";
   showfield($lang['TaskWorker']);
   echo "  <TD>". $t->worker->getLink() ."</TD>\n";
   echo " </TR>\n";

   echo " <TR>\n";
   showfield($lang['TaskState']);
   echo "  <TD COLSPAN=3>". $lang['TaskStates'][$t->state] ."</TD>\n";
   echo " </TR>\n";

   if ( ($t->parent != -1) && ($t->parent->gettype() != "address") ) {
     echo " <TR>\n";
     showfield($lang['TaskSubTask']);
     echo "  <TD COLSPAN=3>\n";
     echo  $lang[$t->parent->gettype()] . "&nbsp;";
     if ( $t->parent->gettype() == "product" ) {
       echo $t->parent->getLink() ."</TD>\n";
     } else if ( $t->parent->gettype() == "task" ) {
       $x = $t;
       $pre = "";
       while ( isset ( $x->parent ) ) {
    	 echo $pre . $x->parent->getLink();
    	 $x = $x->parent;
    	 $pre = " -> ";
       }
       echo "  </TD>\n";
	 }
	 echo " </TR>\n";
   }

   echo " <TR>\n";
   showfield($lang['TaskDesc']);
   echo "  <TD COLSPAN=3 CLASS=pre><PRE>". urlReplace($t->desc) ."</PRE></TD>\n";
   echo " </TR>\n";

   echo " <TR>\n";
   showfield($lang['TaskSched']);
   echo "  <TD>". $lang['DateTimeFrom'] .":&nbsp;". $t->s_start->getDate() ."</TD>\n";
   echo "  <TD COLSPAN=2>". $lang['DateTimeTill'] .":&nbsp;". $t->s_end->getDate() ."</TD>\n";
   echo " </TR>\n";

   echo " <TR>\n";
   showfield($lang['TaskReal']);
   echo "  <TD>". $lang['DateTimeFrom'] .":&nbsp;". $t->r_start->getDateTime() ."</TD>\n";
   echo "  <TD COLSPAN=2>". $lang['DateTimeTill'] .":&nbsp;". $t->r_end->getDateTime() ."</TD>\n";
   echo " </TR>\n";

   echo " <TR>\n";
   showfield($lang['TaskVolumeFull']);
   echo "  <TD>".  number_format($t->volume,2) ." ". $lang['hours'] ."</TD>\n";
   showfield($lang['TaskVolumeDone']);
   echo "  <TD>".  makelink("timetrack_overview.php?link_id=" .$t->id , number_format($t->volume_done,2) , $lang['TimetrackOverview']) ." ". $lang['hours'] ."</TD>\n";
   echo " </TR>\n";

   bug::infolist($current_user,$t,4);

   $t->readTasks();
   if ( count($t->tasklist) > 0 ) {
     @reset($t->tasklist);
     echo "<TR>\n";
     showfield($lang['Tasks']);
     echo " <TD VALIGN=top COLSPAN=3>\n";
     echo  makelink("task_overview.php?id=". $t->id,$lang['TaskOverview'],sprintf($lang['TaskOverviewInfo'],$t->getFullName()));
     echo "<BR>\n";
     $n = 0;
     while ( list ($i,$f) = @each ($t->tasklist) ) {
       if ( $n > 2 ) {
       }
       echo "  ". $f->getLink() ."<BR>\n";
       $n++;
     }
     echo " </TD>\n";
     echo "</TR>\n";
   }

   # Links
   url::infolist($current_user,$t,4);
   # References to modules
   show_module_infolists($current_user,$t,4);

   echo $t->getHistoryLink(4);
   echo "</TABLE>\n";

   $c = $t->getcompletion();
   $m1 = max($c,100);
   $m2 = min($c,100);

   $w = 300;

   # One Percent
   $p = $w / $m1;

   $s = Round($p * 20);

   DoubleTableStart(1,0);
   echo " <TR>\n";
   echo "  <TH COLSPAN=". $w .">". sprintf($lang['TaskCompleted'],$c) ."</TH>\n";
   echo " </TR>\n";
   echo " <TR>\n";
   echo "  <TD COLSPAN=". $s .">0</TD>\n";
   echo "  <TD COLSPAN=". $s .">20</TD>\n";
   echo "  <TD COLSPAN=". $s .">40</TD>\n";
   echo "  <TD COLSPAN=". $s .">60</TD>\n";
   echo "  <TD COLSPAN=". $s .">80</TD>\n";
   if ( $c > 100 ) {
     echo "  <TD ALIGN=center COLSPAN=". ($w - 5 * $s) ."><FONT COLOR=red>&gt; 100</FONT></TD>\n";
   }
   echo " </TR>\n";
   echo " <TR>\n";
   # Work done in time/volume
   if ( Round($m2 * $p) > 0 ) {
     echo "  <TD COLSPAN=\"". Round($m2 * $p) ."\" CLASS=taskdone>&nbsp;</TD>\n";
   }
   # Work to do
   if ( Round((100 - $c) * $p) > 0 ) {
     echo "  <TD COLSPAN=\"". Round((100 - $c) * $p) ."\" CLASS=tasktodo>&nbsp;</TD>\n";
   }
   # Work done more than scheduled
   if ( Round(($c - 100) * $p) > 0 ) {
     echo "  <TD COLSPAN=\"". Round(($c - 100) * $p) ."\" CLASS=taskmuch>&nbsp;</TD>\n";
   }

   echo " </TR>\n";
   DoubleTableEnd();
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos, $lang , $current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $obj->id > 0 ) {
     if ( $obj->mod_ok() ) {
       if ( $current_user->feature_ok(usetaskmanagement,PERM_NEW) ) {
         echo menulink("task_new.php?p_id=". $obj->id ,$lang['NewEntry'],sprintf($lang['TaskCreateInfo'],$obj->name)) ."&nbsp;<BR>\n";
       }
       echo menulink("task_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['TaskModify'],$obj->name)) ."&nbsp;<BR>";
     }
     if ( $obj->del_ok() ) {
       echo confirmlink("task_del.php?id=". $obj->id ,$lang['Delete'],sprintf($lang['TaskDelete'],$obj->name)) ."&nbsp;<BR>";
     }
     echo "<BR>\n";

     if ( $obj->mod_ok() ) {
       echo bug::getaddlink($current_user,$obj);
       echo timetrack::getaddlink($current_user,$obj);
	 }
   }
   echo "<BR>\n";
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }

 HTML_Header($lang['TaskDetail']);

 $t = new task($dbconn);
 if ( isset($HTTP_GET_VARS['id']) ) {
   $t->read($HTTP_GET_VARS['id']);
 }
 if ( ! $t->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$t->getType()]);
 } else {
   if ( $t->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$t->getType()]);
   }
 }

 HTML_Base1();
 navigate($t);
 HTML_Base2($msg);
 if ( ($t->id > 0) && ($t->see_ok()) ) {
   info($t);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: task_show.php,v 1.34.2.1 2002/09/11 06:59:28 gokohnert Exp $
    $Author: gokohnert $
-->
