<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * Editing of teams and their permissions
 *
 * @modulegroup team
 * @module team_new
 * @package team
 */
 include("webelements.p3");
 include("permission.p3");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("team");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$t) {
   global $lang,$tutos,$current_user;

   if ( $current_user->admin == 0) {
     echo "<SPAN CLASS=warn>Only admins are allowed to see this</SPAN>";
     return;
   }

   echo "<FORM name=\"teamadd\" method=\"POST\" action=\"team_ins.php\">\n";
   hiddenFormElements();
   echo "<INPUT type=hidden name=\"id\" value=\"". $t->id ."\">\n";
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=8>".  sprintf($lang['Showing'],$lang[$t->getType()])."</TH>\n";
   echo "</TR>\n";

   if ( $t->id > 0 ) {
     echo "<TR>\n";
     echo " <TD>". $lang['TeamCreation'] ."</TD>\n";
     echo " <TD COLSPAN=3>". $t->creation->getLinkDateTime() ."</TD>\n";
     echo " <TD COLSPAN=4 ALIGN=right>". acl_link($t) ."</TH>\n";
     echo "</TR>\n";
   }
   echo "<TR>\n";
   showfieldc($lang['TeamName'],1,"name");
   echo " <TD COLSPAN=7><INPUT SIZE=30 MAXLENGTH=30 name=\"name\" value=\"". myentities($t->name) ."\"></TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['AdrEmail'],0,"email");
   echo " <TD COLSPAN=7><INPUT SIZE=60 MAXLENGTH=60 name=\"email\" value=\"". myentities($t->email) ."\"></TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfieldc($lang['TeamManager'],0,"owner");
   echo " <TD COLSPAN=7>\n";
   echo "  <SELECT name=\"owner\">\n";
   @reset($t->member);
   $selected = 0;
   while( list ($i,$f) = @each ($t->member)) {
     echo "  <OPTION value=$i";
      if ( $i == $t->owner->id ) {
        echo " SELECTED ";
        $selected = 1;
      }
     echo ">". $f->getFullname() ."</OPTION>";
   }
   if ( $selected == 0 ) {
     echo "  <OPTION value=". $t->owner->id ." SELECTED>". $t->owner->getFullname() ."</OPTION>";
   }
   echo "  </SELECT></TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   echo " <TD COLSPAN=3 VALIGN=top><TABLE WIDHT=100% BORDER=0 CELLSPACING=0>";
   echo "<TR><TH COLSPAN=2><LABEL FOR=\"del[]\">". $lang['TeamMember'] ."</LABEL></TH></TR>\n";
   $line = "";
   @reset($t->member);
   while( list ($i,$f) = @each ($t->member)) {
       $cchecked[$i] = "";
   }
   @reset($t->member);
   while( list ($i,$f) = @each ($t->member)) {
     if ( $line == 1 ) {
       $line = 2;
     } else {
       $line = 1;
     }
     echo "<TR CLASS=line". $line .">\n";
     echo " <TD NOWRAP>&nbsp;". myentities($f->getFullName()) ."&nbsp;</TD>\n";
     echo " <TD NOWRAP ALIGN=right>";
     if ( $t->owner->id == $i ) {
       echo "<I>". $lang['TeamManager'] ."</I>\n";
     } else {
       echo $lang['Delete'] ."<INPUT type=checkbox name=del[] value=\"". $i ."\" ".  $cchecked[$i] .">\n";
     }
     echo " </TD>\n";
     echo "</TR>\n";
   }
   echo "</TABLE></TD>";

   echo "<TD COLSPAN=1>&nbsp;</TD>";

   echo "<TD COLSPAN=4 VALIGN=top><TABLE WIDTH=\"100%\" BORDER=0 CELLSPACING=0>";
   echo "<TR><TH COLSPAN=2 NOWRAP><LABEL FOR=\"add[]\">". $lang['TeamPosMember'] ."</LABEL></TH></TR>\n";
   if ( $current_user->admin ) {
     # Members of the virtual 0 team
     $x = new team($t->dbconn);
     $x->read(0);
     $x->read_member();
     @reset($x->member);
     while( list ($aid,$o) = @each ($x->member)) {
       $uids[$aid] = $o->getFullName();
       $cchecked[$aid] = "";
     }
     unset($x);
   } else {
     $current_user->readKnownParties();
     @reset($current_user->a_parties);
     while( list ($aid,$f) = @each ($current_user->a_parties)) {
       $uids[$aid] = $f;
       $cchecked[$aid] = "";
     }
   }
   # Remove Current Members
   @reset($t->member);
   while( list ($aid,$adr) = @each ($t->member)) {
     unset($uids[$aid]);
   }
   echo "<TR><TD><SELECT MULTIPLE SIZE=". min(count($uids),10) ." NAME=\"add[]\">\n";
   @reset($uids);
   while( list ($i,$f) = @each ($uids)) {
     $cchecked[$i] = "";
   }
   @reset($uids);
   while( list ($i,$f) = @each ($uids)) {
     echo " <OPTION value=\"". $i ."\" ". $cchecked[$i] .">". myentities($f) ."</OPTION>\n";
   }
   echo "</SELECT></TD></TR>\n";
   echo "</TABLE></TD>";
   echo "</TR>\n";

   module_addforms($current_user,$t,8);

   # Feature Permisssions
   permission_form($t);

   echo "<TR>\n";
   if ( $t->id == 0 ) {
     echo "<TD COLSPAN=8><SPAN CLASS=warn>". $lang['Err0021'] ."</SPAN><TD>";
   } elseif ( $t->id == -1 ) {
     submit_reset(0,-1,3,1,3,0);
   } else {
     submit_reset(0,1,3,1,3,0);
   }
   echo "</TR>\n";


   echo "</TABLE>\n";
   echo "</FORM>\n";

   if ( $current_user->feature_ok(useurl,PERM_SEE) ) {
     if ( $t->id != -1 ) {
       url_form($t,"team_new.php?id=". $t->id);
     }
   }

   echo $lang['FldsRequired'] ."\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $current_user,$tutos,$lang;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo menulink("team_new.php",$lang['NewEntry'],$lang['TeamCreateI']) ."<BR>";
   if ( ($obj->id > 0) && $obj->del_ok() ) {
     echo confirmlink("team_del.php?id=". $obj->id ,$lang['Delete'],sprintf($lang['TeamDeleteI'],$obj->getFullName())) ."<BR>";
   }

   echo "<BR>\n";
   show_module_newlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }

 $t = new team($dbconn);
 if ( isset($HTTP_GET_VARS['id'])  ) {
   HTML_Header($lang['TeamModify']);
   $t->read($HTTP_GET_VARS['id']);
   $t->read_member();
   $t->read_permissions();
 } else {
   HTML_Header($lang['TeamCreate']);
   $t->name     = $lang['PlsChangeName'];
   $t->creation = new datetime();
   $t->owner    = $current_user;
   $t->member[$current_user->id] = $current_user;
 }
 if ( isset($HTTP_GET_VARS['name']) ) {
   $t->name = trim(Stripslashes($HTTP_GET_VARS['name']));
 }

 HTML_Base1();
 navigate($t);
 HTML_Base2($msg);
 info($t);
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: team_new.php,v 1.23 2002/07/15 08:01:25 gokohnert Exp $
    $Author: gokohnert $
-->
