<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup team
 * @module team_overview
 * @package team
 */
 include("webelements.p3");
 include("permission.p3");
 include 'appointment.pinc';
 include 'product.pinc';

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("team");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$dbconn,&$result,$start) {
   global $tutos,$lang,$link1,$link2;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $tutos[massupdate] == 1 ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"team_overview.php\">\n";
     hiddenFormElements();
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }

   # Make a big array of all visible teams
   $x = 0;
   while ( $x < $n ) {
     $b = new team($dbconn);
     $b->read_result($result,$x);
     $x++;
     if ( ! $b->see_ok() ) {
       continue;
     }
     $tlist[] = &$b;
     unset($b);
   }
   $n = count($tlist);
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }


   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("name",$lang['Team'],$link2);
   echo order_header("",$lang['TeamManager'],$link2);
   echo order_header("",$lang['TeamCount'],$link2);
   if ( $tutos[massupdate] == 1 ) {
     echo "  <TH NOWRAP><INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\"></TH>\n";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $t = $tlist[$a];

     echo "<TR>\n";
     echo " <TD>". $t->getLink() ."</TD>\n";
     echo " <TD>". $t->owner->getLink() ."</TD>\n";
     echo " <TD ALIGN=right>". count($t->ids) ."</TD>\n";
     if ( $tutos[massupdate] == 1 ) {
		 if ( $t->mod_ok() ) {
         echo " <TD><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $t->id ."\"></TD>\n";
	   } else {
	     echo "<TD>&nbsp;-&nbsp;</TD>";
       }
     }
     echo "</TR>\n";
     $a++;
   }
   echo "</TBODY>\n";
   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,3 + $tutos[massupdate],$start,$a,$n);

   if ( $tutos[massupdate] == 1 ) {
     echo "<TR>\n";
     echo "<TD ALIGN=right COLSPAN=2>\n";
     echo sprintf($lang['withmarked'],$lang['Teams']);
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ."</OPTION>\n";
     echo "</SELECT>\n";

     echo "</TD>\n";
     echo " <TD COLSPAN=2><INPUT type=submit value=\"OK\"></TD>\n";
     echo "</TR>\n";
   }

   echo "</TFOOT>\n";
   echo "</TABLE>\n";

 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate() {
   global $lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   echo tutos_address::getSelectLink($current_user,$lang['Search']) ."<BR>\n";

   if ( $current_user->admin != 0) {
     echo menulink("team_new.php",$lang['NewEntry'],$lang['TeamCreateI']) . "<BR>\n";
   }
   echo "</TD></TR>";

   HTML_Select();
 }

 # Perform possible actions
 if ( isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $obj = new team($dbconn);
       $obj->read($val);
       if ( $obj->id != $val ) {
         continue;
       }
       if ( $obj->del_ok() ) {
         $msg .= $lang['Delete'] ."&nbsp;". $obj->getFullName() ."<BR>";
         $msg .= $obj->delete();
       } else {
         $msg .= $obj->getLink() .": ". sprintf($lang['Err0023'],$lang[$obj->getType()]) ."<BR>";
       }
       unset($obj);
     }
     $dbconn->Commit("WORK");
   }
 }

 HTML_Header($lang['TeamOverview']);

 $link1 = "team_overview.php";
 $q = "SELECT * FROM teams";
 $pre = " WHERE ";

 if ( isset($HTTP_GET_VARS['name']) && ($HTTP_GET_VARS['name'] != "*") && ($HTTP_GET_VARS['name'] != "") ) {
   $q .= $pre .  $dbconn->Like("name",$HTTP_GET_VARS['name']);
   $pre = " AND ";
 }

 # sorting
 $xxx = "";
 $link2 = $link1;
 order_parse($q,$link1,$xxx,$xxx,"name");

 $result = $dbconn->Exec($q);

 if ( isset($HTTP_GET_VARS['start']) ) {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
 }

 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 info($dbconn,$result,$start);
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: team_overview.php,v 1.19.2.2 2002/08/13 15:00:09 gokohnert Exp $
    $Author: gokohnert $
-->
