<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup team
 * @module team_show
 * @package team
 */
 include("webelements.p3");
 include("permission.p3");
 include("appointment.pinc");
 include("product.pinc");
 include("address_tools.p3");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("team");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$t,&$ra) {
   global $tutos,$lang, $current_user;

   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=2>". $lang['Team'] ." ".  $t->name ."</TH>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   echo " <TD>". $lang['TeamCreation'] ."</TD>\n";
   echo " <TD>". $t->creation->getLinkDate() ."</TD>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   showfield($lang['TeamManager']);
   echo " <TD>". $t->owner->getMailLink() ."</TD>\n";
   echo "</TR>\n";

   url::infolist($current_user,$t,4);

   echo "<TR>\n";
   showfield($lang['AdrEmail']);
   echo " <TD>". AsEmail($t->email,$t->email) ."</TD>\n";
   echo "</TR>\n";

   show_module_infolists($current_user,$t,4);

   echo "<TR>\n";
   echo " <TH COLSPAN=2>". $lang['TeamMember'] ."</TH>\n";
   echo "</TR>\n";

   echo "<TR>\n";
   echo "<TD COLSPAN=2>\n";
   address_overview($t->dbconn,$ra);
   echo "</TD>\n";
   echo "</TR>\n";

   if ( $current_user->feature_ok(useprojects,PERM_SEE) ) {
     $xx = $lang['ProdRole'];
     while ( list ($role,$x) = @each ($xx) ) {
       $t->readProducts($role);
       if ( isset($t->prolist[$role]) && (count($t->prolist[$role]) >0) ) {
         Show_LocFields("",$t,"role".$role,0);
       }
     }
   }
   echo $t->getHistoryLink(4);
   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang, $current_user;

   echo "<TABLE>\n";
   echo "<TR><TD>\n";
   echo menulink("team_new.php",$lang['NewEntry'],$lang['TeamCreateI']) ."<BR>";
   if ( ($obj->id > 0) && $obj->mod_ok() ) {
     echo menulink("team_new.php?id=". $obj->id ,$lang['Modify'],sprintf($lang['TeamModifyI'],$obj->name)) ."<BR>";
   }
   echo "<BR>\n";
   if ( ($obj->id > 0) && $obj->see_ok() ) {
     echo $obj->getMailLink() ."<BR>\n";
     if ( $current_user->feature_ok(usecalendar,PERM_SEE) ) {
       echo $obj->getCalLink(sprintf($lang['TeamApps'],$obj->name)) ."<BR>\n";
     }
     if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) ) {
       echo menulink ("task_overview.php?id=". $obj->id ,$lang['TaskOverview'],sprintf($lang['TaskOverviewInfo'],$obj->getFullName())) ."<BR>\n";
     }
     if ( $current_user->feature_ok(usetaskmanagement,PERM_SEE) &&  $current_user->feature_ok(usecalendar,PERM_SEE) ) {
       echo menulink("res_cal.php?id=".$obj->id,$lang['ResCal'],$lang['ResCal']) ."<BR>\n";
     }
     if ( $current_user->feature_ok(usetimetrack,PERM_SEE) ) {
       echo menulink("timetrack_overview.php?worker=". $obj->id,$lang['TimetrackBooked'],sprintf($lang['TimetrackBookedI'],$obj->getFullName())) ."<BR>\n";
     }
   }
   show_module_addlinks($current_user,$obj);
   echo "</TD></TR>\n";

   HTML_Select();
 }

 HTML_Header($lang['TeamDetail']);

 $t = new team($dbconn);

 if ( isset ($HTTP_GET_VARS['id']) ) {
   $t->read($HTTP_GET_VARS['id']);
 }
 if ( ! $t->see_ok() ) {
   $msg .= sprintf($lang['Err0022'],$lang[$t->getType()]);
 } else {
   if ( $t->id < 0 ) {
     $msg .= sprintf($lang['Err0040'],$lang[$t->getType()]);
   } else {
     $t->read_member();
   }
 }

 # Handling of teammember list
 adr_tool_init($atool,$ashow);

 $ashow['f_name'] = 1;
 $ashow['l_name'] = 1;
 $ashow['email'] = 1;


 $atool['maxshow'] = 0;
 $atool['start'] = 0;
 $atool['link1'] = "team_show.php";
 $atool['link2'] = "team_show.php";

 $atool['link1'] = addUrlParameter($atool['link1'],"id=". $t->id);
 $atool['link2'] = addUrlParameter($atool['link2'],"id=". $t->id);

 $qa = "SELECT * from addresses a , adrteam t where a.id = t.adr_id and t.team_id = ". $t->id;

 # sorting
 $xxx = "";
 order_parse($qa,$atool['link1'],$xxx,$xxx,"l_name");

 $ra = $dbconn->Exec($qa);



 HTML_Base1();
 navigate($t);
 HTML_Base2($msg);
 if ( ($t->id > 0) && $t->see_ok() ) {
   info($t,$ra);
 }
 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: team_show.php,v 1.22.2.1 2002/09/02 20:51:59 gokohnert Exp $
    $Author: gokohnert $
-->
