<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 *  CVS Info:  $Id: timetrack_ins.php,v 1.23.2.2 2002/09/13 12:14:42 gokohnert Exp $
 *  $Author: gokohnert $
 *
 * @modulegroup timetrack
 * @module timetrack_ins
 * @package timetrack
 */
 include("webelements.p3");
 include("permission.p3");
 include("bug.pinc");
 include("product.pinc");
 include("installation.pinc");
 include("timetrack.pinc");
 include("task.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("timetrack");

 /* Check Input */
 $msg = "";
 $mode = 0;
 $tt = new timetrack($dbconn);


 if ( isset($HTTP_POST_VARS['gotourl']) ) {
   $gotourl = $HTTP_POST_VARS['gotourl'];
 } else {
   $gotourl = "timetrack_new.php";
 }
 if ( isset($HTTP_POST_VARS['mode']) ) {
   $mode = $HTTP_POST_VARS['mode'];
   $gotourl= addUrlParameter($gotourl,"mode=". $mode);
 }
 if ( isset($HTTP_POST_VARS['id']) ) {
   $tt->read($HTTP_POST_VARS['id']);
   $gotourl= addUrlParameter($gotourl,"id=". $tt->id);
 } else {
   $tt->creator = $current_user;
 }
 
 # reference
 if ( isset($HTTP_POST_VARS['lfn']) ) {
   if ( empty($HTTP_POST_VARS['lfn']) ) {
     $msg .= sprintf($lang['Err0009'],$lang['TimetrackRef']) ."<BR>";
   } else {
     $x = check_field(StripSlashes($HTTP_POST_VARS['lfn']),"lfn","ll","a");
     $tt->setReference($x->id);
     $tt->ref = getObject($dbconn,$tt->link_id);
     $gotourl= addUrlParameter($gotourl,"lid=". $x->id);
   }
 } else if ( isset($HTTP_POST_VARS['lid']) ) {
   $tt->setReference($HTTP_POST_VARS['lid']);
   $tt->ref = getObject($dbconn,$tt->link_id);
   $gotourl= addUrlParameter($gotourl,"lid=". $HTTP_POST_VARS['lid']);
 }

 # worker
 if ( isset($HTTP_POST_VARS['wfn']) ) {
   if ( empty($HTTP_POST_VARS['wfn']) ) {
     $msg .= sprintf($lang['Err0009'],$lang['TimetrackWorker']) ."<BR>";
   } else {
     $x = check_field(StripSlashes($HTTP_POST_VARS['wfn']),"wfn","wl","a");
	 $tt->setWorker($x->id);
     $gotourl= addUrlParameter($gotourl,"wid=". $x->id);
   }
 } else if ( isset($HTTP_POST_VARS['wid']) ) {
   $tt->setWorker($HTTP_POST_VARS['wid']);
   $gotourl= addUrlParameter($gotourl,"wid=". $HTTP_POST_VARS['wid']);
 }
 # description
 if ( empty($HTTP_POST_VARS['desc'])  ) {
   $msg .= sprintf($lang['Err0009'],$lang['Description']) ."<BR>";
 } else {
   if ( isset($HTTP_POST_VARS['desc']) ) {
     $tt->setDescription(StripSlashes($HTTP_POST_VARS['desc']));
     $gotourl= addUrlParameter($gotourl,"desc=". UrlEncode($tt->desc));
   }
 }
 # state
 if ( isset($HTTP_POST_VARS['state']) ) {
   $tt->setState($HTTP_POST_VARS['state']);
   $gotourl= addUrlParameter($gotourl,"state=". UrlEncode($tt->state));
 }

 # Read the Work Day
 $wd = new DateTime(0);
 if ( isset($HTTP_POST_VARS['wd_d']) ) {
   $wd->setDateTimeF("wd",1);
   if ( 1 != $wd->checkDMY() ) {
     $msg .= sprintf($lang['Err0038'],$lang['Date']) ."<BR>";
   } else {
     $gotourl= addUrlParameter($gotourl,"wd=". $wd->getYYYYMMDD());
   }
   $tt->setWorkday($wd);
 }

 if ( isset($HTTP_POST_VARS['start_d']) ) {
   $start = new DateTime();
   $start->setDateTimeF("start",0);
   if ( 1 != $start->checkDMY() ) {
     $msg .= sprintf($lang['Err0038'],$lang['AppStart']) ."<BR>";
   } else {
    $gotourl= addUrlParameter($gotourl,"start=". $start->getYYYYMMDDHHMM());
   }
   $tt->setStart($start);
 }
 if ( isset($HTTP_POST_VARS['end_d']) ) {
   $end   = new DateTime();
   $end->setDateTimeF("end",0);
   if ( 1 != $end->checkDMY() ) {
     $msg .= sprintf($lang['Err0038'],$lang['AppEnd']) ."<BR>";
   } else {
     $gotourl= addUrlParameter($gotourl,"end=". $end->getYYYYMMDDHHMM());
   }
   $tt->setEnd($end);
   if ( $tt->t_end->notime == 0 ) {
     $tt->setVolume( ($tt->t_end->getTimeStamp() - $tt->t_start->getTimeStamp()) / 3600.0);
   }
 }
 # volume
 if ( $tt->t_start->notime == 1 ) {
   $volume = 0.0;
   list($volume) = sscanf($HTTP_POST_VARS['volume'],"%f");
   if ( (empty($volume) || ! is_double($volume) ) ) {
     $msg .= sprintf($lang['Err0009'],$lang['TaskVolumeDone']) ."<BR>";
   } else {
     $gotourl= addUrlParameter($gotourl,"volume=". UrlEncode($volume));
     $tt->setVolume($volume);
   }
 }
 if ( isset($HTTP_POST_VARS['cph']) ) {
   $cph = 0.0;
   list($cph) = sscanf($HTTP_POST_VARS['cph'],"%f");
   if ( empty($cph) || ! is_double($cph) ) {
#   $msg .= sprintf($lang['Err0009'],$lang['TTcph']) ."<BR>";
   } else {
     $gotourl= addUrlParameter($gotourl,"cph=". UrlEncode($cph));
     $tt->setCph($cph);
   }
 }
 # currency
 if ( isset($HTTP_POST_VARS['currency']) ) {
   $tt->setCurrency($HTTP_POST_VARS['currency']);
   $gotourl= addUrlParameter($gotourl,"currency=". UrlEncode($tt->currency));
 }

 # other modules
 $msg .= module_parseforms($current_user,$tt,$gotourl);

 if ( $msg == "" ) {
   $dbconn->Begin("WORK");
   $msg .= $tt->save();
   $dbconn->Commit("WORK");
   $gotourl = $tt->ref->getURL();
 }

 $gotourl = addSessionKey($gotourl);
 $gotourl= addUrlParameter($gotourl,"msg=". UrlEncode($msg));

 Header("Status: 302 Moved Temporarily");
 Header("Location: ". getBaseUrl() . $gotourl);
 $dbconn->Close();
?>
