<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup timetrack
 * @module timetrack_new
 * @package timetrack
 */
 include("webelements.p3");
 include("permission.p3");
 include("timetrack.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("timetrack");

 /* ---------------------------------------------------------------------------
  *
  */
 Function info(&$obj,$mode) {
   global $lang, $title, $current_user, $tutos;

   if ( $mode == 1 ) {
     # if we are in time record mode we first give a list of all OPEN records
     $q = "SELECT * from ". $obj->tablename ." WHERE t_start is not null AND t_end is NULL and adr_id = ". $obj->worker->id;
     $r = $obj->dbconn->Exec($q);
     $n = $r->numrows();
     $a = 0;
	 if ( $n > 0 ) {
       echo "<TABLE CLASS=single BORDER=0 CELLSPACING=0>\n";
	   echo "<TR>\n";
	   echo "<TH>". $lang['Timetrack'] ."</TH>\n";
	   echo "<TH>". $lang['AppStart'] ."</TH>\n";
	   echo "<TH>". $lang['TimetrackModify'] ."</TH>\n";
	   echo "<TH>". $lang['TTfinish'] ."</TH>\n";
	   echo "</TR>\n";
	 }
     while ( $a < $n ) {
       $f = new timetrack($obj->dbconn);
       $f->read_result($r,$a);
       $a++;
	   echo "<TR>\n";
       echo "<TD>". $f->getLink() ."</TD>";
       echo "<TD>". $f->t_start->getDateTime() ."</TD>";
       echo "<TD>". makelink("timetrack_new.php?mode=2&id=". $f->id,$lang['Modify'],$lang['TimetrackModify']) ."</TD>";
       echo "<TD>". makelink("timetrack_finish.php?id=". $f->id,$lang['TTfinish'],$lang['TTfinish']) ."</TD>";
	   echo "</TR>\n";
	 }
	 $r->free();
	 if ( $n > 0 ) {
       echo "</TABLE>\n";
       return;
	 }
   }

   echo "<FORM name=\"ttadd\" action=\"timetrack_ins.php\" method=\"POST\">\n";
   hiddenFormElements();
   echo "<INPUT type=\"hidden\" value=\"". $mode ."\" name=\"mode\">\n";
   echo "<TABLE CLASS=single BORDER=0 CELLSPACING=0>\n";
   echo "<TR><TH COLSPAN=4>";
   echo "&nbsp;";
   echo "</TH></TR>\n";

   if ( $obj->id > 0 ) {
     echo "<INPUT type=\"hidden\" value=\"". $obj->id ."\" name=\"id\">\n";
   }
   echo "<TR>\n";
   showfield($lang['TimetrackRef']);
   echo " <TD COLSPAN=3>\n";
   if ( $mode != 0 ) {
     select_from_array_or_input($obj,"l",$obj->ref,0);
   } else {
     if ( $obj->ref > 0 ) {
       echo  $lang[$obj->ref->getType()] ." ". $obj->ref->getLink() ."\n";
     } else {
       echo  $lang['HistoryDeleted'] ."\n";
     }
     echo "<INPUT type=\"hidden\" value=\"". $obj->ref->id ."\" name=\"lid\">\n";
   }
   echo " </TD>\n";
   echo "</TR>\n";
   echo "<TR>\n";
   showfieldc($lang['TimetrackWorker'],1,"wfn");
   echo " <TD COLSPAN=3>\n";
   if ( $mode == 0 ) {
     select_from_array_or_input($obj,"w",$obj->worker,0);
   } else {
     echo $obj->worker->getLink();
     echo "<INPUT type=\"hidden\" value=\"". $obj->worker->id ."\" name=\"wid\">\n";
     echo "<INPUT type=\"hidden\" value=\"". $obj->ref->id ."\" name=\"lid\">\n";
   }
   echo " </TD>\n";
   echo "</TR>\n";

   if ( $obj->t_start->notime != 0 ) {
     echo "<TR>\n";
     showfieldc($lang['TaskVolumeDone'],1,"volume");
     echo " <TD COLSPAN=1><INPUT SIZE=10 MAXLENGTH=10 name=\"volume\" value=\"". $obj->volume ."\">". $lang['hours'] ."</TD>\n";
     showfieldc($lang['atDateTime'],1,"wd");
     echo " <TD>\n";
     $obj->wday->EnterDate("wd",1);
     echo " </TD>\n";
     echo "</TR>\n";
   } else {
     echo "<TR>\n";
     showfieldc($lang['AppStart'],1,"start");
     echo " <TD>\n";
     $obj->t_start->EnterDateTime("start",1);
     echo " </TD>\n";
     showfieldc($lang['AppEnd'],0,"end");
     echo " <TD>\n";
     $obj->t_end->EnterDateTime("end",1);
     echo " </TD>\n";
     echo "</TR>\n";
   }



   if( $tutos[useinvoice] ) {
     echo "<TR>\n";
     showfieldc($lang['TTcph'],0,"cph");
     echo " <TD COLSPAN=1><INPUT SIZE=10 MAXLENGTH=10 name=\"cph\" value=\"". $obj->cph ."\">\n";
     Currency_Select("currency",$obj->currency);
     echo "</TD>\n";
     showfieldc($lang['TTState'],1,"state");
     echo " <TD><SELECT NAME=\"state\">\n";
     @reset($lang['TTStates']);
     while ( list ($s,$x) = @each ($lang['TTStates']) ) {
       echo "   <OPTION VALUE=\"". $s ."\" ". ($obj->state == $s ? "SELECTED" : "") .">". $lang['TTStates'][$s] ."</OPTION>\n";
     }
     echo "</SELECT></TD>\n";
     echo "</TR>\n";
   }

   echo "<TR>\n";
   showfieldc($lang['Description'],1,"desc");
   echo " <TD COLSPAN=3><INPUT SIZE=60 MAXLENGTH=60 name=\"desc\" value=\"". $obj->desc ."\"></TD>\n";
   echo "</TR>\n";

   # References to modules
   module_addforms($current_user,$obj,4);

   echo "<TR>\n";
   if ( $obj->id != -1 ) {
     submit_reset(0,1,1,1,1,0);
   } else {
     submit_reset(0,-1,1,1,1,0);
   }
   echo "</TR>\n";

   echo "</TABLE>\n";
   echo "</FORM>\n";
   echo $lang['FldsRequired'] ."\n";
 }

 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate(&$obj) {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(usetimetrack,PERM_SEL) ) {
     echo menulink("timetrack_select.php",$lang['Search'],$lang['SearchForTT']) ."<BR>\n";
   }
   if ( $obj->id > 0 ) {
     if ( $obj->del_ok() ) {
       if ( $obj->ref > 0 ) {
         echo confirmlink("timetrack_del.php?id=". $obj->id,$lang['Delete'],sprintf($lang['TimetrackDelI'],$obj->ref->getFullname())) ."<BR>\n";
       }
     }
     echo timetrack::getaddlink($current_user,$obj->ref);
   }
   echo "<BR>\n";
   show_module_newlinks($current_user,$obj);
   echo "</TD></TR>";

   HTML_Select();
 }

#
# Mode
# 0 = classical Timetrack
# 1 = timerecord with a list of open entries
# 2 = timerecord editable
#
 if ( isset($HTTP_GET_VARS['mode']) ) {
   $mode = $HTTP_GET_VARS['mode'];
 } else {
   $mode = 0;
 }

 $tt = new timetrack($dbconn);
 if ( isset($HTTP_GET_VARS['id']) && ($HTTP_GET_VARS['id'] > 0) ) {
   # existing timetrack
   $tt->read($HTTP_GET_VARS['id']);
   if ( ($tt->t_start->notime == 0) && ( $mode != 2) ) {
     $mode = 1;
   }
 } else {
   # new stuff
   if ( $mode == 1 ) {
	 $tt->t_start = new DateTime();
   }
   $tt->ref = $current_user;
 }

 if ( $mode != 0 ) {
   HTML_Header($lang['TTRecord']);
   $tt->worker = &$tt->ref;
 } else if ( $tt->id > 0 )  {
   HTML_Header($lang['TimetrackModify']);
 } else {
   HTML_Header($lang['TimetrackNew']);
 }

 if ( isset($HTTP_GET_VARS['desc']) ) {
   $tt->desc = StripSlashes($HTTP_GET_VARS['desc']);
 }
 if ( isset($HTTP_GET_VARS['volume']) ) {
   $tt->volume = $HTTP_GET_VARS['volume'];
 }
 if ( isset($HTTP_GET_VARS['state']) ) {
   $tt->state = $HTTP_GET_VARS['state'];
 }
 if ( isset($HTTP_GET_VARS['cph']) ) {
   $tt->cph = $HTTP_GET_VARS['cph'];
 }
 if ( isset($HTTP_GET_VARS['currency']) ) {
   $tt->currncy = $HTTP_GET_VARS['currency'];
 }
 if ( isset($HTTP_GET_VARS['wd']) ) {
   $tt->wday->setDateTime($HTTP_GET_VARS['wd']);
 }
 if ( isset($HTTP_GET_VARS['start']) ) {
   $tt->t_start->setDateTime($HTTP_GET_VARS['start']);
 }
 if ( isset($HTTP_GET_VARS['end']) ) {
   $tt->t_end->setDateTime($HTTP_GET_VARS['end']);
 }

 preset_from_array_or_input($tt,'worker',"w");
 preset_from_array_or_input($tt,'ref',"l");
 $tt->link_id = $tt->ref->id;
 if ( $tt->link_id == -1 ) {
   $msg .= "Unknown reference";
 }
 HTML_Base1();
 navigate($tt);
 HTML_Base2($msg);
 info($tt,$mode);

 HTML_Base3();

 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: timetrack_new.php,v 1.28 2002/07/20 13:14:44 gokohnert Exp $
    $Author: gokohnert $
-->
