<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 *  CVS Info:  $Id: timetrack_overview.php,v 1.38.2.4 2002/09/09 17:46:13 gokohnert Exp $
 *  $Author: gokohnert $
 *
 * an overview of all booked times
 *
 * @modulegroup timetrack
 * @module timetrack_overview
 * @package timetrack
 */
 include("webelements.p3");
 include("permission.p3");
 include("timetrack.pinc");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules('timetrack','overview');

 /**
  * format a floating hour number
  */
 function hour_format($hours) {
   $h = floor($hours);
   $m = ($hours - $h) * 60;
   return $h .":". sprintf("%02d",$m);
 }
 /**
  *
  */
 Function info(&$dbconn,&$r,$start,$hidden) {
   global $lang, $tutos, $link1,$link2, $current_user;

   $n = $r->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   $cols = 8;
   if ( $tutos[massupdate] == 1 ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"timetrack_overview.php\">\n";
     echo $hidden;
     hiddenFormElements();
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }

   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("","#",$link2);
   echo order_header("",$lang['TimetrackRef'],$link2);
   echo order_header("",$lang['TimetrackWorker'],$link2);
   echo order_header("volume",$lang['TaskVolumeDone'],$link2);
   echo order_header("vtime",$lang['TimetrackDate'],$link2);
   echo order_header("description",$lang['Description'],$link2); 
   echo order_header("state",$lang['TTState'],$link2);
   echo order_header("",$lang['ProdCost'],$link2);
   $cols += show_module_overviewheader($current_user,"timetrack");
   if ( $tutos[massupdate] == 1 ) {
     $cols++;
     echo "  <TH NOWRAP><INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\"></TH>\n";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   $sum['v'] = 0.0;
   $sum[''] = 0.0;
   @reset($tutos[currencies]);
   while( list ($ia,$c) = @each ($tutos[currencies])) {
     $sum[$c] = 0.0;
   }

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   # Fill the sum
   $x = 0;
   while ( $x < $a ) {
     $sum['v'] += $r->get($x, "volume");
     $sum[$r->get($x, "currency")] += ( $r->get($x, "cph") * $r->get($x, "volume") );
     $x++;
   }

   echo "<TBODY>\n";
   while ( ($a < $n) && ($a < $end) ) {
     $tt = new timetrack($dbconn);
     $tt->read_result($r,$a);

     echo "<TR>\n";
     echo " <TD ALIGN=right>". makelink("timetrack_new.php?id=". $tt->id ,($a + 1),$lang['TimetrackModify']) ."</TD>\n";
     if ( $tt->ref ==  -1 ) {
       echo " <TD><I>". makelink("history_show.php?id=". $tt->link_id ,$lang['HistoryDeleted']) ."</I></TD>\n";
     } else {
       echo " <TD>". $tt->ref->getLink() ."</TD>\n";
     }
     if ( $tt->worker->id ==  -1 ) {
         echo " <TD><I>". makelink("history_show.php?id=". $tt->wid ,$lang['HistoryDeleted']) ."</I></TD>\n";
     } else {
       echo " <TD>". $tt->worker->getLink() ."</TD>\n";
     }
#     echo " <TD ALIGN=right>". number_format($tt->volume,2,$lang['DecPoint'],$lang['ThousandPoint']) ."</TD>\n";
     echo " <TD ALIGN=right>". hour_format($tt->volume) ."</TD>\n";

     $sum['v'] += $tt->volume;
     $sum[$tt->currency] += ( $tt->cph * $tt->volume );

     echo " <TD ALIGN=right NOWRAP>\n";
     echo $tt->wday->getDate();
	 if ( $tt->t_start->notime != 1) {
       echo "<BR>". $tt->t_start->getDateTimeShort() ." - ". $tt->t_end->getDateTimeShort() ."</TD>\n";
	 } else {
       echo "&nbsp;</TD>\n";
     }
     echo " <TD>". myentities($tt->desc) ."</TD>\n";
     echo " <TD>". $lang['TTStates'][$tt->state] ."</TD>\n";
     echo " <TD ALIGN=right>". number_format($tt->cph * $tt->volume,2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". myentities($tt->currency) ."</TD>\n";

     show_module_overviewdata($current_user,$tt);
     if ( $tutos[massupdate] == 1 ) {
       if ( $tt->mod_ok() ) {
         echo " <TD><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $tt->id ."\"></TD>\n";
       } else {
         echo "<TD>&nbsp;-&nbsp;</TD>";
       }
     }

     echo "</TR>\n";
     $a++;
     unset($tt);
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";

   ShowBackForwardNav($link1,$cols ,$start,$a,$n);

   # Fill the sum
   while ( $a < $n ) {
     $sum['v'] += $r->get($a, "volume");
     $sum[$r->get($a, "currency")] += ( $r->get($a, "cph") * $r->get($a, "volume") );
     $a++;
   }
   echo "<TR>\n";
   echo " <TD COLSPAN=3>&nbsp;</TD>\n";
#   echo " <TD ALIGN=right><B>". number_format($sum['v'],2,$lang['DecPoint'],$lang['ThousandPoint']) ."</B></TD>\n";
   echo " <TD ALIGN=right><B>". hour_format($sum['v']) ."</B></TD>\n";
   echo " <TD COLSPAN=3>&nbsp;</TD>\n";
   echo " <TD ALIGN=right><B>\n";
   @reset($sum);
   while ( list ($s,$x) = @each ($sum) ) {
     if ( ($s != 'v') && ($x != 0.0) ) {
       echo  number_format($sum[$s],2,$lang['DecPoint'],$lang['ThousandPoint']) ." ". myentities($s) ."<BR>\n";
	 } else {
       echo "&nbsp;";
	 }
   }
   echo "</B></TD>\n";
   if ( $cols > 8 ) {
     echo " <TD COLSPAN=". ( $cols - 8 ).">&nbsp;</TD>\n";
   }
   echo "</TR>\n";

   if ( $tutos[massupdate] == 1 ) {
     echo "<TR>\n";
     echo "<TD ALIGN=right COLSPAN=7>\n";
     echo sprintf($lang['withmarked'],$lang['Timetracks']);
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ."</OPTION>\n";
     @reset($lang['TTStates']);
     while ( list ($f,$i) = @each ($lang['TTStates']) ) {
       echo " <OPTION VALUE=\"S". $f ."\">". sprintf($lang['SetTo'],$lang['TTState'],$i) ."</OPTION>\n";
     }
     echo "</SELECT>\n";

     echo "</TD>\n";
     echo " <TD COLSPAN=".($cols -7) ."><INPUT type=submit value=OK></TD>\n";
     echo "</TR>\n";
   }
   echo "</TFOOT>\n";

   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  * Statistical Timetrack Info
  */
 Function exportinfo(&$dbconn,&$r) {
   global $lang,$tutos,$link,$format;

   $n = $r->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   $a = 0;
   while ( $a < $n ) {
     $tt = new timetrack($dbconn);
     $tt->read_result($r,$a);
     echo $tt->exportCSV();
     $a++;
     flush();
     unset($tt);
   }
 }

 /* ---------------------------------------------------------------------------
  * Statistical Timetrack Info
  */
 Function statinfo(&$dbconn,&$result) {
   global $lang,$tutos,$link,$format;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }
   $a = 0;
   $v = 0;
   while ( $a < $n ) {
     $tt = new timetrack($dbconn);
     $tt->read_result($result,$a);
     if ( !isset($w[$tt->worker->id]) ) {
       $w[$tt->worker->id] = 0;
     }
     if ( !isset($p[$tt->ref->id]) ) {
       $p[$tt->ref->id] = 0;
     }
     $w[$tt->worker->id] += $tt->volume;
     $p[$tt->ref->id] += $tt->volume;
     $v += $tt->volume;
     $a++;
     unset($tt);
   }
   echo "<TABLE CLASS=single BORDER=0 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<TR>\n";
   echo " <TH COLSPAN=5>". $lang['TTStatsTitle'] ."</TH>\n";
   echo "</TR>\n";

   $link = "graph_bars.php";
   $link = addSessionKey($link);
   $c = 0;
   while ( list ($i,$f) = @each ($w) ) {
     if ( $v > 0 ) {
       $val = number_format($f * 100.0 / $v ,2);
     } else {
       $val = 0;
     }
     $worker = getObject($dbconn,$i);
     if ( $worker != -1 ) {
       $link = addUrlParameter($link,"f[". $c ."]=".$val);
       $link = addUrlParameter($link,"t0[". $c  ."]=". UrlEncode($worker->getShortName()));
       $link = addUrlParameter($link,"t1[". $c ."]=". UrlEncode( hour_format($f) ." ". $lang['hours']));
       $c ++;
     }
   }
   echo "<TR>\n";
   echo " <TD COLSPAN=5 VALIGN=top><IMG SRC=\"". $link ."\"></TD>";
   echo "</TR>\n";

   $c = 0;
   $r = 0;
   while ( list ($i,$f) = @each ($p) ) {
     if ( $c == 0 ) {
       $r++;
       $links[$r] = "graph_bars.php";
       $links[$r] = addSessionKey($links[$r]);
     }
     if ( $v > 0 ) {
       $val = number_format($f * 100.0 / $v ,2);
     } else {
       $val = 0;
     }
     $pp = getObject($dbconn,$i);
     $links[$r] = addUrlParameter($links[$r],"f[". $c ."]=".$val);
     if ( $pp == -1 ) {
       $links[$r] = addUrlParameter($links[$r],"t0[". $c  ."]=". UrlEncode($lang['HistoryDeleted']));
     } else {
       $links[$r] = addUrlParameter($links[$r],"t0[". $c  ."]=". UrlEncode($pp->getFullName()));
     }
     $links[$r] = addUrlParameter($links[$r],"t1[". $c ."]=". UrlEncode( hour_format($f) ." ". $lang['hours']));
     $c++;
     if ( $c == 5 ) {
       $c = 0;
     }
   }
   if ( function_exists('ImageCreate') ) {
     echo "<TR><TD COLSPAN=5 VALIGN=top>\n";
     @reset($links);
     while ( list ($i,$f) = @each ($links) ) {
       echo "<IMG SRC=\"". $links[$i] ."\"><BR>\n";
     }
     echo "</TD></TR>\n";
   }


   echo "</TABLE>\n";
 }
 /* ---------------------------------------------------------------------------
  *
  */
 Function navigate($link) {
   global $tutos,$lang,$format,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";
   if ( $current_user->feature_ok(usetimetrack,PERM_SEL) ) {
     echo menulink("timetrack_select.php",$lang['Search'],$lang['SearchForTT']) ."<BR>\n";
   }
   echo "<BR>\n";
   if ( $format != "stat" ) {
     $l = addUrlParameter($link,"format=stat");
     echo menulink($l,$lang['BugStats'],$lang['BugStatsInfo']) . "<BR>\n";
   } else {
     echo $lang['BugStats'] . "<BR>\n";
   }

   $l = addUrlParameter($link,"format=export");
   echo menulink($l,$lang['Export'],$lang['ExportInfo']);

   echo "</TD></TR>";

   HTML_Select();
 }


 # Perform some action
 if ( isset($HTTP_GET_VARS['mark']) && isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $p = new timetrack($dbconn);
       $p->read($val);
       if ( $p->id != $val ) {
         $msg .= "Unknown ". $lang['Timetrack'] ." ". $val ."<BR>\n";
         continue;
	   }
       if ( $p->ref->del_ok() ) {
         $msg .= sprintf($lang['Delete']) .":". $p->getFullName() ."<BR>";
         $msg .= $p->delete();
       } else {
         $msg .= $p->getLink() .": ". sprintf($lang['Err0023'],$lang[$p->getType()]) ."<BR>\n";
       }
       unset($p);
     }
     $dbconn->Commit("WORK");
   } else if ( ereg("^([S])(.*)",$HTTP_GET_VARS['action'],$a) ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $p = new timetrack($dbconn);
       $p->read($val);
       if ( $p->id != $val ) {
         $msg .= "Unknown ". $lang['Timetrack'] ." ". $val ."<BR>\n";
         continue;
       }
       if ( $p->mod_ok() ) {
         $x = (integer)$a[2];
         $msg .= $p->getLink() ." ". sprintf($lang['SetTo'],$lang['TTState'],$lang['TTStates'][$x]) ."<BR>";
         $msg .= $p->setState($x);
         $msg .= $p->save();
       } else {
         $msg .= $p->getLink() .": ". sprintf($lang['Err0024'],$lang[$p->getType()]) ."<BR>\n";
       }
       unset ($p);
     }
     $dbconn->Commit("WORK");
   }
 }



 $link1 = "timetrack_overview.php";
 $hidden = "";

 $q = "SELECT * FROM timetrack";
 $pre = " WHERE ";

 if ( isset($HTTP_GET_VARS['id']) ) {
   $q .= $pre . "id =" . $HTTP_GET_VARS['id'];
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"id=".$HTTP_GET_VARS['id']);
   $hidden .= "<INPUT TYPE=hidden NAME=\"id\" VALUE=\"". $HTTP_GET_VARS['id'] ."\">\n";
 }
 if ( isset($HTTP_GET_VARS['link_id']) ) {
   $q .= $pre . "link_id =" . $HTTP_GET_VARS['link_id'];
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"link_id=". $HTTP_GET_VARS['link_id']);
   $hidden .= "<INPUT TYPE=hidden NAME=\"link_id\" VALUE=\"". $HTTP_GET_VARS['link_id'] ."\">\n";
 }

 # Search in description
 if ( isset($HTTP_GET_VARS['name']) && ! empty($HTTP_GET_VARS['name']) ) {
   $q .= $pre . $dbconn->Like("description",$HTTP_GET_VARS['name']);
   $link1 = addUrlParameter($link1,"name=". UrlEncode($HTTP_GET_VARS['name']));
   $pre = " AND ";
   $hidden .= "<INPUT TYPE=hidden NAME=\"name\" VALUE=\"". $HTTP_GET_VARS['name'] ."\">\n";
 }

 # Start Date for search
 $from = new DateTime(0);
 if ( isset($HTTP_GET_VARS['fd']) ) {
   $from->setDateTime($HTTP_GET_VARS['fd']);
 } else {
   $from->setDateTimeF("f");
   # remember this
   $HTTP_SESSION_VARS['ttsearchfrom'] = $from->getYYYYMMDD();
 }
 if ( $from->notime != 1 ) {
   $q .= $pre ."( vtime >= ". $dbconn->Date($from) .")";
   $pre = "AND ";

   $link1 = addUrlParameter($link1,"fd=".$from->getYYYYMMDD());
   $hidden .= "<INPUT TYPE=hidden NAME=\"fd\" VALUE=\"". $from->getYYYYMMDD() ."\">\n";
 }
 # End Date for search
 $to = new DateTime(0);
 if ( isset($HTTP_GET_VARS['td']) ) {
   $to->setDateTime($HTTP_GET_VARS['td']);
 } else {
   $to->setDateTimeF("t");
   # remember this
   $HTTP_SESSION_VARS['ttsearchto'] = $to->getYYYYMMDD();
 }
 if ( $to->notime != 1 ) {
   $q .= $pre ."( vtime <= ". $dbconn->Date($to) .")";
   $pre = " AND ";

   $link1 = addUrlParameter($link1,"td=".$to->getYYYYMMDD());
   $hidden .= "<INPUT TYPE=hidden NAME=\"td\" VALUE=\"". $to->getYYYYMMDD() ."\">\n";
 }
 # Search for state
 if ( isset($HTTP_GET_VARS['state']) && ($HTTP_GET_VARS['state'] != -2) ) {
   $q .= $pre ." (state = ". $HTTP_GET_VARS['state'] .")";
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"state=".$HTTP_GET_VARS['state']);
   $HTTP_SESSION_VARS['ttsearchstate'] = $HTTP_GET_VARS['state'];
   $hidden .= "<INPUT TYPE=hidden NAME=\"state\" VALUE=\"". $HTTP_GET_VARS['state'] ."\">\n";
 }

 # Search for worker
 if ( isset($HTTP_GET_VARS['worker']) ) {
   $x = getObject($dbconn,$HTTP_GET_VARS['worker']);
   if ( $x->getType() == "address" ) {
     $q .= $pre . "adr_id =" . $HTTP_GET_VARS['worker'];
   } else if ( $x->getType() == "user" ) {
     $q .= $pre . "adr_id =" . $HTTP_GET_VARS['worker'];
   } else if ( $x->getType() == "team" ) {
     $q .= $pre . "adr_id in (" . $HTTP_GET_VARS['worker'];
     $x->read_member();
     @reset($x->member);
     while ( list ($i1,$f1) = @each ($x->member) ) {
       $q .= "," . $i1;
     }
     $q .= ")";
   } else {
     $q .= $pre . "adr_id =" . $link_id;
   }
   $pre = " AND ";
   $link1 = addUrlParameter($link1,"worker=".$HTTP_GET_VARS['worker']);
   $hidden .= "<INPUT TYPE=hidden NAME=\"worker\" VALUE=\"". $HTTP_GET_VARS['worker'] ."\">\n";
 }

 # sorting
 $link2 = $link1;
 $xxx = "";
 order_parse($q,$link1,$xxx,$hidden,"vtime DESC");

 $r = $dbconn->Exec($q);

 if ( isset($HTTP_GET_VARS['start']) ) {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
 }
 if ( isset($HTTP_GET_VARS['format']) ) {
   $format = $HTTP_GET_VARS['format'];
 } else {
   $format = "";
 }

 if ( $format == "export") {
   $n = $r->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
   } else {
     Header("Content-type: text");
     Header("Content-Disposition: attachment; filename=\"TUTOS_timetrack_export.csv\"");
     Header("Content-Description: Upload from TUTOS" );
     exportinfo($dbconn,$r);
   }
 } else {
   HTML_Header($lang['TimetrackOverview']);
   HTML_Base1();
   navigate($link1);
   HTML_Base2($msg);
   if ( $format == "") {
     info($dbconn,$r,$start,$hidden);
   } else if ( $format == "stat") {
     statinfo($dbconn,$r);
   }
   HTML_Base3();
 }
 $r->free();
 $dbconn->Close();
?>
