<?
/**
 * Copyright 2002 by Gero Kohnert
 *
 * Update all tables indices etc for TUTOS
 *
 * !! Remove/Disable this script after running !!
 *
 * @modulegroup ADMIN
 * @module update
 * @package BASE
 */
include("webelements.p3");
include("permission.p3");
include("table.pinc");


 Function info (&$dbc) {
   global $current_user, $table, $tableidx, $sequence, $tutos;

   echo "<H2>". $dbc->getFullName() ."</H2>\n";
   echo "<P>TABLES<P>\n";
   @reset($table);
   while ( list ($i,$f) = @each ($table) ) {
     echo $f[Desc] ."<BR>\n";
     if ($dbc->createtable($f) == -1) {
 #      echo "Table ". $f[name] ." not created:<SPAN class=warn>". $dbc->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN CLASS=found>Table <B>". $f[name] ."</B> created</SPAN><BR>\n";
     }
     flush();
   }

   echo "<P>COLUMNS<P>\n";
   @reset($table);
   while ( list ($i,$f) = @each ($table) ) {
     echo $f[Desc] ."<BR>\n";
     @reset($f);
     while ( list ($i2,$f2) = @each ($f) ) {
       if ( gettype($f2) != "array" ) {
         continue;
	   }
       if ($dbc->createcolumn($f[name],$f2) == -1) {
#         echo "Column ". $f[name] ." (". $f2[column] .") not created: <SPAN class=warn>". $dbc->lasterror ."</SPAN><BR>\n";
       } else {
         echo "Column <SPAN class=found>". $f[name] ." (". $f2[column] .")</SPAN> created<BR>\n";
       } 
     }
     flush();
   }

   echo "<P>INIDCES<P>\n";
   @reset($tableidx);
   while ( list ($i,$f) = @each ($tableidx) ) {
     echo $f[Desc] ."<BR>\n";
     if ($dbc->createindex($f) == -1) {
#       echo "Index not created:<SPAN class=warn>". $dbc->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN class=found>Index <B>". $f[name] ."</B> created</SPAN><BR>\n";
     }
     flush();
   }
   echo "<P>SEQUENCERS<P>\n";
   @reset($sequence);
   while ( list ($i,$f) = @each ($sequence) ) {
     echo $f[Desc] ."<BR>\n";
     if ($dbc->createsequence($f) == -1) {
 #      echo "Sequence ". $f[name] ." not created:<SPAN class=warn>". $dbc->lasterror ."</SPAN><BR>\n";
     } else { 
       echo "<SPAN CLASS=found>Sequence <B>". $f[name] ."</B> created</SPAN><BR>\n";
     }
     flush();
   }

   # Update the DB entry
   # The current DB entry is always that with the ID 1
   $dbc->db->SetVersion($tutos[version]);
   $dbc->db->read_update();

   echo "<SPAN CLASS=warn>If everything works disable this script</SPAN><BR>\n";
 }

 Function navigate () {
   global $tutos,$lang,$current_user;

   echo "<TABLE>";
   echo "<TR><TD>";

   echo "</TD></TR>";

   HTML_Select();
 }

 # read the table definitions of modules
 @reset($tutos[modules]);
 while ( list ($r,$x) = @each ($tutos[modules])) {
   @include(dirname($tutos['base'] ."/". $tutos[modules][$r][file]) ."/mtable.pinc");
 }


 if (  isset($HTTP_GET_VARS['id']) ) {
   if ( ! isset ($current_user) ) {
      ReadLang($lang);
   }
   if ( isset($tutos[dbname][$HTTP_GET_VARS['id']] ) ) {
     $dbc = DB_Open($HTTP_GET_VARS['id'],false);
   } else {
     $msg .= "<BR>The given database id ". $HTTP_GET_VARS['id'] ." is not defined in you configuration";
   }
 } else {
   /* Check if user is allowed to use it */
   check_user();
   $dbc = &$current_user->dbconn;
 }

 HTML_Header($lang['DBUpdate']);


 HTML_Base1();
# navigate();
 HTML_Base2($msg);
 if ($msg == "" ) {
   info($dbc);
 }
 HTML_Base3();

?>
<!--
    CVS Info:  $Id: update.php,v 1.16.2.2 2002/08/15 19:30:22 gokohnert Exp $
    $Author: gokohnert $
-->
