<?
/**
 * Copyright 1999 - 2002 by Gero Kohnert
 *
 * @modulegroup user
 * @module user_overview
 * @package user
 */
 include("webelements.p3");
 include("permission.p3");

 /* Check if user is allowed to use it */
 check_user();
 loadmodules("user");

 /**
  * a sortable overview on a selection of bugs
  */
 Function info(&$dbconn,&$result,$start,$hidden,$link1,$link2) {
   global $lang,$tutos;

   $n = $result->numrows();
   if ( 0 == $n) {
     echo "<SPAN CLASS=warn>". $lang['Err0048'] ."</SPAN>";
     return;
   }

   if ( $tutos[massupdate] == 1 ) {
     echo "<FORM NAME=\"actionform\" METHOD=\"GET\" ACTION=\"user_overview.php\">\n";
     echo $hidden;
     hiddenFormElements();
     echo "<SCRIPT language=\"JavaScript\">\n";
     echo "<!--\n";
     echo "function CheckAll2() {\n";
     echo "  for (var i=0; i < document.forms['actionform'].elements.length; i++) {\n";
     echo "   var e = document.forms['actionform'].elements[i];\n";
     echo "   if (e.name != 'checkit')\n";
     echo "     e.checked = document.forms['actionform'].checkit.checked;\n";
     echo "  }\n";
     echo "}\n";
     echo "//-->\n";
     echo "</SCRIPT>\n";
   }

   echo "<TABLE CLASS=single BORDER=1 CELLPADDING=3 CELLSPACING=0>\n";
   echo "<THEAD>\n";
   echo "<TR>\n";
   echo order_header("login", $lang['User'],$link2);
   echo order_header("last_seen", $lang['UserLastSeen'],$link2);
   echo order_header("last_host", $lang['UserLastHost'],$link2);
   echo order_header("disabled", $lang['UserDisabled'],$link2);
   echo order_header("lang", $lang['UserLanguage'],$link2);
   echo order_header("tz", $lang['UserTimezone'],$link2);
   echo order_header("theme", $lang['UserTheme'],$link2);
   if ( $tutos[massupdate] == 1 ) {
     echo "  <TH NOWRAP><INPUT TYPE=checkbox name=checkit onClick=\"CheckAll2();\"></TH>\n";
   }
   echo "</TR>\n";
   echo "</THEAD>\n";

   if ( $start == -1 ) {
     $a = $n - $tutos[maxshow];
     $end = $n;
     $start = $a;
   } else {
     $a = $start;
     $end = $start + $tutos[maxshow];
   }

   echo "<TBODY>\n";

   while ( ($a < $n) && ($a < $end) ) {
     $f = new tutos_user($dbconn);
     $uid = $result->get($a, "id");
     $f->read($uid,1);
     $a++;
     if ( ! $f->see_ok() ) {
       continue;
     }
     echo "<TR>\n";
     echo " <TD ALIGN=right>". makelink("user_new.php?uid=".$f->uid ,$f->login) ."</TD>";
     echo " <TD>". $f->last_seen->getDateTime() ."&nbsp;</TD>";
     echo " <TD>". $f->last_host ."&nbsp;</TD>";
     echo " <TD ALIGN=center>". ($f->disabled == 1 ? $lang['yes']:$lang['no']) ."</TD>";
     echo " <TD>". $f->lang ."&nbsp;</TD>";
     echo " <TD>". $f->tz ."&nbsp;</TD>";
     echo " <TD>". $f->theme ."&nbsp;</TD>";
     if ( $tutos[massupdate] == 1 ) {
  	   if ( $f->mod_ok() ) {
         echo " <TD><INPUT NAME=\"mark[]\" TYPE=checkbox value=\"". $f->uid ."\"></TD>\n";
       } else {
         echo "<TD>&nbsp;-&nbsp;</TD>";
       }
     }
     echo "</TR>\n";
     unset ($f);
   }
   echo "</TBODY>\n";

   echo "<TFOOT>\n";
   ShowBackForwardNav($link1,8 + $tutos[massupdate],$start,$a,$n);

   if ( $tutos[massupdate] == 1 ) {
     echo "<TR>\n";
     echo "<TD ALIGN=right COLSPAN=7>\n";
     echo sprintf($lang['withmarked'],$lang['Users']);
     echo "<SELECT NAME=action>\n";
     echo " <OPTION VALUE=\"-1\" SELECTED>". $lang['MailActionNil'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"-2\">". $lang['Delete'] ."</OPTION>\n";
     echo " <OPTION VALUE=\"enable\">". sprintf($lang['SetTo'],$lang['UserDisabled'],$lang['no']) ."</OPTION>\n";
     echo " <OPTION VALUE=\"disable\">". sprintf($lang['SetTo'],$lang['UserDisabled'],$lang['yes']) ."</OPTION>\n";
     echo "</SELECT>\n";

     echo "</TD>\n";
     echo " <TD COLSPAN=2><INPUT type=submit value=\"OK\"></TD>\n";
     echo "</TR>\n";
   }

   echo "</TFOOT>\n";
   echo "</TABLE>\n";
   if ( $tutos[massupdate] == 1 ) {
     echo "</FORM>";
   }
 }
/**
  *
  */
 Function navigate() {
   echo "<TABLE>";
   echo "<TR><TD>";
   echo "</TD></TR>";

   HTML_Select();
 }


 $stop = 0;
 if ( $current_user->admin == 0 ) {
   $msg .= "<SPAN CLASS=warn>Only admins are allowed to see this</SPAN><BR>\n";
   if ( $tutos[demo] == 1 ) {
     $msg .= "<SPAN CLASS=warn>exceptionally enabled for this demo</SPAN><BR>\n";
   } else {
     $stop = 1;
   }
 }

 # Perform possible actions
 if ( ($current_user->admin == 1) && isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] != -1) ) {
   @reset($HTTP_GET_VARS['mark']);
   if ( $HTTP_GET_VARS['action'] == -2 ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = new tutos_user($dbconn);
       $b->read($val,2);
       if ( $b->uid != $val ) {
         $msg .= $b->uid ." != ". $val ."<BR>";
         continue;
	   }
       if ( $b->del_ok() ) {
         $msg .= $lang['Delete'] ."&nbsp;". $b->login ."<BR>";
         $msg .= $b->delete();
	   } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0023'],$lang[$b->getType()]);
	   }
       unset($b);
     }
     $dbconn->Commit("WORK");
   } else if ( $HTTP_GET_VARS['action'] == 'enable' ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = new tutos_user($dbconn);
       $b->read($val,2);
       if ( $b->uid != $val ) {
         $msg .= $b->uid ." != ". $val ."<BR>";
         continue;
	   }
       if ( $b->mod_ok() ) {
         $msg .= $lang['UserDisable'] ."&nbsp;". $b->login ."<BR>";
         $msg .= $b->setDisabled(0);
         $msg .= $b->save();
	   } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0024'],$lang[$b->getType()]);
	   }
       unset($b);
	 }
     $dbconn->Commit("WORK");
   } else if ( $HTTP_GET_VARS['action'] == 'disable' ) {
     $dbconn->Begin("WORK");
     while (list ($key,$val) = @each ($HTTP_GET_VARS['mark'])) {
       $b = new tutos_user($dbconn);
       $b->read($val,2);
       if ( $b->uid != $val ) {
         $msg .= $b->uid ." != ". $val ."<BR>";
         continue;
	   }
       if ( $b->mod_ok() ) {
         $msg .= $lang['UserDisabled'] ."&nbsp;". $b->login ."<BR>";
         $msg .= $b->setDisabled(1);
         $msg .= $b->save();
	   } else {
         $msg .= $b->getLink() .": ". sprintf($lang['Err0024'],$lang[$b->getType()]);
	   }
       unset($b);
	 }
     $dbconn->Commit("WORK");
   }
 }

 $link1 = "user_overview.php";
 $link2 = "user_overview.php";
 $hidden = "";
 $q = "SELECT people.*,id as u_id from people";


 # sorting
 $xxx = "";
 order_parse($q,$link1,$xxx,$xxx,"login");

 $result = $dbconn->Exec($q);

 if ( isset($HTTP_GET_VARS['start'])  ) {
   $start = $HTTP_GET_VARS['start'];
 } else {
   $start = 0;
 }

 HTML_Header($lang['UserOverview']);
 HTML_Base1();
 navigate();
 HTML_Base2($msg);
 if ( $stop == 0 ) {
   info($dbconn,$result,$start,$hidden,$link1,$link2);
 }
 HTML_Base3();

 $result->Free();
 $dbconn->Close();
?>
<!--
    CVS Info:  $Id: user_overview.php,v 1.4.2.2 2002/08/30 13:55:27 gokohnert Exp $
    $Author: gokohnert $
-->
